/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 32 "parser.y"

/** @endcond */

// local
#include "pjl_config.h"                 /* must go first */
#include "c_ast.h"
#include "c_ast_check.h"
#include "c_ast_util.h"
#include "c_keyword.h"
#include "c_lang.h"
#include "c_operator.h"
#include "c_sglob.h"
#include "c_sname.h"
#include "c_type.h"
#include "c_typedef.h"
#include "cdecl.h"
#include "cdecl_keyword.h"
#include "color.h"
#include "decl_flags.h"
#include "dump.h"
#include "did_you_mean.h"
#include "english.h"
#include "gibberish.h"
#include "help.h"
#include "lexer.h"
#include "literals.h"
#include "options.h"
#include "p_macro.h"
#include "p_token.h"
#include "print.h"
#include "set_options.h"
#include "show.h"
#include "slist.h"
#include "types.h"
#include "util.h"

/// @cond DOXYGEN_IGNORE

// standard
#include <assert.h>
#include <stdarg.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

// Silence these warnings for Bison-generated code.
#ifdef __GNUC__
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wconversion"
# pragma GCC diagnostic ignored "-Wredundant-decls"
# pragma GCC diagnostic ignored "-Wunreachable-code"
#endif /* __GNUC__ */

// Developer aid for tracing when Bison %destructors are called.
#if 0
#define DTRACE                    EPRINTF( "%d: destructor\n", __LINE__ )
#else
#define DTRACE                    NO_OP
#endif

#define IF_CDECL_DEBUG(...) \
  BLOCK( if ( opt_cdecl_debug != CDECL_DEBUG_NO ) { __VA_ARGS__ } )

/// @endcond

///////////////////////////////////////////////////////////////////////////////

/**
 * @defgroup parser-group Parser
 * Helper macros, data structures, variables, functions, and the grammar for
 * C/C++ declarations.
 * @{
 */

/**
 * Calls #elaborate_error_dym() with #DYM_NONE.
 *
 * @param ... Arguments passed to fl_elaborate_error().
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  | Y_define error
 *    {
 *      elaborate_error( "name expected" );
 *    }
 * ```
 * @note A newline _is_ printed.
 *
 * @sa elaborate_error_dym()
 * @sa keyword_expected()
 * @sa punct_expected()
 */
#define elaborate_error(...) \
  elaborate_error_dym( DYM_NONE, __VA_ARGS__ )

/**
 * Calls fl_elaborate_error() followed by #PARSE_ABORT().
 *
 * @param DYM_KINDS The bitwise-or of \ref dym_kind_t things possibly meant.
 * @param ... Arguments passed to fl_elaborate_error().
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  | error
 *    {
 *      elaborate_error_dym( DYM_COMMANDS, "unexpected token" );
 *    }
 * ```
 * @note A newline _is_ printed.
 *
 * @sa elaborate_error()
 * @sa keyword_expected()
 * @sa punct_expected()
 */
#define elaborate_error_dym(DYM_KINDS,...) BLOCK( \
  fl_elaborate_error( __FILE__, __LINE__, (DYM_KINDS), __VA_ARGS__ ); PARSE_ABORT(); )

/**
 * Prints that a particular language feature is not supported by **cdecl** and
 * will be ignored.
 *
 * @param LOC The location of what's being ignored.
 * @param ... The `printf()` arguments, the first of which _must_ be a string
 * literal of what is being ignored.
 *
 * @sa #UNSUPPORTED()
 */
#define IGNORING(LOC,...) \
  IGNORING_IMPL( (LOC), __VA_ARGS__, CDECL )

/// @cond DOXYGEN_IGNORE
#define IGNORING_IMPL(LOC,WHAT,...) \
  print_warning( (LOC), WHAT " not supported by %s (ignoring)%s", __VA_ARGS__, "\n" )
/// @endcond

/**
 * Checks whether the type currently being declared (`enum`, `struct`,
 * `typedef`, or `union`) is nested within some other type (`struct` or
 * `union`) and whether the current language is C: if not, prints an error
 * message.
 *
 * @remarks In debug mode, also includes the file & line where the function was
 * called from in the error message.
 *
 * @param TYPE_LOC The location of the type declaration.
 * @return Returns `true` only if the type currently being declared is either
 * not nested or the current language is C++.
 *
 * @sa fl_is_nested_type_ok()
 */
#define is_nested_type_ok(TYPE_LOC) \
  fl_is_nested_type_ok( __FILE__, __LINE__, (TYPE_LOC) )

/**
 * Checks whether \ref opt_lang_id is among the bitwise-or of languages
 * specified by \a LANG_MACRO, i.e., \a LANG_MACRO is supported by \ref
 * opt_lang_id.
 *
 * @param LANG_MACRO A `LANG_*` macro without the `LANG_` prefix.
 * @return Returns `true` only if either **cdecl** is \ref cdecl_initialized is
 * `false` or \ref opt_lang_id is among the bitwise-or of languages specified
 * by \a LANG_MACRO.
 *
 * @sa #OPT_LANG_IS()
 */
#define IS_SUPPORTED(LANG_MACRO) \
  ( !cdecl_initialized || OPT_LANG_IS( LANG_MACRO ) )

/**
 * Calls fl_keyword_expected() followed by #PARSE_ABORT().
 *
 * @param KEYWORD A keyword literal.
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  : Y_virtual
 *  | error
 *    {
 *      keyword_expected( L_virtual );
 *    }
 * ```
 *
 * @sa elaborate_error()
 * @sa elaborate_error_dym()
 * @sa punct_expected()
 */
#define keyword_expected(KEYWORD) BLOCK ( \
  fl_keyword_expected( __FILE__, __LINE__, (KEYWORD) ); PARSE_ABORT(); )

/**
 * Aborts the current parse after an error message has been printed.
 *
 * @sa #PARSE_ASSERT()
 */
#define PARSE_ABORT() \
  BLOCK( parse_cleanup( /*fatal_error=*/true ); YYABORT; )

/**
 * Evaluates \a EXPR: if `false`, calls #PARSE_ABORT().
 *
 * @param EXPR The expression to evalulate.
 */
#define PARSE_ASSERT(EXPR)        BLOCK( if ( !(EXPR) ) PARSE_ABORT(); )

/**
 * Calls fl_punct_expected() followed by #PARSE_ABORT().
 *
 * @param PUNCT The punctuation character that was expected.
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  : ','
 *  | error
 *    {
 *      punct_expected( ',' );
 *    }
 * ```
 *
 * @sa elaborate_error()
 * @sa elaborate_error_dym()
 * @sa keyword_expected()
 */
#define punct_expected(PUNCT) BLOCK( \
  fl_punct_expected( __FILE__, __LINE__, (PUNCT) ); PARSE_ABORT(); )

/**
 * Prints that a particular language feature is not supported by **cdecl** and
 * it an error.
 *
 * @param LOC The location of what's not supported.
 * @param ... The `printf()` arguments, the first of which _must_ be a string
 * literal of what is unsupported.
 *
 * @sa #IGNORING()
 */
#define UNSUPPORTED(LOC,...) \
  UNSUPPORTED_IMPL( (LOC), __VA_ARGS__, CDECL )

/// @cond DOXYGEN_IGNORE
#define UNSUPPORTED_IMPL(LOC,WHAT,...) \
  print_error( (LOC), WHAT " not supported by %s%s", __VA_ARGS__, "\n" )
/// @endcond

/** @} */

///////////////////////////////////////////////////////////////////////////////

/**
 * @defgroup parser-dump-group Debugging Macros
 * Macros that are used to dump a trace during parsing when \ref
 * opt_cdecl_debug is set.
 * @ingroup parser-group
 * @{
 */

/**
 * Dumps \a ALIGN.
 *
 * @param KEY The key name to print.
 * @param ALIGN The \ref c_alignas to dump.
 */
#define DUMP_ALIGN(KEY,ALIGN) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_alignas_dump( &(ALIGN), stdout ); )

/**
 * Dumps an AST.
 *
 * @param KEY The key name to print.
 * @param AST The AST to dump.
 *
 * @sa #DUMP_AST_LIST()
 * @sa #DUMP_AST_PAIR()
 */
#define DUMP_AST(KEY,AST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_ast_dump( (AST), stdout ); )

/**
 * Dumps an s_list of AST.
 *
 * @param KEY The key name to print.
 * @param AST_LIST The \ref slist of AST to dump.
 *
 * @sa #DUMP_AST()
 * @sa #DUMP_AST_PAIR()
 */
#define DUMP_AST_LIST(KEY,AST_LIST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_ast_list_dump( &(AST_LIST), stdout ); )

/**
 * Dump a \ref c_ast_pair.
 *
 * @param KEY The key name to print.
 * @param ASTP The \ref c_ast_pair to dump.
 *
 * @sa #DUMP_AST()
 */
#define DUMP_AST_PAIR(KEY,ASTP) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_ast_pair_dump( &(ASTP), stdout ); )

/**
 * Dumps a `bool`.
 *
 * @param KEY The key name to print.
 * @param BOOL The `bool` to dump.
 */
#define DUMP_BOOL(KEY,BOOL)  IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); bool_dump( (BOOL), stdout ); )

/**
 * Ends a dump block.
 *
 * @sa #DUMP_START()
 */
#define DUMP_END()                IF_CDECL_DEBUG( PUTS( "\n}\n\n" ); )

/**
 * Possibly dumps a comma and a newline followed by the `printf()` arguments
 * --- used for printing a key followed by a value.
 *
 * @param ... The `printf()` arguments.
 *
 * @warning This _must_ only be called inside #IF_CDECL_DEBUG().
 */
#define DUMP_KEY_IMPL(...) BLOCK(         \
  fput_sep( ",\n", &dump_comma, stdout ); \
  PRINTF( "  " __VA_ARGS__ ); )

/**
 * Dumps an integer.
 *
 * @param KEY The key name to print.
 * @param NUM The integer to dump.
 *
 * @sa #DUMP_STR()
 */
#define DUMP_INT(KEY,NUM) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": %d", STATIC_CAST( int, (NUM) ) ); )

/**
 * Dumps a \ref p_macro.
 *
 * @param KEY The key name to print.
 * @param MACRO The \ref p_macro to dump.
 */
#define DUMP_MACRO(KEY,MACRO) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); p_macro_dump( (MACRO), stdout ); )

/**
 * Dumps a list of macro arguments.
 *
 * @param KEY The key name to print.
 * @param ARG_LIST The list of arguments to dump.
 */
#define DUMP_MACRO_ARG_LIST(KEY,ARG_LIST) IF_CDECL_DEBUG( \
  if ( (ARG_LIST) != NULL ) {                             \
    DUMP_KEY_IMPL( KEY ": " );                            \
    p_arg_list_dump( (ARG_LIST), /*indent=*/1, stdout );  \
  } )

/**
 * Dumps a list of \ref p_param.
 *
 * @param KEY The key name to print.
 * @param PARAM_LIST The list of \ref p_param to dump.
 */
#define DUMP_MACRO_PARAM_LIST(KEY,PARAM_LIST) IF_CDECL_DEBUG( \
  if ( (PARAM_LIST) != NULL ) {                               \
    DUMP_KEY_IMPL( KEY ": " );                                \
    p_param_list_dump( (PARAM_LIST), /*indent=*/1, stdout );  \
  } )

/**
 * Dumps a list of \ref p_token.
 *
 * @param KEY The key name to print.
 * @param TOKEN_LIST The list of \ref p_token to dump.
 */
#define DUMP_MACRO_TOKEN_LIST(KEY,TOKEN_LIST) IF_CDECL_DEBUG( \
  if ( (TOKEN_LIST) != NULL ) {                               \
    DUMP_KEY_IMPL( KEY ": " );                                \
    p_token_list_dump( (TOKEN_LIST), /*indent=*/1, stdout );  \
  } )

/**
 * Starts a dump block.
 *
 * @remarks If a production has a result, it should be dumped as the final
 * thing before the #DUMP_END() with the KEY of `$$_` followed by a suffix
 * denoting the type, e.g., `ast`.  For example:
 * ```
 *  DUMP_START( "rule",
 *              "subrule_1 subrule_2 ..." );
 *  DUMP_AST( "subrule_1", $1 );
 *  DUMP_STR( "name", $2 );
 *  DUMP_AST( "subrule_2", $3 );
 *  // ...
 *  DUMP_AST( "$$_ast", $$ );
 *  DUMP_END();
 * ```
 *
 * @param NAME The grammar production name.
 * @param RULE The grammar production rule.
 *
 * @note The dump block _must_ end with #DUMP_END().
 *
 * @sa #DUMP_END()
 */
#define DUMP_START(NAME,RULE) \
  bool dump_comma = false;    \
  IF_CDECL_DEBUG( PUTS( "{\n  rule: {\n    lhs: \"" NAME "\",\n    rhs: \"" RULE "\"\n  },\n" ); )

/**
 * Dumps a scoped name.
 *
 * @param KEY The key name to print.
 * @param SNAME The scoped name to dump.
 *
 * @sa #DUMP_SNAME_LIST()
 * @sa #DUMP_STR()
 */
#define DUMP_SNAME(KEY,SNAME) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_sname_dump( &(SNAME), stdout ); )

/**
 * Dumps a list of scoped names.
 *
 * @param KEY The key name to print.
 * @param LIST The list of scoped names to dump.
 *
 * @sa #DUMP_SNAME()
 */
#define DUMP_SNAME_LIST(KEY,LIST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_sname_list_dump( &(LIST), stdout ); )

/**
 * Dumps a C string.
 *
 * @param KEY The key name to print.
 * @param STR The C string to dump.
 *
 * @sa #DUMP_INT()
 * @sa #DUMP_SNAME()
 * @sa #DUMP_STR_LIST()
 */
#define DUMP_STR(KEY,STR) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); fputs_quoted( (STR), '"', stdout ); )

/**
 * Dumps a list of C strings.
 *
 * @param KEY The key name to print.
 * @param STR_LIST The list of C strings to dump.
 *
 * @sa #DUMP_STR()
 */
#define DUMP_STR_LIST(KEY,STR_LIST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); str_list_dump( (STR_LIST), stdout ); )

/**
 * Dumps a \ref c_tid_t.
 *
 * @param KEY The key name to print.
 * @param TID The \ref c_tid_t to dump.
 *
 * @sa #DUMP_TYPE()
 */
#define DUMP_TID(KEY,TID) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_tid_dump( (TID), stdout ); )

/**
 * Dumps a \ref c_type.
 *
 * @param KEY The key name to print.
 * @param TYPE The \ref c_type to dump.
 *
 * @sa #DUMP_TID()
 */
#define DUMP_TYPE(KEY,TYPE) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_type_dump( &(TYPE), stdout ); )

/** @} */

///////////////////////////////////////////////////////////////////////////////

/**
 * @addtogroup parser-group
 * @{
 */

/**
 * Inherited attributes.
 *
 * @remarks These are grouped into a `struct` (rather than having them as
 * separate global variables) so that they can all be reset (mostly) via a
 * single assignment from `{0}`.
 *
 * @sa ia_cleanup()
 */
struct in_attr {
  c_alignas_t     align;            ///< Alignment, if any.
  unsigned        ast_depth;        ///< Parentheses nesting depth.
  bool            is_typename;      ///< C++ only: is `typename` specified?
  c_sname_t       scope_sname;      ///< C++ only: current scope name, if any.

  /**
   * Type AST stack.
   *
   * @sa ia_type_ast_peek()
   * @sa ia_type_ast_pop()
   * @sa ia_type_ast_push()
   */
  c_ast_list_t    type_ast_stack;

  /**
   * Declaration type specifier AST.
   *
   * @remarks A C/C++ declaration is of the form:
   *
   *      type-specifier declarator+
   *
   * where one or more declarators all have the same base type, e.g.:
   *
   *      int i, *p, a[2], f(double);
   *
   * This is a pointer to the base type AST (above, `int`) that is duplicated
   * for each declarator.  It's set by the first call to ia_type_ast_push().
   *
   * @sa ia_type_spec_ast()
   */
  c_ast_t const  *type_spec_ast;

  /**
   * Red-black node for temporary `typedef`.
   *
   * @remarks This is used only in the `pc99_func_or_constructor_declaration_c`
   * grammar production. It's needed because a temporary `typedef` needs to be
   * created in a mid-rule action then removed in the end-rule action and
   * there's no way to pass local variables between Bison actions, so it's
   * passed via an inherited attribute.
   */
  rb_node_t      *typedef_rb;
};
typedef struct in_attr in_attr_t;

// local functions
PJL_PRINTF_LIKE_FUNC(4)
static void fl_elaborate_error( char const*, int, dym_kind_t, char const*,
                                ... );

// local variables
static c_ast_list_t   gc_ast_list;      ///< c_ast nodes freed after parse.
static in_attr_t      in_attr;          ///< Inherited attributes.
static c_ast_list_t   typedef_ast_list; ///< List of ASTs for `typedef`s.

////////// inline functions ///////////////////////////////////////////////////

/**
 * Duplicates \a ast and adds it to \ref gc_ast_list.
 *
 * @param ast The AST to duplicate.
 * @return Returns the duplicated AST.
 *
 * @sa c_ast_new_gc()
 */
static inline c_ast_t* c_ast_dup_gc( c_ast_t const *ast ) {
  return c_ast_dup( ast, &gc_ast_list );
}

/**
 * Garbage-collects the AST nodes on \a ast_list but does _not_ free \a
 * ast_list itself.
 *
 * @param ast_list The AST list to free the nodes of.
 *
 * @sa c_ast_list_cleanup()
 * @sa c_ast_dup_gc()
 * @sa c_ast_new_gc()
 * @sa c_ast_pair_new_gc()
 */
static inline void c_ast_list_cleanup_gc( c_ast_list_t *ast_list ) {
  slist_cleanup( ast_list, POINTER_CAST( slist_free_fn_t, &c_ast_free ) );
}

/**
 * Creates a new AST and adds it to \ref gc_ast_list.
 *
 * @param kind The kind of AST to create.
 * @param loc A pointer to the token location data.
 * @return Returns a pointer to a new AST.
 *
 * @sa c_ast_dup_gc()
 * @sa c_ast_pair_new_gc()
 */
NODISCARD
static inline c_ast_t* c_ast_new_gc( c_ast_kind_t kind, c_loc_t const *loc ) {
  return c_ast_new( kind, in_attr.ast_depth, loc, &gc_ast_list );
}

/**
 * Set our mode to deciphering gibberish into English.
 */
static inline void gibberish_to_english( void ) {
  lexer_find &= ~LEXER_FIND_CDECL_KEYWORDS;
}

/**
 * Peeks at the type AST at the top of the
 * \ref in_attr.type_ast_stack "type AST inherited attribute stack".
 *
 * @return Returns said AST.
 *
 * @sa ia_type_ast_pop()
 * @sa ia_type_ast_push()
 */
NODISCARD
static inline c_ast_t* ia_type_ast_peek( void ) {
  return slist_front( &in_attr.type_ast_stack );
}

/**
 * Pops a type AST from the
 * \ref in_attr.type_ast_stack "type AST inherited attribute stack".
 *
 * @return Returns said AST.
 *
 * @sa ia_type_ast_peek()
 * @sa ia_type_ast_push()
 */
PJL_DISCARD
static inline c_ast_t* ia_type_ast_pop( void ) {
  return slist_pop_front( &in_attr.type_ast_stack );
}

/**
 * Pushes a type AST onto the
 * \ref in_attr.type_ast_stack "type AST inherited attribute  stack".
 *
 * @remarks Additionally, if \a ast is #K_BUILTIN and \ref
 * in_attr::type_spec_ast "type_spec_ast" is NULL, sets \ref
 * in_attr::type_spec_ast "type_spec_ast" to \a ast.
 *
 * @param ast The AST to push.
 *
 * @sa ia_type_ast_peek()
 * @sa ia_type_ast_pop()
 */
static inline void ia_type_ast_push( c_ast_t *ast ) {
  slist_push_front( &in_attr.type_ast_stack, ast );
  if ( in_attr.type_spec_ast == NULL && ast->kind == K_BUILTIN )
    in_attr.type_spec_ast = ast;
}

/**
 * Given an AST for a type that is the "of type", return type, or "to type" of
 * a declaration, returns a duplicate of \a type_ast if necessary.
 *
 * @param type_ast The AST of a type.
 * @return If \a type_ast `==` \ref in_attr::type_spec_ast "type_spec_ast",
 * returns a duplicate of \a type_ast; otherwise returns \a type_ast.
 *
 * @sa \ref in_attr::type_spec_ast
 */
NODISCARD
static inline c_ast_t* ia_type_spec_ast( c_ast_t *type_ast ) {
  // Yes, == is correct here: we mean the same AST node.
  return type_ast == in_attr.type_spec_ast ?
    c_ast_dup_gc( type_ast ) : type_ast;
}

////////// local functions ////////////////////////////////////////////////////

/**
 * Prints a warning that the attribute \a keyword syntax is not supported (and
 * ignored).
 *
 * @param keyword The attribute syntax keyword, e.g., `__attribute__` or
 * `__declspec`.
 * @param keyword_loc The source location of \a keyword.
 */
static void attr_syntax_not_supported( char const *keyword,
                                       c_loc_t const *keyword_loc ) {
  assert( keyword != NULL );
  assert( keyword_loc != NULL );

  print_warning( keyword_loc,
    "\"%s\" not supported by " CDECL " (ignoring)", keyword
  );
  if ( OPT_LANG_IS( ATTRIBUTES ) )
    print_hint( "%s...%s", other_token_c( "[[" ), other_token_c( "]]" ) );
  else
    EPUTC( '\n' );
}

/**
 * A predicate function for slist_free_if() that checks whether \a ast is one
 * that can be garbage collected: if so, c_ast_free()s it.
 *
 * @param ast_node The \ref slist_node pointing to the AST to check.
 * @param data Contains the AST of the type being declared.
 * @return Returns `true` only if \a ast should be removed from the list.
 */
NODISCARD
static bool c_ast_free_if_garbage( slist_node_t *ast_node, void *data ) {
  assert( ast_node != NULL );
  c_ast_t *const ast = ast_node->data;
  assert( ast != NULL );
  c_ast_t const *const type_ast = data;
  assert( type_ast != NULL );

  if ( ast == type_ast || !c_ast_is_orphan( ast ) ) {
    assert( ast->kind != K_PLACEHOLDER );
    return false;
  }

  // We also need to ensure the AST isn't in the type_ast_stack.
  FOREACH_SLIST_NODE( type_node, &in_attr.type_ast_stack ) {
    c_ast_t const *const stack_type_ast = type_node->data;
    if ( ast == stack_type_ast )
      return false;
  } // for

  c_ast_free( ast );
  return true;
}

/**
 * Checks whether `typename` is OK since the type's name is a qualified name.
 *
 * @param ast The AST to check.
 * @return Returns `true` only upon success.
 */
NODISCARD
bool c_ast_is_typename_ok( c_ast_t const *ast ) {
  c_ast_t const *const raw_ast = c_ast_untypedef( ast );
  if ( c_sname_count( &raw_ast->sname ) < 2 ) {
    print_error( &ast->loc, "qualified name expected after \"typename\"\n" );
    return false;
  }
  return true;
}

/**
 * If \a bit_width is &gt; 0 and \a ast is an integral type, sets \a ast's \ref
 * c_bit_field_ast::bit_width "bit_width" to \a bit_width.
 *
 * @remarks This check has to be done now in the parser rather than later in
 * the AST since we need to use the \ref c_ast::bit_field `union` member now.
 *
 * @param ast The AST whose \ref c_bit_field_ast::bit_width "bit_width" to
 * possibly set.
 * @param bit_width The bit-field width.
 * @return Return's `true` only if \a ast if an integral type.
 */
NODISCARD
static bool c_ast_set_bit_field_width( c_ast_t *ast, unsigned bit_width ) {
  assert( ast != NULL );

  if ( bit_width > 0 ) {
    if ( !c_ast_is_integral( ast ) ) {
      print_error( &ast->loc, "invalid bit-field type " );
      print_ast_type_aka( ast, stderr );
      EPRINTF( "; must be an integral %stype\n",
        OPT_LANG_IS( enum_BITFIELDS ) ? "or enumeration " : ""
      );
      return false;
    }
    ast->bit_field.bit_width = bit_width;
  }

  return true;
}

/**
 * Defines a type by adding it to the global set.
 *
 * @param type_ast The AST of the type to define.
 * @param decl_flags The declaration flags to use; must only be one of
 * #C_ENG_DECL, #C_GIB_TYPEDEF, or #C_GIB_USING.
 * @return Returns `true` either if the type was defined or it's equivalent to
 * an existing type; `false` if a different type already exists having the same
 * name.
 */
NODISCARD
static bool define_type( c_ast_t const *type_ast, unsigned decl_flags ) {
  assert( type_ast != NULL );
  assert( is_1_bit_only_in_set( decl_flags, C_TYPE_DECL_ANY ) );

  c_ast_t const *const leaf_ast = c_ast_leaf( type_ast );
  if ( c_ast_is_tid_any( leaf_ast, TB_auto ) ) {
    print_error( &leaf_ast->loc,
      "\"%s\" illegal in type definition\n",
      c_type_name_error( &leaf_ast->type )
    );
    return false;
  }

  rb_node_t const *const typedef_rb = c_typedef_add( type_ast, decl_flags );
  c_typedef_t *const tdef = typedef_rb->data;

  if ( tdef->ast == type_ast ) {
    //
    // Type was added: we have to move the AST from the gc_ast_list so it won't
    // be garbage collected at the end of the parse to a separate
    // typedef_ast_list that's freed only at program termination.
    //
    // But first, garbage collect all orphaned AST nodes.  (For a non-type-
    // defining parse, this step isn't necessary since all nodes are freed at
    // the end of the parse anyway.)
    //
    slist_free_if(
      &gc_ast_list,
      &c_ast_free_if_garbage,
      CONST_CAST( void*, type_ast )
    );
    slist_push_list_back( &typedef_ast_list, &gc_ast_list );
  }
  else {
    //
    // Type was NOT added because a previously declared type having the same
    // name was returned: check if the types are equal.
    //
    // In C, multiple typedef declarations having the same name are allowed
    // only if the types are equivalent:
    //
    //      typedef int T;
    //      typedef int T;                // OK
    //      typedef double T;             // error: types aren't equivalent
    //
    if ( !c_ast_equal( type_ast, tdef->ast ) ) {
      print_error( &type_ast->loc, "type " );
      print_ast_type_aka( type_ast, stderr );
      EPUTS( " redefinition incompatible with original type \"" );
      print_type_ast( tdef, stderr );
      EPUTS( "\"\n" );
      return false;
    }

    // Update the language(s) the type is available in to include opt_lang_id.
    if ( opt_lang_id < c_lang_oldest( tdef->lang_ids ) )
      tdef->lang_ids = c_lang_and_newer( opt_lang_id );
  }

  return true;
}

/**
 * Checks whether the type currently being declared (`enum`, `struct`,
 * `typedef`, or `union`) is nested within some other type (`struct` or
 * `union`) and whether the current language is C: if not, prints an error
 * message.
 *
 * @note It is unnecessary to check either when a `class` is being declared or
 * when a type is being declared within a `namespace` since those are not legal
 * in C anyway.
 *
 * @note This function isn't normally called directly; use the
 * #is_nested_type_ok() macro instead.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param type_loc The location of the type declaration.
 * @return Returns `true` only if the type currently being declared is either
 * not nested or the current language is C++.
 */
NODISCARD
static bool fl_is_nested_type_ok( char const *file, int line,
                                  c_loc_t const *type_loc ) {
  assert( type_loc != NULL );
  if ( !c_sname_empty( &in_attr.scope_sname ) &&
       !OPT_LANG_IS( NESTED_TYPES ) ) {
    fl_print_error( file, line, type_loc,
      "nested types not supported%s\n",
      C_LANG_WHICH( NESTED_TYPES )
    );
    return false;
  }
  return true;
}

/**
 * A special case of fl_elaborate_error() that prevents oddly worded error
 * messages where a C/C++ keyword is expected, but that keyword isn't a keyword
 * either until a later version of the language or in a different language;
 * hence, the lexer will return the keyword as the `Y_NAME` token instead of
 * the keyword token.
 *
 * For example, if fl_elaborate_error() were used for the following \b cdecl
 * command when the current language is C, you'd get the following:
 * ```
 * declare f as virtual function returning void
 *              ^
 * 14: syntax error: "virtual": "virtual" expected; not a keyword until C++98
 * ```
 * because it's really this:
 * ```
 * ... "virtual" [the name]": "virtual" [the token] expected ...
 * ```
 * and that looks odd.
 *
 * @note This function isn't normally called directly; use the
 * #keyword_expected() macro instead.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param keyword A keyword literal.
 *
 * @sa fl_elaborate_error()
 * @sa fl_punct_expected()
 * @sa yyerror()
 */
static void fl_keyword_expected( char const *file, int line,
                                 char const *keyword ) {
  assert( keyword != NULL );

  dym_kind_t dym_kinds = DYM_NONE;

  char const *const error_token = lexer_printable_token();
  if ( error_token != NULL ) {
    if ( strcmp( error_token, keyword ) == 0 ) {
      //
      // The error token is the expected keyword which means the lexer returned
      // it as a name and not the token which likely means it's not a C/C++
      // keyword until a later version of the current language.
      //
      c_keyword_t const *const ck =
        c_keyword_find( keyword, LANG_ANY, C_KW_CTX_DEFAULT );
      if ( ck != NULL ) {
        char const *const which_lang = c_lang_which( ck->lang_ids );
        if ( which_lang[0] != '\0' ) {
          EPUTS( ": " );
          print_debug_file_line( file, line );
          EPRINTF( "\"%s\" not supported%s\n", keyword, which_lang );
          return;
        }
      }
    }

    dym_kinds = is_english_to_gibberish() ? DYM_CDECL_KEYWORDS : DYM_C_KEYWORDS;
  }

  fl_elaborate_error( file, line, dym_kinds, "\"%s\" expected", keyword );
}

/**
 * A special case of fl_elaborate_error() that prevents oddly worded error
 * messages when a punctuation character is expected by not doing keyword look-
 * ups of the error token.

 * For example, if fl_elaborate_error() were used for the following \b cdecl
 * command, you'd get the following:
 * ```
 * explain void f(int g const)
 *                      ^
 * 29: syntax error: "const": ',' expected ("const" is a keyword)
 * ```
 * and that looks odd since, if a punctuation character was expected, it seems
 * silly to point out that the encountered token is a keyword.
 *
 * @note This function isn't normally called directly; use the
 * #punct_expected() macro instead.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param punct The punctuation character that was expected.
 *
 * @sa fl_elaborate_error()
 * @sa fl_keyword_expected()
 * @sa yyerror()
 */
static void fl_punct_expected( char const *file, int line, char punct ) {
  EPUTS( ": " );
  print_debug_file_line( file, line );

  char const *const error_token = lexer_printable_token();
  if ( error_token != NULL )
    EPRINTF( "\"%s\": ", error_token );

  print_debug_file_line( file, line );
  EPRINTF( "'%c' expected\n", punct );
}

/**
 * Cleans-up all resources used by \ref in_attr "inherited attributes".
 */
static void ia_cleanup( void ) {
  c_sname_cleanup( &in_attr.scope_sname );
  // Do _not_ pass &c_ast_free for the 2nd argument! All AST nodes were already
  // free'd from the gc_ast_list in parse_cleanup(). Just free the slist nodes.
  slist_cleanup( &in_attr.type_ast_stack, /*free_fn=*/NULL );
  in_attr = (in_attr_t){ 0 };
}

/**
 * Joins \a type_ast and \a decl_ast into a single AST.
 *
 * @param type_ast The type AST.
 * @param decl_ast The declaration AST.
 * @return Returns the joined AST on success or NULL on error.
 */
NODISCARD
c_ast_t* join_type_decl( c_ast_t *type_ast, c_ast_t *decl_ast ) {
  assert( type_ast != NULL );
  assert( decl_ast != NULL );

  if ( in_attr.is_typename && !c_ast_is_typename_ok( type_ast ) )
    return NULL;

  c_type_t type = c_ast_take_type_any( type_ast, &T_TS_typedef );

  if ( c_tid_is_any( type.stids, TS_typedef ) && decl_ast->kind == K_TYPEDEF ) {
    //
    // This is for a case like:
    //
    //      explain typedef int int32_t;
    //
    // that is: explaining an existing typedef.  In order to do that, we have
    // to un-typedef it so we explain the type that it's a typedef for.
    //
    c_ast_t const *const raw_decl_ast = c_ast_untypedef( decl_ast );

    //
    // However, we also have to check whether the typedef being explained is
    // not equivalent to the existing typedef.  This is for a case like:
    //
    //      explain typedef char int32_t;
    //
    if ( !c_ast_equal( type_ast, raw_decl_ast ) ) {
      print_error( &decl_ast->loc, "type " );
      print_ast_type_aka( type_ast, stderr );
      EPUTS( " redefinition incompatible with original type " );
      print_ast_type_aka( decl_ast, stderr );
      EPUTC( '\n' );
      return NULL;
    }

    //
    // Because the raw_decl_ast for the existing type is about to be combined
    // with type_ast, duplicate raw_decl_ast first.
    //
    decl_ast = c_ast_dup_gc( raw_decl_ast );
  }

  c_ast_t *const ast = c_ast_patch_placeholder( type_ast, decl_ast );
  c_type_t const tdef_type = c_ast_take_type_any( ast, &T_TS_typedef );
  c_type_or_eq( &type, &tdef_type );
  c_type_or_eq( &ast->type, &type );

  if ( in_attr.align.kind != C_ALIGNAS_NONE ) {
    ast->align = in_attr.align;
    if ( c_tid_is_any( type.stids, TS_typedef ) ) {
      //
      // We check for illegal aligned typedef here rather than in c_ast_check.c
      // because the "typedef-ness" needed to be removed previously before the
      // eventual call to c_ast_check().
      //
      print_error( &ast->align.loc, "typedef can not be aligned\n" );
      return NULL;
    }
  }

  if ( ast->kind == K_UDEF_CONV &&
       c_sname_local_type( &ast->sname )->btids == TB_SCOPE ) {
    //
    // User-defined conversions don't have names, but they can still have a
    // scope.  Since only classes can have them, if the scope is still
    // TB_SCOPE, change it to TB_class.
    //
    c_sname_set_local_type( &ast->sname, &C_TYPE_LIT_B( TB_class ) );
  }

  return ast;
}

/**
 * Cleans up individial parse data after each parse.
 *
 * @param fatal_error Must be `true` only if a fatal semantic error has
 * occurred and `YYABORT` is about to be called to bail out of parsing by
 * returning from yyparse().
 */
static void parse_cleanup( bool fatal_error ) {
  //
  // We need to reset the lexer differently depending on whether we completed a
  // parse with a fatal error.  If so, do a "hard" reset that also resets the
  // EOF flag of the lexer.
  //
  lexer_reset( /*hard_reset=*/fatal_error );

  c_ast_list_cleanup_gc( &gc_ast_list );
  ia_cleanup();
}

/**
 * Creates a new \ref p_token_list_t containing a single #P_PLACEMARKER token.
 *
 * @return Returns said list.
 */
NODISCARD
static p_token_list_t* p_token_list_new_placemarker( void ) {
  p_token_list_t *const rv_tokens = MALLOC( p_token_list_t, 1 );
  slist_init( rv_tokens );
  slist_push_back( rv_tokens, p_token_new( P_PLACEMARKER, /*literal=*/NULL ) );
  return rv_tokens;
}

/**
 * Called by Bison to print a parsing error message to standard error.
 *
 * @remarks A custom error printing function via `%%define parse.error custom`
 * and
 * [`yyreport_syntax_error()`](https://www.gnu.org/software/bison/manual/html_node/Syntax-Error-Reporting-Function.html)
 * is not done because printing a (perhaps long) list of all the possible
 * expected tokens isn't helpful.
 * @par
 * It's also more flexible to be able to call one of #elaborate_error(),
 * #keyword_expected(), or #punct_expected() at the point of the error rather
 * than having a single function try to figure out the best type of error
 * message to print.
 *
 * @note A newline is _not_ printed since the error message will be appended to
 * by fl_elaborate_error().  For example, the parts of an error message are
 * printed by the functions shown:
 *
 *      42: syntax error: "int": "into" expected
 *      |--||----------||----------------------|
 *      |   |           |
 *      |   yyerror()   fl_elaborate_error()
 *      |
 *      print_loc()
 *
 * @param msg The error message to print.  Bison invariably passes `syntax
 * error`.
 *
 * @sa fl_elaborate_error()
 * @sa fl_keyword_expected()
 * @sa fl_punct_expected()
 * @sa print_loc()
 */
static void yyerror( char const *msg ) {
  assert( msg != NULL );

  c_loc_t const loc = lexer_loc();
  print_loc( &loc );

  color_start( stderr, sgr_error );
  EPUTS( msg );                         // no newline
  color_end( stderr, sgr_error );

  //
  // A syntax error has occurred, but syntax errors aren't fatal since Bison
  // tries to recover.  We'll clean-up the current parse, but YYABORT won't be
  // called so we won't bail out of parsing by returning from yyparse(); hence,
  // parsing will continue.
  //
  parse_cleanup( /*fatal_error=*/false );
}

/** @} */

///////////////////////////////////////////////////////////////////////////////

/// @cond DOXYGEN_IGNORE


#line 1239 "parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include  "parser.h" 
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_Y_cast = 3,                     /* Y_cast  */
  YYSYMBOL_Y_const_ENG = 4,                /* Y_const_ENG  */
  YYSYMBOL_Y_declare = 5,                  /* Y_declare  */
  YYSYMBOL_Y_define = 6,                   /* Y_define  */
  YYSYMBOL_Y_dynamic = 7,                  /* Y_dynamic  */
  YYSYMBOL_Y_explain = 8,                  /* Y_explain  */
  YYSYMBOL_Y_no = 9,                       /* Y_no  */
  YYSYMBOL_Y_quit = 10,                    /* Y_quit  */
  YYSYMBOL_Y_reinterpret = 11,             /* Y_reinterpret  */
  YYSYMBOL_Y_set = 12,                     /* Y_set  */
  YYSYMBOL_Y_show = 13,                    /* Y_show  */
  YYSYMBOL_Y_aligned = 14,                 /* Y_aligned  */
  YYSYMBOL_Y_all = 15,                     /* Y_all  */
  YYSYMBOL_Y_array = 16,                   /* Y_array  */
  YYSYMBOL_Y_as = 17,                      /* Y_as  */
  YYSYMBOL_Y_bit = 18,                     /* Y_bit  */
  YYSYMBOL_Y_bit_precise = 19,             /* Y_bit_precise  */
  YYSYMBOL_Y_bits = 20,                    /* Y_bits  */
  YYSYMBOL_Y_by = 21,                      /* Y_by  */
  YYSYMBOL_Y_bytes = 22,                   /* Y_bytes  */
  YYSYMBOL_Y_capturing = 23,               /* Y_capturing  */
  YYSYMBOL_Y_commands = 24,                /* Y_commands  */
  YYSYMBOL_Y_constructor = 25,             /* Y_constructor  */
  YYSYMBOL_Y_conversion = 26,              /* Y_conversion  */
  YYSYMBOL_Y_copy = 27,                    /* Y_copy  */
  YYSYMBOL_Y_defined = 28,                 /* Y_defined  */
  YYSYMBOL_Y_destructor = 29,              /* Y_destructor  */
  YYSYMBOL_Y_english = 30,                 /* Y_english  */
  YYSYMBOL_Y_evaluation = 31,              /* Y_evaluation  */
  YYSYMBOL_Y_expand = 32,                  /* Y_expand  */
  YYSYMBOL_Y_expression = 33,              /* Y_expression  */
  YYSYMBOL_Y_floating = 34,                /* Y_floating  */
  YYSYMBOL_Y_function = 35,                /* Y_function  */
  YYSYMBOL_Y_initialization = 36,          /* Y_initialization  */
  YYSYMBOL_Y_into = 37,                    /* Y_into  */
  YYSYMBOL_Y_lambda = 38,                  /* Y_lambda  */
  YYSYMBOL_Y_length = 39,                  /* Y_length  */
  YYSYMBOL_Y_linkage = 40,                 /* Y_linkage  */
  YYSYMBOL_Y_literal = 41,                 /* Y_literal  */
  YYSYMBOL_Y_macros = 42,                  /* Y_macros  */
  YYSYMBOL_Y_member = 43,                  /* Y_member  */
  YYSYMBOL_Y_non_empty = 44,               /* Y_non_empty  */
  YYSYMBOL_Y_non_member = 45,              /* Y_non_member  */
  YYSYMBOL_Y_of = 46,                      /* Y_of  */
  YYSYMBOL_Y_options = 47,                 /* Y_options  */
  YYSYMBOL_Y_point = 48,                   /* Y_point  */
  YYSYMBOL_Y_pointer = 49,                 /* Y_pointer  */
  YYSYMBOL_Y_precise = 50,                 /* Y_precise  */
  YYSYMBOL_Y_precision = 51,               /* Y_precision  */
  YYSYMBOL_Y_predefined = 52,              /* Y_predefined  */
  YYSYMBOL_Y_pure = 53,                    /* Y_pure  */
  YYSYMBOL_Y_reference = 54,               /* Y_reference  */
  YYSYMBOL_Y_returning = 55,               /* Y_returning  */
  YYSYMBOL_Y_rvalue = 56,                  /* Y_rvalue  */
  YYSYMBOL_Y_scope = 57,                   /* Y_scope  */
  YYSYMBOL_Y_to = 58,                      /* Y_to  */
  YYSYMBOL_Y_user = 59,                    /* Y_user  */
  YYSYMBOL_Y_user_defined = 60,            /* Y_user_defined  */
  YYSYMBOL_Y_variable = 61,                /* Y_variable  */
  YYSYMBOL_Y_wide = 62,                    /* Y_wide  */
  YYSYMBOL_Y_width = 63,                   /* Y_width  */
  YYSYMBOL_Y_PREC_LESS_THAN_upc_layout_qualifier = 64, /* Y_PREC_LESS_THAN_upc_layout_qualifier  */
  YYSYMBOL_Y_COLON_COLON = 65,             /* Y_COLON_COLON  */
  YYSYMBOL_66_ = 66,                       /* "::"  */
  YYSYMBOL_Y_COLON_COLON_STAR = 67,        /* Y_COLON_COLON_STAR  */
  YYSYMBOL_Y_PLUS_PLUS = 68,               /* "++"  */
  YYSYMBOL_Y_MINUS_MINUS = 69,             /* "--"  */
  YYSYMBOL_70_ = 70,                       /* '('  */
  YYSYMBOL_71_ = 71,                       /* ')'  */
  YYSYMBOL_72_ = 72,                       /* '['  */
  YYSYMBOL_73_ = 73,                       /* ']'  */
  YYSYMBOL_74_ = 74,                       /* '.'  */
  YYSYMBOL_Y_MINUS_GREATER = 75,           /* Y_MINUS_GREATER  */
  YYSYMBOL_76_ = 76,                       /* "->"  */
  YYSYMBOL_77_ = 77,                       /* '&'  */
  YYSYMBOL_78_ = 78,                       /* '*'  */
  YYSYMBOL_79_ = 79,                       /* '!'  */
  YYSYMBOL_Y_sizeof = 80,                  /* Y_sizeof  */
  YYSYMBOL_81_ = 81,                       /* '~'  */
  YYSYMBOL_Y_DOT_STAR = 82,                /* Y_DOT_STAR  */
  YYSYMBOL_83_ = 83,                       /* ".*"  */
  YYSYMBOL_Y_MINUS_GREATER_STAR = 84,      /* Y_MINUS_GREATER_STAR  */
  YYSYMBOL_85_ = 85,                       /* "->*"  */
  YYSYMBOL_86_ = 86,                       /* '/'  */
  YYSYMBOL_87_ = 87,                       /* '%'  */
  YYSYMBOL_88_ = 88,                       /* '-'  */
  YYSYMBOL_89_ = 89,                       /* '+'  */
  YYSYMBOL_Y_LESS_LESS = 90,               /* Y_LESS_LESS  */
  YYSYMBOL_91_ = 91,                       /* "<<"  */
  YYSYMBOL_Y_GREATER_GREATER = 92,         /* Y_GREATER_GREATER  */
  YYSYMBOL_93_ = 93,                       /* ">>"  */
  YYSYMBOL_Y_LESS_EQUAL_GREATER = 94,      /* Y_LESS_EQUAL_GREATER  */
  YYSYMBOL_95_ = 95,                       /* "<=>"  */
  YYSYMBOL_96_ = 96,                       /* '<'  */
  YYSYMBOL_97_ = 97,                       /* '>'  */
  YYSYMBOL_Y_LESS_EQUAL = 98,              /* Y_LESS_EQUAL  */
  YYSYMBOL_99_ = 99,                       /* "<="  */
  YYSYMBOL_Y_GREATER_EQUAL = 100,          /* Y_GREATER_EQUAL  */
  YYSYMBOL_101_ = 101,                     /* ">="  */
  YYSYMBOL_Y_EQUAL_EQUAL = 102,            /* Y_EQUAL_EQUAL  */
  YYSYMBOL_103_ = 103,                     /* "=="  */
  YYSYMBOL_Y_EXCLAM_EQUAL = 104,           /* Y_EXCLAM_EQUAL  */
  YYSYMBOL_Y_bit_and = 105,                /* Y_bit_and  */
  YYSYMBOL_106_ = 106,                     /* '^'  */
  YYSYMBOL_107_ = 107,                     /* '|'  */
  YYSYMBOL_Y_AMPER_AMPER = 108,            /* Y_AMPER_AMPER  */
  YYSYMBOL_Y_PIPE_PIPE = 109,              /* Y_PIPE_PIPE  */
  YYSYMBOL_Y_QMARK_COLON = 110,            /* Y_QMARK_COLON  */
  YYSYMBOL_111_ = 111,                     /* "?:"  */
  YYSYMBOL_112_ = 112,                     /* '='  */
  YYSYMBOL_Y_PERCENT_EQUAL = 113,          /* Y_PERCENT_EQUAL  */
  YYSYMBOL_114_ = 114,                     /* "%="  */
  YYSYMBOL_Y_AMPER_EQUAL = 115,            /* Y_AMPER_EQUAL  */
  YYSYMBOL_Y_STAR_EQUAL = 116,             /* Y_STAR_EQUAL  */
  YYSYMBOL_117_ = 117,                     /* "*="  */
  YYSYMBOL_Y_PLUS_EQUAL = 118,             /* Y_PLUS_EQUAL  */
  YYSYMBOL_119_ = 119,                     /* "+="  */
  YYSYMBOL_Y_MINUS_EQUAL = 120,            /* Y_MINUS_EQUAL  */
  YYSYMBOL_121_ = 121,                     /* "-="  */
  YYSYMBOL_Y_SLASH_EQUAL = 122,            /* Y_SLASH_EQUAL  */
  YYSYMBOL_123_ = 123,                     /* "/="  */
  YYSYMBOL_Y_LESS_LESS_EQUAL = 124,        /* Y_LESS_LESS_EQUAL  */
  YYSYMBOL_125_ = 125,                     /* "<<="  */
  YYSYMBOL_Y_GREATER_GREATER_EQUAL = 126,  /* Y_GREATER_GREATER_EQUAL  */
  YYSYMBOL_127_ = 127,                     /* ">>="  */
  YYSYMBOL_Y_CARET_EQUAL = 128,            /* Y_CARET_EQUAL  */
  YYSYMBOL_Y_PIPE_EQUAL = 129,             /* Y_PIPE_EQUAL  */
  YYSYMBOL_130_ = 130,                     /* ','  */
  YYSYMBOL_Y_auto_STORAGE = 131,           /* Y_auto_STORAGE  */
  YYSYMBOL_Y_break = 132,                  /* Y_break  */
  YYSYMBOL_Y_case = 133,                   /* Y_case  */
  YYSYMBOL_Y_char = 134,                   /* Y_char  */
  YYSYMBOL_Y_continue = 135,               /* Y_continue  */
  YYSYMBOL_Y_default = 136,                /* Y_default  */
  YYSYMBOL_Y_do = 137,                     /* Y_do  */
  YYSYMBOL_Y_double = 138,                 /* Y_double  */
  YYSYMBOL_Y_else = 139,                   /* Y_else  */
  YYSYMBOL_Y_extern = 140,                 /* Y_extern  */
  YYSYMBOL_Y_float = 141,                  /* Y_float  */
  YYSYMBOL_Y_for = 142,                    /* Y_for  */
  YYSYMBOL_Y_goto = 143,                   /* Y_goto  */
  YYSYMBOL_Y_if = 144,                     /* Y_if  */
  YYSYMBOL_Y_int = 145,                    /* Y_int  */
  YYSYMBOL_Y_long = 146,                   /* Y_long  */
  YYSYMBOL_Y_register = 147,               /* Y_register  */
  YYSYMBOL_Y_return = 148,                 /* Y_return  */
  YYSYMBOL_Y_short = 149,                  /* Y_short  */
  YYSYMBOL_Y_static = 150,                 /* Y_static  */
  YYSYMBOL_Y_struct = 151,                 /* Y_struct  */
  YYSYMBOL_Y_switch = 152,                 /* Y_switch  */
  YYSYMBOL_Y_typedef = 153,                /* Y_typedef  */
  YYSYMBOL_Y_union = 154,                  /* Y_union  */
  YYSYMBOL_Y_unsigned = 155,               /* Y_unsigned  */
  YYSYMBOL_Y_while = 156,                  /* Y_while  */
  YYSYMBOL_157_ = 157,                     /* '#'  */
  YYSYMBOL_PY_CONCAT = 158,                /* "##"  */
  YYSYMBOL_PY_SPACE = 159,                 /* PY_SPACE  */
  YYSYMBOL_PY_define = 160,                /* PY_define  */
  YYSYMBOL_PY_elif = 161,                  /* PY_elif  */
  YYSYMBOL_PY_else = 162,                  /* PY_else  */
  YYSYMBOL_PY_error = 163,                 /* PY_error  */
  YYSYMBOL_PY_if = 164,                    /* PY_if  */
  YYSYMBOL_PY_ifdef = 165,                 /* PY_ifdef  */
  YYSYMBOL_PY_ifndef = 166,                /* PY_ifndef  */
  YYSYMBOL_PY_line = 167,                  /* PY_line  */
  YYSYMBOL_PY_undef = 168,                 /* PY_undef  */
  YYSYMBOL_PY___VA_ARGS__ = 169,           /* PY___VA_ARGS__  */
  YYSYMBOL_PY___VA_OPT__ = 170,            /* PY___VA_OPT__  */
  YYSYMBOL_PY_pragma = 171,                /* PY_pragma  */
  YYSYMBOL_PY_elifdef = 172,               /* PY_elifdef  */
  YYSYMBOL_PY_elifndef = 173,              /* PY_elifndef  */
  YYSYMBOL_PY_embed = 174,                 /* PY_embed  */
  YYSYMBOL_PY_warning = 175,               /* PY_warning  */
  YYSYMBOL_Y_asm = 176,                    /* Y_asm  */
  YYSYMBOL_Y_const = 177,                  /* Y_const  */
  YYSYMBOL_Y_DOT_DOT_DOT = 178,            /* "..."  */
  YYSYMBOL_Y_enum = 179,                   /* Y_enum  */
  YYSYMBOL_Y_signed = 180,                 /* Y_signed  */
  YYSYMBOL_Y_void = 181,                   /* Y_void  */
  YYSYMBOL_Y_volatile = 182,               /* Y_volatile  */
  YYSYMBOL_Y_wchar_t = 183,                /* Y_wchar_t  */
  YYSYMBOL_Y__Bool = 184,                  /* Y__Bool  */
  YYSYMBOL_Y__Complex = 185,               /* Y__Complex  */
  YYSYMBOL_Y__Imaginary = 186,             /* Y__Imaginary  */
  YYSYMBOL_Y_inline = 187,                 /* Y_inline  */
  YYSYMBOL_Y_restrict = 188,               /* Y_restrict  */
  YYSYMBOL_Y__Alignas = 189,               /* Y__Alignas  */
  YYSYMBOL_Y__Alignof = 190,               /* Y__Alignof  */
  YYSYMBOL_Y__Atomic_QUAL = 191,           /* Y__Atomic_QUAL  */
  YYSYMBOL_Y__Atomic_SPEC = 192,           /* Y__Atomic_SPEC  */
  YYSYMBOL_Y__Generic = 193,               /* Y__Generic  */
  YYSYMBOL_Y__Noreturn = 194,              /* Y__Noreturn  */
  YYSYMBOL_Y__Static_assert = 195,         /* Y__Static_assert  */
  YYSYMBOL_Y__Thread_local = 196,          /* Y__Thread_local  */
  YYSYMBOL_Y_thread = 197,                 /* Y_thread  */
  YYSYMBOL_Y_local = 198,                  /* Y_local  */
  YYSYMBOL_Y_bool = 199,                   /* Y_bool  */
  YYSYMBOL_Y_catch = 200,                  /* Y_catch  */
  YYSYMBOL_Y_class = 201,                  /* Y_class  */
  YYSYMBOL_Y_const_cast = 202,             /* Y_const_cast  */
  YYSYMBOL_Y_CONSTRUCTOR_SNAME = 203,      /* Y_CONSTRUCTOR_SNAME  */
  YYSYMBOL_Y_delete = 204,                 /* Y_delete  */
  YYSYMBOL_Y_DESTRUCTOR_SNAME = 205,       /* Y_DESTRUCTOR_SNAME  */
  YYSYMBOL_Y_dynamic_cast = 206,           /* Y_dynamic_cast  */
  YYSYMBOL_Y_explicit = 207,               /* Y_explicit  */
  YYSYMBOL_Y_false = 208,                  /* Y_false  */
  YYSYMBOL_Y_friend = 209,                 /* Y_friend  */
  YYSYMBOL_Y_mutable = 210,                /* Y_mutable  */
  YYSYMBOL_Y_namespace = 211,              /* Y_namespace  */
  YYSYMBOL_Y_new = 212,                    /* Y_new  */
  YYSYMBOL_Y_operator = 213,               /* Y_operator  */
  YYSYMBOL_Y_OPERATOR_SNAME = 214,         /* Y_OPERATOR_SNAME  */
  YYSYMBOL_Y_private = 215,                /* Y_private  */
  YYSYMBOL_Y_protected = 216,              /* Y_protected  */
  YYSYMBOL_Y_public = 217,                 /* Y_public  */
  YYSYMBOL_Y_reinterpret_cast = 218,       /* Y_reinterpret_cast  */
  YYSYMBOL_Y_static_cast = 219,            /* Y_static_cast  */
  YYSYMBOL_Y_template = 220,               /* Y_template  */
  YYSYMBOL_Y_this = 221,                   /* Y_this  */
  YYSYMBOL_Y_throw = 222,                  /* Y_throw  */
  YYSYMBOL_Y_true = 223,                   /* Y_true  */
  YYSYMBOL_Y_try = 224,                    /* Y_try  */
  YYSYMBOL_Y_typeid = 225,                 /* Y_typeid  */
  YYSYMBOL_Y_typename = 226,               /* Y_typename  */
  YYSYMBOL_Y_using = 227,                  /* Y_using  */
  YYSYMBOL_Y_virtual = 228,                /* Y_virtual  */
  YYSYMBOL_Y_char16_t = 229,               /* Y_char16_t  */
  YYSYMBOL_Y_char32_t = 230,               /* Y_char32_t  */
  YYSYMBOL_Y__BitInt = 231,                /* Y__BitInt  */
  YYSYMBOL_Y_reproducible = 232,           /* Y_reproducible  */
  YYSYMBOL_Y_typeof = 233,                 /* Y_typeof  */
  YYSYMBOL_Y_typeof_unqual = 234,          /* Y_typeof_unqual  */
  YYSYMBOL_Y_unsequenced = 235,            /* Y_unsequenced  */
  YYSYMBOL_Y_ATTR_BEGIN = 236,             /* Y_ATTR_BEGIN  */
  YYSYMBOL_Y_alignas = 237,                /* Y_alignas  */
  YYSYMBOL_Y_alignof = 238,                /* Y_alignof  */
  YYSYMBOL_Y_auto_TYPE = 239,              /* Y_auto_TYPE  */
  YYSYMBOL_Y_carries = 240,                /* Y_carries  */
  YYSYMBOL_Y_dependency = 241,             /* Y_dependency  */
  YYSYMBOL_Y_carries_dependency = 242,     /* Y_carries_dependency  */
  YYSYMBOL_Y_constexpr = 243,              /* Y_constexpr  */
  YYSYMBOL_Y_decltype = 244,               /* Y_decltype  */
  YYSYMBOL_Y_except = 245,                 /* Y_except  */
  YYSYMBOL_Y_final = 246,                  /* Y_final  */
  YYSYMBOL_Y_noexcept = 247,               /* Y_noexcept  */
  YYSYMBOL_Y_nullptr = 248,                /* Y_nullptr  */
  YYSYMBOL_Y_override = 249,               /* Y_override  */
  YYSYMBOL_Y_static_assert = 250,          /* Y_static_assert  */
  YYSYMBOL_Y_thread_local = 251,           /* Y_thread_local  */
  YYSYMBOL_Y_deprecated = 252,             /* Y_deprecated  */
  YYSYMBOL_Y_discard = 253,                /* Y_discard  */
  YYSYMBOL_Y_maybe_unused = 254,           /* Y_maybe_unused  */
  YYSYMBOL_Y_maybe = 255,                  /* Y_maybe  */
  YYSYMBOL_Y_unused = 256,                 /* Y_unused  */
  YYSYMBOL_Y_nodiscard = 257,              /* Y_nodiscard  */
  YYSYMBOL_Y_noreturn = 258,               /* Y_noreturn  */
  YYSYMBOL_Y_char8_t = 259,                /* Y_char8_t  */
  YYSYMBOL_Y_concept = 260,                /* Y_concept  */
  YYSYMBOL_Y_consteval = 261,              /* Y_consteval  */
  YYSYMBOL_Y_constinit = 262,              /* Y_constinit  */
  YYSYMBOL_Y_co_await = 263,               /* Y_co_await  */
  YYSYMBOL_Y_co_return = 264,              /* Y_co_return  */
  YYSYMBOL_Y_co_yield = 265,               /* Y_co_yield  */
  YYSYMBOL_Y_export = 266,                 /* Y_export  */
  YYSYMBOL_Y_no_unique_address = 267,      /* Y_no_unique_address  */
  YYSYMBOL_Y_requires = 268,               /* Y_requires  */
  YYSYMBOL_Y_unique = 269,                 /* Y_unique  */
  YYSYMBOL_Y_address = 270,                /* Y_address  */
  YYSYMBOL_Y_EMC__Accum = 271,             /* Y_EMC__Accum  */
  YYSYMBOL_Y_EMC__Fract = 272,             /* Y_EMC__Fract  */
  YYSYMBOL_Y_EMC__Sat = 273,               /* Y_EMC__Sat  */
  YYSYMBOL_Y_UPC_relaxed = 274,            /* Y_UPC_relaxed  */
  YYSYMBOL_Y_UPC_shared = 275,             /* Y_UPC_shared  */
  YYSYMBOL_Y_UPC_strict = 276,             /* Y_UPC_strict  */
  YYSYMBOL_Y_GNU___attribute__ = 277,      /* Y_GNU___attribute__  */
  YYSYMBOL_Y_GNU___restrict = 278,         /* Y_GNU___restrict  */
  YYSYMBOL_Y_Apple___block = 279,          /* Y_Apple___block  */
  YYSYMBOL_Y_Apple_block = 280,            /* Y_Apple_block  */
  YYSYMBOL_Y_MSC___cdecl = 281,            /* Y_MSC___cdecl  */
  YYSYMBOL_Y_MSC___clrcall = 282,          /* Y_MSC___clrcall  */
  YYSYMBOL_Y_MSC___declspec = 283,         /* Y_MSC___declspec  */
  YYSYMBOL_Y_MSC___fastcall = 284,         /* Y_MSC___fastcall  */
  YYSYMBOL_Y_MSC___stdcall = 285,          /* Y_MSC___stdcall  */
  YYSYMBOL_Y_MSC___thiscall = 286,         /* Y_MSC___thiscall  */
  YYSYMBOL_Y_MSC___vectorcall = 287,       /* Y_MSC___vectorcall  */
  YYSYMBOL_288_ = 288,                     /* ':'  */
  YYSYMBOL_289_ = 289,                     /* ';'  */
  YYSYMBOL_290_ = 290,                     /* '{'  */
  YYSYMBOL_291_ = 291,                     /* '}'  */
  YYSYMBOL_Y_CHAR_LIT = 292,               /* Y_CHAR_LIT  */
  YYSYMBOL_Y_END = 293,                    /* Y_END  */
  YYSYMBOL_Y_ERROR = 294,                  /* Y_ERROR  */
  YYSYMBOL_Y_FLOAT_LIT = 295,              /* Y_FLOAT_LIT  */
  YYSYMBOL_Y_GLOB = 296,                   /* Y_GLOB  */
  YYSYMBOL_Y_INT_LIT = 297,                /* Y_INT_LIT  */
  YYSYMBOL_Y_NAME = 298,                   /* Y_NAME  */
  YYSYMBOL_Y_SET_OPTION = 299,             /* Y_SET_OPTION  */
  YYSYMBOL_Y_STR_LIT = 300,                /* Y_STR_LIT  */
  YYSYMBOL_Y_TYPEDEF_NAME = 301,           /* Y_TYPEDEF_NAME  */
  YYSYMBOL_Y_TYPEDEF_SNAME = 302,          /* Y_TYPEDEF_SNAME  */
  YYSYMBOL_Y_LEXER_ERROR = 303,            /* Y_LEXER_ERROR  */
  YYSYMBOL_304_ = 304,                     /* '$'  */
  YYSYMBOL_305_ = 305,                     /* '@'  */
  YYSYMBOL_306_ = 306,                     /* '`'  */
  YYSYMBOL_307_ = 307,                     /* '?'  */
  YYSYMBOL_YYACCEPT = 308,                 /* $accept  */
  YYSYMBOL_command_list = 309,             /* command_list  */
  YYSYMBOL_command = 310,                  /* command  */
  YYSYMBOL_cast_command = 311,             /* cast_command  */
  YYSYMBOL_new_style_cast_english = 312,   /* new_style_cast_english  */
  YYSYMBOL_declare_command = 313,          /* declare_command  */
  YYSYMBOL_314_1 = 314,                    /* $@1  */
  YYSYMBOL_alignas_or_width_decl_english_ast = 315, /* alignas_or_width_decl_english_ast  */
  YYSYMBOL_alignas_specifier_english = 316, /* alignas_specifier_english  */
  YYSYMBOL_aligned_english = 317,          /* aligned_english  */
  YYSYMBOL_capturing_paren_capture_decl_list_english_opt = 318, /* capturing_paren_capture_decl_list_english_opt  */
  YYSYMBOL_paren_capture_decl_list_english = 319, /* paren_capture_decl_list_english  */
  YYSYMBOL_capture_decl_list_english_opt = 320, /* capture_decl_list_english_opt  */
  YYSYMBOL_capture_decl_list_english = 321, /* capture_decl_list_english  */
  YYSYMBOL_capture_decl_english_ast = 322, /* capture_decl_english_ast  */
  YYSYMBOL_capture_default_opt = 323,      /* capture_default_opt  */
  YYSYMBOL_width_specifier_english_uint = 324, /* width_specifier_english_uint  */
  YYSYMBOL_storage_class_subset_english_type_opt = 325, /* storage_class_subset_english_type_opt  */
  YYSYMBOL_storage_class_subset_english_type = 326, /* storage_class_subset_english_type  */
  YYSYMBOL_storage_class_subset_english_stid = 327, /* storage_class_subset_english_stid  */
  YYSYMBOL_define_command = 328,           /* define_command  */
  YYSYMBOL_expand_command = 329,           /* expand_command  */
  YYSYMBOL_expand_command2 = 330,          /* expand_command2  */
  YYSYMBOL_p_extra_token_except_lparen = 331, /* p_extra_token_except_lparen  */
  YYSYMBOL_p_extra_tokens_opt = 332,       /* p_extra_tokens_opt  */
  YYSYMBOL_p_extra_tokens = 333,           /* p_extra_tokens  */
  YYSYMBOL_p_extra_token = 334,            /* p_extra_token  */
  YYSYMBOL_p_arg_list_opt = 335,           /* p_arg_list_opt  */
  YYSYMBOL_p_comma_arg_list = 336,         /* p_comma_arg_list  */
  YYSYMBOL_p_arg_list = 337,               /* p_arg_list  */
  YYSYMBOL_p_arg_tokens = 338,             /* p_arg_tokens  */
  YYSYMBOL_p_arg_token_as_list = 339,      /* p_arg_token_as_list  */
  YYSYMBOL_p_arg_token = 340,              /* p_arg_token  */
  YYSYMBOL_p_num_lit = 341,                /* p_num_lit  */
  YYSYMBOL_p_other = 342,                  /* p_other  */
  YYSYMBOL_p_punctuator = 343,             /* p_punctuator  */
  YYSYMBOL_p_arg_tokens_with_comma_opt = 344, /* p_arg_tokens_with_comma_opt  */
  YYSYMBOL_p_arg_tokens_with_comma = 345,  /* p_arg_tokens_with_comma  */
  YYSYMBOL_p_arg_token_with_comma_as_list = 346, /* p_arg_token_with_comma_as_list  */
  YYSYMBOL_p_arg_token_with_comma = 347,   /* p_arg_token_with_comma  */
  YYSYMBOL_explain_command = 348,          /* explain_command  */
  YYSYMBOL_349_2 = 349,                    /* $@2  */
  YYSYMBOL_explain = 350,                  /* explain  */
  YYSYMBOL_help_command = 351,             /* help_command  */
  YYSYMBOL_352_3 = 352,                    /* $@3  */
  YYSYMBOL_help_what_opt = 353,            /* help_what_opt  */
  YYSYMBOL_preprocessor_command = 354,     /* preprocessor_command  */
  YYSYMBOL_p_define = 355,                 /* p_define  */
  YYSYMBOL_p_paren_param_list_opt = 356,   /* p_paren_param_list_opt  */
  YYSYMBOL_p_param_list_opt = 357,         /* p_param_list_opt  */
  YYSYMBOL_p_param_list = 358,             /* p_param_list  */
  YYSYMBOL_p_param = 359,                  /* p_param  */
  YYSYMBOL_p_replace_list_opt = 360,       /* p_replace_list_opt  */
  YYSYMBOL_p_replace_list = 361,           /* p_replace_list  */
  YYSYMBOL_p_replace_token = 362,          /* p_replace_token  */
  YYSYMBOL_p_undef = 363,                  /* p_undef  */
  YYSYMBOL_quit_command = 364,             /* quit_command  */
  YYSYMBOL_scoped_command = 365,           /* scoped_command  */
  YYSYMBOL_set_command = 366,              /* set_command  */
  YYSYMBOL_set_option_list = 367,          /* set_option_list  */
  YYSYMBOL_set_option = 368,               /* set_option  */
  YYSYMBOL_set_option_value_opt = 369,     /* set_option_value_opt  */
  YYSYMBOL_show_command = 370,             /* show_command  */
  YYSYMBOL_show_format = 371,              /* show_format  */
  YYSYMBOL_show_format_exp = 372,          /* show_format_exp  */
  YYSYMBOL_show_format_opt = 373,          /* show_format_opt  */
  YYSYMBOL_show_types_opt = 374,           /* show_types_opt  */
  YYSYMBOL_predefined_or_user_types_opt = 375, /* predefined_or_user_types_opt  */
  YYSYMBOL_template_command = 376,         /* template_command  */
  YYSYMBOL_typedef_command = 377,          /* typedef_command  */
  YYSYMBOL_using_command = 378,            /* using_command  */
  YYSYMBOL_c_style_cast_expr_c = 379,      /* c_style_cast_expr_c  */
  YYSYMBOL_380_4 = 380,                    /* $@4  */
  YYSYMBOL_new_style_cast_expr_c = 381,    /* new_style_cast_expr_c  */
  YYSYMBOL_382_5 = 382,                    /* $@5  */
  YYSYMBOL_new_style_cast_c = 383,         /* new_style_cast_c  */
  YYSYMBOL_aligned_declaration_c = 384,    /* aligned_declaration_c  */
  YYSYMBOL_385_6 = 385,                    /* $@6  */
  YYSYMBOL_386_7 = 386,                    /* $@7  */
  YYSYMBOL_alignas_specifier_c = 387,      /* alignas_specifier_c  */
  YYSYMBOL_388_8 = 388,                    /* $@8  */
  YYSYMBOL_alignas = 389,                  /* alignas  */
  YYSYMBOL_asm_declaration_c = 390,        /* asm_declaration_c  */
  YYSYMBOL_scoped_declaration_c = 391,     /* scoped_declaration_c  */
  YYSYMBOL_class_struct_union_declaration_c = 392, /* class_struct_union_declaration_c  */
  YYSYMBOL_393_9 = 393,                    /* $@9  */
  YYSYMBOL_394_10 = 394,                   /* $@10  */
  YYSYMBOL_enum_declaration_c = 395,       /* enum_declaration_c  */
  YYSYMBOL_396_11 = 396,                   /* $@11  */
  YYSYMBOL_namespace_declaration_c = 397,  /* namespace_declaration_c  */
  YYSYMBOL_398_12 = 398,                   /* $@12  */
  YYSYMBOL_399_13 = 399,                   /* $@13  */
  YYSYMBOL_namespace_sname_c_exp = 400,    /* namespace_sname_c_exp  */
  YYSYMBOL_namespace_sname_c = 401,        /* namespace_sname_c  */
  YYSYMBOL_namespace_typedef_sname_c = 402, /* namespace_typedef_sname_c  */
  YYSYMBOL_brace_in_scope_declaration_c_exp = 403, /* brace_in_scope_declaration_c_exp  */
  YYSYMBOL_brace_in_scope_declaration_c_opt = 404, /* brace_in_scope_declaration_c_opt  */
  YYSYMBOL_brace_in_scope_declaration_c = 405, /* brace_in_scope_declaration_c  */
  YYSYMBOL_in_scope_declaration_c_exp = 406, /* in_scope_declaration_c_exp  */
  YYSYMBOL_lambda_declaration_c = 407,     /* lambda_declaration_c  */
  YYSYMBOL_capture_decl_list_c_opt = 408,  /* capture_decl_list_c_opt  */
  YYSYMBOL_capture_decl_list_c = 409,      /* capture_decl_list_c  */
  YYSYMBOL_capture_decl_c_ast = 410,       /* capture_decl_c_ast  */
  YYSYMBOL_lambda_param_c_ast_list_opt = 411, /* lambda_param_c_ast_list_opt  */
  YYSYMBOL_lambda_return_type_c_ast_opt = 412, /* lambda_return_type_c_ast_opt  */
  YYSYMBOL_413_14 = 413,                   /* $@14  */
  YYSYMBOL_template_declaration_c = 414,   /* template_declaration_c  */
  YYSYMBOL_typed_declaration_c = 415,      /* typed_declaration_c  */
  YYSYMBOL_416_15 = 416,                   /* $@15  */
  YYSYMBOL_typedef_declaration_c = 417,    /* typedef_declaration_c  */
  YYSYMBOL_418_16 = 418,                   /* $@16  */
  YYSYMBOL_419_17 = 419,                   /* $@17  */
  YYSYMBOL_typedef_decl_list_c = 420,      /* typedef_decl_list_c  */
  YYSYMBOL_typedef_decl_c = 421,           /* typedef_decl_c  */
  YYSYMBOL_typedef_decl_c_exp = 422,       /* typedef_decl_c_exp  */
  YYSYMBOL_user_defined_conversion_declaration_c = 423, /* user_defined_conversion_declaration_c  */
  YYSYMBOL_using_declaration_c = 424,      /* using_declaration_c  */
  YYSYMBOL_using_decl_c_ast = 425,         /* using_decl_c_ast  */
  YYSYMBOL_426_18 = 426,                   /* $@18  */
  YYSYMBOL_427_19 = 427,                   /* $@19  */
  YYSYMBOL_decl_list_c_opt = 428,          /* decl_list_c_opt  */
  YYSYMBOL_decl_list_c = 429,              /* decl_list_c  */
  YYSYMBOL_decl_c = 430,                   /* decl_c  */
  YYSYMBOL_decl_c_exp = 431,               /* decl_c_exp  */
  YYSYMBOL_decl_c_astp = 432,              /* decl_c_astp  */
  YYSYMBOL_msc_calling_convention_c_astp = 433, /* msc_calling_convention_c_astp  */
  YYSYMBOL_decl2_c_astp = 434,             /* decl2_c_astp  */
  YYSYMBOL_array_decl_c_astp = 435,        /* array_decl_c_astp  */
  YYSYMBOL_array_size_c_ast = 436,         /* array_size_c_ast  */
  YYSYMBOL_block_decl_c_astp = 437,        /* block_decl_c_astp  */
  YYSYMBOL_438_20 = 438,                   /* $@20  */
  YYSYMBOL_destructor_declaration_c = 439, /* destructor_declaration_c  */
  YYSYMBOL_no_destructor_params = 440,     /* no_destructor_params  */
  YYSYMBOL_file_scope_constructor_declaration_c = 441, /* file_scope_constructor_declaration_c  */
  YYSYMBOL_file_scope_destructor_declaration_c = 442, /* file_scope_destructor_declaration_c  */
  YYSYMBOL_func_decl_c_astp = 443,         /* func_decl_c_astp  */
  YYSYMBOL_pc99_func_or_constructor_declaration_c = 444, /* pc99_func_or_constructor_declaration_c  */
  YYSYMBOL_445_21 = 445,                   /* $@21  */
  YYSYMBOL_rparen_func_qualifier_list_c_stid_opt = 446, /* rparen_func_qualifier_list_c_stid_opt  */
  YYSYMBOL_447_22 = 447,                   /* $@22  */
  YYSYMBOL_func_qualifier_list_c_stid_opt = 448, /* func_qualifier_list_c_stid_opt  */
  YYSYMBOL_func_qualifier_c_stid = 449,    /* func_qualifier_c_stid  */
  YYSYMBOL_func_ref_qualifier_c_stid_opt = 450, /* func_ref_qualifier_c_stid_opt  */
  YYSYMBOL_noexcept_c_stid_opt = 451,      /* noexcept_c_stid_opt  */
  YYSYMBOL_noexcept_bool_stid_exp = 452,   /* noexcept_bool_stid_exp  */
  YYSYMBOL_trailing_return_type_c_ast_opt = 453, /* trailing_return_type_c_ast_opt  */
  YYSYMBOL_454_23 = 454,                   /* $@23  */
  YYSYMBOL_func_equals_c_stid_opt = 455,   /* func_equals_c_stid_opt  */
  YYSYMBOL_param_c_ast_list_exp = 456,     /* param_c_ast_list_exp  */
  YYSYMBOL_param_c_ast_list_opt = 457,     /* param_c_ast_list_opt  */
  YYSYMBOL_param_c_ast_list = 458,         /* param_c_ast_list  */
  YYSYMBOL_param_c_ast = 459,              /* param_c_ast  */
  YYSYMBOL_460_24 = 460,                   /* $@24  */
  YYSYMBOL_param_c_ast_exp = 461,          /* param_c_ast_exp  */
  YYSYMBOL_nested_decl_c_astp = 462,       /* nested_decl_c_astp  */
  YYSYMBOL_463_25 = 463,                   /* $@25  */
  YYSYMBOL_oper_decl_c_astp = 464,         /* oper_decl_c_astp  */
  YYSYMBOL_pointer_decl_c_astp = 465,      /* pointer_decl_c_astp  */
  YYSYMBOL_466_26 = 466,                   /* $@26  */
  YYSYMBOL_pointer_type_c_ast = 467,       /* pointer_type_c_ast  */
  YYSYMBOL_pc99_pointer_decl_list_c = 468, /* pc99_pointer_decl_list_c  */
  YYSYMBOL_pc99_pointer_decl_c = 469,      /* pc99_pointer_decl_c  */
  YYSYMBOL_470_27 = 470,                   /* $@27  */
  YYSYMBOL_pc99_pointer_type_c_ast = 471,  /* pc99_pointer_type_c_ast  */
  YYSYMBOL_pointer_to_member_decl_c_astp = 472, /* pointer_to_member_decl_c_astp  */
  YYSYMBOL_473_28 = 473,                   /* $@28  */
  YYSYMBOL_pointer_to_member_type_c_ast = 474, /* pointer_to_member_type_c_ast  */
  YYSYMBOL_reference_decl_c_astp = 475,    /* reference_decl_c_astp  */
  YYSYMBOL_476_29 = 476,                   /* $@29  */
  YYSYMBOL_reference_type_c_ast = 477,     /* reference_type_c_ast  */
  YYSYMBOL_typedef_type_decl_c_ast = 478,  /* typedef_type_decl_c_ast  */
  YYSYMBOL_user_defined_conversion_decl_c_astp = 479, /* user_defined_conversion_decl_c_astp  */
  YYSYMBOL_480_30 = 480,                   /* $@30  */
  YYSYMBOL_user_defined_literal_decl_c_astp = 481, /* user_defined_literal_decl_c_astp  */
  YYSYMBOL_cast_c_astp_opt = 482,          /* cast_c_astp_opt  */
  YYSYMBOL_cast_c_astp = 483,              /* cast_c_astp  */
  YYSYMBOL_cast2_c_astp = 484,             /* cast2_c_astp  */
  YYSYMBOL_array_cast_c_astp = 485,        /* array_cast_c_astp  */
  YYSYMBOL_block_cast_c_astp = 486,        /* block_cast_c_astp  */
  YYSYMBOL_487_31 = 487,                   /* $@31  */
  YYSYMBOL_func_cast_c_astp = 488,         /* func_cast_c_astp  */
  YYSYMBOL_nested_cast_c_astp = 489,       /* nested_cast_c_astp  */
  YYSYMBOL_490_32 = 490,                   /* $@32  */
  YYSYMBOL_pointer_cast_c_astp = 491,      /* pointer_cast_c_astp  */
  YYSYMBOL_492_33 = 492,                   /* $@33  */
  YYSYMBOL_pointer_to_member_cast_c_astp = 493, /* pointer_to_member_cast_c_astp  */
  YYSYMBOL_494_34 = 494,                   /* $@34  */
  YYSYMBOL_reference_cast_c_astp = 495,    /* reference_cast_c_astp  */
  YYSYMBOL_496_35 = 496,                   /* $@35  */
  YYSYMBOL_udc_decl_c_ast_opt = 497,       /* udc_decl_c_ast_opt  */
  YYSYMBOL_udc_decl_c_ast = 498,           /* udc_decl_c_ast  */
  YYSYMBOL_pointer_udc_decl_c_ast = 499,   /* pointer_udc_decl_c_ast  */
  YYSYMBOL_500_36 = 500,                   /* $@36  */
  YYSYMBOL_pointer_to_member_udc_decl_c_ast = 501, /* pointer_to_member_udc_decl_c_ast  */
  YYSYMBOL_502_37 = 502,                   /* $@37  */
  YYSYMBOL_reference_udc_decl_c_ast = 503, /* reference_udc_decl_c_ast  */
  YYSYMBOL_504_38 = 504,                   /* $@38  */
  YYSYMBOL_type_c_ast = 505,               /* type_c_ast  */
  YYSYMBOL_type_modifier_list_c_type_opt = 506, /* type_modifier_list_c_type_opt  */
  YYSYMBOL_type_modifier_list_c_type = 507, /* type_modifier_list_c_type  */
  YYSYMBOL_type_modifier_c_type = 508,     /* type_modifier_c_type  */
  YYSYMBOL_type_modifier_base_type = 509,  /* type_modifier_base_type  */
  YYSYMBOL_east_modified_type_c_ast = 510, /* east_modified_type_c_ast  */
  YYSYMBOL_atomic_builtin_typedef_type_c_ast = 511, /* atomic_builtin_typedef_type_c_ast  */
  YYSYMBOL_atomic_specifier_type_c_ast = 512, /* atomic_specifier_type_c_ast  */
  YYSYMBOL_513_39 = 513,                   /* $@39  */
  YYSYMBOL_builtin_type_c_ast = 514,       /* builtin_type_c_ast  */
  YYSYMBOL_builtin_no_BitInt_c_btid = 515, /* builtin_no_BitInt_c_btid  */
  YYSYMBOL_typeof_type_c_ast = 516,        /* typeof_type_c_ast  */
  YYSYMBOL_517_40 = 517,                   /* $@40  */
  YYSYMBOL_typeof = 518,                   /* typeof  */
  YYSYMBOL_enum_class_struct_union_c_ast = 519, /* enum_class_struct_union_c_ast  */
  YYSYMBOL_class_struct_union_c_ast = 520, /* class_struct_union_c_ast  */
  YYSYMBOL_enum_c_ast = 521,               /* enum_c_ast  */
  YYSYMBOL_enum_btids = 522,               /* enum_btids  */
  YYSYMBOL_enum_fixed_type_c_ast_opt = 523, /* enum_fixed_type_c_ast_opt  */
  YYSYMBOL_enum_fixed_type_c_ast = 524,    /* enum_fixed_type_c_ast  */
  YYSYMBOL_enum_fixed_type_modifier_list_btid_opt = 525, /* enum_fixed_type_modifier_list_btid_opt  */
  YYSYMBOL_enum_fixed_type_modifier_list_btid = 526, /* enum_fixed_type_modifier_list_btid  */
  YYSYMBOL_enum_fixed_type_modifier_btid = 527, /* enum_fixed_type_modifier_btid  */
  YYSYMBOL_enum_unmodified_fixed_type_c_ast = 528, /* enum_unmodified_fixed_type_c_ast  */
  YYSYMBOL_class_struct_btid_opt = 529,    /* class_struct_btid_opt  */
  YYSYMBOL_class_struct_btid = 530,        /* class_struct_btid  */
  YYSYMBOL_class_struct_union_btid = 531,  /* class_struct_union_btid  */
  YYSYMBOL_type_qualifier_list_c_stid_opt = 532, /* type_qualifier_list_c_stid_opt  */
  YYSYMBOL_type_qualifier_list_c_stid = 533, /* type_qualifier_list_c_stid  */
  YYSYMBOL_type_qualifier_c_stid = 534,    /* type_qualifier_c_stid  */
  YYSYMBOL_cv_qualifier_stid = 535,        /* cv_qualifier_stid  */
  YYSYMBOL_cv_qualifier_list_stid_opt = 536, /* cv_qualifier_list_stid_opt  */
  YYSYMBOL_restrict_qualifier_c_stid = 537, /* restrict_qualifier_c_stid  */
  YYSYMBOL_upc_layout_qualifier_c = 538,   /* upc_layout_qualifier_c  */
  YYSYMBOL_storage_class_c_type = 539,     /* storage_class_c_type  */
  YYSYMBOL__Noreturn_atid = 540,           /* _Noreturn_atid  */
  YYSYMBOL_attribute_specifier_list_c_atid_opt = 541, /* attribute_specifier_list_c_atid_opt  */
  YYSYMBOL_attribute_specifier_list_c_atid = 542, /* attribute_specifier_list_c_atid  */
  YYSYMBOL_543_41 = 543,                   /* $@41  */
  YYSYMBOL_using_opt = 544,                /* using_opt  */
  YYSYMBOL_attribute_list_c_atid_opt = 545, /* attribute_list_c_atid_opt  */
  YYSYMBOL_attribute_list_c_atid = 546,    /* attribute_list_c_atid  */
  YYSYMBOL_attribute_c_atid_exp = 547,     /* attribute_c_atid_exp  */
  YYSYMBOL_attribute_str_arg_c_opt = 548,  /* attribute_str_arg_c_opt  */
  YYSYMBOL_gnu_or_msc_attribute_specifier_list_c_opt = 549, /* gnu_or_msc_attribute_specifier_list_c_opt  */
  YYSYMBOL_gnu_or_msc_attribute_specifier_list_c = 550, /* gnu_or_msc_attribute_specifier_list_c  */
  YYSYMBOL_gnu_attribute_specifier_list_c_opt = 551, /* gnu_attribute_specifier_list_c_opt  */
  YYSYMBOL_gnu_attribute_specifier_list_c = 552, /* gnu_attribute_specifier_list_c  */
  YYSYMBOL_gnu_attribute_specifier_c = 553, /* gnu_attribute_specifier_c  */
  YYSYMBOL_554_42 = 554,                   /* $@42  */
  YYSYMBOL_gnu_attribute_list_c_opt = 555, /* gnu_attribute_list_c_opt  */
  YYSYMBOL_gnu_attribuet_list_c = 556,     /* gnu_attribuet_list_c  */
  YYSYMBOL_gnu_attribute_c_exp = 557,      /* gnu_attribute_c_exp  */
  YYSYMBOL_gnu_attribute_decl_arg_list_c_opt = 558, /* gnu_attribute_decl_arg_list_c_opt  */
  YYSYMBOL_gnu_attribute_arg_list_c_opt = 559, /* gnu_attribute_arg_list_c_opt  */
  YYSYMBOL_gnu_attribute_arg_list_c = 560, /* gnu_attribute_arg_list_c  */
  YYSYMBOL_gnu_attribute_arg_c = 561,      /* gnu_attribute_arg_c  */
  YYSYMBOL_msc_attribute_specifier_list_c = 562, /* msc_attribute_specifier_list_c  */
  YYSYMBOL_msc_attribute_specifier_c = 563, /* msc_attribute_specifier_c  */
  YYSYMBOL_564_43 = 564,                   /* $@43  */
  YYSYMBOL_msc_attribute_list_c_opt = 565, /* msc_attribute_list_c_opt  */
  YYSYMBOL_msc_attribuet_list_c = 566,     /* msc_attribuet_list_c  */
  YYSYMBOL_decl_english_ast = 567,         /* decl_english_ast  */
  YYSYMBOL_array_decl_english_ast = 568,   /* array_decl_english_ast  */
  YYSYMBOL_array_size_decl_ast = 569,      /* array_size_decl_ast  */
  YYSYMBOL_length_opt = 570,               /* length_opt  */
  YYSYMBOL_block_decl_english_ast = 571,   /* block_decl_english_ast  */
  YYSYMBOL_constructor_decl_english_ast = 572, /* constructor_decl_english_ast  */
  YYSYMBOL_destructor_decl_english_ast = 573, /* destructor_decl_english_ast  */
  YYSYMBOL_destructor_parens_opt = 574,    /* destructor_parens_opt  */
  YYSYMBOL_func_decl_english_ast = 575,    /* func_decl_english_ast  */
  YYSYMBOL_func_qualifier_english_type_opt = 576, /* func_qualifier_english_type_opt  */
  YYSYMBOL_msc_calling_convention_atid = 577, /* msc_calling_convention_atid  */
  YYSYMBOL_paren_param_decl_list_english_opt = 578, /* paren_param_decl_list_english_opt  */
  YYSYMBOL_paren_param_decl_list_english = 579, /* paren_param_decl_list_english  */
  YYSYMBOL_param_decl_list_english_opt = 580, /* param_decl_list_english_opt  */
  YYSYMBOL_param_decl_list_english = 581,  /* param_decl_list_english  */
  YYSYMBOL_decl_english_ast_exp = 582,     /* decl_english_ast_exp  */
  YYSYMBOL_ref_qualifier_english_stid_opt = 583, /* ref_qualifier_english_stid_opt  */
  YYSYMBOL_returning_english_ast_opt = 584, /* returning_english_ast_opt  */
  YYSYMBOL_returning_english_ast = 585,    /* returning_english_ast  */
  YYSYMBOL_qualified_decl_english_ast = 586, /* qualified_decl_english_ast  */
  YYSYMBOL_type_qualifier_list_english_type_opt = 587, /* type_qualifier_list_english_type_opt  */
  YYSYMBOL_type_qualifier_list_english_type = 588, /* type_qualifier_list_english_type  */
  YYSYMBOL_type_qualifier_english_type = 589, /* type_qualifier_english_type  */
  YYSYMBOL_attribute_english_atid = 590,   /* attribute_english_atid  */
  YYSYMBOL_storage_class_english_stid = 591, /* storage_class_english_stid  */
  YYSYMBOL_eval_expr_init_stid = 592,      /* eval_expr_init_stid  */
  YYSYMBOL_linkage_stid = 593,             /* linkage_stid  */
  YYSYMBOL_linkage_opt = 594,              /* linkage_opt  */
  YYSYMBOL_type_qualifier_english_stid = 595, /* type_qualifier_english_stid  */
  YYSYMBOL_upc_layout_qualifier_english = 596, /* upc_layout_qualifier_english  */
  YYSYMBOL_qualifiable_decl_english_ast = 597, /* qualifiable_decl_english_ast  */
  YYSYMBOL_pointer_decl_english_ast = 598, /* pointer_decl_english_ast  */
  YYSYMBOL_reference_decl_english_ast = 599, /* reference_decl_english_ast  */
  YYSYMBOL_reference_english_ast = 600,    /* reference_english_ast  */
  YYSYMBOL_user_defined_literal_decl_english_ast = 601, /* user_defined_literal_decl_english_ast  */
  YYSYMBOL_var_decl_english_ast = 602,     /* var_decl_english_ast  */
  YYSYMBOL_type_english_ast = 603,         /* type_english_ast  */
  YYSYMBOL_type_modifier_list_english_type_opt = 604, /* type_modifier_list_english_type_opt  */
  YYSYMBOL_type_modifier_list_english_type = 605, /* type_modifier_list_english_type  */
  YYSYMBOL_type_modifier_english_type = 606, /* type_modifier_english_type  */
  YYSYMBOL_unmodified_type_english_ast = 607, /* unmodified_type_english_ast  */
  YYSYMBOL_builtin_type_english_ast = 608, /* builtin_type_english_ast  */
  YYSYMBOL_builtin_no_BitInt_english_btid = 609, /* builtin_no_BitInt_english_btid  */
  YYSYMBOL_BitInt_english_int = 610,       /* BitInt_english_int  */
  YYSYMBOL_BitInt_english = 611,           /* BitInt_english  */
  YYSYMBOL_precise_opt = 612,              /* precise_opt  */
  YYSYMBOL_class_struct_union_english_ast = 613, /* class_struct_union_english_ast  */
  YYSYMBOL_enum_english_ast = 614,         /* enum_english_ast  */
  YYSYMBOL_of_type_enum_fixed_type_english_ast_opt = 615, /* of_type_enum_fixed_type_english_ast_opt  */
  YYSYMBOL_enum_fixed_type_english_ast = 616, /* enum_fixed_type_english_ast  */
  YYSYMBOL_enum_fixed_type_modifier_list_english_btid_opt = 617, /* enum_fixed_type_modifier_list_english_btid_opt  */
  YYSYMBOL_enum_fixed_type_modifier_list_english_btid = 618, /* enum_fixed_type_modifier_list_english_btid  */
  YYSYMBOL_enum_unmodified_fixed_type_english_ast = 619, /* enum_unmodified_fixed_type_english_ast  */
  YYSYMBOL_any_name = 620,                 /* any_name  */
  YYSYMBOL_any_name_exp = 621,             /* any_name_exp  */
  YYSYMBOL_any_sname_c = 622,              /* any_sname_c  */
  YYSYMBOL_any_sname_c_exp = 623,          /* any_sname_c_exp  */
  YYSYMBOL_any_sname_c_opt = 624,          /* any_sname_c_opt  */
  YYSYMBOL_any_typedef = 625,              /* any_typedef  */
  YYSYMBOL_name_ast = 626,                 /* name_ast  */
  YYSYMBOL_name_exp = 627,                 /* name_exp  */
  YYSYMBOL_name_cat = 628,                 /* name_cat  */
  YYSYMBOL_name_opt = 629,                 /* name_opt  */
  YYSYMBOL_oper_sname_c_opt = 630,         /* oper_sname_c_opt  */
  YYSYMBOL_typedef_type_c_ast = 631,       /* typedef_type_c_ast  */
  YYSYMBOL_sub_scope_sname_c_opt = 632,    /* sub_scope_sname_c_opt  */
  YYSYMBOL_sname_c = 633,                  /* sname_c  */
  YYSYMBOL_sname_c_ast = 634,              /* sname_c_ast  */
  YYSYMBOL_bit_field_c_uint_opt = 635,     /* bit_field_c_uint_opt  */
  YYSYMBOL_sname_c_exp = 636,              /* sname_c_exp  */
  YYSYMBOL_sname_c_opt = 637,              /* sname_c_opt  */
  YYSYMBOL_sname_english = 638,            /* sname_english  */
  YYSYMBOL_sname_english_ast = 639,        /* sname_english_ast  */
  YYSYMBOL_sname_english_exp = 640,        /* sname_english_exp  */
  YYSYMBOL_sname_english_opt = 641,        /* sname_english_opt  */
  YYSYMBOL_sname_list_english = 642,       /* sname_list_english  */
  YYSYMBOL_typedef_sname_c = 643,          /* typedef_sname_c  */
  YYSYMBOL_address_exp = 644,              /* address_exp  */
  YYSYMBOL_array_exp = 645,                /* array_exp  */
  YYSYMBOL_as_exp = 646,                   /* as_exp  */
  YYSYMBOL_as_into_to_exp = 647,           /* as_into_to_exp  */
  YYSYMBOL_as_or_to_opt = 648,             /* as_or_to_opt  */
  YYSYMBOL_bits_opt = 649,                 /* bits_opt  */
  YYSYMBOL_bytes_opt = 650,                /* bytes_opt  */
  YYSYMBOL_cast_exp = 651,                 /* cast_exp  */
  YYSYMBOL_char_exp = 652,                 /* char_exp  */
  YYSYMBOL_class_struct_union_btid_exp = 653, /* class_struct_union_btid_exp  */
  YYSYMBOL_colon_exp = 654,                /* colon_exp  */
  YYSYMBOL_comma_exp = 655,                /* comma_exp  */
  YYSYMBOL_conversion_exp = 656,           /* conversion_exp  */
  YYSYMBOL_c_operator = 657,               /* c_operator  */
  YYSYMBOL_default_exp = 658,              /* default_exp  */
  YYSYMBOL_defined_exp = 659,              /* defined_exp  */
  YYSYMBOL_dependency_exp = 660,           /* dependency_exp  */
  YYSYMBOL_destructor_sname = 661,         /* destructor_sname  */
  YYSYMBOL_empty_str_lit_exp = 662,        /* empty_str_lit_exp  */
  YYSYMBOL_equals_exp = 663,               /* equals_exp  */
  YYSYMBOL_extern_linkage_c_stid = 664,    /* extern_linkage_c_stid  */
  YYSYMBOL_extern_linkage_c_stid_opt = 665, /* extern_linkage_c_stid_opt  */
  YYSYMBOL_glob = 666,                     /* glob  */
  YYSYMBOL_glob_opt = 667,                 /* glob_opt  */
  YYSYMBOL_gt_exp = 668,                   /* gt_exp  */
  YYSYMBOL_inline_stid_opt = 669,          /* inline_stid_opt  */
  YYSYMBOL_int_exp = 670,                  /* int_exp  */
  YYSYMBOL_literal_exp = 671,              /* literal_exp  */
  YYSYMBOL_local_exp = 672,                /* local_exp  */
  YYSYMBOL_lparen_exp = 673,               /* lparen_exp  */
  YYSYMBOL_lt_exp = 674,                   /* lt_exp  */
  YYSYMBOL_member_or_non_member_opt = 675, /* member_or_non_member_opt  */
  YYSYMBOL_namespace_btid_exp = 676,       /* namespace_btid_exp  */
  YYSYMBOL_namespace_type = 677,           /* namespace_type  */
  YYSYMBOL_of_exp = 678,                   /* of_exp  */
  YYSYMBOL_of_scope_english = 679,         /* of_scope_english  */
  YYSYMBOL_of_scope_list_english = 680,    /* of_scope_list_english  */
  YYSYMBOL_of_scope_list_english_opt = 681, /* of_scope_list_english_opt  */
  YYSYMBOL_operator_exp = 682,             /* operator_exp  */
  YYSYMBOL_operator_opt = 683,             /* operator_opt  */
  YYSYMBOL_point_exp = 684,                /* point_exp  */
  YYSYMBOL_precision_opt = 685,            /* precision_opt  */
  YYSYMBOL_rbrace_exp = 686,               /* rbrace_exp  */
  YYSYMBOL_rbracket_exp = 687,             /* rbracket_exp  */
  YYSYMBOL_reference_exp = 688,            /* reference_exp  */
  YYSYMBOL_returning = 689,                /* returning  */
  YYSYMBOL_returning_exp = 690,            /* returning_exp  */
  YYSYMBOL_rparen_exp = 691,               /* rparen_exp  */
  YYSYMBOL_scope_english_type = 692,       /* scope_english_type  */
  YYSYMBOL_scope_english_type_exp = 693,   /* scope_english_type_exp  */
  YYSYMBOL_semi_exp = 694,                 /* semi_exp  */
  YYSYMBOL_semi_opt = 695,                 /* semi_opt  */
  YYSYMBOL_semi_or_end = 696,              /* semi_or_end  */
  YYSYMBOL_static_stid_opt = 697,          /* static_stid_opt  */
  YYSYMBOL_str_lit = 698,                  /* str_lit  */
  YYSYMBOL_str_lit_exp = 699,              /* str_lit_exp  */
  YYSYMBOL_this_exp = 700,                 /* this_exp  */
  YYSYMBOL_this_stid_opt = 701,            /* this_stid_opt  */
  YYSYMBOL_to_exp = 702,                   /* to_exp  */
  YYSYMBOL_type_opt = 703,                 /* type_opt  */
  YYSYMBOL_typename_flag_opt = 704,        /* typename_flag_opt  */
  YYSYMBOL_uint_lit = 705,                 /* uint_lit  */
  YYSYMBOL_uint_lit_exp = 706,             /* uint_lit_exp  */
  YYSYMBOL_uint_lit_opt = 707,             /* uint_lit_opt  */
  YYSYMBOL_unused_exp = 708,               /* unused_exp  */
  YYSYMBOL_user_defined = 709,             /* user_defined  */
  YYSYMBOL_virtual_stid_exp = 710,         /* virtual_stid_exp  */
  YYSYMBOL_virtual_stid_opt = 711          /* virtual_stid_opt  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   6287

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  308
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  404
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1084
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1428

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   534


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    79,     2,   157,   304,    87,    77,     2,
      70,    71,    78,    89,   130,    88,    74,    86,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   288,   289,
      96,   112,    97,   307,   305,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    72,     2,    73,   106,     2,   306,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   290,   107,   291,    81,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    75,    76,    80,    82,    83,
      84,    85,    90,    91,    92,    93,    94,    95,    98,    99,
     100,   101,   102,   103,   104,   105,   108,   109,   110,   111,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1861,  1861,  1862,  1871,  1872,  1873,  1874,  1875,  1876,
    1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,
    1905,  1927,  1951,  1952,  1953,  1954,  1955,  1964,  2042,  2041,
    2105,  2140,  2172,  2182,  2184,  2199,  2229,  2235,  2241,  2250,
    2251,  2252,  2256,  2257,  2261,  2268,  2272,  2276,  2284,  2285,
    2289,  2304,  2319,  2324,  2329,  2335,  2339,  2340,  2341,  2345,
    2359,  2360,  2378,  2379,  2400,  2404,  2405,  2406,  2407,  2408,
    2409,  2410,  2411,  2412,  2413,  2414,  2415,  2416,  2417,  2418,
    2419,  2425,  2475,  2496,  2503,  2518,  2530,  2538,  2539,  2546,
    2547,  2551,  2556,  2565,  2566,  2574,  2579,  2591,  2611,  2631,
    2653,  2660,  2668,  2673,  2692,  2704,  2713,  2718,  2722,  2728,
    2737,  2741,  2745,  2749,  2753,  2757,  2761,  2768,  2769,  2773,
    2774,  2775,  2779,  2780,  2781,  2782,  2785,  2786,  2788,  2789,
    2790,  2791,  2792,  2793,  2794,  2795,  2796,  2797,  2798,  2799,
    2800,  2801,  2802,  2803,  2804,  2805,  2806,  2807,  2808,  2809,
    2810,  2811,  2812,  2813,  2814,  2815,  2816,  2817,  2818,  2819,
    2820,  2821,  2822,  2823,  2824,  2825,  2826,  2827,  2828,  2829,
    2834,  2838,  2852,  2858,  2862,  2868,  2877,  2878,  2890,  2895,
    2900,  2905,  2910,  2915,  2920,  2925,  2930,  2935,  2945,  2954,
    2964,  2964,  2979,  2984,  3007,  3014,  3021,  3039,  3038,  3057,
    3058,  3059,  3060,  3065,  3077,  3078,  3080,  3082,  3087,  3092,
    3097,  3102,  3107,  3112,  3117,  3122,  3127,  3132,  3137,  3142,
    3149,  3190,  3191,  3195,  3205,  3209,  3222,  3237,  3242,  3247,
    3258,  3259,  3263,  3269,  3278,  3289,  3293,  3297,  3301,  3305,
    3309,  3316,  3325,  3331,  3337,  3341,  3345,  3346,  3350,  3360,
    3361,  3362,  3372,  3382,  3392,  3398,  3404,  3409,  3437,  3446,
    3447,  3448,  3462,  3463,  3473,  3474,  3478,  3479,  3483,  3484,
    3489,  3492,  3493,  3499,  3505,  3511,  3522,  3521,  3558,  3569,
    3568,  3600,  3601,  3602,  3603,  3613,  3614,  3613,  3619,  3632,
    3632,  3650,  3657,  3658,  3664,  3675,  3676,  3677,  3685,  3690,
    3684,  3739,  3738,  3780,  3784,  3779,  3847,  3848,  3849,  3862,
    3876,  3891,  3907,  3926,  3940,  3956,  3974,  3978,  3979,  3986,
    3987,  3991,  3992,  3996,  3997,  3998,  3999,  4008,  4040,  4041,
    4045,  4061,  4076,  4081,  4087,  4092,  4097,  4102,  4110,  4111,
    4115,  4116,  4116,  4136,  4146,  4146,  4156,  4162,  4155,  4177,
    4178,  4183,  4247,  4248,  4257,  4273,  4284,  4305,  4283,  4369,
    4417,  4425,  4430,  4439,  4467,  4468,  4475,  4476,  4477,  4478,
    4479,  4488,  4489,  4493,  4494,  4495,  4496,  4497,  4498,  4502,
    4506,  4507,  4514,  4549,  4554,  4560,  4566,  4572,  4580,  4588,
    4594,  4603,  4612,  4623,  4622,  4675,  4725,  4726,  4753,  4790,
    4832,  4969,  4968,  5078,  5077,  5096,  5097,  5113,  5114,  5115,
    5123,  5127,  5128,  5129,  5133,  5134,  5135,  5139,  5143,  5160,
    5161,  5162,  5169,  5171,  5171,  5223,  5230,  5231,  5232,  5233,
    5241,  5253,  5254,  5262,  5263,  5267,  5280,  5298,  5297,  5332,
    5337,  5349,  5350,  5360,  5359,  5384,  5440,  5440,  5460,  5480,
    5485,  5493,  5493,  5513,  5553,  5553,  5573,  5612,  5612,  5631,
    5649,  5671,  5769,  5768,  5814,  5859,  5860,  5864,  5865,  5866,
    5867,  5871,  5872,  5873,  5874,  5876,  5886,  5924,  5923,  5973,
    6048,  6047,  6090,  6090,  6112,  6112,  6135,  6135,  6164,  6165,
    6169,  6170,  6171,  6172,  6176,  6176,  6194,  6194,  6212,  6212,
    6239,  6274,  6289,  6293,  6294,  6298,  6312,  6316,  6340,  6341,
    6342,  6349,  6350,  6351,  6352,  6353,  6354,  6355,  6361,  6365,
    6382,  6400,  6401,  6402,  6403,  6410,  6409,  6457,  6468,  6483,
    6484,  6485,  6486,  6487,  6488,  6489,  6490,  6491,  6492,  6493,
    6494,  6495,  6496,  6501,  6500,  6542,  6551,  6552,  6558,  6559,
    6563,  6582,  6594,  6615,  6629,  6633,  6634,  6635,  6651,  6669,
    6695,  6714,  6715,  6719,  6735,  6739,  6740,  6741,  6742,  6746,
    6747,  6748,  6754,  6755,  6759,  6760,  6764,  6765,  6771,  6772,
    6776,  6791,  6796,  6803,  6804,  6805,  6806,  6807,  6808,  6809,
    6813,  6814,  6818,  6819,  6835,  6849,  6853,  6854,  6855,  6856,
    6865,  6866,  6867,  6868,  6869,  6870,  6871,  6872,  6873,  6874,
    6875,  6876,  6877,  6878,  6907,  6909,  6910,  6911,  6912,  6913,
    6917,  6918,  6924,  6925,  6930,  6929,  6954,  6961,  6962,  6970,
    6971,  6975,  6989,  6993,  6994,  6995,  6996,  6997,  6998,  6999,
    7000,  7001,  7032,  7039,  7040,  7048,  7049,  7053,  7054,  7058,
    7059,  7063,  7064,  7069,  7068,  7084,  7085,  7089,  7090,  7094,
    7098,  7105,  7106,  7110,  7111,  7115,  7116,  7120,  7121,  7122,
    7123,  7124,  7125,  7132,  7133,  7138,  7137,  7150,  7151,  7162,
    7163,  7171,  7172,  7173,  7179,  7194,  7218,  7222,  7228,  7234,
    7242,  7243,  7250,  7272,  7290,  7302,  7303,  7310,  7337,  7341,
    7348,  7349,  7350,  7351,  7352,  7353,  7359,  7360,  7364,  7378,
    7379,  7383,  7398,  7415,  7416,  7425,  7426,  7427,  7434,  7445,
    7449,  7460,  7469,  7489,  7490,  7494,  7510,  7514,  7515,  7516,
    7520,  7521,  7522,  7523,  7524,  7525,  7526,  7527,  7528,  7529,
    7530,  7531,  7532,  7533,  7537,  7538,  7539,  7543,  7544,  7545,
    7546,  7547,  7548,  7549,  7550,  7551,  7555,  7556,  7557,  7558,
    7559,  7560,  7561,  7562,  7564,  7565,  7566,  7567,  7568,  7569,
    7570,  7571,  7572,  7576,  7577,  7578,  7589,  7609,  7610,  7614,
    7615,  7616,  7617,  7618,  7619,  7620,  7624,  7625,  7629,  7630,
    7631,  7632,  7633,  7634,  7635,  7636,  7646,  7668,  7688,  7701,
    7718,  7723,  7732,  7773,  7797,  7802,  7819,  7841,  7861,  7862,
    7866,  7882,  7886,  7890,  7891,  7892,  7893,  7897,  7909,  7924,
    7925,  7926,  7927,  7928,  7940,  7941,  7942,  7943,  7944,  7945,
    7946,  7947,  7948,  7949,  7950,  7954,  7958,  7962,  7966,  7973,
    7974,  7975,  7979,  7980,  7984,  8001,  8022,  8023,  8030,  8048,
    8063,  8064,  8068,  8084,  8088,  8089,  8097,  8098,  8106,  8107,
    8115,  8116,  8120,  8121,  8129,  8130,  8134,  8135,  8139,  8153,
    8154,  8162,  8167,  8171,  8172,  8176,  8178,  8187,  8248,  8249,
    8256,  8281,  8303,  8317,  8337,  8338,  8352,  8353,  8361,  8362,
    8366,  8385,  8414,  8415,  8423,  8424,  8428,  8444,  8460,  8479,
    8501,  8509,  8510,  8517,  8518,  8525,  8545,  8552,  8553,  8554,
    8555,  8562,  8563,  8564,  8568,  8569,  8570,  8574,  8575,  8579,
    8580,  8587,  8588,  8595,  8596,  8603,  8604,  8611,  8612,  8619,
    8620,  8627,  8628,  8629,  8630,  8631,  8632,  8633,  8634,  8635,
    8636,  8637,  8638,  8639,  8640,  8641,  8642,  8643,  8644,  8645,
    8646,  8647,  8648,  8649,  8650,  8651,  8652,  8653,  8654,  8655,
    8656,  8657,  8658,  8659,  8660,  8661,  8662,  8663,  8664,  8665,
    8666,  8667,  8668,  8669,  8670,  8671,  8672,  8673,  8674,  8678,
    8679,  8686,  8687,  8694,  8695,  8702,  8703,  8711,  8726,  8727,
    8734,  8735,  8743,  8744,  8748,  8763,  8764,  8768,  8769,  8776,
    8777,  8781,  8782,  8789,  8790,  8797,  8798,  8805,  8806,  8813,
    8814,  8821,  8822,  8823,  8827,  8828,  8835,  8836,  8840,  8841,
    8848,  8871,  8882,  8886,  8887,  8891,  8892,  8899,  8900,  8904,
    8905,  8911,  8912,  8916,  8917,  8924,  8925,  8932,  8933,  8940,
    8941,  8945,  8946,  8953,  8954,  8961,  8962,  8963,  8967,  8968,
    8977,  8978,  8985,  8986,  8990,  8991,  8995,  8996,  9000,  9001,
    9009,  9010,  9018,  9019,  9026,  9027,  9031,  9032,  9039,  9040,
    9044,  9045,  9049,  9065,  9066,  9073,  9074,  9078,  9079,  9086,
    9087,  9091,  9092,  9099,  9100
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "Y_cast",
  "Y_const_ENG", "Y_declare", "Y_define", "Y_dynamic", "Y_explain", "Y_no",
  "Y_quit", "Y_reinterpret", "Y_set", "Y_show", "Y_aligned", "Y_all",
  "Y_array", "Y_as", "Y_bit", "Y_bit_precise", "Y_bits", "Y_by", "Y_bytes",
  "Y_capturing", "Y_commands", "Y_constructor", "Y_conversion", "Y_copy",
  "Y_defined", "Y_destructor", "Y_english", "Y_evaluation", "Y_expand",
  "Y_expression", "Y_floating", "Y_function", "Y_initialization", "Y_into",
  "Y_lambda", "Y_length", "Y_linkage", "Y_literal", "Y_macros", "Y_member",
  "Y_non_empty", "Y_non_member", "Y_of", "Y_options", "Y_point",
  "Y_pointer", "Y_precise", "Y_precision", "Y_predefined", "Y_pure",
  "Y_reference", "Y_returning", "Y_rvalue", "Y_scope", "Y_to", "Y_user",
  "Y_user_defined", "Y_variable", "Y_wide", "Y_width",
  "Y_PREC_LESS_THAN_upc_layout_qualifier", "Y_COLON_COLON", "\"::\"",
  "Y_COLON_COLON_STAR", "\"++\"", "\"--\"", "'('", "')'", "'['", "']'",
  "'.'", "Y_MINUS_GREATER", "\"->\"", "'&'", "'*'", "'!'", "Y_sizeof",
  "'~'", "Y_DOT_STAR", "\".*\"", "Y_MINUS_GREATER_STAR", "\"->*\"", "'/'",
  "'%'", "'-'", "'+'", "Y_LESS_LESS", "\"<<\"", "Y_GREATER_GREATER",
  "\">>\"", "Y_LESS_EQUAL_GREATER", "\"<=>\"", "'<'", "'>'",
  "Y_LESS_EQUAL", "\"<=\"", "Y_GREATER_EQUAL", "\">=\"", "Y_EQUAL_EQUAL",
  "\"==\"", "Y_EXCLAM_EQUAL", "Y_bit_and", "'^'", "'|'", "Y_AMPER_AMPER",
  "Y_PIPE_PIPE", "Y_QMARK_COLON", "\"?:\"", "'='", "Y_PERCENT_EQUAL",
  "\"%=\"", "Y_AMPER_EQUAL", "Y_STAR_EQUAL", "\"*=\"", "Y_PLUS_EQUAL",
  "\"+=\"", "Y_MINUS_EQUAL", "\"-=\"", "Y_SLASH_EQUAL", "\"/=\"",
  "Y_LESS_LESS_EQUAL", "\"<<=\"", "Y_GREATER_GREATER_EQUAL", "\">>=\"",
  "Y_CARET_EQUAL", "Y_PIPE_EQUAL", "','", "Y_auto_STORAGE", "Y_break",
  "Y_case", "Y_char", "Y_continue", "Y_default", "Y_do", "Y_double",
  "Y_else", "Y_extern", "Y_float", "Y_for", "Y_goto", "Y_if", "Y_int",
  "Y_long", "Y_register", "Y_return", "Y_short", "Y_static", "Y_struct",
  "Y_switch", "Y_typedef", "Y_union", "Y_unsigned", "Y_while", "'#'",
  "\"##\"", "PY_SPACE", "PY_define", "PY_elif", "PY_else", "PY_error",
  "PY_if", "PY_ifdef", "PY_ifndef", "PY_line", "PY_undef",
  "PY___VA_ARGS__", "PY___VA_OPT__", "PY_pragma", "PY_elifdef",
  "PY_elifndef", "PY_embed", "PY_warning", "Y_asm", "Y_const", "\"...\"",
  "Y_enum", "Y_signed", "Y_void", "Y_volatile", "Y_wchar_t", "Y__Bool",
  "Y__Complex", "Y__Imaginary", "Y_inline", "Y_restrict", "Y__Alignas",
  "Y__Alignof", "Y__Atomic_QUAL", "Y__Atomic_SPEC", "Y__Generic",
  "Y__Noreturn", "Y__Static_assert", "Y__Thread_local", "Y_thread",
  "Y_local", "Y_bool", "Y_catch", "Y_class", "Y_const_cast",
  "Y_CONSTRUCTOR_SNAME", "Y_delete", "Y_DESTRUCTOR_SNAME",
  "Y_dynamic_cast", "Y_explicit", "Y_false", "Y_friend", "Y_mutable",
  "Y_namespace", "Y_new", "Y_operator", "Y_OPERATOR_SNAME", "Y_private",
  "Y_protected", "Y_public", "Y_reinterpret_cast", "Y_static_cast",
  "Y_template", "Y_this", "Y_throw", "Y_true", "Y_try", "Y_typeid",
  "Y_typename", "Y_using", "Y_virtual", "Y_char16_t", "Y_char32_t",
  "Y__BitInt", "Y_reproducible", "Y_typeof", "Y_typeof_unqual",
  "Y_unsequenced", "Y_ATTR_BEGIN", "Y_alignas", "Y_alignof", "Y_auto_TYPE",
  "Y_carries", "Y_dependency", "Y_carries_dependency", "Y_constexpr",
  "Y_decltype", "Y_except", "Y_final", "Y_noexcept", "Y_nullptr",
  "Y_override", "Y_static_assert", "Y_thread_local", "Y_deprecated",
  "Y_discard", "Y_maybe_unused", "Y_maybe", "Y_unused", "Y_nodiscard",
  "Y_noreturn", "Y_char8_t", "Y_concept", "Y_consteval", "Y_constinit",
  "Y_co_await", "Y_co_return", "Y_co_yield", "Y_export",
  "Y_no_unique_address", "Y_requires", "Y_unique", "Y_address",
  "Y_EMC__Accum", "Y_EMC__Fract", "Y_EMC__Sat", "Y_UPC_relaxed",
  "Y_UPC_shared", "Y_UPC_strict", "Y_GNU___attribute__",
  "Y_GNU___restrict", "Y_Apple___block", "Y_Apple_block", "Y_MSC___cdecl",
  "Y_MSC___clrcall", "Y_MSC___declspec", "Y_MSC___fastcall",
  "Y_MSC___stdcall", "Y_MSC___thiscall", "Y_MSC___vectorcall", "':'",
  "';'", "'{'", "'}'", "Y_CHAR_LIT", "Y_END", "Y_ERROR", "Y_FLOAT_LIT",
  "Y_GLOB", "Y_INT_LIT", "Y_NAME", "Y_SET_OPTION", "Y_STR_LIT",
  "Y_TYPEDEF_NAME", "Y_TYPEDEF_SNAME", "Y_LEXER_ERROR", "'$'", "'@'",
  "'`'", "'?'", "$accept", "command_list", "command", "cast_command",
  "new_style_cast_english", "declare_command", "$@1",
  "alignas_or_width_decl_english_ast", "alignas_specifier_english",
  "aligned_english", "capturing_paren_capture_decl_list_english_opt",
  "paren_capture_decl_list_english", "capture_decl_list_english_opt",
  "capture_decl_list_english", "capture_decl_english_ast",
  "capture_default_opt", "width_specifier_english_uint",
  "storage_class_subset_english_type_opt",
  "storage_class_subset_english_type", "storage_class_subset_english_stid",
  "define_command", "expand_command", "expand_command2",
  "p_extra_token_except_lparen", "p_extra_tokens_opt", "p_extra_tokens",
  "p_extra_token", "p_arg_list_opt", "p_comma_arg_list", "p_arg_list",
  "p_arg_tokens", "p_arg_token_as_list", "p_arg_token", "p_num_lit",
  "p_other", "p_punctuator", "p_arg_tokens_with_comma_opt",
  "p_arg_tokens_with_comma", "p_arg_token_with_comma_as_list",
  "p_arg_token_with_comma", "explain_command", "$@2", "explain",
  "help_command", "$@3", "help_what_opt", "preprocessor_command",
  "p_define", "p_paren_param_list_opt", "p_param_list_opt", "p_param_list",
  "p_param", "p_replace_list_opt", "p_replace_list", "p_replace_token",
  "p_undef", "quit_command", "scoped_command", "set_command",
  "set_option_list", "set_option", "set_option_value_opt", "show_command",
  "show_format", "show_format_exp", "show_format_opt", "show_types_opt",
  "predefined_or_user_types_opt", "template_command", "typedef_command",
  "using_command", "c_style_cast_expr_c", "$@4", "new_style_cast_expr_c",
  "$@5", "new_style_cast_c", "aligned_declaration_c", "$@6", "$@7",
  "alignas_specifier_c", "$@8", "alignas", "asm_declaration_c",
  "scoped_declaration_c", "class_struct_union_declaration_c", "$@9",
  "$@10", "enum_declaration_c", "$@11", "namespace_declaration_c", "$@12",
  "$@13", "namespace_sname_c_exp", "namespace_sname_c",
  "namespace_typedef_sname_c", "brace_in_scope_declaration_c_exp",
  "brace_in_scope_declaration_c_opt", "brace_in_scope_declaration_c",
  "in_scope_declaration_c_exp", "lambda_declaration_c",
  "capture_decl_list_c_opt", "capture_decl_list_c", "capture_decl_c_ast",
  "lambda_param_c_ast_list_opt", "lambda_return_type_c_ast_opt", "$@14",
  "template_declaration_c", "typed_declaration_c", "$@15",
  "typedef_declaration_c", "$@16", "$@17", "typedef_decl_list_c",
  "typedef_decl_c", "typedef_decl_c_exp",
  "user_defined_conversion_declaration_c", "using_declaration_c",
  "using_decl_c_ast", "$@18", "$@19", "decl_list_c_opt", "decl_list_c",
  "decl_c", "decl_c_exp", "decl_c_astp", "msc_calling_convention_c_astp",
  "decl2_c_astp", "array_decl_c_astp", "array_size_c_ast",
  "block_decl_c_astp", "$@20", "destructor_declaration_c",
  "no_destructor_params", "file_scope_constructor_declaration_c",
  "file_scope_destructor_declaration_c", "func_decl_c_astp",
  "pc99_func_or_constructor_declaration_c", "$@21",
  "rparen_func_qualifier_list_c_stid_opt", "$@22",
  "func_qualifier_list_c_stid_opt", "func_qualifier_c_stid",
  "func_ref_qualifier_c_stid_opt", "noexcept_c_stid_opt",
  "noexcept_bool_stid_exp", "trailing_return_type_c_ast_opt", "$@23",
  "func_equals_c_stid_opt", "param_c_ast_list_exp", "param_c_ast_list_opt",
  "param_c_ast_list", "param_c_ast", "$@24", "param_c_ast_exp",
  "nested_decl_c_astp", "$@25", "oper_decl_c_astp", "pointer_decl_c_astp",
  "$@26", "pointer_type_c_ast", "pc99_pointer_decl_list_c",
  "pc99_pointer_decl_c", "$@27", "pc99_pointer_type_c_ast",
  "pointer_to_member_decl_c_astp", "$@28", "pointer_to_member_type_c_ast",
  "reference_decl_c_astp", "$@29", "reference_type_c_ast",
  "typedef_type_decl_c_ast", "user_defined_conversion_decl_c_astp", "$@30",
  "user_defined_literal_decl_c_astp", "cast_c_astp_opt", "cast_c_astp",
  "cast2_c_astp", "array_cast_c_astp", "block_cast_c_astp", "$@31",
  "func_cast_c_astp", "nested_cast_c_astp", "$@32", "pointer_cast_c_astp",
  "$@33", "pointer_to_member_cast_c_astp", "$@34", "reference_cast_c_astp",
  "$@35", "udc_decl_c_ast_opt", "udc_decl_c_ast", "pointer_udc_decl_c_ast",
  "$@36", "pointer_to_member_udc_decl_c_ast", "$@37",
  "reference_udc_decl_c_ast", "$@38", "type_c_ast",
  "type_modifier_list_c_type_opt", "type_modifier_list_c_type",
  "type_modifier_c_type", "type_modifier_base_type",
  "east_modified_type_c_ast", "atomic_builtin_typedef_type_c_ast",
  "atomic_specifier_type_c_ast", "$@39", "builtin_type_c_ast",
  "builtin_no_BitInt_c_btid", "typeof_type_c_ast", "$@40", "typeof",
  "enum_class_struct_union_c_ast", "class_struct_union_c_ast",
  "enum_c_ast", "enum_btids", "enum_fixed_type_c_ast_opt",
  "enum_fixed_type_c_ast", "enum_fixed_type_modifier_list_btid_opt",
  "enum_fixed_type_modifier_list_btid", "enum_fixed_type_modifier_btid",
  "enum_unmodified_fixed_type_c_ast", "class_struct_btid_opt",
  "class_struct_btid", "class_struct_union_btid",
  "type_qualifier_list_c_stid_opt", "type_qualifier_list_c_stid",
  "type_qualifier_c_stid", "cv_qualifier_stid",
  "cv_qualifier_list_stid_opt", "restrict_qualifier_c_stid",
  "upc_layout_qualifier_c", "storage_class_c_type", "_Noreturn_atid",
  "attribute_specifier_list_c_atid_opt", "attribute_specifier_list_c_atid",
  "$@41", "using_opt", "attribute_list_c_atid_opt",
  "attribute_list_c_atid", "attribute_c_atid_exp",
  "attribute_str_arg_c_opt", "gnu_or_msc_attribute_specifier_list_c_opt",
  "gnu_or_msc_attribute_specifier_list_c",
  "gnu_attribute_specifier_list_c_opt", "gnu_attribute_specifier_list_c",
  "gnu_attribute_specifier_c", "$@42", "gnu_attribute_list_c_opt",
  "gnu_attribuet_list_c", "gnu_attribute_c_exp",
  "gnu_attribute_decl_arg_list_c_opt", "gnu_attribute_arg_list_c_opt",
  "gnu_attribute_arg_list_c", "gnu_attribute_arg_c",
  "msc_attribute_specifier_list_c", "msc_attribute_specifier_c", "$@43",
  "msc_attribute_list_c_opt", "msc_attribuet_list_c", "decl_english_ast",
  "array_decl_english_ast", "array_size_decl_ast", "length_opt",
  "block_decl_english_ast", "constructor_decl_english_ast",
  "destructor_decl_english_ast", "destructor_parens_opt",
  "func_decl_english_ast", "func_qualifier_english_type_opt",
  "msc_calling_convention_atid", "paren_param_decl_list_english_opt",
  "paren_param_decl_list_english", "param_decl_list_english_opt",
  "param_decl_list_english", "decl_english_ast_exp",
  "ref_qualifier_english_stid_opt", "returning_english_ast_opt",
  "returning_english_ast", "qualified_decl_english_ast",
  "type_qualifier_list_english_type_opt",
  "type_qualifier_list_english_type", "type_qualifier_english_type",
  "attribute_english_atid", "storage_class_english_stid",
  "eval_expr_init_stid", "linkage_stid", "linkage_opt",
  "type_qualifier_english_stid", "upc_layout_qualifier_english",
  "qualifiable_decl_english_ast", "pointer_decl_english_ast",
  "reference_decl_english_ast", "reference_english_ast",
  "user_defined_literal_decl_english_ast", "var_decl_english_ast",
  "type_english_ast", "type_modifier_list_english_type_opt",
  "type_modifier_list_english_type", "type_modifier_english_type",
  "unmodified_type_english_ast", "builtin_type_english_ast",
  "builtin_no_BitInt_english_btid", "BitInt_english_int", "BitInt_english",
  "precise_opt", "class_struct_union_english_ast", "enum_english_ast",
  "of_type_enum_fixed_type_english_ast_opt", "enum_fixed_type_english_ast",
  "enum_fixed_type_modifier_list_english_btid_opt",
  "enum_fixed_type_modifier_list_english_btid",
  "enum_unmodified_fixed_type_english_ast", "any_name", "any_name_exp",
  "any_sname_c", "any_sname_c_exp", "any_sname_c_opt", "any_typedef",
  "name_ast", "name_exp", "name_cat", "name_opt", "oper_sname_c_opt",
  "typedef_type_c_ast", "sub_scope_sname_c_opt", "sname_c", "sname_c_ast",
  "bit_field_c_uint_opt", "sname_c_exp", "sname_c_opt", "sname_english",
  "sname_english_ast", "sname_english_exp", "sname_english_opt",
  "sname_list_english", "typedef_sname_c", "address_exp", "array_exp",
  "as_exp", "as_into_to_exp", "as_or_to_opt", "bits_opt", "bytes_opt",
  "cast_exp", "char_exp", "class_struct_union_btid_exp", "colon_exp",
  "comma_exp", "conversion_exp", "c_operator", "default_exp",
  "defined_exp", "dependency_exp", "destructor_sname", "empty_str_lit_exp",
  "equals_exp", "extern_linkage_c_stid", "extern_linkage_c_stid_opt",
  "glob", "glob_opt", "gt_exp", "inline_stid_opt", "int_exp",
  "literal_exp", "local_exp", "lparen_exp", "lt_exp",
  "member_or_non_member_opt", "namespace_btid_exp", "namespace_type",
  "of_exp", "of_scope_english", "of_scope_list_english",
  "of_scope_list_english_opt", "operator_exp", "operator_opt", "point_exp",
  "precision_opt", "rbrace_exp", "rbracket_exp", "reference_exp",
  "returning", "returning_exp", "rparen_exp", "scope_english_type",
  "scope_english_type_exp", "semi_exp", "semi_opt", "semi_or_end",
  "static_stid_opt", "str_lit", "str_lit_exp", "this_exp", "this_stid_opt",
  "to_exp", "type_opt", "typename_flag_opt", "uint_lit", "uint_lit_exp",
  "uint_lit_opt", "unused_exp", "user_defined", "virtual_stid_exp",
  "virtual_stid_opt", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1062)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1085)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1062,  1091, -1062, -1062,   582,  3060,    73,   181, -1062, -1062,
     181,  -110,  1718,   101,   181, -1062,     6, -1062,  1293,   181,
      18,   129, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062,   360,    73,   360,   360,   360,   360,
    1659,   360,   -17,   360, -1062,   360,   360,   360,   360,   360,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062,   221, -1062,   219,
   -1062,   592,   406, -1062, -1062, -1062, -1062,   139,   126, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062,   419,   476, -1062,
    4568, -1062,   131, -1062, -1062, -1062,   468, -1062, -1062, -1062,
   -1062,   444,  -110, -1062, -1062,    83, -1062, -1062, -1062,    34,
     460, -1062,  5019, -1062, -1062, -1062, -1062,   102, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062,   102, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,    94,
     121, -1062,   592, -1062, -1062, -1062, -1062, -1062,  5638,   506,
     933, -1062, -1062, -1062,   367, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062,   123, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062,   -24, -1062, -1062, -1062,   123, -1062, -1062, -1062,
   -1062, -1062, -1062,   512, -1062,   501, -1062, -1062,   123, -1062,
   -1062,   515, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062,   523, -1062, -1062,
   -1062, -1062, -1062,   545, -1062, -1062,   122, -1062, -1062,   123,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
     502, -1062, -1062, -1062,  5796, -1062, -1062, -1062,  6004, -1062,
   -1062, -1062, -1062,   123, -1062, -1062, -1062,   400,   400, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062,   380, -1062,   405, -1062,
     572,   487, -1062,   219,   466,   479,   -20,   622, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062,    86,    86,    92,   548,
   -1062,   221, -1062,   598, -1062, -1062, -1062, -1062,  4137,   582,
   -1062, -1062, -1062, -1062, -1062, -1062,   126,   126,   821,   -15,
     451,    96, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062,    76, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
      71, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,   579,
   -1062, -1062, -1062,    73,  4137,   221,  4137,    47, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062,   490,    98, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062,  1318, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062,  5156, -1062, -1062, -1062, -1062, -1062,
    5796, -1062, -1062,   648, -1062, -1062, -1062, -1062, -1062,   400,
   -1062,   103, -1062, -1062,   426,  4137, -1062, -1062,   139, -1062,
   -1062,   430,    78, -1062, -1062, -1062,   658,   130, -1062, -1062,
     809,   263,   809, -1062, -1062,   458, -1062, -1062, -1062,    54,
    5796, -1062,  5796,    44, -1062,   114, -1062,   123,   123, -1062,
   -1062, -1062,  5796,     6,  3671,  1666,  1666,  1741, -1062, -1062,
   -1062,  6004,  3829,   356,    68, -1062,    68, -1062, -1062,   582,
   -1062,  5796, -1062,   123, -1062, -1062,   123,    94, -1062, -1062,
     446, -1062, -1062, -1062, -1062,   693,   698, -1062, -1062, -1062,
   -1062, -1062, -1062,    86, -1062, -1062, -1062,   821,   377, -1062,
      96,   525, -1062, -1062, -1062,   367, -1062, -1062, -1062, -1062,
   -1062, -1062,   223, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,     7,
   -1062, -1062,   463, -1062, -1062, -1062, -1062,  4619,  4449, -1062,
   -1062, -1062, -1062, -1062, -1062,   141, -1062,   167, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,    67,
     118,   620,   703, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062,   261, -1062, -1062,    97,   468, -1062, -1062,
   -1062,    98, -1062, -1062, -1062, -1062, -1062,  5263, -1062,   708,
    5400,   654,  5507, -1062, -1062, -1062, -1062, -1062,  5156, -1062,
   -1062,    58,  4904,   135, -1062, -1062, -1062, -1062, -1062,   134,
   -1062, -1062, -1062, -1062,   724, -1062, -1062,   506,   263, -1062,
   -1062, -1062, -1062, -1062, -1062,   139, -1062, -1062, -1062, -1062,
   -1062,   139,   569,   733, -1062,   126,   126,   123,    63,    50,
   -1062, -1062,   737, -1062,   139,   704,   933,   933,   933, -1062,
   -1062, -1062, -1062, -1062, -1062,   691, -1062, -1062,   411, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062,   524,   762,   435,   618,   552,    19,   380,
   -1062, -1062,   691, -1062, -1062,   546,   446,   553, -1062,   566,
   -1062, -1062,    50,   151,   123,   988, -1062,   570,    77,   485,
     557, -1062, -1062, -1062, -1062, -1062, -1062, -1062,   802, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062,   166,   703,   793,   171,
     199,   153,   829,   703, -1062, -1062, -1062, -1062, -1062, -1062,
     637, -1062, -1062, -1062, -1062, -1062,   171, -1062,  4293,  4277,
   -1062, -1062,  4137, -1062, -1062,   123, -1062, -1062, -1062, -1062,
     620,   620, -1062,    95,   136,   797,   125, -1062, -1062,  3982,
     140, -1062, -1062, -1062,   660,   120,    44, -1062, -1062, -1062,
    1940, -1062,  4449, -1062,  5263,   800,  5263, -1062, -1062,  5156,
   -1062,   654,  5400, -1062, -1062,  1666, -1062, -1062, -1062,   806,
     138, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
    4904, -1062, -1062, -1062,  5796,   775, -1062, -1062, -1062,   155,
   -1062,   812, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
      50, -1062, -1062, -1062, -1062,   134, -1062,   102,   634, -1062,
   -1062, -1062,    82, -1062,   815, -1062,   824,   100, -1062, -1062,
   -1062,   826,   143, -1062, -1062,  5796,   134,  5796, -1062,   134,
   -1062, -1062,  1666, -1062, -1062, -1062,   563,    50,  1075,   380,
    1666,  1666,  1666, -1062,   411,   619, -1062,    35,   827,  1449,
      44, -1062, -1062, -1062,   380,   134, -1062, -1062, -1062,   480,
     838, -1062,   838,   151, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062,  5944, -1062,   529, -1062,   300, -1062, -1062, -1062,
   -1062, -1062,   102, -1062, -1062,   102, -1062, -1062, -1062, -1062,
   -1062, -1062,   491, -1062, -1062,   151, -1062, -1062, -1062,  2227,
   -1062, -1062,   212, -1062,   164,   140, -1062, -1062,   855,  4137,
     860,   104,   154,   112,   615,   866, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,    86,
      86, -1062, -1062, -1062, -1062,    80, -1062, -1062, -1062, -1062,
   -1062,  3982,   848,   847,   117, -1062, -1062,   102, -1062, -1062,
     620, -1062,   850,   144, -1062, -1062, -1062, -1062,  2514, -1062,
     221, -1062, -1062, -1062,   727, -1062, -1062,   904,   713,   856,
   -1062, -1062, -1062,  5400,  5507,   798, -1062, -1062, -1062,    70,
   -1062, -1062, -1062,   134,   134,   134,   134, -1062,   632,    50,
     862,  4704,   155,   124, -1062, -1062, -1062, -1062,   861, -1062,
     861, -1062, -1062,   867,   150, -1062,   219,   864,   162, -1062,
     170, -1062, -1062, -1062,   409,  3353, -1062,   119, -1062,   155,
     933,   139, -1062, -1062, -1062,   838,   868,   933,   126,   869,
     477, -1062,   126, -1062, -1062, -1062, -1062, -1062,   123,   102,
   -1062, -1062,   155, -1062, -1062, -1062,   123, -1062, -1062, -1062,
   -1062, -1062, -1062,   409,   409,   838, -1062,   529, -1062,   529,
   -1062, -1062, -1062,   653,    61,    61, -1062, -1062, -1062, -1062,
    4137,   873, -1062,   491, -1062, -1062, -1062,   641, -1062,   703,
   -1062, -1062,   104, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062,   899, -1062, -1062,    44,
      44,   727,   877, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062,  2801, -1062, -1062,   111, -1062, -1062, -1062, -1062, -1062,
   -1062,   153,   637, -1062,   952, -1062,   134,   933,   155,   879,
     879,   879,   219, -1062,   838, -1062,  5796, -1062, -1062, -1062,
   -1062, -1062,    54, -1062, -1062,   126,   354,   139,   105,   170,
   -1062, -1062, -1062, -1062, -1062,   878,   417, -1062,   123,   882,
     843, -1062, -1062, -1062,   134, -1062, -1062,   123, -1062,  1666,
   -1062,    69, -1062,   306, -1062,   126, -1062, -1062,   347, -1062,
     356,    50,   123, -1062,   480,   480,   480,   838, -1062,   380,
     380,   409, -1062, -1062,    72, -1062, -1062, -1062, -1062, -1062,
   -1062,   422, -1062,   491,   140, -1062,   805, -1062,   727,   139,
   -1062,   140, -1062, -1062, -1062, -1062, -1062,  4137, -1062,   200,
   -1062, -1062, -1062,   879,   134, -1062,   409, -1062,   139, -1062,
   -1062, -1062, -1062,   504, -1062,   170,  3194,   242,    89, -1062,
     879,   106,   139, -1062, -1062,   409,   126,   126, -1062,   126,
     126,   838,  3512, -1062, -1062, -1062,   409,   589, -1062, -1062,
     380, -1062, -1062, -1062, -1062, -1062,    73,  4137, -1062, -1062,
     529, -1062, -1062, -1062, -1062, -1062, -1062,   703,   155,    33,
     134, -1062,   528, -1062, -1062,   580, -1062, -1062, -1062, -1062,
     139, -1062, -1062, -1062, -1062, -1062,   219,   139,   123,    33,
   -1062, -1062, -1062, -1062,    69, -1062,   888,   584,   843, -1062,
   -1062, -1062, -1062, -1062,   843,  4137, -1062, -1062, -1062,  4344,
    1214,   140,   123,  5796, -1062,   380,   879, -1062, -1062, -1062,
      50,   843,   409,   409, -1062, -1062, -1062,   221, -1062, -1062,
   -1062, -1062, -1062,    50, -1062,   889, -1062,    33,    33,   891,
     134,   380,   843, -1062, -1062, -1062, -1062, -1062
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     1,    19,   894,     0,     0,     0,   196,   242,
       0,   244,     0,     0,     0,   575,  1070,   577,     0,     0,
     572,     0,   574,   281,   282,  1016,   283,   284,   343,   356,
    1054,  1055,   197,     3,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,     0,     0,     0,     0,     0,
      26,   243,   295,   296,   297,   273,   274,   275,   355,   301,
     576,   298,   303,    18,   882,   866,   867,  1023,   900,   860,
     895,     0,   861,    32,   959,   947,   951,     0,     0,   955,
     953,   940,   944,   936,   978,   956,   954,   957,   938,   950,
     946,   961,   968,   964,   960,   967,   963,   970,   966,   937,
     973,   975,   941,   976,   971,   965,   939,   942,   945,   948,
     952,   958,   962,   969,   974,   977,   949,   934,   932,   931,
     592,   897,     0,    28,   893,   892,     0,   920,   919,    23,
      24,   249,   245,   247,   258,   270,   268,   269,   257,   995,
     264,    83,    84,    25,  1071,   346,   219,     0,   207,   210,
     212,   213,   214,   215,   216,     0,   217,   208,   209,   211,
     218,   205,   206,    22,   554,   573,  1015,  1014,  1017,     0,
       0,     4,     0,     5,     6,     7,     8,   195,     0,   328,
     578,   600,   533,   540,   607,   539,   538,   513,   518,   514,
     615,   616,   516,     0,   590,   515,   529,   591,   537,   531,
     511,   512,   611,   594,   292,   583,     0,   620,   617,   532,
     605,   610,   612,     0,   190,   619,   535,   536,     0,   546,
     547,     0,   293,   530,   603,   609,   614,   618,   621,   534,
     602,   604,   606,   541,   542,   517,   586,   587,   589,   653,
     595,   601,   675,   882,   178,   179,     0,   181,   285,     0,
     182,   186,   189,   180,   192,   184,   183,   185,   187,   188,
     450,   451,   354,   344,   500,   506,   507,   502,   503,   521,
     522,   527,   524,     0,   592,   548,   549,   622,   622,   508,
     584,   585,   509,   613,   510,   626,   647,   652,   648,   674,
     878,     0,   523,   194,   608,     0,     0,     0,     9,    10,
      11,    13,    14,    15,    16,    17,     0,     0,     0,     0,
    1022,  1024,   890,     0,   910,   907,   908,   909,   723,     0,
    1044,  1043,   943,  1036,  1035,   972,     0,     0,     0,     0,
      42,     0,    77,    72,   738,    68,    71,    73,    78,    79,
     742,   743,     0,   731,    66,    70,    75,    76,   732,   734,
       0,   736,   739,    65,    67,    69,   741,    61,    63,     0,
      62,   906,   905,     0,   723,  1023,   723,     0,   248,   246,
     271,   272,   267,   256,   994,   996,   264,     0,   259,   260,
     261,   265,   252,   147,   167,   162,     0,    88,   137,   138,
     129,   160,   125,   126,   122,   143,   149,   161,   130,   124,
     128,   127,   157,   153,   156,   133,   135,   155,   152,   150,
     151,   139,   141,   144,   165,   134,   163,   145,   169,   166,
     159,   168,   158,   154,   146,   164,   177,   123,   113,   148,
     131,   132,   140,   142,   110,   117,   118,   111,   114,   119,
     120,   121,   136,    82,    89,   176,   112,   115,   116,    87,
       0,   870,   869,   221,   241,   859,   856,   857,   858,   622,
     203,     0,   872,   198,   200,   723,   611,   619,     0,   276,
     608,   332,     0,   334,   336,   335,     0,     0,   331,   453,
     579,   645,     0,  1058,  1059,   990,   776,  1008,  1007,     0,
       0,   876,     0,     0,   624,     0,   588,     0,     0,   401,
    1010,  1009,     0,  1070,     0,   875,   875,   359,   505,   501,
     519,   504,     0,   520,     0,   623,     0,   651,   673,     0,
     877,     0,   193,     0,   985,   986,     0,     0,   863,   862,
     555,   299,   308,   312,   304,   306,   307,   316,  1049,  1047,
    1045,  1046,  1048,     0,  1021,   880,   881,     0,     0,   762,
       0,     0,  1079,   744,   750,   754,   764,   770,   805,   758,
     779,   767,     0,   751,   752,   757,   759,   765,   769,   771,
     748,   756,   761,   763,   768,   747,   749,   753,   782,   783,
     785,   745,  1023,   780,   781,    20,   681,   808,   724,   726,
     727,   728,   729,   682,   683,     0,   804,     0,   899,   898,
     935,   933,   773,   774,   775,    64,   737,    74,   735,     0,
       0,    48,   706,  1082,  1081,    80,   984,   983,   730,  1078,
    1077,   733,   593,     0,   896,    27,    33,     0,    81,   251,
     250,     0,   254,   263,   262,   253,   101,   170,   103,     0,
      97,    96,   105,   107,   108,    94,    93,    85,    90,    92,
     347,     0,   230,     0,   202,   201,   871,    21,   278,   465,
     333,  1063,  1062,   337,   338,   928,   927,     0,   645,   582,
     646,   581,   991,  1061,  1060,     0,   525,   191,  1074,  1072,
    1073,     0,   627,     0,   596,     0,     0,     0,     0,  1064,
     279,   286,     0,   289,     0,   443,   578,   578,   578,   700,
     701,   702,   703,   704,   705,   449,   362,   363,   366,   373,
     374,   375,   376,   377,   367,   446,   368,   454,   369,   457,
     379,   380,   381,   875,     0,   878,     0,   884,   884,   649,
     452,   345,   360,   545,   543,   862,   555,     0,   550,     0,
     879,   462,  1064,     0,     0,     0,   302,   319,     0,     0,
       0,  1020,   746,   760,   772,   982,   981,  1080,   777,  1006,
    1005,   766,   787,   784,   786,   891,   686,   706,   695,     0,
     716,     0,   690,   706,   812,   788,   789,   790,   791,   792,
    1011,   699,   698,   722,   793,   794,     0,   795,     0,   809,
     811,   725,   723,  1004,  1003,     0,   902,   901,   740,    47,
      48,    48,    43,    56,    56,     0,     0,    51,    55,   723,
     718,   707,   930,   929,  1027,   911,     0,    40,    41,    34,
       0,    35,   723,   255,   170,     0,   171,   173,   174,    89,
     102,    98,   100,   106,    91,   875,   229,   228,   227,     0,
       0,   226,   235,   236,   237,   238,   239,   240,   234,   220,
     231,   233,   989,   988,     0,   480,   482,   484,   486,     0,
     466,   467,   471,   472,   473,   474,   468,   469,   470,   475,
    1064,    60,   330,   580,   294,   465,   528,     0,     0,   599,
     598,   597,     0,   660,   661,   680,     0,     0,   440,  1065,
     868,     0,     0,   436,   439,     0,   465,     0,   291,   465,
     288,   393,   875,   459,   448,   460,     0,  1064,     0,   649,
     875,   875,   875,   370,     0,   371,   372,   884,     0,     0,
       0,   461,   883,   378,   650,   465,   552,   553,   551,   488,
       0,   397,     0,     0,   557,   565,   566,   568,   567,   569,
     571,   556,   558,   564,   561,   570,     0,   300,   320,   318,
     305,   317,     0,   309,   310,     0,   314,   313,   778,   755,
     689,   688,     0,   687,   693,     0,   694,  1067,  1066,     0,
    1038,  1037,   717,   691,     0,   718,  1012,  1013,     0,   723,
     842,     0,     0,     0,  1075,  1031,   830,   829,   819,   827,
     821,   822,   825,   826,   839,   820,   824,   833,   834,     0,
       0,   806,   813,   817,   818,     0,   814,   815,   816,   810,
     803,   723,     0,     0,     0,    58,    52,     0,    53,    44,
       0,   712,     0,     0,  1039,  1040,    30,   719,     0,  1028,
    1023,   912,   913,    39,   914,    38,    37,   917,   715,     0,
     109,   172,    86,    99,   104,   348,   350,   351,   222,     0,
     232,   357,   477,   465,   465,   465,   465,   476,   888,  1064,
       0,   340,     0,     0,   642,   639,   640,   633,   643,   635,
     643,   637,   638,     0,     0,   632,   641,     0,     0,   658,
     663,   659,   676,   679,   414,     0,   437,     0,   287,     0,
     578,     0,   365,   364,   361,     0,  1036,   578,     0,     0,
       0,   383,     0,   382,   447,   455,   458,   592,     0,     0,
     987,   885,     0,   494,   496,   498,     0,   489,   490,   491,
     492,   493,   403,   414,   414,     0,   563,   561,   560,   562,
     326,   321,   323,  1052,     0,     0,   311,   315,  1019,  1018,
     723,     0,   798,     0,   796,   904,   903,   873,   692,   706,
     799,   843,     0,  1002,  1001,   840,  1030,  1029,   831,   922,
     921,   828,  1076,   823,  1032,   832,   846,   844,   838,     0,
       0,   914,     0,    46,    45,   980,   979,    57,    54,    50,
     708,     0,   721,   720,     0,   915,   916,    59,   918,    36,
     716,     0,  1011,   175,     0,   225,   465,   578,     0,   483,
     485,   487,   889,   277,     0,   339,     0,   327,   526,   926,
     925,   628,     0,   634,   636,     0,     0,     0,     0,     0,
     668,   669,   667,   670,   672,     0,     0,   666,     0,   415,
     426,   442,   441,   435,   465,   998,   997,     0,   290,   875,
     444,   411,   392,     0,   385,     0,  1057,   386,     0,   384,
     456,  1064,     0,   544,   488,   488,   488,     0,   405,   649,
     649,   414,   559,  1053,     0,  1051,  1050,   324,   325,   684,
     696,     0,   874,     0,   718,   841,  1068,   845,   914,     0,
     835,   718,   714,   713,   711,  1042,  1041,   723,   717,     0,
     353,   352,   349,   358,   465,   481,   414,   341,     0,   625,
     631,   654,   657,     0,   662,     0,     0,     0,     0,   402,
     438,     0,     0,   412,   413,   414,     0,     0,   389,     0,
       0,     0,     0,   495,   497,   499,   414,   404,   398,   399,
     649,  1034,  1033,   322,   924,   923,     0,   723,   697,  1069,
     850,   837,   836,   802,    31,  1026,  1025,   706,     0,   422,
     465,   644,   928,   671,   665,     0,   417,   421,   419,   420,
       0,   430,   427,   428,   429,   887,   886,     0,     0,   422,
     391,   390,   388,   387,   411,   432,     0,     0,   426,   408,
     409,   410,   406,   407,   426,   723,   685,   853,   847,     0,
     851,   718,     0,     0,   479,   425,   342,   418,   416,   280,
    1064,   426,   414,   414,   463,   395,   797,  1023,   854,   848,
     855,   852,    29,  1064,   423,     0,   400,   422,   422,     0,
     465,   649,   426,   464,   478,   424,   394,   445
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062,   -11, -1062,   -57,   160, -1062,    99, -1062, -1062,
   -1062, -1062, -1062,   825,   137, -1062,   320, -1062,  -549,   329,
    -627,  -600,  -225, -1062, -1062, -1062,   148, -1062,   147,  -200,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062,   -75, -1062, -1062,   133, -1062, -1062, -1062, -1062, -1062,
     844, -1062, -1062,  -295,   348,   604, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062,   945, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062,    42, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062,   244, -1062, -1062,
   -1062, -1062,  -145, -1062, -1062, -1062,   950,  -463, -1062,    48,
   -1062, -1062, -1062,  -201, -1062, -1062,    52,   709, -1062, -1062,
   -1062,   492,   109, -1062,  -471, -1062,   280, -1062,  -620, -1062,
   -1062, -1062,  -365, -1062, -1062,   282, -1062, -1062,  -875, -1062,
   -1062, -1062,  -366,  -698, -1062,  -653, -1062,  -569, -1062,  -721,
    -771,   -69, -1062, -1062, -1062, -1062, -1062,   294, -1062,  -454,
     840, -1062, -1062, -1062, -1062, -1062,  -216, -1062, -1062,   -99,
   -1062,   981, -1062, -1062,  -758, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,  -340,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062,  -169, -1062,   757,
    -189,  -473,   763, -1062, -1062, -1062,  -487, -1062,  -470, -1062,
   -1062, -1062, -1062, -1062,    10,   290, -1062,   -95,   283,  -895,
      91, -1062,  1015,     4,  -631,   128,  -154,  -268,  -256,  -303,
   -1062, -1062, -1062,   -26,   -12, -1062, -1062, -1062, -1062,  -175,
     -28,   376,  -136,  -887,  -688,  -276, -1062, -1062, -1062,  -833,
   -1062, -1062,  -174,  -259, -1062,   759, -1062, -1062, -1062,  -306,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,   461,
    -727, -1062,    39, -1062, -1062,    13,  -942, -1062, -1062,   230,
   -1062,   465,  -104, -1062,   508,   507, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,   268, -1062,
    -326, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062, -1062,
   -1062, -1062, -1062,   537,     2,  -279,   549,    -8, -1062,  -138,
   -1062, -1062,  1026,  -482, -1062,    -4,  -332,   340, -1062, -1062,
     819,  -319,   -32, -1062, -1062, -1062, -1062, -1062,   -96,   900,
   -1062, -1061, -1062,   650, -1062, -1062, -1062,  -464, -1062,   152,
   -1062, -1062, -1062, -1062, -1062, -1062,  1034, -1062, -1062, -1062,
   -1062, -1062,   -74, -1062, -1062,  -179, -1062,  -115, -1062,   771,
   -1034,   770, -1062,   -53, -1062, -1062, -1062, -1062, -1062,  -307,
    -105,   -94, -1062,  -292, -1062, -1062,   -47, -1062,  1154, -1062,
    -146,  -863, -1062, -1062,   303, -1062,   590,  -415,  -773, -1062,
   -1062,   741,   555, -1062
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,    33,    34,    35,    36,   365,   625,   819,   820,
     612,   802,   805,   806,   807,  1016,   821,   120,   357,   358,
      37,    38,   443,   646,   647,   648,   649,   639,   640,   641,
     642,   643,   445,   446,   447,   448,   825,   826,   827,   449,
      39,   492,    40,    41,   170,   463,    42,   161,   652,   839,
     840,   841,   849,   850,   851,   162,    43,    44,    45,   132,
     133,   368,    46,   381,   635,   382,   139,   372,    47,    48,
      49,   244,   659,   245,   896,    50,   247,   503,   897,   248,
     899,   249,   250,    51,    52,   307,   747,    53,   306,    54,
     308,   748,   534,   535,   536,   950,   947,   948,  1133,   251,
     476,   477,   808,   871,  1207,  1350,    55,   253,   507,    56,
     450,   835,  1045,  1046,  1292,   254,    57,    58,   169,  1196,
     731,   705,   706,  1094,   707,   913,   708,   709,  1057,   710,
    1090,   255,   932,   256,   257,   711,   258,   689,  1123,  1258,
    1327,  1382,  1315,  1230,  1360,  1394,  1420,  1309,  1376,   891,
     892,   893,  1234,  1233,   712,   902,   713,   714,   910,   856,
     259,   260,   506,   261,   716,   911,   857,   718,   912,   858,
     720,   721,   929,   722,   859,   860,   861,   862,   863,  1197,
     864,   865,  1053,   866,  1054,   867,  1055,   868,  1056,  1116,
    1117,  1118,  1254,  1119,  1255,  1120,  1256,   263,   510,   264,
     265,   266,   267,   268,   269,   875,   270,   271,   272,   925,
     273,   274,   275,   276,   277,   746,   941,  1128,  1129,   943,
     944,   164,    60,   278,   479,   480,   279,   280,   359,   281,
     496,   282,   283,   514,   284,   682,   878,  1073,  1074,  1075,
    1213,   669,   285,   923,   286,   287,   497,  1077,  1078,   885,
    1081,  1225,  1226,  1227,   288,   289,   498,   886,   887,  1021,
     775,   962,   974,   776,   777,   778,   966,   779,   780,   723,
     810,   811,  1022,  1023,  1284,   782,  1026,  1027,   586,   587,
     588,   589,   590,   591,   605,   485,   959,   592,   763,   783,
     784,   785,   786,   593,   594,   787,   788,   789,   790,  1001,
    1002,  1003,  1004,  1005,  1152,  1006,  1007,  1277,  1388,  1389,
    1390,  1409,   458,   459,   724,   530,   737,    68,   894,   453,
     464,  1273,   726,   292,   520,   728,   869,   922,  1367,  1203,
     125,   596,   126,    71,   122,    72,   798,  1147,   364,   318,
    1033,  1187,  1189,   129,  1161,  1336,  1211,  1085,   814,   123,
    1177,   757,   618,   526,  1109,   854,   470,   295,   375,   376,
    1237,   296,  1155,   795,   761,   489,   502,   978,   168,    62,
    1140,   310,   311,   765,  1347,  1030,  1158,  1165,  1333,   325,
     972,  1028,  1287,   322,   542,   543,  1267,  1264,    63,  1248,
     674,   675,   663,   895,   969,  1340,   145,   680,   681,  1163,
     621,   597,   615,   297
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      69,    69,    69,   172,   140,    61,    67,    67,    67,   469,
     517,    59,   585,   667,   312,   584,   360,   454,   513,   600,
     601,   930,  1103,   727,   727,   727,   481,   490,   531,   677,
     366,    69,   290,  1148,   478,   730,   293,    67,   486,   493,
     964,   924,   833,  1034,   482,   678,   975,  1126,   629,  1079,
     583,   715,   715,   715,  1083,   673,  1110,  1124,   626,   836,
     628,   584,  1265,   584,   883,   903,   904,   905,   796,   528,
     504,   836,   619,  1331,   124,   508,   373,   616,   949,   661,
     686,  1168,   634,   883,   313,   762,  -860,   528,   909,   694,
    1361,   622,   832,   532,   512,   455,   583,   613,   583,   633,
     313,   883,   141,   451,   654,  1153,   883,  1365,  1393,  1271,
    1280,   815,  1285,  1159,   774,   683,  1014,  1062,  1175,   799,
    1235,  -433,   460,   500,   487,  1209,   665,   323,   378,  -223,
     166,   665,   361,   606,  -677,   370,   852,  1031,  1087,   665,
     320,  1089,   371,  1169,   665,   665,  1313,  1111,   362,  1060,
    1170,   665,   931,  -655,   970,  1156,   320,  1014,   792,   657,
     816,   644,   584,   665,   764,  1145,  1024,  1112,   793,    15,
     290,  -678,   967,   729,   729,   729,   658,  1314,  1032, -1000,
    1146, -1000,   127,   523,   128,   524,  1095,   684,   800,   131,
     801,   908,   685,   488,  1017,  1024,   -49,   583,   -49,   324,
    -800,  1345,  1157,  -329,   855,  1044,   313,   971,   794,  -224,
     321,   696,   697,  -801,  -434,  -710,  1236,  1341,   501,    22,
    1241,   924,  -396,  -630,   759,  1362,   321,   908,   888,   968,
     607,  1015,   144,  -656,  1126,   736,   837,   738,   608,  1337,
    1219,   727,   698,  1357,   960,   622,  1160,   853,   837,  1154,
    1261,   379,   516,  1176,   609,   666,   290,  -800,   939,  1025,
     666,   363,   812,   945,   751,   515,   515,   309,   666,   715,
    -801,   889,  1015,   666,   666,   940,   299,  1099,   461, -1000,
     666,   650,  1043,   525,   313,   584,   817,   813,  1025,   717,
     717,   717,   666,  1363,   909,  1198,  1199,  1200,  1201,   662,
     537,  1130,    69,    69,   679,   546,  1008,   920,   529,   529,
     239,   598,   627,   540,   595,   599,   774,   617,   687,   688,
     583,   676,   508,   920,   614,   380,   668,   620,   671,  1296,
     374,   624,  1338,   690,   818,   693,   634,   797,  1204,  1343,
     167,   679,  1020,   734,   742,   670,   630,   743,   890,  1298,
    1266,   963,   741,   727,   483,  1064,   838,   484,  -864,    69,
     595,   884,   595,  1332,  1047,    67,    64,   946,   838,    65,
      66,    64,  1328,  1329,    65,    66,  1049,   679,   880,   881,
     884,   715,  1326,   874,    64,  1302,   679,    65,    66,   876,
     533,   729,   456,    65,    66,   457,  1278,  1279,   884,   142,
     452,   655,   900,   884,    64,  1037,   719,   719,   719,   486,
    -199,   679,  1210,  1346,  -199,   644,  1044,   644,   665,   462,
     727,   760,  1274,  1334,   727,  1259,  1260,   848,   727,   727,
     727,  1091,    64,   653,  1088,    65,    66,   828,  1293,  1104,
    1105,  1106,   290,  1384,   833,  1387,  1374,   515,   715,  1412,
    1358,    15,   715,    16,    17,   939,   715,   715,   715,  1239,
     945,   595,  1220,   679,   961,  1359,  1243,  1221,  1222,   361,
    1223,   319,   940,  1224,   610,  1113,  1310,   377,   323,    20,
    -882,   907,   290,   908,   290,   362,  1010,    21,  -664,   584,
     378,   326,  1138,  1102,   290,  1411,   290,   725,   725,   725,
     519,    22,  -900,   729,   290,  1352,   584,   631,   882,   309,
      69,    25,    69,   290,  1036,    69,   735,   584,   735,   584,
     378,   740,   872,   611,   583,   606,   755,    29,  -882, -1044,
    1321,   822,   670,   194,  1426,  1355,  1348,  1139,   197,    69,
     239,   583,   481,   481,   481,   529,   242,   666,   327,   538,
     324,  1377,   583,   756,   583,  -579,   367,   696,   697,  1181,
     482,   482,   482,  1330,  1092,   933,  1294,  1058,  1125,  1162,
     729,   924,   924,    15,   729,   321,    17,   491,   729,   729,
     729,   665, -1084,   471,   472,   665,  1065,   494,   698,  1066,
    1171,  1131,  1396,   314,   695,   495,  1067,  1121,  1349, -1044,
    1141,  1101,   697,   679,  1316,   539,  1068,   644,  1069,   315,
    1216,  1070,  1071,   379,  1218,   499,  1011,  1369,   473,   717,
    1391,  1072,   753,    22,   828,   848,   828,  1246,  1378,   316,
     608,  1228,   505,   695,   666,  1064,   221,   519,   551,   552,
     696,   697,   924,   379,   679,  1319,   609,   803,   517,    30,
     317,  1397,    64,    31,   194,  -431,  1229,   239, -1044,   197,
     130,  1395,  1425,  1144,   143,   203,   584,   483,   205,   163,
     484,   698,   952,  1150,   804,   935,   584,   239,   936,  1415,
     976,  1395,   977,   242,   937,  1051,   717,   380,   242,  -375,
     717,  -375,  1419,  -993,   717,   717,   717,   471,   472,    15,
     521,   583,    17,   527,  1417,  1418,    29,  -629,   584,   938,
     666,   583,   727,  1114,   666,   290,  1401,   380,   651,   917,
    1166,  1167,  1183,  1047,   656,   584,  1086,   474,   660,  1395,
    1395,   664,   473,   924,   745,    21,   719,   290,   213,  1063,
     715,   954,   956,   583,   955,  1185,   957,  1186,   672,    22,
     741,   236,   237,   238,   481,   240,   194,   727,   749,    25,
     583,   197,  1305,   750,  1422,  1423,   194,  1190,  1312,  1191,
    1208,   197,   482,   809, -1056, -1056,  -875,   213,    64,   829,
     290,    65,    66,   953,   638,   715,    65,    66,   595,  1012,
    1013,  1244,  1000,  1247,   870,  1249,   877,  1238,   999,  1240,
    1113,  1113,  1113,   719,   475,   595,   879,   719,   898,  1404,
     901,   719,   719,   719,  1136,  1405,   595,  1137,   644,   644,
    1253,   906,    64,    70,   121,    65,    66,   725,  1317,   918,
    1115,   919,  1416,  1320,  1269,  1379,  -865,   584,  1380,  1305,
     920,   474,   958,   927,   699,   700,   290,   701,   702,   703,
     704,  1250,   602,  1427,   603,    64,   928,   604,    65,    66,
     946,    64,   729,   965,    65,    66,  1065,  1381,   973,  1066,
    1019,  1040,   583,  1029,  1076,  1283,  1067,  1048,   584,  1178,
      64,  1052,  1059,    65,    66,  1080,  1068,   290,  1069,   290,
    1149,  1070,  1071,  1364,   725,  1082,   545,  1084,   725,    65,
      66,  1072,   725,   725,   725,  1107,  1295,   729,  1299,  1122,
    1151,   290,   679,   583,  1323,  1324,  1325,  1164,   475,  1173,
    1174,  1180,  1121,  1121,  1121,  1301,  1188,  1193,  1194,  1251,
      64,  1212,    64,  1205,   290,  1217,   481,  1257,  1318,  1272,
    1215,  1242,  1263,   481,  1270,  1276,   668,  1245,  1281,  1304,
      61,   908,  1307,  1290,   482,  1308,    59,   360,  1339,  1403,
    1421,   482,  1424,  1179,  1018,   595,  1042,   444,   834,   831,
    1061,  1252,  1039,  1041,  1195,   595,   369,  1184,   717,   823,
     632,  1344,   622,  1050,   584,   246,   194,  1342,  1132,   934,
     252,   197,   951,  1291,  1134,    69,    69,   203,  1135,   732,
     205,   529,   529,   914,   522,   915,  1351,   595,  1402,  1370,
    1371,  1353,  1372,  1373,  1356,  1093,  1232,   916,   468,   583,
    1368,   262,   695,   717,   595,   511,   926,   509,   942,   696,
     697,  1386,  1262,  1127,   584,   165,  1100,  1297,  1114,  1114,
    1114,  1300,  1214,   481,   873,  1303,  1354,   518,   781,  1306,
    1172,  1192,  1038,   791,  1202,   752,  1392,  1009,  1311,  1383,
     698,   482,   758,  1408,   744,   739,   291,   921,  1398,   583,
    1410,  1108,   465,  1322,   294,  1399,  1096,  1289,  1275,  1406,
     541,   544,   584,   236,   237,   238,  1288,   240,  1268,   979,
    1286,     2,     3,   691,     4,   719,     5,     6,     7,     8,
     623,     9,    10,    11,    12,   754,     0,     0,     0,     0,
     194,     0,     0,     0,     0,   197,     0,   583,     0,   517,
       0,   203,   182,    13,   205,     0,   183,     0,     0,   185,
       0,     0,     0,   186,   935,     0,   595,   936,     0,     0,
     719,     0,     0,   937,     0,     0,     0,     0,   324,     0,
       0,     0,     0,  -578,     0,  1115,  1115,  1115,     0,     0,
       0,     0,     0,     0,     0,  -875,   213,     0,   938,   196,
       0,   198,   199,     0,     0,     0,     0,   595,     0,     0,
       0,     0,     0,     0,     0,     0,   725,   209,   171,  1400,
     173,   174,   175,   176,     0,   298,     0,   300,   290,   301,
     302,   303,   304,   305,     0,     0,     0,   236,   237,   238,
     239,   240,  1076,  1413,     0,  -849,   242,   216,   217,   218,
       0,   219,   220,     0,  1414,  1097,     0,   223,  -849,     0,
       0,   725,     0,   699,   700,     0,   701,   702,   703,   704,
       0,    14,    15,     0,    16,    17,     0,   229,    18,     0,
      64,     0,   194,    65,    66,     0,     0,   197,     0,   233,
     234,     0,     0,   203,     0,     0,   205,     0,    19,     0,
      20,     0,     0,     0,     0,  1335,     0,  -849,    21,     0,
       0,     0,     0,   595,     0,  -849,     0,     0,     0,    65,
      66,     0,    22,    23,   146,     0,     0,    24,     0,     0,
       0,     0,    25,     0,  1385,     0,     0,  1366,     0,    26,
      27,    28,     0,     0,     0,     0,     0,     0,    29,   636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    69,   595,     0,     0,     0,     0,    67,     0,
       0,     0,     0,     0,  -849,     0,     0,     0,     0,   236,
     237,   238,   239,   240,     0,     0,     0,     0,   242,     0,
     935,     0,     0,   936,     0,     0,     0,     0,     0,   937,
       0,     0,   679,  1098,     0,     0,     0,     0,     0,     0,
      30,   595,     0,   383,    31,   290,   384,   385,   637,   -95,
     388,   389,   390,   391,   938,   392,   393,   394,    32,   395,
     396,     0,   397,  -849,   398,   399,   400,   401,   402,     0,
     403,     0,   404,     0,   405,   406,   407,     0,   408,     0,
     409,     0,   410,     0,   411,   412,   413,   414,     0,     0,
     415,   416,     0,   417,   418,     0,   419,     0,   420,     0,
     421,     0,   422,     0,   423,     0,   424,   425,   638,     0,
     673,  -849,     0,   147,   148,   149,   150,   151,   152,   153,
     154,   155,     0,     0,   156,   157,   158,   159,   160,     0,
       0,     0,     0,     0,     0,   427,     0,   428,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   429,     0,     0,     0,
       0,     0,     0,  -849,     0,     0,     0,  -849,     0,     0,
       0,     0,     0,     0,    74,     0,     0,    75,    76,    77,
       0,    78,     0,    79,    80,     0,    81,    82,    83,     0,
      84,    85,     0,    86,     0,    87,    88,    89,    90,    91,
       0,    92,     0,    93,     0,    94,    95,    96,     0,    97,
       0,    98,     0,    99,     0,   100,   101,   102,   103,   104,
       0,   105,   106,     0,   107,   108,     0,   109,     0,   110,
       0,   111,     0,   112,     0,   113,     0,   114,   115,   116,
     181,     0,     0,   182,     0,     0,  -204,   183,     0,   184,
     185,     0,     0,     0,   186,   187,   188,     0,   189,   190,
      15,     0,   191,    17,   192,     0,   430,   431,   432,   433,
     434,     0,     0,   435,     0,   436,   437,     0,   438,     0,
       0,     0,   439,   440,   441,   442,   194,     0,    20,   195,
     196,   197,   198,   199,   200,   201,   466,   203,     0,     0,
     205,   206,     0,   207,     0,   208,     0,     0,   209,     0,
      22,     0,     0,   117,     0,     0,   210,     0,   211,   212,
     177,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   467,   216,   217,
     218,     0,   219,   220,     0,   221,     0,     0,   223,     0,
       0,     0,   224,     0,     0,   225,     0,     0,   226,     0,
     227,     0,     0,     0,     0,     0,     0,   228,   229,     0,
     230,   231,   119,     0,     0,   232,     0,     0,     0,   134,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   178,
       0,   179,   242,   135,     0,  -266,   695,   180,     0,     0,
   -1083,     0,     0,   696,   697,     0,     0,     0,  -266,   483,
      65,    66,   484,     0,     0,     0,     0,     0,     0,     0,
    -266,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     136,     0,     0,     0,   698,     0,     0,   137,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     181,     0,     0,   182,     0,     0,     0,   183,     0,   184,
     185,     0,     0,     0,   186,   187,   188,     0,   189,   190,
      15,   695,   191,    17,   192,     0,     0,     0,   696,   697,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   193,   194,     0,    20,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   698,
     205,   206,     0,   207,     0,   208,     0,     0,   209,     0,
      22,    23,  -999,     0,  -999,    24,   210,     0,   211,   212,
       0,  -266,  -875,   213,     0,     0,     0,    26,    27,    28,
     213,     0,     0,     0,     0,   214,  -992,   215,   216,   217,
     218,     0,   219,   220,     0,   221,   222,     0,   223,     0,
       0,     0,   224,     0,     0,   225,     0,     0,   226,     0,
     227,     0,     0,     0,     0,     0,     0,   228,   229,     0,
     230,   231,     0,     0,     0,   232,     0,     0,     0,     0,
     233,   234,   235,   236,   237,   238,   239,   240,   241,     0,
       0,  1035,   242,     0,   547,  -266,     0,   699,   700,   548,
     701,   702,   703,   704,  -875,   213,  -723,   243,  -723,  -723,
      65,    66,  -999,     0,    64,  -723,     0,    65,    66,  -723,
       0,     0,     0,     0,  -723,  -723,     0,     0,     0,     0,
       0,     0,     0,  -723,   549,  -723,     0,     0,     0,  -723,
       0,     0,     0,   550,  -723,     0,  -723,     0,     0,   551,
     552,  -723,  -723,     0,     0,     0,     0,  -266,     0,     0,
       0,  -266,     0,     0,  -266,     0,   138,     0,     0,    65,
      66,     0,   699,   700,     0,   701,   702,   703,   704,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    64,
       0,     0,    65,    66,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   553,     0,     0,  -723,     0,   554,     0,  -723,     0,
     555,  -723,     0,     0,     0,  -723,  -723,  -723,     0,  -723,
     556,  -723,     0,   557,  -723,  -723,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   194,   558,  -723,
    -723,  -723,   197,  -723,  -723,  -723,  -723,   559,   203,     0,
       0,   560,     0,     0,   334,     0,   561,   562,     0,  -723,
       0,  -723,     0,     0,   563,     0,     0,   564,     0,   565,
     566,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   567,   568,     0,     0,     0,     0,     0,   569,  -723,
    -723,  -723,   340,     0,     0,   341,     0,     0,     0,  -723,
     342,     0,   343,   570,     0,     0,   571,   572,     0,   573,
       0,   574,   348,     0,   349,   350,     0,   351,   352,  -723,
       0,   575,   576,     0,     0,     0,   577,   356,     0,     0,
       0,  -723,  -723,  -723,   578,   579,   580,     0,   240,   581,
    -723,  -723,  -723,     0,  -723,  -723,  -723,  -723,  1142,     0,
       0,   547,     0,     0,     0,     0,   548,   679,   582,     0,
       0,  -723,  -723,  -723,     0,  -723,  -723,     0,     0,     0,
       0,     0,  -723,     0,     0,     0,  -723,     0,     0,     0,
       0,  -723,  -723,     0,     0,     0,     0,     0,     0,     0,
    1143,   549,  -723,     0,     0,     0,  -723,     0,     0,     0,
     550,  -723,     0,  -723,     0,     0,   551,   552,  -723,  -723,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   553,     0,
       0,  -723,     0,   554,     0,  -723,     0,   555,  -723,     0,
       0,     0,  -723,  -723,  -723,     0,  -723,   556,  -723,     0,
     557,  -723,  -723,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   194,   558,  -723,  -723,  -723,   197,
    -723,  -723,  -723,  -723,   559,   203,     0,     0,   560,     0,
       0,   334,     0,   561,   562,     0,  -723,     0,  -723,     0,
       0,   563,     0,     0,   564,     0,   565,   566,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   567,   568,
       0,     0,     0,     0,     0,   569,  -723,  -723,  -723,   340,
       0,     0,   341,     0,     0,     0,  -723,   342,     0,   343,
     570,     0,     0,   571,   572,     0,   573,     0,   574,   348,
       0,   349,   350,     0,   351,   352,  -723,     0,   575,   576,
       0,     0,     0,   577,   356,     0,     0,     0,  -723,  -723,
    -723,   578,   579,   580,     0,   240,   581,  -723,  -723,  -723,
       0,  -723,  -723,  -723,  -723,  1182,     0,     0,   547,     0,
       0,     0,     0,   548,     0,   582,     0,     0,  -723,  -723,
    -723,     0,  -723,  -723,     0,     0,     0,     0,     0,  -723,
       0,     0,     0,  -723,     0,     0,     0,     0,  -723,  -723,
       0,     0,     0,     0,     0,     0,     0,  -723,   549,  -723,
       0,     0,     0,  -723,     0,     0,     0,   550,  -723,     0,
    -723,     0,     0,   551,   552,  -723,  -723,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   553,     0,     0,  -723,     0,
     554,     0,  -723,     0,   555,  -723,     0,     0,     0,  -723,
    -723,  -723,     0,  -723,   556,  -723,     0,   557,  -723,  -723,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   194,   558,  -723,  -723,  -723,   197,  -723,  -723,  -723,
    -723,   559,   203,     0,     0,   560,     0,     0,   334,     0,
     561,   562,     0,  -723,     0,  -723,     0,     0,   563,     0,
       0,   564,     0,   565,   566,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   567,   568,     0,     0,     0,
       0,     0,   569,  -723,  -723,  -723,   340,     0,     0,   341,
       0,     0,     0,  -723,   342,     0,   343,   570,     0,     0,
     571,   572,     0,   573,     0,   574,   348,     0,   349,   350,
       0,   351,   352,  -723,     0,   575,   576,     0,     0,     0,
     577,   356,     0,     0,     0,  -723,  -723,  -723,   578,   579,
     580,     0,   240,   581,  -723,  -723,  -723,     0,  -723,  -723,
    -723,  -723,  1282,     0,     0,   547,     0,     0,     0,     0,
     548,     0,   582,     0,     0,  -723,  -723,  -723,     0,  -723,
    -723,     0,     0,     0,     0,     0,  -723,     0,     0,     0,
    -723,     0,     0,     0,     0,  -723,  -723,     0,     0,     0,
       0,     0,     0,     0,  -723,   549,  -723,     0,     0,     0,
    -723,     0,     0,     0,   550,  -723,     0,  -723,     0,     0,
     551,   552,  -723,  -723,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   553,     0,     0,  -723,     0,   554,     0,  -723,
       0,   555,  -723,     0,     0,     0,  -723,  -723,  -723,     0,
    -723,   556,  -723,     0,   557,  -723,  -723,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   194,   558,
    -723,  -723,  -723,   197,  -723,  -723,  -723,  -723,   559,   203,
       0,     0,   560,     0,     0,   334,     0,   561,   562,     0,
    -723,     0,  -723,     0,     0,   563,     0,     0,   564,     0,
     565,   566,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   567,   568,     0,     0,     0,     0,     0,   569,
    -723,  -723,  -723,   340,     0,     0,   341,     0,     0,     0,
    -723,   342,     0,   343,   570,     0,     0,   571,   572,     0,
     573,     0,   574,   348,     0,   349,   350,     0,   351,   352,
    -723,    73,   575,   576,   -60,     0,     0,   577,   356,   -60,
       0,     0,  -723,  -723,  -723,   578,   579,   580,     0,   240,
     581,  -723,  -723,  -723,     0,  -723,  -723,  -723,  -723,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   -60,   582,
       0,     0,  -723,  -723,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   -60,     0,     0,     0,     0,     0,   -60,
     -60,     0,     0,     0,     0,    74,     0,     0,    75,    76,
      77,     0,    78,     0,    79,    80,     0,    81,    82,    83,
       0,    84,    85,     0,    86,     0,    87,    88,    89,    90,
      91,     0,    92,     0,    93,     0,    94,    95,    96,     0,
      97,     0,    98,     0,    99,     0,   100,   101,   102,   103,
     104,     0,   105,   106,     0,   107,   108,     0,   109,     0,
     110,     0,   111,     0,   112,     0,   113,     0,   114,   115,
     116,     0,     0,     0,     0,   320,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     -60,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   -60,     0,     0,
       0,     0,   -60,     0,     0,     0,     0,   -60,     0,     0,
       0,     0,     0,     0,   -60,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,   321,     0,   -60,     0,   -60,
     -60,     0,   118,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   -60,     0,     0,     0,     0,     0,   -60,     0,
       0,     0,   -60,     0,     0,   -60,     0,     0,     0,     0,
     -60,     0,   -60,   -60,     0,     0,   -60,   -60,     0,   -60,
       0,     0,   -60,     0,   -60,   -60,     0,   -60,   -60,     0,
       0,   -60,   -60,   119,     0, -1064,   -60,   -60, -1064,     0,
       0,     0, -1064,     0, -1064, -1064,     0,     0,     0, -1064,
   -1064, -1064,     0, -1064, -1064, -1064,     0, -1064, -1064, -1064,
       0,     0,     0,     0,  1231,     0,     0,     0,    64,     0,
       0,    65,    66,     0,     0,     0,     0,     0,     0,     0,
       0, -1064,   888, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064,     0,     0, -1064, -1064,     0, -1064,     0,
   -1064,     0,     0, -1064,     0, -1064,     0,     0,     0,     0,
       0, -1064,     0, -1064, -1064,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   889,     0,     0,     0,     0,
       0,     0, -1064, -1064, -1064, -1064,     0, -1064, -1064,     0,
   -1064,     0,     0, -1064,     0,     0,     0, -1064,     0,     0,
   -1064,     0,     0, -1064,     0, -1064,     0,     0,     0,     0,
       0,     0, -1064, -1064,     0, -1064, -1064,     0,     0,     0,
   -1064,     0,     0,     0,     0, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064,     0,     0,     0, -1064,     0,     0,
       0,     0,     0,     0, -1064,     0,     0, -1064,     0,     0,
       0, -1064,   890, -1064, -1064, -1064, -1064,     0, -1064, -1064,
   -1064,     0, -1064, -1064, -1064,     0, -1064, -1064, -1064,     0,
       0,     0,     0,  1375,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -1064,   888, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064,     0,     0, -1064, -1064,     0, -1064,     0, -1064,
       0,     0, -1064,     0, -1064,     0,     0,     0,     0,     0,
   -1064,     0, -1064, -1064,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   889,     0,     0,     0,     0,     0,
       0, -1064, -1064, -1064, -1064,     0, -1064, -1064,     0, -1064,
       0,     0, -1064,     0,     0,     0, -1064,     0,     0, -1064,
       0,     0, -1064,     0, -1064,     0,     0,     0,     0,     0,
       0, -1064, -1064,     0, -1064, -1064,     0,     0,     0, -1064,
       0,     0,     0,     0, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064,     0,     0,     0, -1064,     0,     0,     0,
       0,     0,     0, -1064,     0,     0, -1064,     0,     0,     0,
   -1064,   890, -1064, -1064, -1064, -1064,     0, -1064, -1064, -1064,
       0, -1064, -1064, -1064,     0, -1064, -1064, -1064,     0,     0,
       0,     0,   692,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -1064,
     888, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064,     0,     0, -1064, -1064,     0, -1064,     0, -1064,     0,
       0, -1064,     0, -1064,     0,     0,     0,     0,     0, -1064,
       0, -1064, -1064,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   889,     0,     0,     0,     0,     0,     0,
   -1064, -1064, -1064, -1064,     0, -1064, -1064,     0, -1064,     0,
       0, -1064,     0,     0,     0, -1064,     0,     0, -1064,     0,
       0, -1064,     0, -1064,     0,     0,     0,     0,     0,     0,
   -1064, -1064,     0, -1064, -1064,     0,     0,     0, -1064,     0,
       0,     0,     0, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064,     0,     0,     0, -1064,     0,     0,     0,     0,
       0,     0,   181,     0,     0,   182,     0,     0,     0,   183,
     890,   184,   185, -1064, -1064,     0,   186,   187,   188,     0,
     189,   190,    15,     0,   191,    17,   192,     0,     0,     0,
     733,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   194,     0,
      20,   195,   196,   197,   198,   199,   200,   201,   466,   203,
       0,     0,   205,   206,     0,   207,     0,   208,     0,     0,
     209,     0,    22,     0,     0,     0,     0,     0,   210,     0,
     211,   212,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   467,
     216,   217,   218,     0,   219,   220,     0,   221,     0,     0,
     223,     0,     0,     0,   224,     0,     0,   225,     0,     0,
     226,     0,   227,     0,     0,     0,     0,     0,     0,   228,
     229,     0,   230,   231,     0,     0,     0,   232,     0,     0,
       0,     0,   233,   234,   235,   236,   237,   238,   239,   240,
     241,     0,     0,     0,   242,     0,     0,     0,     0,     0,
     181,     0,     0,   182,     0,     0,     0,   183,   679,   184,
     185,     0,    65,    66,   186,   187,   188,     0,   189,   190,
      15,     0,   191,    17,   192,     0,   547,     0,     0,     0,
       0,   548,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   194,     0,    20,   195,
     196,   197,   198,   199,   200,   201,   466,   203,     0,     0,
     205,   206,     0,   207,     0,   208,   549,     0,   209,     0,
      22,     0,     0,     0,     0,   550,   210,     0,   211,   212,
       0,   551,   552,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -709,     0,     0,     0,   467,   216,   217,
     218,     0,   219,   220,     0,   221,     0,     0,   223,     0,
       0,     0,   224,     0,     0,   225,     0,     0,   226,     0,
     227,     0,     0,     0,     0,     0,     0,   228,   229,     0,
     230,   231,     0,     0,     0,   232,     0,     0,     0,     0,
     233,   234,   235,   236,   237,   238,   239,   240,   241,     0,
       0,     0,   242,   553,     0,     0,     0,     0,   554,     0,
       0,     0,   555,     0,     0,     0,     0,     0,     0,     0,
      65,    66,   556,     0,     0,   557,     0,     0,     0,     0,
       0,   547,     0,     0,     0,     0,   548,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   194,
     558,     0,     0,     0,   197,     0,     0,     0,     0,   559,
     203,     0,     0,   560,     0,     0,   334,     0,   561,   562,
       0,   549,     0,     0,     0,     0,   563,     0,     0,   564,
     550,   565,   566,     0,     0,     0,   551,   552,     0,     0,
       0,     0,     0,   567,   568,     0,     0,     0,     0,     0,
     569,     0,     0,     0,   340,     0,     0,   341,     0,     0,
       0,     0,   342,     0,   343,   570,     0,     0,   571,   572,
       0,   573,     0,   574,   348,     0,   349,   350,     0,   351,
     352,     0,     0,   575,   576,     0,     0,     0,   577,   356,
       0,     0,     0,     0,     0,     0,   578,   579,   580,     0,
     240,   581,     0,     0,     0,     0,     0,     0,   553,     0,
       0,     0,     0,   554,     0,     0,     0,   555,  -807,     0,
     582,     0,     0,     0,     0,     0,     0,   556,     0,     0,
     557,  -807,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   980,   981,     0,   194,   558,     0,     0,     0,   197,
       0,     0,     0,     0,   559,   203,     0,   982,   560,     0,
       0,   334,     0,   561,   562,     0,     0,     0,     0,     0,
    -807,   563,     0,     0,   564,     0,   565,   566,  -807,     0,
       0,     0,     0,     0,     0,   983,     0,     0,   567,   568,
       0,     0,   980,   981,     0,   569,     0,     0,     0,   340,
       0,     0,   341,     0,     0,     0,     0,   342,   982,   343,
     570,     0,     0,   571,   572,     0,   573,     0,   574,   348,
       0,   349,   350,     0,   351,   352,     0,     0,   575,   576,
       0,     0,     0,   577,   356,     0,   983,  -807,     0,     0,
       0,   578,   579,   580,     0,   240,   581,     0,     0,     0,
       0,     0,     0,   187,   188,     0,   189,   984,     0,     0,
       0,   985,   192,     0,   986,   582,     0,     0,   987,     0,
       0,     0,     0,     0,    15,     0,     0,    17,     0,     0,
       0,     0,     0,   547,     0,     0,     0,   195,   548,     0,
       0,     0,   200,   201,     0,     0,  -807,     0,     0,     0,
       0,     0,    20,     0,   988,     0,   989,   990,   984,     0,
       0,     0,   985,     0,     0,   986,     0,     0,     0,   987,
       0,     0,   991,   549,    22,     0,     0,     0,     0,     0,
       0,     0,   550,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -807,     0,     0,     0,     0,     0,
       0,     0,   992,   993,   994,   988,     0,   989,   990,     0,
       0,     0,   995,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   991,     0,     0,     0,     0,     0,     0,
     235,     0,   996,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   997,   998,  -807,     0,     0,     0,
    -807,     0,   328,   992,   993,   994,     0,   329,     0,     0,
     553,     0,     0,   995,     0,   554,     0,     0,     0,   555,
       0,     0,     0,     0,    65,    66,     0,     0,     0,   556,
       0,     0,   557,   996,     0,     0,   330,     0,     0,     0,
       0,     0,     0,     0,     0,   997,   998,     0,     0,     0,
       0,   331,     0,     0,     0,     0,   194,     0,     0,     0,
       0,   197,     0,     0,     0,   766,   559,   203,     0,     0,
     560,     0,  1407,   334,   767,   561,   562,     0,   768,     0,
       0,     0,     0,   563,  -715,     0,   564,     0,   565,   566,
       0,     0,  -715,     0,  -715,     0,     0,     0,   769,     0,
     567,   568,     0,   770,     0,   771,     0,   569,     0,     0,
     772,   340,     0,     0,   341,     0,     0,     0,     0,   342,
       0,   343,   570,     0,     0,   571,   572,     0,   573,     0,
     574,   348,     0,   349,   350,     0,   351,   352,   328,     0,
     575,   576,     0,   329,     0,   577,   356,     0,   332,     0,
       0,     0,     0,   578,   579,   580,     0,   240,   581,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   333,     0,   331,     0,     0,
       0,     0,   334,     0,     0,   187,   188,     0,   189,     0,
       0,     0,     0,     0,   192,   335,     0,   336,   337,  1206,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     338,     0,     0,     0,     0,     0,   339,     0,     0,   195,
     340,     0,     0,   341,   200,   201,     0,     0,   342,     0,
     343,   344,     0,     0,   345,   346,     0,   347,     0,     0,
     348,     0,   349,   350,     0,   351,   352,     0,     0,   353,
     354,     0,     0,     0,   355,   356,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   332,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   333,   235,     0,     0,     0,     0,     0,   334,   773,
     699,   700,     0,   701,   702,   703,   704,     0,     0,     0,
       0,   335,     0,   336,   337,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   338,     0,     0,     0,
       0,     0,   339,     0,     0,     0,   340,     0,     0,   341,
       0,     0,     0,     0,   342,     0,   343,   344,     0,     0,
     345,   346,     0,   347,     0,     0,   348,     0,   349,   350,
       0,   351,   352,     0,     0,   353,   354,     0,     0,   383,
     355,   356,   384,   385,   842,   843,   388,   389,   390,   391,
       0,   392,   393,   394,     0,   395,   396,     0,   397,     0,
     398,   399,   400,   401,   402,     0,   403,     0,   404,     0,
     405,   406,   407,     0,   408,     0,   409,     0,   410,     0,
     411,   412,   413,   414,     0,     0,   415,   416,     0,   417,
     418,     0,   419,     0,   420,     0,   421,     0,   422,     0,
     423,     0,   424,   425,   844,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   427,   845,   428,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   846,   847,     0,     0,     0,     0,     0,
       0,     0,   429,     0,   383,     0,     0,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,     0,
     395,   396,     0,   397,     0,   398,   399,   400,   401,   402,
       0,   403,     0,   404,     0,   405,   406,   407,     0,   408,
       0,   409,     0,   410,     0,   411,   412,   413,   414,     0,
       0,   415,   416,     0,   417,   418,     0,   419,     0,   420,
       0,   421,     0,   422,     0,   423,     0,   424,   425,   426,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   427,     0,   428,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   430,   431,   432,   433,   434,   429,     0,   435,
       0,   436,   437,     0,   438,     0,     0,     0,   439,   440,
     441,   442,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   383,     0,     0,   384,   385,   645,   387,   388,   389,
     390,   391,     0,   392,   393,   394,     0,   395,   396,     0,
     397,     0,   398,   399,   400,   401,   402,     0,   403,     0,
     404,     0,   405,   406,   407,     0,   408,     0,   409,     0,
     410,     0,   411,   412,   413,   414,     0,     0,   415,   416,
       0,   417,   418,     0,   419,     0,   420,     0,   421,     0,
     422,     0,   423,     0,   424,   425,   426,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   430,   431,   432,
     433,   434,     0,   427,   435,   428,   436,   437,     0,   438,
       0,     0,     0,   439,   440,   441,   442,     0,   383,     0,
       0,   384,   385,   824,   429,   388,   389,   390,   391,     0,
     392,   393,   394,     0,   395,   396,     0,   397,     0,   398,
     399,   400,   401,   402,     0,   403,     0,   404,     0,   405,
     406,   407,     0,   408,     0,   409,     0,   410,     0,   411,
     412,   413,   414,     0,     0,   415,   416,     0,   417,   418,
       0,   419,     0,   420,     0,   421,     0,   422,     0,   423,
       0,   424,   425,   426,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     427,     0,   428,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   429,     0,     0,   430,   431,   432,   433,   434,     0,
       0,   435,     0,   436,   437,     0,   438,     0,     0,     0,
     439,   440,   441,   442,     0,   383,     0,     0,   384,   385,
     637,     0,   388,   389,   390,   391,     0,   392,   393,   394,
       0,   395,   396,     0,   397,     0,   398,   399,   400,   401,
     402,     0,   403,     0,   404,     0,   405,   406,   407,     0,
     408,     0,   409,     0,   410,     0,   411,   412,   413,   414,
       0,     0,   415,   416,     0,   417,   418,     0,   419,     0,
     420,     0,   421,     0,   422,     0,   423,     0,   424,   425,
     830,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   430,   431,   432,   433,   434,     0,   427,   435,   428,
     436,   437,     0,   438,     0,     0,     0,   439,   440,   441,
     442,     0,   383,     0,     0,   384,   385,   637,   429,   388,
     389,   390,   391,     0,   392,   393,   394,     0,   395,   396,
       0,   397,     0,   398,   399,   400,   401,   402,     0,   403,
       0,   404,     0,   405,   406,   407,     0,   408,     0,   409,
       0,   410,     0,   411,   412,   413,   414,     0,     0,   415,
     416,     0,   417,   418,     0,   419,     0,   420,     0,   421,
       0,   422,     0,   423,     0,   424,   425,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   427,     0,   428,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   429,     0,     0,   430,   431,
     432,   433,   434,     0,     0,   435,     0,   436,   437,     0,
     438,     0,     0,     0,   439,   440,   441,   442,     0,     0,
       0,     0,     0,     0,     0,     0,   180,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   181,
       0,     0,   182,     0,     0,     0,   183,     0,   184,   185,
       0,     0,     0,   186,   187,   188,     0,   189,   190,    15,
       0,   191,    17,   192,     0,   430,   431,   432,   433,   434,
       0,     0,   435,     0,   436,   437,     0,   438,     0,     0,
       0,   439,   440,   441,   442,   194,     0,    20,   195,   196,
     197,   198,   199,   200,   201,   466,   203,     0,     0,   205,
     206,     0,   207,     0,   208,     0,     0,   209,     0,    22,
       0,     0,     0,     0,     0,   210,     0,   211,   212,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   467,   216,   217,   218,
       0,   219,   220,     0,   221,     0,     0,   223,     0,     0,
       0,   224,     0,     0,   225,     0,     0,   226,     0,   227,
       0,     0,     0,     0,     0,     0,   228,   229,     0,   230,
     231,     0,     0,     0,   232,     0,     0,     0,     0,   233,
     234,   235,   236,   237,   238,   239,   240,   241,     0,     0,
       0,   242,     0,     0,     0,     0,     0,   181,     0,     0,
     182,     0,     0,     0,   183,     0,   184,   185,     0,    65,
      66,   186,   187,   188,     0,   189,   190,    15,     0,   191,
      17,   192,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   194,     0,    20,   195,   196,   197,   198,
     199,   200,   201,   466,   203,     0,     0,   205,   206,     0,
     207,     0,   208,     0,     0,   209,     0,    22,     0,     0,
       0,     0,     0,   210,     0,   211,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   467,   216,   217,   218,     0,   219,
     220,     0,   221,     0,     0,   223,     0,     0,     0,   224,
       0,     0,   225,     0,     0,   226,     0,   227,     0,     0,
       0,     0,     0,     0,   228,   229,     0,   230,   231,     0,
       0,     0,   232,     0,     0,     0,     0,   233,   234,   235,
     236,   237,   238,   239,   240,   241,     0,     0,   182,   242,
       0,     0,   183,     0,     0,   185,     0,     0,     0,   186,
     935,     0,     0,   936,     0,     0,     0,    65,    66,   937,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   938,   196,     0,   198,   199,     0,
       0,     0,     0,     0,     0,   181,     0,     0,     0,     0,
       0,     0,     0,   209,   184,     0,     0,     0,     0,     0,
     187,   188,     0,   189,   190,     0,     0,   191,     0,   192,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   216,   217,   218,     0,   219,   220,     0,
       0,   194,     0,   223,   195,     0,   197,     0,     0,   200,
     201,   466,   203,     0,     0,   205,     0,     0,   207,     0,
     208,     0,     0,   229,     0,     0,     0,     0,     0,     0,
       0,   210,     0,   211,   212,   233,   234,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   467,     0,     0,     0,     0,     0,     0,     0,
     221,     0,     0,     0,     0,    65,    66,   224,     0,     0,
     225,     0,     0,   226,     0,   227,     0,     0,     0,     0,
       0,     0,   228,     0,     0,   230,   231,     0,     0,     0,
     232,     0,     0,     0,     0,     0,     0,   235,   236,   237,
     238,   239,   240,   241,     0,     0,     0,   242
};

static const yytype_int16 yycheck[] =
{
       4,     5,     6,    35,    12,     1,     4,     5,     6,   178,
     286,     1,   318,   477,    67,   318,   120,   155,   274,   326,
     327,   742,   909,   505,   506,   507,   180,   206,   307,   492,
     126,    35,    40,   975,   179,   506,    40,    35,   184,   218,
     767,   729,   642,   816,   180,     1,   773,   942,     1,   882,
     318,   505,   506,   507,   887,     1,   919,   932,   364,     1,
     366,   364,     1,   366,     1,   696,   697,   698,     1,     1,
     249,     1,     1,     1,     1,   264,    42,     1,     1,     1,
     495,     1,   377,     1,    65,    78,    67,     1,   708,   504,
       1,   359,   641,     1,   273,     1,   364,     1,   366,     1,
      65,     1,     1,     1,     1,     1,     1,     1,    75,  1143,
    1171,    14,     1,     1,   587,     1,    21,   875,     1,     1,
       1,    71,     1,     1,     1,     1,     1,     1,    30,    71,
       1,     1,     1,   148,    71,    52,     1,    17,   896,     1,
       1,   899,    59,    63,     1,     1,    77,   920,    17,   870,
      70,     1,     1,    71,     1,     1,     1,    21,    17,   465,
      63,   386,   465,     1,   579,     1,    55,   925,     1,   151,
     178,    71,     1,   505,   506,   507,   468,   108,    58,   203,
      16,   205,     1,   203,     3,   205,   907,    73,    70,   299,
      72,    72,    78,    70,    58,    55,    71,   465,    73,    73,
       1,     1,    48,    73,    70,   832,    65,    54,    41,    71,
      71,    77,    78,     1,    71,    71,    97,  1278,    96,   201,
    1095,   909,    71,    73,     1,   136,    71,    72,   178,    58,
     245,   136,   226,    71,  1129,   514,   178,   516,   253,  1273,
      70,   723,   108,     1,    78,   513,   134,   112,   178,   145,
    1125,   153,   278,   136,   269,   130,   264,    58,   745,   148,
     130,   130,     1,   745,   543,   277,   278,    46,   130,   723,
      58,   221,   136,   130,   130,   745,   293,   908,   157,   303,
     130,   450,   831,   303,    65,   588,   189,    26,   148,   505,
     506,   507,   130,   204,   914,  1053,  1054,  1055,  1056,   221,
     308,     1,   306,   307,   297,   313,   788,   288,   306,   307,
     277,   319,   365,   309,   318,   319,   789,   241,   497,   498,
     588,   490,   511,   288,   228,   227,   480,   256,   482,  1204,
     296,   363,  1274,   502,   237,   504,   631,   270,  1059,  1281,
     211,   297,   806,   512,   523,   481,   299,   526,   298,  1212,
     289,   766,   521,   835,   300,     1,   298,   303,   290,   363,
     364,   298,   366,   291,   835,   363,   298,   290,   298,   301,
     302,   298,  1259,  1260,   301,   302,   840,   297,   685,   686,
     298,   835,  1257,   675,   298,  1218,   297,   301,   302,   681,
     298,   723,   298,   301,   302,   301,  1169,  1170,   298,   298,
     298,   298,   694,   298,   298,   820,   505,   506,   507,   555,
     289,   297,   288,   213,   293,   640,  1043,   642,     1,   298,
     902,   198,  1149,     1,   906,  1123,  1124,   652,   910,   911,
     912,   902,   298,   459,   897,   301,   302,   637,  1196,   910,
     911,   912,   450,  1330,  1044,  1340,  1321,   459,   902,  1391,
     208,   151,   906,   153,   154,   942,   910,   911,   912,  1090,
     942,   465,   292,   297,   298,   223,  1097,   297,   298,     1,
     300,    65,   942,   303,    23,   929,  1234,    17,     1,   179,
      17,    70,   490,    72,   492,    17,   792,   187,    71,   792,
      30,    72,     1,   908,   502,  1390,   504,   505,   506,   507,
      65,   201,    67,   835,   512,     1,   809,    17,   687,    46,
     514,   211,   516,   521,   820,   519,   514,   820,   516,   822,
      30,   519,   667,    72,   792,   148,     1,   227,    65,     1,
    1251,   627,   668,   177,  1421,  1306,  1294,    46,   182,   543,
     277,   809,   696,   697,   698,   543,   283,   130,    72,     1,
      73,  1322,   820,    28,   822,    78,   112,    77,    78,  1023,
     696,   697,   698,  1261,     1,   744,  1197,   859,   933,   984,
     902,  1259,  1260,   151,   906,    71,   154,    65,   910,   911,
     912,     1,    81,    77,    78,     1,   232,    72,   108,   235,
    1005,   291,  1350,     1,    70,    72,   242,   929,  1296,    71,
     965,   908,    78,   297,   298,    57,   252,   832,   254,    17,
    1074,   257,   258,   153,  1078,    70,   795,  1315,   112,   835,
    1347,   267,   245,   201,   824,   850,   826,   150,  1326,    37,
     253,   222,   130,    70,   130,     1,   236,    65,    59,    60,
      77,    78,  1330,   153,   297,   298,   269,    27,   924,   289,
      58,    71,   298,   293,   177,    71,   247,   277,   130,   182,
      10,  1349,  1420,   969,    14,   188,   969,   300,   191,    19,
     303,   108,   187,   979,    54,   146,   979,   277,   149,  1400,
      43,  1369,    45,   283,   155,   854,   902,   227,   283,    70,
     906,    72,  1413,   227,   910,   911,   912,    77,    78,   151,
     213,   969,   154,    81,  1402,  1403,   227,    73,  1011,   180,
     130,   979,  1194,   929,   130,   723,  1369,   227,    70,   723,
     999,  1000,  1028,  1194,   298,  1028,   895,   221,   298,  1417,
    1418,    73,   112,  1421,   288,   187,   835,   745,   214,   877,
    1194,   749,   750,  1011,   187,    18,   750,    20,   290,   201,
     919,   274,   275,   276,   908,   278,   177,  1239,    65,   211,
    1028,   182,  1226,    65,  1417,  1418,   177,    54,  1239,    56,
    1062,   182,   908,    70,   297,   298,   213,   214,   298,    71,
     788,   301,   302,   298,   130,  1239,   301,   302,   792,   800,
     801,  1098,   788,  1100,    70,  1102,   227,  1089,   788,  1091,
    1254,  1255,  1256,   902,   298,   809,    73,   906,    71,  1378,
     106,   910,   911,   912,   952,  1384,   820,   955,  1043,  1044,
    1112,   130,   298,     4,     5,   301,   302,   835,  1243,    67,
     929,   213,  1401,  1248,  1140,   246,   290,  1140,   249,  1303,
     288,   221,    40,   290,   281,   282,   854,   284,   285,   286,
     287,  1107,    31,  1422,    33,   298,   290,    36,   301,   302,
     290,   298,  1194,    70,   301,   302,   232,   278,    39,   235,
      73,    71,  1140,   213,   878,  1181,   242,    71,  1181,  1017,
     298,   106,    70,   301,   302,    70,   252,   895,   254,   897,
      35,   257,   258,  1308,   902,    71,   298,    71,   906,   301,
     302,   267,   910,   911,   912,    78,  1198,  1239,  1215,    71,
      50,   919,   297,  1181,  1254,  1255,  1256,    51,   298,    71,
      73,    71,  1254,  1255,  1256,  1217,    22,    71,   130,  1108,
     298,    70,   298,    71,   942,    71,  1090,  1116,  1245,   298,
      73,    73,   289,  1097,    71,    46,  1100,    78,    71,    71,
     946,    72,    70,     1,  1090,   112,   946,  1061,   153,    71,
      71,  1097,    71,  1020,   804,   969,   829,   142,   648,   640,
     871,  1109,   824,   826,  1049,   979,   132,  1030,  1194,   631,
     376,  1287,  1250,   850,  1287,    40,   177,  1279,   946,     1,
      40,   182,   748,  1194,   946,   999,  1000,   188,   946,   507,
     191,   999,  1000,   723,   295,   723,  1298,  1011,  1374,  1316,
    1317,  1303,  1319,  1320,  1306,   906,  1085,   723,   178,  1287,
    1312,    40,    70,  1239,  1028,   268,   736,   264,   745,    77,
      78,  1337,  1127,   942,  1337,    20,   908,  1206,  1254,  1255,
    1256,  1216,  1070,  1197,   668,  1219,  1305,   288,   587,  1228,
    1011,  1038,   822,   588,  1058,   547,  1348,   789,  1237,  1327,
     108,  1197,   555,  1389,   527,   516,    40,   727,  1360,  1337,
    1389,   919,   172,  1252,    40,  1367,     1,  1192,  1152,  1385,
     309,   311,  1385,   274,   275,   276,  1191,   278,  1135,   786,
    1184,     0,     1,   503,     3,  1194,     5,     6,     7,     8,
     359,    10,    11,    12,    13,   550,    -1,    -1,    -1,    -1,
     177,    -1,    -1,    -1,    -1,   182,    -1,  1385,    -1,  1395,
      -1,   188,   134,    32,   191,    -1,   138,    -1,    -1,   141,
      -1,    -1,    -1,   145,   146,    -1,  1140,   149,    -1,    -1,
    1239,    -1,    -1,   155,    -1,    -1,    -1,    -1,    73,    -1,
      -1,    -1,    -1,    78,    -1,  1254,  1255,  1256,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   213,   214,    -1,   180,   181,
      -1,   183,   184,    -1,    -1,    -1,    -1,  1181,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1194,   199,    34,  1368,
      36,    37,    38,    39,    -1,    41,    -1,    43,  1206,    45,
      46,    47,    48,    49,    -1,    -1,    -1,   274,   275,   276,
     277,   278,  1216,  1392,    -1,     1,   283,   229,   230,   231,
      -1,   233,   234,    -1,  1393,   150,    -1,   239,    14,    -1,
      -1,  1239,    -1,   281,   282,    -1,   284,   285,   286,   287,
      -1,   150,   151,    -1,   153,   154,    -1,   259,   157,    -1,
     298,    -1,   177,   301,   302,    -1,    -1,   182,    -1,   271,
     272,    -1,    -1,   188,    -1,    -1,   191,    -1,   177,    -1,
     179,    -1,    -1,    -1,    -1,  1271,    -1,    63,   187,    -1,
      -1,    -1,    -1,  1287,    -1,    71,    -1,    -1,    -1,   301,
     302,    -1,   201,   202,     1,    -1,    -1,   206,    -1,    -1,
      -1,    -1,   211,    -1,  1336,    -1,    -1,  1311,    -1,   218,
     219,   220,    -1,    -1,    -1,    -1,    -1,    -1,   227,     1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1336,  1337,    -1,    -1,    -1,    -1,  1336,    -1,
      -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,   274,
     275,   276,   277,   278,    -1,    -1,    -1,    -1,   283,    -1,
     146,    -1,    -1,   149,    -1,    -1,    -1,    -1,    -1,   155,
      -1,    -1,   297,   298,    -1,    -1,    -1,    -1,    -1,    -1,
     289,  1385,    -1,    65,   293,  1393,    68,    69,    70,    71,
      72,    73,    74,    75,   180,    77,    78,    79,   307,    81,
      82,    -1,    84,   189,    86,    87,    88,    89,    90,    -1,
      92,    -1,    94,    -1,    96,    97,    98,    -1,   100,    -1,
     102,    -1,   104,    -1,   106,   107,   108,   109,    -1,    -1,
     112,   113,    -1,   115,   116,    -1,   118,    -1,   120,    -1,
     122,    -1,   124,    -1,   126,    -1,   128,   129,   130,    -1,
       1,   237,    -1,   160,   161,   162,   163,   164,   165,   166,
     167,   168,    -1,    -1,   171,   172,   173,   174,   175,    -1,
      -1,    -1,    -1,    -1,    -1,   157,    -1,   159,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,    -1,
      -1,    -1,    -1,   289,    -1,    -1,    -1,   293,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    -1,    68,    69,    70,
      -1,    72,    -1,    74,    75,    -1,    77,    78,    79,    -1,
      81,    82,    -1,    84,    -1,    86,    87,    88,    89,    90,
      -1,    92,    -1,    94,    -1,    96,    97,    98,    -1,   100,
      -1,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,    -1,   115,   116,    -1,   118,    -1,   120,
      -1,   122,    -1,   124,    -1,   126,    -1,   128,   129,   130,
     131,    -1,    -1,   134,    -1,    -1,   293,   138,    -1,   140,
     141,    -1,    -1,    -1,   145,   146,   147,    -1,   149,   150,
     151,    -1,   153,   154,   155,    -1,   288,   289,   290,   291,
     292,    -1,    -1,   295,    -1,   297,   298,    -1,   300,    -1,
      -1,    -1,   304,   305,   306,   307,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,    -1,
     191,   192,    -1,   194,    -1,   196,    -1,    -1,   199,    -1,
     201,    -1,    -1,   204,    -1,    -1,   207,    -1,   209,   210,
       1,   212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,    -1,   239,    -1,
      -1,    -1,   243,    -1,    -1,   246,    -1,    -1,   249,    -1,
     251,    -1,    -1,    -1,    -1,    -1,    -1,   258,   259,    -1,
     261,   262,   263,    -1,    -1,   266,    -1,    -1,    -1,     1,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    70,
      -1,    72,   283,    15,    -1,    17,    70,    78,    -1,    -1,
      81,    -1,    -1,    77,    78,    -1,    -1,    -1,    30,   300,
     301,   302,   303,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,   108,    -1,    -1,    59,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     131,    -1,    -1,   134,    -1,    -1,    -1,   138,    -1,   140,
     141,    -1,    -1,    -1,   145,   146,   147,    -1,   149,   150,
     151,    70,   153,   154,   155,    -1,    -1,    -1,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   108,
     191,   192,    -1,   194,    -1,   196,    -1,    -1,   199,    -1,
     201,   202,   203,    -1,   205,   206,   207,    -1,   209,   210,
      -1,   153,   213,   214,    -1,    -1,    -1,   218,   219,   220,
     214,    -1,    -1,    -1,    -1,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,   237,    -1,   239,    -1,
      -1,    -1,   243,    -1,    -1,   246,    -1,    -1,   249,    -1,
     251,    -1,    -1,    -1,    -1,    -1,    -1,   258,   259,    -1,
     261,   262,    -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
      -1,     1,   283,    -1,     4,   227,    -1,   281,   282,     9,
     284,   285,   286,   287,   213,   214,    16,   298,    18,    19,
     301,   302,   303,    -1,   298,    25,    -1,   301,   302,    29,
      -1,    -1,    -1,    -1,    34,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    53,    54,    -1,    56,    -1,    -1,    59,
      60,    61,    62,    -1,    -1,    -1,    -1,   289,    -1,    -1,
      -1,   293,    -1,    -1,   296,    -1,   298,    -1,    -1,   301,
     302,    -1,   281,   282,    -1,   284,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,
      -1,    -1,   301,   302,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   131,    -1,    -1,   134,    -1,   136,    -1,   138,    -1,
     140,   141,    -1,    -1,    -1,   145,   146,   147,    -1,   149,
     150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,    -1,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,    -1,   207,    -1,   209,
     210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   221,   222,    -1,    -1,    -1,    -1,    -1,   228,   229,
     230,   231,   232,    -1,    -1,   235,    -1,    -1,    -1,   239,
     240,    -1,   242,   243,    -1,    -1,   246,   247,    -1,   249,
      -1,   251,   252,    -1,   254,   255,    -1,   257,   258,   259,
      -1,   261,   262,    -1,    -1,    -1,   266,   267,    -1,    -1,
      -1,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,   287,     1,    -1,
      -1,     4,    -1,    -1,    -1,    -1,     9,   297,   298,    -1,
      -1,   301,   302,    16,    -1,    18,    19,    -1,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    -1,    29,    -1,    -1,    -1,
      -1,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      53,    54,    -1,    56,    -1,    -1,    59,    60,    61,    62,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,
      -1,   134,    -1,   136,    -1,   138,    -1,   140,   141,    -1,
      -1,    -1,   145,   146,   147,    -1,   149,   150,   151,    -1,
     153,   154,   155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,    -1,   207,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,   222,
      -1,    -1,    -1,    -1,    -1,   228,   229,   230,   231,   232,
      -1,    -1,   235,    -1,    -1,    -1,   239,   240,    -1,   242,
     243,    -1,    -1,   246,   247,    -1,   249,    -1,   251,   252,
      -1,   254,   255,    -1,   257,   258,   259,    -1,   261,   262,
      -1,    -1,    -1,   266,   267,    -1,    -1,    -1,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
      -1,   284,   285,   286,   287,     1,    -1,    -1,     4,    -1,
      -1,    -1,    -1,     9,    -1,   298,    -1,    -1,   301,   302,
      16,    -1,    18,    19,    -1,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,    34,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    53,    54,    -1,
      56,    -1,    -1,    59,    60,    61,    62,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,   134,    -1,
     136,    -1,   138,    -1,   140,   141,    -1,    -1,    -1,   145,
     146,   147,    -1,   149,   150,   151,    -1,   153,   154,   155,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,    -1,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
      -1,   207,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,   222,    -1,    -1,    -1,
      -1,    -1,   228,   229,   230,   231,   232,    -1,    -1,   235,
      -1,    -1,    -1,   239,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,   249,    -1,   251,   252,    -1,   254,   255,
      -1,   257,   258,   259,    -1,   261,   262,    -1,    -1,    -1,
     266,   267,    -1,    -1,    -1,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,   287,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
       9,    -1,   298,    -1,    -1,   301,   302,    16,    -1,    18,
      19,    -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,
      29,    -1,    -1,    -1,    -1,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    53,    54,    -1,    56,    -1,    -1,
      59,    60,    61,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,    -1,   134,    -1,   136,    -1,   138,
      -1,   140,   141,    -1,    -1,    -1,   145,   146,   147,    -1,
     149,   150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,    -1,   191,    -1,    -1,   194,    -1,   196,   197,    -1,
     199,    -1,   201,    -1,    -1,   204,    -1,    -1,   207,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,   228,
     229,   230,   231,   232,    -1,    -1,   235,    -1,    -1,    -1,
     239,   240,    -1,   242,   243,    -1,    -1,   246,   247,    -1,
     249,    -1,   251,   252,    -1,   254,   255,    -1,   257,   258,
     259,     1,   261,   262,     4,    -1,    -1,   266,   267,     9,
      -1,    -1,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,    -1,   284,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,   298,
      -1,    -1,   301,   302,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    -1,    65,    -1,    -1,    68,    69,
      70,    -1,    72,    -1,    74,    75,    -1,    77,    78,    79,
      -1,    81,    82,    -1,    84,    -1,    86,    87,    88,    89,
      90,    -1,    92,    -1,    94,    -1,    96,    97,    98,    -1,
     100,    -1,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,    -1,   115,   116,    -1,   118,    -1,
     120,    -1,   122,    -1,   124,    -1,   126,    -1,   128,   129,
     130,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,   182,    -1,    -1,    -1,    -1,   187,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   204,    71,    -1,   207,    -1,   209,
     210,    -1,   212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   222,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,    -1,   232,    -1,    -1,   235,    -1,    -1,    -1,    -1,
     240,    -1,   242,   243,    -1,    -1,   246,   247,    -1,   249,
      -1,    -1,   252,    -1,   254,   255,    -1,   257,   258,    -1,
      -1,   261,   262,   263,    -1,   131,   266,   267,   134,    -1,
      -1,    -1,   138,    -1,   140,   141,    -1,    -1,    -1,   145,
     146,   147,    -1,   149,   150,   151,    -1,   153,   154,   155,
      -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,   298,    -1,
      -1,   301,   302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,    -1,    -1,   191,   192,    -1,   194,    -1,
     196,    -1,    -1,   199,    -1,   201,    -1,    -1,    -1,    -1,
      -1,   207,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,
      -1,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,    -1,    -1,   239,    -1,    -1,    -1,   243,    -1,    -1,
     246,    -1,    -1,   249,    -1,   251,    -1,    -1,    -1,    -1,
      -1,    -1,   258,   259,    -1,   261,   262,    -1,    -1,    -1,
     266,    -1,    -1,    -1,    -1,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,    -1,    -1,   283,    -1,    -1,
      -1,    -1,    -1,    -1,   131,    -1,    -1,   134,    -1,    -1,
      -1,   138,   298,   140,   141,   301,   302,    -1,   145,   146,
     147,    -1,   149,   150,   151,    -1,   153,   154,   155,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,    -1,   191,   192,    -1,   194,    -1,   196,
      -1,    -1,   199,    -1,   201,    -1,    -1,    -1,    -1,    -1,
     207,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,    -1,
      -1,   228,   229,   230,   231,    -1,   233,   234,    -1,   236,
      -1,    -1,   239,    -1,    -1,    -1,   243,    -1,    -1,   246,
      -1,    -1,   249,    -1,   251,    -1,    -1,    -1,    -1,    -1,
      -1,   258,   259,    -1,   261,   262,    -1,    -1,    -1,   266,
      -1,    -1,    -1,    -1,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,    -1,    -1,   283,    -1,    -1,    -1,
      -1,    -1,    -1,   131,    -1,    -1,   134,    -1,    -1,    -1,
     138,   298,   140,   141,   301,   302,    -1,   145,   146,   147,
      -1,   149,   150,   151,    -1,   153,   154,   155,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,    -1,    -1,   191,   192,    -1,   194,    -1,   196,    -1,
      -1,   199,    -1,   201,    -1,    -1,    -1,    -1,    -1,   207,
      -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,    -1,    -1,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,    -1,
      -1,   239,    -1,    -1,    -1,   243,    -1,    -1,   246,    -1,
      -1,   249,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,
     258,   259,    -1,   261,   262,    -1,    -1,    -1,   266,    -1,
      -1,    -1,    -1,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,    -1,   134,    -1,    -1,    -1,   138,
     298,   140,   141,   301,   302,    -1,   145,   146,   147,    -1,
     149,   150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,    -1,   191,   192,    -1,   194,    -1,   196,    -1,    -1,
     199,    -1,   201,    -1,    -1,    -1,    -1,    -1,   207,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,    -1,    -1,
     239,    -1,    -1,    -1,   243,    -1,    -1,   246,    -1,    -1,
     249,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,   258,
     259,    -1,   261,   262,    -1,    -1,    -1,   266,    -1,    -1,
      -1,    -1,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,
     131,    -1,    -1,   134,    -1,    -1,    -1,   138,   297,   140,
     141,    -1,   301,   302,   145,   146,   147,    -1,   149,   150,
     151,    -1,   153,   154,   155,    -1,     4,    -1,    -1,    -1,
      -1,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,    -1,
     191,   192,    -1,   194,    -1,   196,    44,    -1,   199,    -1,
     201,    -1,    -1,    -1,    -1,    53,   207,    -1,   209,   210,
      -1,    59,    60,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    -1,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,    -1,    -1,   239,    -1,
      -1,    -1,   243,    -1,    -1,   246,    -1,    -1,   249,    -1,
     251,    -1,    -1,    -1,    -1,    -1,    -1,   258,   259,    -1,
     261,   262,    -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
      -1,    -1,   283,   131,    -1,    -1,    -1,    -1,   136,    -1,
      -1,    -1,   140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     301,   302,   150,    -1,    -1,   153,    -1,    -1,    -1,    -1,
      -1,     4,    -1,    -1,    -1,    -1,     9,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,
     178,    -1,    -1,    -1,   182,    -1,    -1,    -1,    -1,   187,
     188,    -1,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
      -1,    44,    -1,    -1,    -1,    -1,   204,    -1,    -1,   207,
      53,   209,   210,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    -1,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,    -1,   232,    -1,    -1,   235,    -1,    -1,
      -1,    -1,   240,    -1,   242,   243,    -1,    -1,   246,   247,
      -1,   249,    -1,   251,   252,    -1,   254,   255,    -1,   257,
     258,    -1,    -1,   261,   262,    -1,    -1,    -1,   266,   267,
      -1,    -1,    -1,    -1,    -1,    -1,   274,   275,   276,    -1,
     278,   279,    -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,
      -1,    -1,    -1,   136,    -1,    -1,    -1,   140,     1,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,   150,    -1,    -1,
     153,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    -1,   177,   178,    -1,    -1,    -1,   182,
      -1,    -1,    -1,    -1,   187,   188,    -1,    34,   191,    -1,
      -1,   194,    -1,   196,   197,    -1,    -1,    -1,    -1,    -1,
      63,   204,    -1,    -1,   207,    -1,   209,   210,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,   221,   222,
      -1,    -1,    18,    19,    -1,   228,    -1,    -1,    -1,   232,
      -1,    -1,   235,    -1,    -1,    -1,    -1,   240,    34,   242,
     243,    -1,    -1,   246,   247,    -1,   249,    -1,   251,   252,
      -1,   254,   255,    -1,   257,   258,    -1,    -1,   261,   262,
      -1,    -1,    -1,   266,   267,    -1,    62,   130,    -1,    -1,
      -1,   274,   275,   276,    -1,   278,   279,    -1,    -1,    -1,
      -1,    -1,    -1,   146,   147,    -1,   149,   134,    -1,    -1,
      -1,   138,   155,    -1,   141,   298,    -1,    -1,   145,    -1,
      -1,    -1,    -1,    -1,   151,    -1,    -1,   154,    -1,    -1,
      -1,    -1,    -1,     4,    -1,    -1,    -1,   180,     9,    -1,
      -1,    -1,   185,   186,    -1,    -1,   189,    -1,    -1,    -1,
      -1,    -1,   179,    -1,   181,    -1,   183,   184,   134,    -1,
      -1,    -1,   138,    -1,    -1,   141,    -1,    -1,    -1,   145,
      -1,    -1,   199,    44,   201,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   237,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   229,   230,   231,   181,    -1,   183,   184,    -1,
      -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   199,    -1,    -1,    -1,    -1,    -1,    -1,
     273,    -1,   259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   271,   272,   289,    -1,    -1,    -1,
     293,    -1,     4,   229,   230,   231,    -1,     9,    -1,    -1,
     131,    -1,    -1,   239,    -1,   136,    -1,    -1,    -1,   140,
      -1,    -1,    -1,    -1,   301,   302,    -1,    -1,    -1,   150,
      -1,    -1,   153,   259,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   271,   272,    -1,    -1,    -1,
      -1,    53,    -1,    -1,    -1,    -1,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,    16,   187,   188,    -1,    -1,
     191,    -1,   298,   194,    25,   196,   197,    -1,    29,    -1,
      -1,    -1,    -1,   204,    35,    -1,   207,    -1,   209,   210,
      -1,    -1,    43,    -1,    45,    -1,    -1,    -1,    49,    -1,
     221,   222,    -1,    54,    -1,    56,    -1,   228,    -1,    -1,
      61,   232,    -1,    -1,   235,    -1,    -1,    -1,    -1,   240,
      -1,   242,   243,    -1,    -1,   246,   247,    -1,   249,    -1,
     251,   252,    -1,   254,   255,    -1,   257,   258,     4,    -1,
     261,   262,    -1,     9,    -1,   266,   267,    -1,   150,    -1,
      -1,    -1,    -1,   274,   275,   276,    -1,   278,   279,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   187,    -1,    53,    -1,    -1,
      -1,    -1,   194,    -1,    -1,   146,   147,    -1,   149,    -1,
      -1,    -1,    -1,    -1,   155,   207,    -1,   209,   210,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     222,    -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,   180,
     232,    -1,    -1,   235,   185,   186,    -1,    -1,   240,    -1,
     242,   243,    -1,    -1,   246,   247,    -1,   249,    -1,    -1,
     252,    -1,   254,   255,    -1,   257,   258,    -1,    -1,   261,
     262,    -1,    -1,    -1,   266,   267,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   150,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   187,   273,    -1,    -1,    -1,    -1,    -1,   194,   280,
     281,   282,    -1,   284,   285,   286,   287,    -1,    -1,    -1,
      -1,   207,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   222,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,    -1,   232,    -1,    -1,   235,
      -1,    -1,    -1,    -1,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,   249,    -1,    -1,   252,    -1,   254,   255,
      -1,   257,   258,    -1,    -1,   261,   262,    -1,    -1,    65,
     266,   267,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    77,    78,    79,    -1,    81,    82,    -1,    84,    -1,
      86,    87,    88,    89,    90,    -1,    92,    -1,    94,    -1,
      96,    97,    98,    -1,   100,    -1,   102,    -1,   104,    -1,
     106,   107,   108,   109,    -1,    -1,   112,   113,    -1,   115,
     116,    -1,   118,    -1,   120,    -1,   122,    -1,   124,    -1,
     126,    -1,   128,   129,   130,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   169,   170,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   178,    -1,    65,    -1,    -1,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    77,    78,    79,    -1,
      81,    82,    -1,    84,    -1,    86,    87,    88,    89,    90,
      -1,    92,    -1,    94,    -1,    96,    97,    98,    -1,   100,
      -1,   102,    -1,   104,    -1,   106,   107,   108,   109,    -1,
      -1,   112,   113,    -1,   115,   116,    -1,   118,    -1,   120,
      -1,   122,    -1,   124,    -1,   126,    -1,   128,   129,   130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   288,   289,   290,   291,   292,   178,    -1,   295,
      -1,   297,   298,    -1,   300,    -1,    -1,    -1,   304,   305,
     306,   307,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    -1,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    77,    78,    79,    -1,    81,    82,    -1,
      84,    -1,    86,    87,    88,    89,    90,    -1,    92,    -1,
      94,    -1,    96,    97,    98,    -1,   100,    -1,   102,    -1,
     104,    -1,   106,   107,   108,   109,    -1,    -1,   112,   113,
      -1,   115,   116,    -1,   118,    -1,   120,    -1,   122,    -1,
     124,    -1,   126,    -1,   128,   129,   130,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,   289,   290,
     291,   292,    -1,   157,   295,   159,   297,   298,    -1,   300,
      -1,    -1,    -1,   304,   305,   306,   307,    -1,    65,    -1,
      -1,    68,    69,    70,   178,    72,    73,    74,    75,    -1,
      77,    78,    79,    -1,    81,    82,    -1,    84,    -1,    86,
      87,    88,    89,    90,    -1,    92,    -1,    94,    -1,    96,
      97,    98,    -1,   100,    -1,   102,    -1,   104,    -1,   106,
     107,   108,   109,    -1,    -1,   112,   113,    -1,   115,   116,
      -1,   118,    -1,   120,    -1,   122,    -1,   124,    -1,   126,
      -1,   128,   129,   130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     157,    -1,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   178,    -1,    -1,   288,   289,   290,   291,   292,    -1,
      -1,   295,    -1,   297,   298,    -1,   300,    -1,    -1,    -1,
     304,   305,   306,   307,    -1,    65,    -1,    -1,    68,    69,
      70,    -1,    72,    73,    74,    75,    -1,    77,    78,    79,
      -1,    81,    82,    -1,    84,    -1,    86,    87,    88,    89,
      90,    -1,    92,    -1,    94,    -1,    96,    97,    98,    -1,
     100,    -1,   102,    -1,   104,    -1,   106,   107,   108,   109,
      -1,    -1,   112,   113,    -1,   115,   116,    -1,   118,    -1,
     120,    -1,   122,    -1,   124,    -1,   126,    -1,   128,   129,
     130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   288,   289,   290,   291,   292,    -1,   157,   295,   159,
     297,   298,    -1,   300,    -1,    -1,    -1,   304,   305,   306,
     307,    -1,    65,    -1,    -1,    68,    69,    70,   178,    72,
      73,    74,    75,    -1,    77,    78,    79,    -1,    81,    82,
      -1,    84,    -1,    86,    87,    88,    89,    90,    -1,    92,
      -1,    94,    -1,    96,    97,    98,    -1,   100,    -1,   102,
      -1,   104,    -1,   106,   107,   108,   109,    -1,    -1,   112,
     113,    -1,   115,   116,    -1,   118,    -1,   120,    -1,   122,
      -1,   124,    -1,   126,    -1,   128,   129,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   157,    -1,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,   288,   289,
     290,   291,   292,    -1,    -1,   295,    -1,   297,   298,    -1,
     300,    -1,    -1,    -1,   304,   305,   306,   307,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,
      -1,    -1,   134,    -1,    -1,    -1,   138,    -1,   140,   141,
      -1,    -1,    -1,   145,   146,   147,    -1,   149,   150,   151,
      -1,   153,   154,   155,    -1,   288,   289,   290,   291,   292,
      -1,    -1,   295,    -1,   297,   298,    -1,   300,    -1,    -1,
      -1,   304,   305,   306,   307,   177,    -1,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,    -1,    -1,   191,
     192,    -1,   194,    -1,   196,    -1,    -1,   199,    -1,   201,
      -1,    -1,    -1,    -1,    -1,   207,    -1,   209,   210,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   228,   229,   230,   231,
      -1,   233,   234,    -1,   236,    -1,    -1,   239,    -1,    -1,
      -1,   243,    -1,    -1,   246,    -1,    -1,   249,    -1,   251,
      -1,    -1,    -1,    -1,    -1,    -1,   258,   259,    -1,   261,
     262,    -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    -1,    -1,
      -1,   283,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,
     134,    -1,    -1,    -1,   138,    -1,   140,   141,    -1,   301,
     302,   145,   146,   147,    -1,   149,   150,   151,    -1,   153,
     154,   155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   177,    -1,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,    -1,    -1,   191,   192,    -1,
     194,    -1,   196,    -1,    -1,   199,    -1,   201,    -1,    -1,
      -1,    -1,    -1,   207,    -1,   209,   210,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,   229,   230,   231,    -1,   233,
     234,    -1,   236,    -1,    -1,   239,    -1,    -1,    -1,   243,
      -1,    -1,   246,    -1,    -1,   249,    -1,   251,    -1,    -1,
      -1,    -1,    -1,    -1,   258,   259,    -1,   261,   262,    -1,
      -1,    -1,   266,    -1,    -1,    -1,    -1,   271,   272,   273,
     274,   275,   276,   277,   278,   279,    -1,    -1,   134,   283,
      -1,    -1,   138,    -1,    -1,   141,    -1,    -1,    -1,   145,
     146,    -1,    -1,   149,    -1,    -1,    -1,   301,   302,   155,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   180,   181,    -1,   183,   184,    -1,
      -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   199,   140,    -1,    -1,    -1,    -1,    -1,
     146,   147,    -1,   149,   150,    -1,    -1,   153,    -1,   155,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   229,   230,   231,    -1,   233,   234,    -1,
      -1,   177,    -1,   239,   180,    -1,   182,    -1,    -1,   185,
     186,   187,   188,    -1,    -1,   191,    -1,    -1,   194,    -1,
     196,    -1,    -1,   259,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   207,    -1,   209,   210,   271,   272,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     236,    -1,    -1,    -1,    -1,   301,   302,   243,    -1,    -1,
     246,    -1,    -1,   249,    -1,   251,    -1,    -1,    -1,    -1,
      -1,    -1,   258,    -1,    -1,   261,   262,    -1,    -1,    -1,
     266,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,   275,
     276,   277,   278,   279,    -1,    -1,    -1,   283
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   309,     0,     1,     3,     5,     6,     7,     8,    10,
      11,    12,    13,    32,   150,   151,   153,   154,   157,   177,
     179,   187,   201,   202,   206,   211,   218,   219,   220,   227,
     289,   293,   307,   310,   311,   312,   313,   328,   329,   348,
     350,   351,   354,   364,   365,   366,   370,   376,   377,   378,
     383,   391,   392,   395,   397,   414,   417,   424,   425,   522,
     530,   531,   677,   696,   298,   301,   302,   622,   625,   633,
     638,   641,   643,     1,    65,    68,    69,    70,    72,    74,
      75,    77,    78,    79,    81,    82,    84,    86,    87,    88,
      89,    90,    92,    94,    96,    97,    98,   100,   102,   104,
     106,   107,   108,   109,   110,   112,   113,   115,   116,   118,
     120,   122,   124,   126,   128,   129,   130,   204,   212,   263,
     325,   638,   642,   657,     1,   638,   640,     1,     3,   651,
     651,   299,   367,   368,     1,    15,    52,    59,   298,   374,
     625,     1,   298,   651,   226,   704,     1,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   171,   172,   173,   174,
     175,   355,   363,   651,   529,   530,     1,   211,   676,   426,
     352,   696,   640,   696,   696,   696,   696,     1,    70,    72,
      78,   131,   134,   138,   140,   141,   145,   146,   147,   149,
     150,   153,   155,   176,   177,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   191,   192,   194,   196,   199,
     207,   209,   210,   214,   226,   228,   229,   230,   231,   233,
     234,   236,   237,   239,   243,   246,   249,   251,   258,   259,
     261,   262,   266,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   283,   298,   379,   381,   383,   384,   387,   389,
     390,   407,   414,   415,   423,   439,   441,   442,   444,   468,
     469,   471,   479,   505,   507,   508,   509,   510,   511,   512,
     514,   515,   516,   518,   519,   520,   521,   522,   531,   534,
     535,   537,   539,   540,   542,   550,   552,   553,   562,   563,
     625,   630,   631,   633,   664,   665,   669,   711,   696,   293,
     696,   696,   696,   696,   696,   696,   396,   393,   398,    46,
     679,   680,   681,    65,     1,    17,    37,    58,   647,    65,
       1,    71,   691,     1,    73,   687,    72,    72,     4,     9,
      38,    53,   150,   187,   194,   207,   209,   210,   222,   228,
     232,   235,   240,   242,   243,   246,   247,   249,   252,   254,
     255,   257,   258,   261,   262,   266,   267,   326,   327,   536,
     590,     1,    17,   130,   646,   314,   646,   112,   369,   368,
      52,    59,   375,    42,   296,   666,   667,    17,    30,   153,
     227,   371,   373,    65,    68,    69,    70,    71,    72,    73,
      74,    75,    77,    78,    79,    81,    82,    84,    86,    87,
      88,    89,    90,    92,    94,    96,    97,    98,   100,   102,
     104,   106,   107,   108,   109,   112,   113,   115,   116,   118,
     120,   122,   124,   126,   128,   129,   130,   157,   159,   178,
     288,   289,   290,   291,   292,   295,   297,   298,   300,   304,
     305,   306,   307,   330,   331,   340,   341,   342,   343,   347,
     418,     1,   298,   627,   627,     1,   298,   301,   620,   621,
       1,   157,   298,   353,   628,   647,   187,   228,   468,   505,
     664,    77,    78,   112,   221,   298,   408,   409,   410,   532,
     533,   534,   550,   300,   303,   593,   698,     1,    70,   673,
     673,    65,   349,   673,    72,    72,   538,   554,   564,    70,
       1,    96,   674,   385,   673,   130,   470,   416,   508,   510,
     506,   507,   673,   536,   541,   542,   541,   553,   563,    65,
     632,   213,   425,   203,   205,   303,   661,    81,     1,   622,
     623,   623,     1,   298,   400,   401,   402,   625,     1,    57,
     531,   677,   692,   693,   679,   298,   625,     4,     9,    44,
      53,    59,    60,   131,   136,   140,   150,   153,   178,   187,
     191,   196,   197,   204,   207,   209,   210,   221,   222,   228,
     243,   246,   247,   249,   251,   261,   262,   266,   274,   275,
     276,   279,   298,   535,   537,   567,   586,   587,   588,   589,
     590,   591,   595,   601,   602,   633,   639,   709,   625,   633,
     687,   687,    31,    33,    36,   592,   148,   245,   253,   269,
      23,    72,   318,     1,   228,   710,     1,   241,   660,     1,
     256,   708,   535,   709,   640,   315,   567,   681,   567,     1,
     299,    17,   373,     1,   371,   372,     1,    70,   130,   335,
     336,   337,   338,   339,   340,    70,   331,   332,   333,   334,
     505,    70,   356,   541,     1,   298,   298,   567,   691,   380,
     298,     1,   221,   700,    73,     1,   130,   655,   534,   549,
     550,   534,   290,     1,   698,   699,   505,   415,     1,   297,
     705,   706,   543,     1,    73,    78,   705,   673,   673,   445,
     505,   704,     1,   505,   705,    70,    77,    78,   108,   281,
     282,   284,   285,   286,   287,   429,   430,   432,   434,   435,
     437,   443,   462,   464,   465,   467,   472,   474,   475,   477,
     478,   479,   481,   577,   622,   625,   630,   631,   633,   634,
     432,   428,   429,     1,   505,   622,   623,   624,   623,   624,
     622,   505,   673,   673,   621,   288,   523,   394,   399,    65,
      65,   623,   592,   245,   710,     1,    28,   659,   593,     1,
     198,   672,    78,   596,   705,   681,    16,    25,    29,    49,
      54,    56,    61,   280,   509,   568,   571,   572,   573,   575,
     576,   577,   583,   597,   598,   599,   600,   603,   604,   605,
     606,   589,    17,     1,    41,   671,     1,   270,   644,     1,
      70,    72,   319,    27,    54,   320,   321,   322,   410,    70,
     578,   579,     1,    26,   656,    14,    63,   189,   237,   316,
     317,   324,   646,   372,    70,   344,   345,   346,   347,    71,
     130,   337,   336,   339,   334,   419,     1,   178,   298,   357,
     358,   359,    70,    71,   130,   158,   169,   170,   340,   360,
     361,   362,     1,   112,   663,    70,   467,   474,   477,   482,
     483,   484,   485,   486,   488,   489,   491,   493,   495,   634,
      70,   411,   410,   549,   691,   513,   691,   227,   544,    73,
     687,   687,   673,     1,   298,   557,   565,   566,   178,   221,
     298,   457,   458,   459,   626,   701,   382,   386,    71,   388,
     691,   106,   463,   532,   532,   532,   130,    70,    72,   436,
     466,   473,   476,   433,   434,   443,   465,   633,    67,   213,
     288,   635,   635,   551,   552,   517,   523,   290,   290,   480,
     457,     1,   440,   673,     1,   146,   149,   155,   180,   514,
     516,   524,   526,   527,   528,   631,   290,   404,   405,     1,
     403,   405,   187,   298,   625,   187,   625,   633,    40,   594,
      78,   298,   569,   705,   578,    70,   574,     1,    58,   702,
       1,    54,   688,    39,   570,   578,    43,    45,   675,   702,
      18,    19,    34,    62,   134,   138,   141,   145,   181,   183,
     184,   199,   229,   230,   231,   239,   259,   271,   272,   522,
     531,   607,   608,   609,   610,   611,   613,   614,   631,   606,
     567,   673,   320,   320,    21,   136,   323,    58,   323,    73,
     655,   567,   580,   581,    55,   148,   584,   585,   689,   213,
     683,    17,    58,   648,   706,     1,   567,   705,   587,   344,
      71,   346,   332,   336,   338,   420,   421,   432,    71,   655,
     362,   505,   106,   490,   492,   494,   496,   436,   691,    70,
     457,   325,   482,   627,     1,   232,   235,   242,   252,   254,
     257,   258,   267,   545,   546,   547,   633,   555,   556,   557,
      70,   558,    71,   557,    71,   655,   505,   482,   415,   482,
     438,   432,     1,   430,   431,   457,     1,   150,   298,   532,
     533,   687,   705,   551,   432,   432,   432,    78,   657,   662,
     699,   706,   482,   467,   474,   477,   497,   498,   499,   501,
     503,   634,    71,   446,   446,   440,   527,   528,   525,   526,
       1,   291,   391,   406,   417,   424,   627,   627,     1,    46,
     678,   440,     1,    43,   567,     1,    16,   645,   584,    35,
     567,    50,   612,     1,   145,   670,     1,    48,   684,     1,
     134,   652,   705,   707,    51,   685,   623,   623,     1,    63,
      70,   705,   580,    71,    73,     1,   136,   658,   627,   322,
      71,   655,     1,   567,   681,    18,    20,   649,    22,   650,
      54,    56,   583,    71,   130,   359,   427,   487,   482,   482,
     482,   482,   633,   637,   457,    71,    75,   412,   691,     1,
     288,   654,    70,   548,   548,    73,   655,    71,   655,    70,
     292,   297,   298,   300,   303,   559,   560,   561,   222,   247,
     451,     1,   459,   461,   460,     1,    97,   668,   691,   532,
     691,   446,    73,   532,   687,    78,   150,   687,   697,   687,
     536,   673,   627,   691,   500,   502,   504,   673,   447,   451,
     451,   446,   525,   289,   695,     1,   289,   694,   694,   567,
      71,   678,   298,   629,   578,   670,    46,   615,   706,   706,
     649,    71,     1,   567,   582,     1,   689,   690,   688,   675,
       1,   421,   422,   482,   532,   691,   446,   505,   699,   687,
     547,   691,   557,   560,    71,   655,   673,    70,   112,   455,
     482,   673,   432,    77,   108,   450,   298,   705,   687,   298,
     705,   457,   673,   497,   497,   497,   446,   448,   551,   551,
     451,     1,   291,   686,     1,   531,   653,   678,   584,   153,
     703,   649,   691,   584,   567,     1,   213,   682,   482,   451,
     413,   691,     1,   691,   561,   458,   691,     1,   208,   223,
     452,     1,   136,   204,   705,     1,   633,   636,   691,   451,
     687,   687,   687,   687,   446,     1,   456,   458,   451,   246,
     249,   278,   449,   535,   551,   640,   567,   527,   616,   617,
     618,   578,   691,    75,   453,   552,   482,    71,   691,   691,
     673,   453,   450,    71,   455,   455,   567,   298,   608,   619,
     639,   527,   584,   673,   505,   457,   455,   451,   451,   457,
     454,    71,   453,   453,    71,   482,   551,   455
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   308,   309,   309,   310,   310,   310,   310,   310,   310,
     310,   310,   310,   310,   310,   310,   310,   310,   310,   310,
     311,   311,   312,   312,   312,   312,   312,   313,   314,   313,
     313,   313,   313,   315,   315,   315,   316,   316,   316,   317,
     317,   317,   318,   318,   318,   319,   319,   319,   320,   320,
     321,   321,   322,   322,   322,   322,   323,   323,   323,   324,
     325,   325,   326,   326,   327,   327,   327,   327,   327,   327,
     327,   327,   327,   327,   327,   327,   327,   327,   327,   327,
     327,   328,   329,   329,   330,   330,   330,   331,   331,   332,
     332,   333,   333,   334,   334,   335,   335,   335,   335,   335,
     335,   335,   336,   336,   337,   337,   338,   338,   339,   339,
     340,   340,   340,   340,   340,   340,   340,   341,   341,   342,
     342,   342,   343,   343,   343,   343,   343,   343,   343,   343,
     343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
     343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
     343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
     343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
     344,   344,   345,   345,   346,   346,   347,   347,   348,   348,
     348,   348,   348,   348,   348,   348,   348,   348,   348,   348,
     349,   348,   348,   348,   348,   348,   350,   352,   351,   353,
     353,   353,   353,   353,   354,   354,   354,   354,   354,   354,
     354,   354,   354,   354,   354,   354,   354,   354,   354,   354,
     355,   356,   356,   357,   357,   358,   358,   359,   359,   359,
     360,   360,   361,   361,   362,   362,   362,   362,   362,   362,
     362,   363,   364,   365,   366,   366,   367,   367,   368,   369,
     369,   369,   370,   370,   370,   370,   370,   370,   370,   371,
     371,   371,   372,   372,   373,   373,   374,   374,   374,   374,
     375,   375,   375,   376,   377,   378,   380,   379,   379,   382,
     381,   383,   383,   383,   383,   385,   386,   384,   387,   388,
     387,   387,   389,   389,   390,   391,   391,   391,   393,   394,
     392,   396,   395,   398,   399,   397,   400,   400,   400,   401,
     401,   401,   401,   402,   402,   402,   402,   403,   403,   404,
     404,   405,   405,   406,   406,   406,   406,   407,   408,   408,
     409,   409,   410,   410,   410,   410,   410,   410,   411,   411,
     412,   413,   412,   414,   416,   415,   418,   419,   417,   420,
     420,   421,   422,   422,   423,   424,   426,   427,   425,   428,
     428,   429,   429,   430,   431,   431,   432,   432,   432,   432,
     432,   433,   433,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   435,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   438,   437,   439,   440,   440,   441,   442,
     443,   445,   444,   447,   446,   448,   448,   449,   449,   449,
     449,   450,   450,   450,   451,   451,   451,   451,   451,   452,
     452,   452,   453,   454,   453,   453,   455,   455,   455,   455,
     455,   456,   456,   457,   457,   458,   458,   460,   459,   459,
     459,   461,   461,   463,   462,   464,   466,   465,   467,   468,
     468,   470,   469,   471,   473,   472,   474,   476,   475,   477,
     477,   478,   480,   479,   481,   482,   482,   483,   483,   483,
     483,   484,   484,   484,   484,   484,   485,   487,   486,   488,
     490,   489,   492,   491,   494,   493,   496,   495,   497,   497,
     498,   498,   498,   498,   500,   499,   502,   501,   504,   503,
     505,   505,   505,   506,   506,   507,   507,   508,   508,   508,
     508,   509,   509,   509,   509,   509,   509,   509,   509,   510,
     510,   511,   511,   511,   511,   513,   512,   514,   514,   515,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
     515,   515,   515,   517,   516,   516,   518,   518,   519,   519,
     520,   520,   521,   521,   522,   523,   523,   523,   524,   524,
     524,   525,   525,   526,   526,   527,   527,   527,   527,   528,
     528,   528,   529,   529,   530,   530,   531,   531,   532,   532,
     533,   533,   533,   534,   534,   534,   534,   534,   534,   534,
     535,   535,   536,   536,   537,   537,   538,   538,   538,   538,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     540,   540,   541,   541,   543,   542,   542,   544,   544,   545,
     545,   546,   546,   547,   547,   547,   547,   547,   547,   547,
     547,   547,   547,   548,   548,   549,   549,   550,   550,   551,
     551,   552,   552,   554,   553,   555,   555,   556,   556,   557,
     557,   558,   558,   559,   559,   560,   560,   561,   561,   561,
     561,   561,   561,   562,   562,   564,   563,   565,   565,   566,
     566,   567,   567,   567,   568,   568,   569,   569,   569,   569,
     570,   570,   571,   572,   573,   574,   574,   575,   576,   576,
     577,   577,   577,   577,   577,   577,   578,   578,   579,   580,
     580,   581,   581,   582,   582,   583,   583,   583,   584,   584,
     585,   585,   586,   587,   587,   588,   588,   589,   589,   589,
     590,   590,   590,   590,   590,   590,   590,   590,   590,   590,
     590,   590,   590,   590,   591,   591,   591,   591,   591,   591,
     591,   591,   591,   591,   591,   591,   591,   591,   591,   591,
     591,   591,   591,   591,   591,   591,   591,   591,   591,   591,
     591,   591,   591,   592,   592,   592,   593,   594,   594,   595,
     595,   595,   595,   595,   595,   595,   596,   596,   597,   597,
     597,   597,   597,   597,   597,   597,   598,   598,   598,   599,
     600,   600,   601,   602,   602,   602,   603,   603,   604,   604,
     605,   605,   606,   607,   607,   607,   607,   608,   608,   609,
     609,   609,   609,   609,   609,   609,   609,   609,   609,   609,
     609,   609,   609,   609,   609,   610,   610,   610,   610,   611,
     611,   611,   612,   612,   613,   614,   615,   615,   616,   616,
     617,   617,   618,   618,   619,   619,   620,   620,   621,   621,
     622,   622,   623,   623,   624,   624,   625,   625,   626,   627,
     627,   628,   628,   629,   629,   630,   630,   631,   632,   632,
     633,   633,   633,   634,   635,   635,   636,   636,   637,   637,
     638,   639,   640,   640,   641,   641,   642,   642,   643,   643,
     643,   644,   644,   645,   645,   646,   646,   647,   647,   647,
     647,   648,   648,   648,   649,   649,   649,   650,   650,   651,
     651,   652,   652,   653,   653,   654,   654,   655,   655,   656,
     656,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   657,   657,   657,   657,   657,   657,   657,   657,   658,
     658,   659,   659,   660,   660,   661,   661,   662,   663,   663,
     664,   664,   665,   665,   666,   667,   667,   668,   668,   669,
     669,   670,   670,   671,   671,   672,   672,   673,   673,   674,
     674,   675,   675,   675,   676,   676,   677,   677,   678,   678,
     679,   680,   680,   681,   681,   682,   682,   683,   683,   684,
     684,   685,   685,   686,   686,   687,   687,   688,   688,   689,
     689,   690,   690,   691,   691,   692,   692,   692,   693,   693,
     694,   694,   695,   695,   696,   696,   697,   697,   698,   698,
     699,   699,   700,   700,   701,   701,   702,   702,   703,   703,
     704,   704,   705,   706,   706,   707,   707,   708,   708,   709,
     709,   710,   710,   711,   711
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     1,     2,     2,     2,     2,     2,     1,     1,
       4,     4,     2,     2,     2,     2,     1,     4,     0,    11,
       6,     9,     2,     1,     2,     2,     3,     2,     2,     2,
       1,     1,     0,     2,     3,     3,     3,     1,     0,     1,
       3,     1,     2,     2,     3,     1,     0,     2,     1,     3,
       0,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     4,     3,     2,     0,     2,     4,     1,     1,     0,
       1,     2,     1,     1,     1,     0,     1,     1,     2,     3,
       2,     1,     2,     1,     3,     1,     2,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     2,     1,     1,     3,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       0,     4,     2,     3,     2,     2,     1,     0,     3,     0,
       1,     2,     2,     1,     1,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     0,     3,     0,     1,     3,     1,     1,     1,     1,
       0,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     2,     2,     1,     2,     0,
       2,     2,     3,     4,     4,     5,     3,     2,     2,     1,
       1,     1,     1,     1,     0,     1,     0,     2,     1,     1,
       0,     1,     1,     1,     1,     1,     0,     6,     3,     0,
       9,     1,     1,     1,     1,     0,     0,     5,     4,     0,
       6,     4,     1,     1,     4,     1,     1,     1,     0,     0,
       5,     0,     4,     0,     0,     5,     1,     1,     1,     3,
       3,     4,     1,     3,     3,     4,     1,     1,     1,     0,
       1,     2,     4,     1,     2,     2,     1,     6,     0,     1,
       3,     1,     1,     2,     1,     1,     1,     2,     0,     3,
       0,     0,     4,     1,     0,     3,     0,     0,     6,     3,
       1,     1,     1,     1,     1,     1,     0,     0,     8,     0,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     3,     2,     3,     3,     3,     5,     5,     4,
       5,     5,     3,     0,    10,     9,     0,     1,     7,     7,
       8,     0,     7,     0,     3,     0,     2,     1,     1,     1,
       1,     0,     1,     1,     0,     1,     4,     3,     4,     1,
       1,     1,     0,     0,     4,     1,     0,     2,     2,     2,
       2,     1,     1,     0,     1,     3,     1,     0,     4,     1,
       1,     1,     1,     0,     4,    10,     0,     3,     2,     3,
       1,     0,     3,     2,     0,     3,     4,     0,     3,     2,
       2,     2,     0,     9,     9,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     0,     9,     6,
       0,     4,     0,     3,     0,     3,     0,     3,     0,     1,
       1,     1,     1,     1,     0,     3,     0,     3,     0,     3,
       1,     2,     1,     0,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     1,     1,     1,     1,     0,     6,     1,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     6,     3,     1,     1,     1,     1,
       3,     4,     4,     4,     2,     0,     2,     2,     1,     3,
       2,     0,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     0,     1,
       3,     2,     2,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     0,     2,     1,     1,     2,     3,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     0,     7,     1,     0,     3,     0,
       1,     3,     1,     1,     2,     1,     2,     1,     1,     1,
       1,     1,     1,     0,     3,     0,     1,     1,     1,     0,
       1,     2,     1,     0,     7,     0,     1,     3,     1,     2,
       1,     0,     3,     0,     1,     3,     1,     1,     1,     1,
       1,     3,     1,     2,     1,     0,     5,     0,     1,     2,
       1,     1,     1,     1,     4,     6,     0,     1,     1,     1,
       0,     1,     3,     2,     2,     0,     3,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     3,     0,
       1,     3,     1,     1,     1,     0,     1,     2,     0,     1,
       2,     2,     2,     0,     1,     2,     1,     1,     1,     1,
       2,     1,     1,     2,     1,     2,     1,     2,     1,     1,
       3,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     7,     3,     3,
       1,     2,     6,     3,     1,     1,     2,     1,     0,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     2,     1,
       1,     2,     2,     1,     1,     3,     4,     4,     2,     1,
       2,     3,     0,     1,     2,     3,     0,     3,     2,     1,
       0,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     2,     1,     0,     1,     0,     2,     2,     0,     2,
       3,     3,     1,     2,     0,     2,     1,     1,     0,     1,
       2,     2,     1,     1,     0,     1,     3,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     0,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     3,     0,     1,     1,     0,     1,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     2,     1,     1,
       3,     2,     1,     0,     1,     1,     1,     0,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     0,     1,
       0,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       2,     1,     1,     0,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_Y_CONSTRUCTOR_SNAME: /* Y_CONSTRUCTOR_SNAME  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5067 "parser.c"
        break;

    case YYSYMBOL_Y_DESTRUCTOR_SNAME: /* Y_DESTRUCTOR_SNAME  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5073 "parser.c"
        break;

    case YYSYMBOL_Y_OPERATOR_SNAME: /* Y_OPERATOR_SNAME  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5079 "parser.c"
        break;

    case YYSYMBOL_Y_CHAR_LIT: /* Y_CHAR_LIT  */
#line 1855 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5085 "parser.c"
        break;

    case YYSYMBOL_Y_GLOB: /* Y_GLOB  */
#line 1847 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5091 "parser.c"
        break;

    case YYSYMBOL_Y_NAME: /* Y_NAME  */
#line 1847 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5097 "parser.c"
        break;

    case YYSYMBOL_Y_SET_OPTION: /* Y_SET_OPTION  */
#line 1847 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5103 "parser.c"
        break;

    case YYSYMBOL_Y_STR_LIT: /* Y_STR_LIT  */
#line 1855 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5109 "parser.c"
        break;

    case YYSYMBOL_capturing_paren_capture_decl_list_english_opt: /* capturing_paren_capture_decl_list_english_opt  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5115 "parser.c"
        break;

    case YYSYMBOL_paren_capture_decl_list_english: /* paren_capture_decl_list_english  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5121 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_english_opt: /* capture_decl_list_english_opt  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5127 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_english: /* capture_decl_list_english  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5133 "parser.c"
        break;

    case YYSYMBOL_p_extra_token_except_lparen: /* p_extra_token_except_lparen  */
#line 1851 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5139 "parser.c"
        break;

    case YYSYMBOL_p_extra_tokens_opt: /* p_extra_tokens_opt  */
#line 1852 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5145 "parser.c"
        break;

    case YYSYMBOL_p_extra_tokens: /* p_extra_tokens  */
#line 1852 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5151 "parser.c"
        break;

    case YYSYMBOL_p_extra_token: /* p_extra_token  */
#line 1851 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5157 "parser.c"
        break;

    case YYSYMBOL_p_arg_list_opt: /* p_arg_list_opt  */
#line 1848 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5163 "parser.c"
        break;

    case YYSYMBOL_p_comma_arg_list: /* p_comma_arg_list  */
#line 1848 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5169 "parser.c"
        break;

    case YYSYMBOL_p_arg_list: /* p_arg_list  */
#line 1848 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5175 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens: /* p_arg_tokens  */
#line 1852 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5181 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_as_list: /* p_arg_token_as_list  */
#line 1852 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5187 "parser.c"
        break;

    case YYSYMBOL_p_arg_token: /* p_arg_token  */
#line 1851 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5193 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens_with_comma_opt: /* p_arg_tokens_with_comma_opt  */
#line 1852 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5199 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens_with_comma: /* p_arg_tokens_with_comma  */
#line 1852 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5205 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_with_comma_as_list: /* p_arg_token_with_comma_as_list  */
#line 1852 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5211 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_with_comma: /* p_arg_token_with_comma  */
#line 1851 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5217 "parser.c"
        break;

    case YYSYMBOL_help_what_opt: /* help_what_opt  */
#line 1847 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5223 "parser.c"
        break;

    case YYSYMBOL_p_paren_param_list_opt: /* p_paren_param_list_opt  */
#line 1850 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5229 "parser.c"
        break;

    case YYSYMBOL_p_param_list_opt: /* p_param_list_opt  */
#line 1850 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5235 "parser.c"
        break;

    case YYSYMBOL_p_param_list: /* p_param_list  */
#line 1850 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5241 "parser.c"
        break;

    case YYSYMBOL_p_param: /* p_param  */
#line 1849 "parser.y"
            { DTRACE; p_param_free( ((*yyvaluep).p_param) );                     }
#line 5247 "parser.c"
        break;

    case YYSYMBOL_p_replace_list_opt: /* p_replace_list_opt  */
#line 1852 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5253 "parser.c"
        break;

    case YYSYMBOL_p_replace_list: /* p_replace_list  */
#line 1852 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5259 "parser.c"
        break;

    case YYSYMBOL_p_replace_token: /* p_replace_token  */
#line 1851 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5265 "parser.c"
        break;

    case YYSYMBOL_set_option_value_opt: /* set_option_value_opt  */
#line 1855 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5271 "parser.c"
        break;

    case YYSYMBOL_namespace_sname_c_exp: /* namespace_sname_c_exp  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5277 "parser.c"
        break;

    case YYSYMBOL_namespace_sname_c: /* namespace_sname_c  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5283 "parser.c"
        break;

    case YYSYMBOL_namespace_typedef_sname_c: /* namespace_typedef_sname_c  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5289 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_c_opt: /* capture_decl_list_c_opt  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5295 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_c: /* capture_decl_list_c  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5301 "parser.c"
        break;

    case YYSYMBOL_lambda_param_c_ast_list_opt: /* lambda_param_c_ast_list_opt  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5307 "parser.c"
        break;

    case YYSYMBOL_decl_list_c: /* decl_list_c  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5313 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list_exp: /* param_c_ast_list_exp  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5319 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list_opt: /* param_c_ast_list_opt  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5325 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list: /* param_c_ast_list  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5331 "parser.c"
        break;

    case YYSYMBOL_pc99_pointer_decl_list_c: /* pc99_pointer_decl_list_c  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5337 "parser.c"
        break;

    case YYSYMBOL_paren_param_decl_list_english_opt: /* paren_param_decl_list_english_opt  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5343 "parser.c"
        break;

    case YYSYMBOL_paren_param_decl_list_english: /* paren_param_decl_list_english  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5349 "parser.c"
        break;

    case YYSYMBOL_param_decl_list_english_opt: /* param_decl_list_english_opt  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5355 "parser.c"
        break;

    case YYSYMBOL_param_decl_list_english: /* param_decl_list_english  */
#line 1846 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5361 "parser.c"
        break;

    case YYSYMBOL_any_name: /* any_name  */
#line 1847 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5367 "parser.c"
        break;

    case YYSYMBOL_any_name_exp: /* any_name_exp  */
#line 1847 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5373 "parser.c"
        break;

    case YYSYMBOL_any_sname_c: /* any_sname_c  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5379 "parser.c"
        break;

    case YYSYMBOL_any_sname_c_exp: /* any_sname_c_exp  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5385 "parser.c"
        break;

    case YYSYMBOL_any_sname_c_opt: /* any_sname_c_opt  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5391 "parser.c"
        break;

    case YYSYMBOL_name_exp: /* name_exp  */
#line 1847 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5397 "parser.c"
        break;

    case YYSYMBOL_name_cat: /* name_cat  */
#line 1847 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5403 "parser.c"
        break;

    case YYSYMBOL_name_opt: /* name_opt  */
#line 1847 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5409 "parser.c"
        break;

    case YYSYMBOL_oper_sname_c_opt: /* oper_sname_c_opt  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5415 "parser.c"
        break;

    case YYSYMBOL_sub_scope_sname_c_opt: /* sub_scope_sname_c_opt  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5421 "parser.c"
        break;

    case YYSYMBOL_sname_c: /* sname_c  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5427 "parser.c"
        break;

    case YYSYMBOL_sname_c_exp: /* sname_c_exp  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5433 "parser.c"
        break;

    case YYSYMBOL_sname_c_opt: /* sname_c_opt  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5439 "parser.c"
        break;

    case YYSYMBOL_sname_english: /* sname_english  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5445 "parser.c"
        break;

    case YYSYMBOL_sname_english_exp: /* sname_english_exp  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5451 "parser.c"
        break;

    case YYSYMBOL_sname_english_opt: /* sname_english_opt  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5457 "parser.c"
        break;

    case YYSYMBOL_sname_list_english: /* sname_list_english  */
#line 1854 "parser.y"
            { DTRACE; c_sname_list_cleanup( &((*yyvaluep).sname_list) );            }
#line 5463 "parser.c"
        break;

    case YYSYMBOL_typedef_sname_c: /* typedef_sname_c  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5469 "parser.c"
        break;

    case YYSYMBOL_destructor_sname: /* destructor_sname  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5475 "parser.c"
        break;

    case YYSYMBOL_glob: /* glob  */
#line 1847 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5481 "parser.c"
        break;

    case YYSYMBOL_glob_opt: /* glob_opt  */
#line 1847 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5487 "parser.c"
        break;

    case YYSYMBOL_of_scope_english: /* of_scope_english  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5493 "parser.c"
        break;

    case YYSYMBOL_of_scope_list_english: /* of_scope_list_english  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5499 "parser.c"
        break;

    case YYSYMBOL_of_scope_list_english_opt: /* of_scope_list_english_opt  */
#line 1853 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5505 "parser.c"
        break;

    case YYSYMBOL_str_lit: /* str_lit  */
#line 1855 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5511 "parser.c"
        break;

    case YYSYMBOL_str_lit_exp: /* str_lit_exp  */
#line 1855 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5517 "parser.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* command_list: command_list command  */
#line 1863 "parser.y"
    { //
      // We get here only after a successful parse.
      //
      parse_cleanup( /*fatal_error=*/false );
    }
#line 5816 "parser.c"
    break;

  case 19: /* command: error  */
#line 1887 "parser.y"
    {
      if ( lexer_printable_token() != NULL )
        elaborate_error_dym( DYM_COMMANDS, "unexpected token" );
      else
        elaborate_error( "unexpected end of command" );
    }
#line 5827 "parser.c"
    break;

  case 20: /* cast_command: Y_cast sname_english_opt as_into_to_exp decl_english_ast  */
#line 1906 "parser.y"
    {
      DUMP_START( "cast_command",
                  "CAST sname_english_opt {AS|[IN]TO} decl_english_ast" );
      DUMP_SNAME( "sname_english_opt", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[-2].sname) );
      cast_ast->cast.kind = C_CAST_C;
      cast_ast->cast.to_ast = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_gibberish( cast_ast, C_GIB_PRINT_CAST, stdout );
    }
#line 5849 "parser.c"
    break;

  case 21: /* cast_command: new_style_cast_english sname_english_exp as_into_to_exp decl_english_ast  */
#line 1929 "parser.y"
    {
      DUMP_START( "cast_command",
                  "new_style_cast_english sname_english_exp {AS|[IN]TO} "
                  "decl_english_ast" );
      DUMP_STR( "new_style_cast_english", c_cast_gibberish( (yyvsp[-3].cast_kind) ) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[-2].sname) );
      cast_ast->cast.kind = (yyvsp[-3].cast_kind);
      cast_ast->cast.to_ast = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_gibberish( cast_ast, C_GIB_PRINT_CAST, stdout );
    }
#line 5873 "parser.c"
    break;

  case 22: /* new_style_cast_english: Y_const cast_exp  */
#line 1951 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_CONST;        }
#line 5879 "parser.c"
    break;

  case 23: /* new_style_cast_english: Y_dynamic cast_exp  */
#line 1952 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_DYNAMIC;      }
#line 5885 "parser.c"
    break;

  case 24: /* new_style_cast_english: Y_reinterpret cast_exp  */
#line 1953 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_REINTERPRET;  }
#line 5891 "parser.c"
    break;

  case 25: /* new_style_cast_english: Y_static cast_exp  */
#line 1954 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_STATIC;       }
#line 5897 "parser.c"
    break;

  case 27: /* declare_command: Y_declare sname_list_english as_exp alignas_or_width_decl_english_ast  */
#line 1966 "parser.y"
    {
      if ( (yyvsp[0].ast)->kind == K_NAME ) {
        //
        // This checks for a case like:
        //
        //      declare x as y
        //
        // i.e., declaring a variable name as another name (unknown type).
        // This can get this far due to the nature of the C/C++ grammar.
        //
        // This check has to be done now in the parser rather than later in the
        // AST because the name of the AST node needs to be set to the variable
        // name, but the AST node is itself a name and overwriting it would
        // lose information.
        //
        assert( !c_sname_empty( &(yyvsp[0].ast)->sname ) );
        print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].ast)->sname );
        c_sname_list_cleanup( &(yyvsp[-2].sname_list) );
        PARSE_ABORT();
      }

      DUMP_START( "declare_command",
                  "DECLARE sname_list_english AS "
                  "alignas_or_width_decl_english_ast" );
      DUMP_SNAME_LIST( "sname_list_english", (yyvsp[-2].sname_list) );
      DUMP_AST( "alignas_or_width_decl_english_ast", (yyvsp[0].ast) );

      (yyvsp[0].ast)->loc = (yylsp[-2]);

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      // To check the declaration, it needs a name: just dup the first one.
      c_sname_t temp_sname = c_sname_dup( slist_front( &(yyvsp[-2].sname_list) ) );
      c_sname_set( &(yyvsp[0].ast)->sname, &temp_sname );

      bool ok = c_ast_check( (yyvsp[0].ast) );

      if ( ok ) {
        //
        // Ensure that none of the names aren't of a previously declared type:
        //
        //      cdecl> struct S
        //      cdecl> declare S as int // error: "S": previously declared
        //
        // This check is done now in the parser rather than later in the AST
        // since similar checks are also done here in the parser.
        //
        FOREACH_SLIST_NODE( sname_node, &(yyvsp[-2].sname_list) ) {
          c_sname_t const *const sname = sname_node->data;
          c_typedef_t const *const tdef = c_typedef_find_sname( sname );
          if ( tdef != NULL ) {
            print_error( &(yyvsp[0].ast)->loc,
              "\"%s\": previously declared as type \"",
              c_sname_full_name( sname )
            );
            print_type_ast( tdef, stderr );
            EPUTS( "\"\n" );
            ok = false;
            break;
          }
        } // for
      }

      if ( ok )
        c_sname_list_ast_gibberish( &(yyvsp[-2].sname_list), (yyvsp[0].ast), stdout );

      c_sname_list_cleanup( &(yyvsp[-2].sname_list) );
      PARSE_ASSERT( ok );
      PUTC( '\n' );
    }
#line 5973 "parser.c"
    break;

  case 28: /* $@1: %empty  */
#line 2042 "parser.y"
    { //
      // This check is done now in the parser right here mid-rule rather than
      // later in the end-rule action or in the AST since it yields a better
      // error message since otherwise it would warn that "operator" is a
      // keyword in C++98 which skims right past the bigger error that operator
      // overloading isn't supported in C.
      //
      if ( !IS_SUPPORTED( operator ) ) {
        print_error( &(yylsp[0]),
          "operator overloading not supported%s\n",
          C_LANG_WHICH( operator )
        );
        PARSE_ABORT();
      }
    }
#line 5993 "parser.c"
    break;

  case 29: /* declare_command: Y_declare c_operator $@1 of_scope_list_english_opt as_exp type_qualifier_list_english_type_opt ref_qualifier_english_stid_opt member_or_non_member_opt operator_exp paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 2063 "parser.y"
    {
      c_operator_t const *const operator = c_op_get( (yyvsp[-9].op_id) );

      DUMP_START( "declare_command",
                  "DECLARE c_operator of_scope_list_english_opt AS "
                  "type_qualifier_list_english_type_opt "
                  "ref_qualifier_english_stid_opt "
                  "member_or_non_member_opt "
                  "OPERATOR paren_param_decl_list_english_opt "
                  "returning_english_ast_opt" );
      DUMP_STR( "c_operator", operator->literal );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[-7].sname) );
      DUMP_TYPE( "type_qualifier_list_english_type_opt", (yyvsp[-5].type) );
      DUMP_TID( "ref_qualifier_english_stid_opt", (yyvsp[-4].tid) );
      DUMP_INT( "member_or_non_member_opt", (yyvsp[-3].member) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );
      DUMP_END();

      c_ast_t *const oper_ast = c_ast_new_gc( K_OPERATOR, &(yylsp[-9]) );
      c_sname_set( &oper_ast->sname, &(yyvsp[-7].sname) );
      PARSE_ASSERT( c_type_add( &oper_ast->type, &(yyvsp[-5].type), &(yylsp[-5]) ) );
      PARSE_ASSERT(
        c_type_add_tid( &oper_ast->type, (yyvsp[-4].tid), &(yylsp[-4]) )
      );
      oper_ast->oper.operator = operator;
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), oper_ast );
      oper_ast->oper.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      oper_ast->oper.member = (yyvsp[-3].member);
      c_ast_set_parent( (yyvsp[0].ast), oper_ast );

      PARSE_ASSERT( c_ast_check( oper_ast ) );
      unsigned decl_flags = C_GIB_PRINT_DECL;
      if ( opt_semicolon )
        decl_flags |= C_GIB_OPT_SEMICOLON;
      c_ast_gibberish( oper_ast, decl_flags, stdout );
      PUTC( '\n' );
    }
#line 6036 "parser.c"
    break;

  case 30: /* declare_command: Y_declare storage_class_subset_english_type_opt Y_lambda capturing_paren_capture_decl_list_english_opt paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 2109 "parser.y"
    {
      DUMP_START( "declare_command",
                  "DECLARE storage_class_subset_english_type_opt "
                  "LAMBDA capturing_paren_capture_decl_list_english_opt "
                  "paren_param_decl_list_english_opt"
                  "returning_english_ast_opt" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-4].type) );
      DUMP_AST_LIST( "capturing_paren_capture_decl_list_english_opt",
                     (yyvsp[-2].ast_list) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      c_ast_t *const lambda_ast = c_ast_new_gc( K_LAMBDA, &(yyloc) );
      lambda_ast->type = (yyvsp[-4].type);
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), lambda_ast );
      lambda_ast->lambda.capture_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), lambda_ast );
      lambda_ast->lambda.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), lambda_ast );

      DUMP_AST( "$$_ast", lambda_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( lambda_ast ) );
      c_ast_gibberish( lambda_ast, C_GIB_PRINT_DECL, stdout );
      PUTC( '\n' );
    }
#line 6068 "parser.c"
    break;

  case 31: /* declare_command: Y_declare storage_class_subset_english_type_opt cv_qualifier_list_stid_opt user_defined conversion_exp operator_opt of_scope_list_english_opt returning_exp decl_english_ast  */
#line 2144 "parser.y"
    {
      DUMP_START( "declare_command",
                  "DECLARE storage_class_subset_english_type_opt "
                  "cv_qualifier_list_stid_opt "
                  "USER-DEFINED CONVERSION [OPERATOR] "
                  "of_scope_list_english_opt "
                  "RETURNING decl_english_ast" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-7].type) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const udc_ast = c_ast_new_gc( K_UDEF_CONV, &(yyloc) );
      c_sname_set( &udc_ast->sname, &(yyvsp[-2].sname) );
      udc_ast->type = c_type_or( &(yyvsp[-7].type), &C_TYPE_LIT_S( (yyvsp[-6].tid) ) );
      c_ast_set_parent( (yyvsp[0].ast), udc_ast );

      DUMP_AST( "$$_ast", udc_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( udc_ast ) );
      unsigned decl_flags = C_GIB_PRINT_DECL;
      if ( opt_semicolon )
        decl_flags |= C_GIB_OPT_SEMICOLON;
      c_ast_gibberish( udc_ast, decl_flags, stdout );
      PUTC( '\n' );
    }
#line 6100 "parser.c"
    break;

  case 32: /* declare_command: Y_declare error  */
#line 2173 "parser.y"
    {
      if ( OPT_LANG_IS( operator ) )
        elaborate_error( "name or operator expected" );
      else
        elaborate_error( "name expected" );
    }
#line 6111 "parser.c"
    break;

  case 34: /* alignas_or_width_decl_english_ast: decl_english_ast alignas_specifier_english  */
#line 2185 "parser.y"
    {
      DUMP_START( "alignas_or_width_decl_english_ast",
                  "decl_english_ast alignas_specifier_english" );
      DUMP_AST( "decl_english_ast", (yyvsp[-1].ast) );
      DUMP_ALIGN( "alignas_specifier_english", (yyvsp[0].align) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->align = (yyvsp[0].align);
      (yyval.ast)->loc = (yyloc);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 6129 "parser.c"
    break;

  case 35: /* alignas_or_width_decl_english_ast: decl_english_ast width_specifier_english_uint  */
#line 2200 "parser.y"
    {
      DUMP_START( "alignas_or_width_decl_english_ast",
                  "decl_english_ast width_specifier_english_uint" );
      DUMP_AST( "decl_english_ast", (yyvsp[-1].ast) );
      DUMP_INT( "width_specifier_english_uint", (yyvsp[0].uint_val) );

      //
      // This check has to be done now in the parser rather than later in the
      // AST since we need to use the builtin union member now.
      //
      if ( !c_ast_is_integral( (yyvsp[-1].ast) ) ) {
        print_error( &(yylsp[0]), "invalid bit-field type " );
        print_ast_type_aka( (yyvsp[-1].ast), stderr );
        EPRINTF( "; must be an integral %stype\n",
          OPT_LANG_IS( enum_BITFIELDS ) ? "or enumeration " : ""
        );
        PARSE_ABORT();
      }

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      (yyval.ast)->bit_field.bit_width = (yyvsp[0].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 6160 "parser.c"
    break;

  case 36: /* alignas_specifier_english: aligned_english uint_lit bytes_opt  */
#line 2230 "parser.y"
    {
      (yyval.align).kind = C_ALIGNAS_BYTES;
      (yyval.align).loc = (yylsp[-2]);
      (yyval.align).bytes = (yyvsp[-1].uint_val);
    }
#line 6170 "parser.c"
    break;

  case 37: /* alignas_specifier_english: aligned_english decl_english_ast  */
#line 2236 "parser.y"
    {
      (yyval.align).kind = C_ALIGNAS_TYPE;
      (yyval.align).loc = (yylsp[-1]);
      (yyval.align).type_ast = (yyvsp[0].ast);
    }
#line 6180 "parser.c"
    break;

  case 38: /* alignas_specifier_english: aligned_english error  */
#line 2242 "parser.y"
    {
      (yyval.align) = (c_alignas_t){ 0 };
      (yyval.align).loc = (yylsp[-1]);
      elaborate_error( "integer or type expected" );
    }
#line 6190 "parser.c"
    break;

  case 42: /* capturing_paren_capture_decl_list_english_opt: %empty  */
#line 2256 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 6196 "parser.c"
    break;

  case 43: /* capturing_paren_capture_decl_list_english_opt: Y_capturing paren_capture_decl_list_english  */
#line 2258 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[0].ast_list);
    }
#line 6204 "parser.c"
    break;

  case 44: /* capturing_paren_capture_decl_list_english_opt: '[' capture_decl_list_english_opt ']'  */
#line 2262 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6212 "parser.c"
    break;

  case 45: /* paren_capture_decl_list_english: '[' capture_decl_list_english_opt ']'  */
#line 2269 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6220 "parser.c"
    break;

  case 46: /* paren_capture_decl_list_english: '(' capture_decl_list_english_opt ')'  */
#line 2273 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6228 "parser.c"
    break;

  case 47: /* paren_capture_decl_list_english: error  */
#line 2277 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      elaborate_error( "'[' or '(' expected\n" );
    }
#line 6237 "parser.c"
    break;

  case 48: /* capture_decl_list_english_opt: %empty  */
#line 2284 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 6243 "parser.c"
    break;

  case 50: /* capture_decl_list_english: capture_decl_list_english comma_exp capture_decl_english_ast  */
#line 2291 "parser.y"
    {
      DUMP_START( "capture_decl_list_english",
                  "capture_decl_list_english ',' capture_decl_english_ast" );
      DUMP_AST_LIST( "capture_decl_list_english", (yyvsp[-2].ast_list) );
      DUMP_AST( "capture_decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 6260 "parser.c"
    break;

  case 51: /* capture_decl_list_english: capture_decl_english_ast  */
#line 2305 "parser.y"
    {
      DUMP_START( "capture_decl_list_english",
                  "capture_decl_english_ast" );
      DUMP_AST( "capture_decl_english_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 6276 "parser.c"
    break;

  case 52: /* capture_decl_english_ast: Y_copy capture_default_opt  */
#line 2320 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_COPY;
    }
#line 6285 "parser.c"
    break;

  case 53: /* capture_decl_english_ast: Y_reference capture_default_opt  */
#line 2325 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 6294 "parser.c"
    break;

  case 54: /* capture_decl_english_ast: Y_reference Y_to name_exp  */
#line 2330 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_append_name( &(yyval.ast)->sname, (yyvsp[0].name) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 6304 "parser.c"
    break;

  case 59: /* width_specifier_english_uint: Y_width uint_lit_exp bits_opt  */
#line 2346 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since we use 0 to mean "no bit-field."
      //
      if ( (yyvsp[-1].uint_val) == 0 ) {
        print_error( &(yylsp[-1]), "bit-field width must be > 0\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 6319 "parser.c"
    break;

  case 60: /* storage_class_subset_english_type_opt: %empty  */
#line 2359 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 6325 "parser.c"
    break;

  case 61: /* storage_class_subset_english_type_opt: storage_class_subset_english_type_opt storage_class_subset_english_type  */
#line 2362 "parser.y"
    {
      DUMP_START( "storage_class_subset_english_type_opt",
                  "storage_class_subset_english_type_opt "
                  "storage_class_subset_english_type" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-1].type) );
      DUMP_TYPE( "storage_class_subset_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 6343 "parser.c"
    break;

  case 62: /* storage_class_subset_english_type: attribute_english_atid  */
#line 2378 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) ); }
#line 6349 "parser.c"
    break;

  case 63: /* storage_class_subset_english_type: storage_class_subset_english_stid  */
#line 2380 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) );
    }
#line 6357 "parser.c"
    break;

  case 64: /* storage_class_subset_english_stid: Y_const_ENG eval_expr_init_stid  */
#line 2401 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 6365 "parser.c"
    break;

  case 74: /* storage_class_subset_english_stid: Y_no Y_except  */
#line 2413 "parser.y"
                                  { (yyval.tid) = TS_noexcept; }
#line 6371 "parser.c"
    break;

  case 80: /* storage_class_subset_english_stid: Y_pure virtual_stid_exp  */
#line 2419 "parser.y"
                                  { (yyval.tid) = TS_PURE_virtual | (yyvsp[0].tid); }
#line 6377 "parser.c"
    break;

  case 81: /* define_command: Y_define sname_english_exp as_exp decl_english_ast  */
#line 2426 "parser.y"
    {
      DUMP_START( "define_command",
                  "DEFINE sname_english AS decl_english_ast" );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_sname_set( &(yyvsp[0].ast)->sname, &(yyvsp[-2].sname) );

      if ( (yyvsp[0].ast)->kind == K_NAME ) { // see the comment in "declare_command"
        assert( !c_sname_empty( &(yyvsp[0].ast)->sname ) );
        print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].ast)->sname );
        PARSE_ABORT();
      }

      if ( !c_tid_is_any( (yyvsp[0].ast)->type.stids, TS_typedef ) ) {
        //
        // Explicitly add TS_typedef (if it doesn't have it already) to
        // prohibit cases like:
        //
        //      define eint as extern int
        //      define rint as register int
        //      define sint as static int
        //      ...
        //
        // i.e., a defined type with a storage class.  Once the semantic checks
        // pass, remove the TS_typedef.
        //
        PARSE_ASSERT(
          c_type_add( &(yyvsp[0].ast)->type, &T_TS_typedef, &(yylsp[0]) )
        );
      }
      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast) ) );
      PJL_IGNORE_RV( c_ast_take_type_any( (yyvsp[0].ast), &T_TS_typedef ) );

      if ( c_tid_is_any( (yyvsp[0].ast)->type.btids, TB_ANY_SCOPE ) )
        c_sname_set_local_type( &(yyvsp[0].ast)->sname, &(yyvsp[0].ast)->type );
      c_sname_fill_in_namespaces( &(yyvsp[0].ast)->sname );

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      PARSE_ASSERT( c_sname_check( &(yyvsp[0].ast)->sname, &(yylsp[-2]) ) );
      PARSE_ASSERT( define_type( (yyvsp[0].ast), C_ENG_DECL ) );
    }
#line 6426 "parser.c"
    break;

  case 82: /* expand_command: Y_expand Y_NAME expand_command2  */
#line 2476 "parser.y"
    {
      p_arg_list_t   *const arg_list   = (yyvsp[0].ptrs)[0];
      p_token_list_t *const extra_list = (yyvsp[0].ptrs)[1];

      DUMP_START( "expand_command", "EXPAND NAME arg_list_opt extra_list_opt" );
      DUMP_STR( "name", (yyvsp[-1].name) );
      DUMP_MACRO_ARG_LIST( "arg_list", arg_list );
      DUMP_MACRO_TOKEN_LIST( "extra_list", extra_list );
      DUMP_END();

      bool const ok =
        p_macro_expand( (yyvsp[-1].name), &(yylsp[-1]), arg_list, extra_list, stdout );
      p_arg_list_cleanup( arg_list );
      free( arg_list );
      p_token_list_cleanup( extra_list );
      free( extra_list );
      free( (yyvsp[-1].name) );
      PARSE_ASSERT( ok );
    }
#line 6450 "parser.c"
    break;

  case 83: /* expand_command: Y_expand error  */
#line 2497 "parser.y"
    {
      elaborate_error( "macro name expected" );
    }
#line 6458 "parser.c"
    break;

  case 84: /* expand_command2: %empty  */
#line 2503 "parser.y"
                                  { (yyval.ptrs)[0] = (yyval.ptrs)[1] = NULL; }
#line 6464 "parser.c"
    break;

  case 85: /* expand_command2: p_extra_token_except_lparen p_extra_tokens_opt  */
#line 2519 "parser.y"
    {
      if ( (yyvsp[0].p_token_list) == NULL ) {
        (yyvsp[0].p_token_list) = MALLOC( p_token_list_t, 1 );
        slist_init( (yyvsp[0].p_token_list) );
      }
      slist_push_front( (yyvsp[0].p_token_list), (yyvsp[-1].p_token) );

      (yyval.ptrs)[0] = NULL;
      (yyval.ptrs)[1] = (yyvsp[0].p_token_list);
    }
#line 6479 "parser.c"
    break;

  case 86: /* expand_command2: '(' p_arg_list_opt ')' p_extra_tokens_opt  */
#line 2531 "parser.y"
    {
      (yyval.ptrs)[0] = (yyvsp[-2].p_arg_list);
      (yyval.ptrs)[1] = (yyvsp[0].p_token_list);
    }
#line 6488 "parser.c"
    break;

  case 88: /* p_extra_token_except_lparen: ')'  */
#line 2540 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" );
    }
#line 6496 "parser.c"
    break;

  case 89: /* p_extra_tokens_opt: %empty  */
#line 2546 "parser.y"
                                  { (yyval.p_token_list) = NULL; }
#line 6502 "parser.c"
    break;

  case 91: /* p_extra_tokens: p_extra_tokens p_extra_token  */
#line 2552 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6511 "parser.c"
    break;

  case 92: /* p_extra_tokens: p_extra_token  */
#line 2557 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6521 "parser.c"
    break;

  case 94: /* p_extra_token: '('  */
#line 2567 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "(" );
    }
#line 6529 "parser.c"
    break;

  case 95: /* p_arg_list_opt: %empty  */
#line 2574 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
    }
#line 6538 "parser.c"
    break;

  case 97: /* p_arg_list_opt: p_comma_arg_list  */
#line 2592 "parser.y"
    {
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );

      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
      slist_push_list_back( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6551 "parser.c"
    break;

  case 98: /* p_arg_list_opt: p_comma_arg_list p_arg_list  */
#line 2612 "parser.y"
    {
      slist_push_back( (yyvsp[-1].p_arg_list), p_token_list_new_placemarker() );

      (yyval.p_arg_list) = (yyvsp[0].p_arg_list);
      slist_push_list_front( (yyval.p_arg_list), (yyvsp[-1].p_arg_list) );
    }
#line 6562 "parser.c"
    break;

  case 99: /* p_arg_list_opt: p_comma_arg_list p_arg_list p_comma_arg_list  */
#line 2634 "parser.y"
    {
      slist_push_back( (yyvsp[-2].p_arg_list), p_token_list_new_placemarker() );
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );

      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_list_front( (yyval.p_arg_list), (yyvsp[-2].p_arg_list) );
      slist_push_list_back ( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6575 "parser.c"
    break;

  case 100: /* p_arg_list_opt: p_arg_list p_comma_arg_list  */
#line 2654 "parser.y"
    {
      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );
      slist_push_list_back( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6585 "parser.c"
    break;

  case 101: /* p_arg_list_opt: error  */
#line 2661 "parser.y"
    {
      (yyval.p_arg_list) = NULL;
      elaborate_error( "macro argument expected" );
    }
#line 6594 "parser.c"
    break;

  case 102: /* p_comma_arg_list: p_comma_arg_list ','  */
#line 2669 "parser.y"
    {
      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_back( (yyval.p_arg_list), p_token_list_new_placemarker() );
    }
#line 6603 "parser.c"
    break;

  case 103: /* p_comma_arg_list: ','  */
#line 2674 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
    }
#line 6612 "parser.c"
    break;

  case 104: /* p_arg_list: p_arg_list p_comma_arg_list p_arg_tokens  */
#line 2695 "parser.y"
    {
      (yyval.p_arg_list) = (yyvsp[-2].p_arg_list);

      if ( !slist_empty( (yyvsp[-1].p_arg_list) ) )
        slist_push_list_back( (yyval.p_arg_list), (yyvsp[-1].p_arg_list) );

      slist_push_back( (yyval.p_arg_list), (yyvsp[0].p_token_list) );
    }
#line 6625 "parser.c"
    break;

  case 105: /* p_arg_list: p_arg_tokens  */
#line 2705 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
      slist_push_back( (yyval.p_arg_list), (yyvsp[0].p_token_list) );
    }
#line 6635 "parser.c"
    break;

  case 106: /* p_arg_tokens: p_arg_tokens p_arg_token_as_list  */
#line 2714 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_list_back( (yyval.p_token_list), (yyvsp[0].p_token_list) );
    }
#line 6644 "parser.c"
    break;

  case 108: /* p_arg_token_as_list: p_arg_token  */
#line 2723 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6654 "parser.c"
    break;

  case 109: /* p_arg_token_as_list: '(' p_arg_tokens_with_comma_opt ')'  */
#line 2729 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_front( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[-2]), "(" ) );
      slist_push_back ( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" ) );
    }
#line 6664 "parser.c"
    break;

  case 110: /* p_arg_token: Y_CHAR_LIT  */
#line 2738 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_CHAR_LIT, &(yylsp[0]), (yyvsp[0].str_val) );
    }
#line 6672 "parser.c"
    break;

  case 111: /* p_arg_token: Y_NAME  */
#line 2742 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_IDENTIFIER, &(yylsp[0]), (yyvsp[0].name) );
    }
#line 6680 "parser.c"
    break;

  case 112: /* p_arg_token: p_num_lit  */
#line 2746 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_NUM_LIT, &(yylsp[0]), check_strdup( lexer_token ) );
    }
#line 6688 "parser.c"
    break;

  case 113: /* p_arg_token: PY_SPACE  */
#line 2750 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_SPACE, &(yylsp[0]), /*literal=*/NULL );
    }
#line 6696 "parser.c"
    break;

  case 114: /* p_arg_token: Y_STR_LIT  */
#line 2754 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_STR_LIT, &(yylsp[0]), (yyvsp[0].str_val) );
    }
#line 6704 "parser.c"
    break;

  case 115: /* p_arg_token: p_other  */
#line 2758 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_OTHER, &(yylsp[0]), lexer_token );
    }
#line 6712 "parser.c"
    break;

  case 116: /* p_arg_token: p_punctuator  */
#line 2762 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), lexer_token );
    }
#line 6720 "parser.c"
    break;

  case 170: /* p_arg_tokens_with_comma_opt: %empty  */
#line 2834 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
    }
#line 6729 "parser.c"
    break;

  case 172: /* p_arg_tokens_with_comma: p_arg_tokens_with_comma p_arg_token_with_comma_as_list  */
#line 2854 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_list_back( (yyval.p_token_list), (yyvsp[0].p_token_list) );
    }
#line 6738 "parser.c"
    break;

  case 174: /* p_arg_token_with_comma_as_list: p_arg_token_with_comma  */
#line 2863 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6748 "parser.c"
    break;

  case 175: /* p_arg_token_with_comma_as_list: '(' p_arg_tokens_with_comma_opt ')'  */
#line 2869 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_front( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[-2]), "(" ) );
      slist_push_back ( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" ) );
    }
#line 6758 "parser.c"
    break;

  case 177: /* p_arg_token_with_comma: ','  */
#line 2879 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "," );
    }
#line 6766 "parser.c"
    break;

  case 188: /* explain_command: explain pc99_pointer_decl_list_c  */
#line 2946 "parser.y"
    {
      PARSE_ASSERT( c_ast_list_check( &(yyvsp[0].ast_list) ) );
      c_ast_list_english( &(yyvsp[0].ast_list), stdout );
    }
#line 6775 "parser.c"
    break;

  case 190: /* $@2: %empty  */
#line 2964 "parser.y"
                       { in_attr.is_typename = true; }
#line 6781 "parser.c"
    break;

  case 193: /* explain_command: explain extern_linkage_c_stid_opt using_decl_c_ast  */
#line 2985 "parser.y"
    {
      DUMP_START( "explain_command",
                  "EXPLAIN extern_linkage_c_stid_opt using_decl_c_ast" );
      DUMP_TID( "extern_linkage_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_AST( "using_decl_c_ast", (yyvsp[0].ast) );

      PARSE_ASSERT(
        c_type_add_tid( &(yyvsp[0].ast)->type, (yyvsp[-1].tid), &(yylsp[-1]) )
      );

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast) ) );
      c_ast_english( (yyvsp[0].ast), C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 6803 "parser.c"
    break;

  case 194: /* explain_command: explain sname_c  */
#line 3008 "parser.y"
    {
      print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].sname) );
      c_sname_cleanup( &(yyvsp[0].sname) );
      PARSE_ABORT();
    }
#line 6813 "parser.c"
    break;

  case 195: /* explain_command: explain error  */
#line 3015 "parser.y"
    {
      elaborate_error( "cast or declaration expected" );
    }
#line 6821 "parser.c"
    break;

  case 196: /* explain: Y_explain  */
#line 3022 "parser.y"
    { //
      // Set our mode to deciphering gibberish into English and specifically
      // tell the lexer to return cdecl keywords (e.g., "func") as ordinary
      // names, otherwise gibberish like:
      //
      //      int func(void);
      //
      // would result in a parser error.
      //
      gibberish_to_english();
    }
#line 6837 "parser.c"
    break;

  case 197: /* $@3: %empty  */
#line 3039 "parser.y"
    { //
      // We want cdecl commands (like "declare", etc.), other cdecl keywords
      // (like "cast", "commands", "english", "options", etc.), and C/C++
      // keywords (like "const", "static", "typedef", etc.) all to be returned
      // as just strings so we don't have to enumerate all the possible tokens
      // in the grammar.
      //
      lexer_find &= ~(LEXER_FIND_C_KEYWORDS | LEXER_FIND_CDECL_KEYWORDS);
    }
#line 6851 "parser.c"
    break;

  case 198: /* help_command: '?' $@3 help_what_opt  */
#line 3049 "parser.y"
    {
      bool const ok = print_help( (yyvsp[0].name), &(yylsp[0]) );
      free( (yyvsp[0].name) );
      PARSE_ASSERT( ok );
    }
#line 6861 "parser.c"
    break;

  case 199: /* help_what_opt: %empty  */
#line 3057 "parser.y"
                                  { (yyval.name) = NULL; }
#line 6867 "parser.c"
    break;

  case 201: /* help_what_opt: '#' Y_NAME  */
#line 3059 "parser.y"
                                  { (yyval.name) = str_realloc_pcat( "#", "", (yyvsp[0].name) ); }
#line 6873 "parser.c"
    break;

  case 202: /* help_what_opt: '#' error  */
#line 3061 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "\"#define\", \"#include\", or \"#undef\" expected" );
    }
#line 6882 "parser.c"
    break;

  case 203: /* help_what_opt: error  */
#line 3066 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error(
        "<command>, \"commands\", \"english\", or \"options\" expected"
      );
    }
#line 6893 "parser.c"
    break;

  case 207: /* preprocessor_command: '#' PY_elif  */
#line 3083 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elif\"" );
      PARSE_ABORT();
    }
#line 6902 "parser.c"
    break;

  case 208: /* preprocessor_command: '#' PY_elifdef  */
#line 3088 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elifdef\"" );
      PARSE_ABORT();
    }
#line 6911 "parser.c"
    break;

  case 209: /* preprocessor_command: '#' PY_elifndef  */
#line 3093 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elifdef\"" );
      PARSE_ABORT();
    }
#line 6920 "parser.c"
    break;

  case 210: /* preprocessor_command: '#' PY_else  */
#line 3098 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#else\"" );
      PARSE_ABORT();
    }
#line 6929 "parser.c"
    break;

  case 211: /* preprocessor_command: '#' PY_embed  */
#line 3103 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#embed\"" );
      PARSE_ABORT();
    }
#line 6938 "parser.c"
    break;

  case 212: /* preprocessor_command: '#' PY_error  */
#line 3108 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#error\"" );
      PARSE_ABORT();
    }
#line 6947 "parser.c"
    break;

  case 213: /* preprocessor_command: '#' PY_if  */
#line 3113 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#if\"" );
      PARSE_ABORT();
    }
#line 6956 "parser.c"
    break;

  case 214: /* preprocessor_command: '#' PY_ifdef  */
#line 3118 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#ifdef\"" );
      PARSE_ABORT();
    }
#line 6965 "parser.c"
    break;

  case 215: /* preprocessor_command: '#' PY_ifndef  */
#line 3123 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#ifndef\"" );
      PARSE_ABORT();
    }
#line 6974 "parser.c"
    break;

  case 216: /* preprocessor_command: '#' PY_line  */
#line 3128 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#line\"" );
      PARSE_ABORT();
    }
#line 6983 "parser.c"
    break;

  case 217: /* preprocessor_command: '#' PY_pragma  */
#line 3133 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#pragma\"" );
      PARSE_ABORT();
    }
#line 6992 "parser.c"
    break;

  case 218: /* preprocessor_command: '#' PY_warning  */
#line 3138 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#warning\"" );
      PARSE_ABORT();
    }
#line 7001 "parser.c"
    break;

  case 219: /* preprocessor_command: '#' error  */
#line 3143 "parser.y"
    {
      elaborate_error( "\"#define\", \"#include\", or \"#undef\" expected" );
    }
#line 7009 "parser.c"
    break;

  case 220: /* p_define: PY_define name_exp p_paren_param_list_opt p_replace_list_opt  */
#line 3151 "parser.y"
    {
      DUMP_START( "p_define",
                  "#define NAME p_paren_param_list_opt p_replace_list_opt" );
      DUMP_STR( "name", (yyvsp[-2].name) );
      DUMP_MACRO_PARAM_LIST( "p_paren_param_list_opt", (yyvsp[-1].p_param_list) );
      DUMP_MACRO_TOKEN_LIST( "p_replace_list_opt", (yyvsp[0].p_token_list) );

      c_typedef_t const *const tdef = c_typedef_find_name( (yyvsp[-2].name) );
      if ( tdef != NULL ) {
        if ( tdef->is_predefined ) {
          print_warning( &(yylsp[-2]),
            "\"%s\" is a predefined type since %s\n",
            (yyvsp[-2].name),
            c_lang_name( c_lang_oldest( tdef->lang_ids ) )
          );
        }
        else {
          print_warning( &(yylsp[-2]),
            "\"%s\" previously defined as type (\"",
            (yyvsp[-2].name)
          );
          print_type_decl( tdef, tdef->decl_flags, stderr );
          EPUTS( "\")\n" );
        }
      }

      p_macro_t *const macro =
        p_macro_define( (yyvsp[-2].name), &(yylsp[-2]), (yyvsp[-1].p_param_list), (yyvsp[0].p_token_list) );
      p_param_list_cleanup( (yyvsp[-1].p_param_list) );
      free( (yyvsp[-1].p_param_list) );
      p_token_list_cleanup( (yyvsp[0].p_token_list) );
      free( (yyvsp[0].p_token_list) );
      PARSE_ASSERT( macro != NULL );

      DUMP_MACRO( "macro", macro );
      DUMP_END();
    }
#line 7051 "parser.c"
    break;

  case 221: /* p_paren_param_list_opt: %empty  */
#line 3190 "parser.y"
                                  { (yyval.p_param_list) = NULL; }
#line 7057 "parser.c"
    break;

  case 222: /* p_paren_param_list_opt: '(' p_param_list_opt ')'  */
#line 3191 "parser.y"
                                  { (yyval.p_param_list) = (yyvsp[-1].p_param_list); }
#line 7063 "parser.c"
    break;

  case 223: /* p_param_list_opt: %empty  */
#line 3195 "parser.y"
    { //
      // Use an empty list to distinguish a macro with an empty parameter list
      // from one with no parameter list.
      //
      //      #define M   X       // no parameter list: use NULL
      //      #define F() #X      // empty parameter list: use empty list
      //
      (yyval.p_param_list) = MALLOC( p_param_list_t, 1 );
      slist_init( (yyval.p_param_list) );
    }
#line 7078 "parser.c"
    break;

  case 225: /* p_param_list: p_param_list comma_exp p_param  */
#line 3210 "parser.y"
    {
      DUMP_START( "p_param_list", "p_param" );
      DUMP_MACRO_PARAM_LIST( "p_param_list", (yyvsp[-2].p_param_list) );
      DUMP_STR( "p_param", (yyvsp[0].p_param)->name );

      (yyval.p_param_list) = (yyvsp[-2].p_param_list);
      slist_push_back( (yyval.p_param_list), (yyvsp[0].p_param) );

      DUMP_MACRO_PARAM_LIST( "$$_list", (yyval.p_param_list) );
      DUMP_END();
    }
#line 7094 "parser.c"
    break;

  case 226: /* p_param_list: p_param  */
#line 3223 "parser.y"
    {
      DUMP_START( "p_param_list", "p_param" );
      DUMP_STR( "p_param", (yyvsp[0].p_param)->name );

      (yyval.p_param_list) = MALLOC( p_param_list_t, 1 );
      slist_init( (yyval.p_param_list) );
      slist_push_back( (yyval.p_param_list), (yyvsp[0].p_param) );

      DUMP_MACRO_PARAM_LIST( "$$_list", (yyval.p_param_list) );
      DUMP_END();
    }
#line 7110 "parser.c"
    break;

  case 227: /* p_param: Y_NAME  */
#line 3238 "parser.y"
    {
      (yyval.p_param) = MALLOC( p_param_t, 1 );
      *(yyval.p_param) = (p_param_t){ .name = (yyvsp[0].name), .loc = (yylsp[0]) };
    }
#line 7119 "parser.c"
    break;

  case 228: /* p_param: "..."  */
#line 3243 "parser.y"
    {
      (yyval.p_param) = MALLOC( p_param_t, 1 );
      *(yyval.p_param) = (p_param_t){ .name = check_strdup( L_ellipsis ), .loc = (yylsp[0]) };
    }
#line 7128 "parser.c"
    break;

  case 229: /* p_param: error  */
#line 3248 "parser.y"
    {
      (yyval.p_param) = NULL;
      if ( OPT_LANG_IS( VARIADIC_MACROS ) )
        elaborate_error( "parameter name or \"...\" expected" );
      else
        elaborate_error( "parameter name expected" );
    }
#line 7140 "parser.c"
    break;

  case 230: /* p_replace_list_opt: %empty  */
#line 3258 "parser.y"
                                  { (yyval.p_token_list) = NULL; }
#line 7146 "parser.c"
    break;

  case 232: /* p_replace_list: p_replace_list p_replace_token  */
#line 3264 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 7155 "parser.c"
    break;

  case 233: /* p_replace_list: p_replace_token  */
#line 3270 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 7165 "parser.c"
    break;

  case 234: /* p_replace_token: p_arg_token  */
#line 3279 "parser.y"
    {
      if ( p_token_is_punct( (yyvsp[0].p_token), '#' ) ) {
        //
        // A '#' macro argument token is an ordinary '#', but as a replacement
        // token, retroactively make it P_STRINGIFY.
        //
        (yyvsp[0].p_token)->kind = P_STRINGIFY;
      }
      (yyval.p_token) = (yyvsp[0].p_token);
    }
#line 7180 "parser.c"
    break;

  case 235: /* p_replace_token: '('  */
#line 3290 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "(" );
    }
#line 7188 "parser.c"
    break;

  case 236: /* p_replace_token: ')'  */
#line 3294 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" );
    }
#line 7196 "parser.c"
    break;

  case 237: /* p_replace_token: ','  */
#line 3298 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "," );
    }
#line 7204 "parser.c"
    break;

  case 238: /* p_replace_token: "##"  */
#line 3302 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_CONCAT, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7212 "parser.c"
    break;

  case 239: /* p_replace_token: PY___VA_ARGS__  */
#line 3306 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P___VA_ARGS__, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7220 "parser.c"
    break;

  case 240: /* p_replace_token: PY___VA_OPT__  */
#line 3310 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P___VA_OPT__, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7228 "parser.c"
    break;

  case 241: /* p_undef: PY_undef name_exp  */
#line 3317 "parser.y"
    {
      PARSE_ASSERT( p_macro_undef( (yyvsp[0].name), &(yylsp[0]) ) );
    }
#line 7236 "parser.c"
    break;

  case 242: /* quit_command: Y_quit  */
#line 3325 "parser.y"
                                  { cdecl_quit(); }
#line 7242 "parser.c"
    break;

  case 244: /* set_command: Y_set  */
#line 3338 "parser.y"
    {
      PARSE_ASSERT( set_option( NULL, NULL, NULL, NULL ) );
    }
#line 7250 "parser.c"
    break;

  case 248: /* set_option: Y_SET_OPTION set_option_value_opt  */
#line 3351 "parser.y"
    {
      bool const ok = set_option( (yyvsp[-1].name), &(yylsp[-1]), (yyvsp[0].str_val), &(yylsp[0]) );
      free( (yyvsp[-1].name) );
      free( (yyvsp[0].str_val) );
      PARSE_ASSERT( ok );
    }
#line 7261 "parser.c"
    break;

  case 249: /* set_option_value_opt: %empty  */
#line 3360 "parser.y"
                                  { (yyval.str_val) = NULL; }
#line 7267 "parser.c"
    break;

  case 250: /* set_option_value_opt: '=' Y_SET_OPTION  */
#line 3361 "parser.y"
                                  { (yyval.str_val) = (yyvsp[0].name); (yyloc) = (yylsp[0]); }
#line 7273 "parser.c"
    break;

  case 251: /* set_option_value_opt: '=' error  */
#line 3363 "parser.y"
    {
      (yyval.str_val) = NULL;
      elaborate_error( "option value expected" );
    }
#line 7282 "parser.c"
    break;

  case 252: /* show_command: Y_show any_typedef show_format_opt  */
#line 3373 "parser.y"
    {
      DUMP_START( "show_command", "SHOW any_typedef show_format_opt" );
      DUMP_AST( "any_typedef__ast", (yyvsp[-1].tdef)->ast );
      DUMP_INT( "show_format_opt", (yyvsp[0].flags) );
      DUMP_END();

      show_type( (yyvsp[-1].tdef), (yyvsp[0].flags), stdout );
    }
#line 7295 "parser.c"
    break;

  case 253: /* show_command: Y_show any_typedef Y_as show_format_exp  */
#line 3383 "parser.y"
    {
      DUMP_START( "show_command", "SHOW any_typedef AS show_format_exp" );
      DUMP_AST( "any_typedef__ast", (yyvsp[-2].tdef)->ast );
      DUMP_INT( "show_format_exp", (yyvsp[0].flags) );
      DUMP_END();

      show_type( (yyvsp[-2].tdef), (yyvsp[0].flags), stdout );
    }
#line 7308 "parser.c"
    break;

  case 254: /* show_command: Y_show show_types_opt glob_opt show_format_opt  */
#line 3393 "parser.y"
    {
      show_types( (yyvsp[-2].show), (yyvsp[-1].name), (yyvsp[0].flags), stdout );
      free( (yyvsp[-1].name) );
    }
#line 7317 "parser.c"
    break;

  case 255: /* show_command: Y_show show_types_opt glob_opt Y_as show_format_exp  */
#line 3399 "parser.y"
    {
      show_types( (yyvsp[-3].show), (yyvsp[-2].name), (yyvsp[0].flags), stdout );
      free( (yyvsp[-2].name) );
    }
#line 7326 "parser.c"
    break;

  case 256: /* show_command: Y_show show_types_opt Y_macros  */
#line 3405 "parser.y"
    {
      show_macros( (yyvsp[-1].show), stdout );
    }
#line 7334 "parser.c"
    break;

  case 257: /* show_command: Y_show Y_NAME  */
#line 3410 "parser.y"
    {
      bool ok = false;

      //
      // Check to see if $name is a macro here rather than in the lexer since
      // this is the only place in the cdecl grammar where a name can be a
      // macro since cdecl doesn't support using macros everywhere.
      //
      p_macro_t const *const macro = p_macro_find( (yyvsp[0].name) );
      if ( macro == NULL ) {
        print_error( &(yylsp[0]), "\"%s\": no such type or macro defined", (yyvsp[0].name) );
        print_suggestions( DYM_C_MACROS | DYM_C_TYPES, (yyvsp[0].name) );
        EPUTC( '\n' );
      }
      else if ( !(ok = show_macro( macro, stdout )) ) {
        c_lang_id_t const lang_ids = (*macro->dyn_fn)( /*ptoken=*/NULL );
        print_error( &(yylsp[0]),
          "\"%s\" not supported%s\n",
          (yyvsp[0].name), c_lang_which( lang_ids )
        );
      }

      free( (yyvsp[0].name) );
      if ( !ok )
        PARSE_ABORT();
    }
#line 7365 "parser.c"
    break;

  case 258: /* show_command: Y_show error  */
#line 3438 "parser.y"
    {
      elaborate_error(
        "type name or \"all\", \"predefined\", or \"user\" expected"
      );
    }
#line 7375 "parser.c"
    break;

  case 259: /* show_format: Y_english  */
#line 3446 "parser.y"
                                  { (yyval.flags) = C_ENG_DECL; }
#line 7381 "parser.c"
    break;

  case 260: /* show_format: Y_typedef  */
#line 3447 "parser.y"
                                  { (yyval.flags) = C_GIB_TYPEDEF; }
#line 7387 "parser.c"
    break;

  case 261: /* show_format: Y_using  */
#line 3449 "parser.y"
    {
      if ( !IS_SUPPORTED( using_DECLS ) ) {
        print_error( &(yylsp[0]),
          "\"using\" not supported%s\n",
          C_LANG_WHICH( using_DECLS )
        );
        PARSE_ABORT();
      }
      (yyval.flags) = C_GIB_USING;
    }
#line 7402 "parser.c"
    break;

  case 263: /* show_format_exp: error  */
#line 3464 "parser.y"
    {
      if ( OPT_LANG_IS( using_DECLS ) )
        elaborate_error( "\"english\", \"typedef\", or \"using\" expected" );
      else
        elaborate_error( "\"english\" or \"typedef\" expected" );
    }
#line 7413 "parser.c"
    break;

  case 264: /* show_format_opt: %empty  */
#line 3473 "parser.y"
                                  { (yyval.flags) = 0/*as declared*/; }
#line 7419 "parser.c"
    break;

  case 266: /* show_types_opt: %empty  */
#line 3478 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7425 "parser.c"
    break;

  case 267: /* show_types_opt: Y_all predefined_or_user_types_opt  */
#line 3480 "parser.y"
    {
      (yyval.show) = (yyvsp[0].show) | CDECL_SHOW_OPT_IGNORE_LANG;
    }
#line 7433 "parser.c"
    break;

  case 268: /* show_types_opt: Y_predefined  */
#line 3483 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_PREDEFINED; }
#line 7439 "parser.c"
    break;

  case 269: /* show_types_opt: Y_user  */
#line 3484 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7445 "parser.c"
    break;

  case 270: /* predefined_or_user_types_opt: %empty  */
#line 3489 "parser.y"
    {
      (yyval.show) = CDECL_SHOW_PREDEFINED | CDECL_SHOW_USER_DEFINED;
    }
#line 7453 "parser.c"
    break;

  case 271: /* predefined_or_user_types_opt: Y_predefined  */
#line 3492 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_PREDEFINED; }
#line 7459 "parser.c"
    break;

  case 272: /* predefined_or_user_types_opt: Y_user  */
#line 3493 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7465 "parser.c"
    break;

  case 276: /* $@4: %empty  */
#line 3522 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 7473 "parser.c"
    break;

  case 277: /* c_style_cast_expr_c: '(' type_c_ast $@4 cast_c_astp_opt rparen_exp sname_c_opt  */
#line 3526 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "explain_command",
                  "EXPLAIN '(' type_c_ast cast_c_astp_opt ')' sname_c_opt" );
      DUMP_AST( "type_c_ast", (yyvsp[-4].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-2].ast_pair) );
      DUMP_SNAME( "sname_c_opt", (yyvsp[0].sname) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[0].sname) );
      cast_ast->cast.kind = C_CAST_C;
      cast_ast->cast.to_ast =
        c_ast_patch_placeholder( (yyvsp[-4].ast), (yyvsp[-2].ast_pair).ast );

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_english( cast_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 7500 "parser.c"
    break;

  case 278: /* c_style_cast_expr_c: '(' pc99_pointer_decl_list_c rparen_exp  */
#line 3559 "parser.y"
    {
      PARSE_ASSERT( c_ast_list_check( &(yyvsp[-1].ast_list) ) );
      c_ast_list_english( &(yyvsp[-1].ast_list), stdout );
    }
#line 7509 "parser.c"
    break;

  case 279: /* $@5: %empty  */
#line 3569 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 7517 "parser.c"
    break;

  case 280: /* new_style_cast_expr_c: new_style_cast_c lt_exp type_c_ast $@5 cast_c_astp_opt gt_exp lparen_exp sname_c_exp rparen_exp  */
#line 3573 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "explain_command",
                  "EXPLAIN new_style_cast_c"
                  "'<' type_c_ast cast_c_astp_opt '>' '(' sname ')'" );
      DUMP_STR( "new_style_cast_c", c_cast_english( (yyvsp[-8].cast_kind) ) );
      DUMP_AST( "type_c_ast", (yyvsp[-6].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-4].ast_pair) );
      DUMP_SNAME( "sname_c_exp", (yyvsp[-1].sname) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[-1].sname) );
      cast_ast->cast.kind = (yyvsp[-8].cast_kind);
      cast_ast->cast.to_ast =
        c_ast_patch_placeholder( (yyvsp[-6].ast), (yyvsp[-4].ast_pair).ast );

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_english( cast_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 7546 "parser.c"
    break;

  case 281: /* new_style_cast_c: Y_const_cast  */
#line 3600 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_CONST;        }
#line 7552 "parser.c"
    break;

  case 282: /* new_style_cast_c: Y_dynamic_cast  */
#line 3601 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_DYNAMIC;      }
#line 7558 "parser.c"
    break;

  case 283: /* new_style_cast_c: Y_reinterpret_cast  */
#line 3602 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_REINTERPRET;  }
#line 7564 "parser.c"
    break;

  case 284: /* new_style_cast_c: Y_static_cast  */
#line 3603 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_STATIC;       }
#line 7570 "parser.c"
    break;

  case 285: /* $@6: %empty  */
#line 3613 "parser.y"
                                  { in_attr.align = (yyvsp[0].align); }
#line 7576 "parser.c"
    break;

  case 286: /* $@7: %empty  */
#line 3614 "parser.y"
                                  { in_attr.is_typename = (yyvsp[0].flag); }
#line 7582 "parser.c"
    break;

  case 288: /* alignas_specifier_c: alignas lparen_exp uint_lit rparen_exp  */
#line 3620 "parser.y"
    {
      DUMP_START( "alignas_specifier_c", "ALIGNAS '(' uint_lit ')'" );
      DUMP_INT( "uint_lit", (yyvsp[-1].uint_val) );

      (yyval.align).kind = C_ALIGNAS_BYTES;
      (yyval.align).loc = (yylsp[-3]);
      (yyval.align).bytes = (yyvsp[-1].uint_val);

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 7598 "parser.c"
    break;

  case 289: /* $@8: %empty  */
#line 3632 "parser.y"
                                            { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 7604 "parser.c"
    break;

  case 290: /* alignas_specifier_c: alignas lparen_exp type_c_ast $@8 cast_c_astp_opt rparen_exp  */
#line 3634 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "alignas_specifier_c",
                  "ALIGNAS '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.align).kind = C_ALIGNAS_TYPE;
      (yyval.align).loc = (yylsp[-5]);
      (yyval.align).type_ast = c_ast_patch_placeholder( (yyvsp[-3].ast), (yyvsp[-1].ast_pair).ast );

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 7624 "parser.c"
    break;

  case 291: /* alignas_specifier_c: alignas lparen_exp error ')'  */
#line 3651 "parser.y"
    {
      elaborate_error( "integer or type expected" );
    }
#line 7632 "parser.c"
    break;

  case 294: /* asm_declaration_c: Y_asm lparen_exp str_lit_exp rparen_exp  */
#line 3665 "parser.y"
    {
      free( (yyvsp[-1].str_val) );
      UNSUPPORTED( &(yylsp[-3]), "asm declarations" );
      PARSE_ABORT();
    }
#line 7642 "parser.c"
    break;

  case 298: /* $@9: %empty  */
#line 3685 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[0]) ) );
      gibberish_to_english();           // see the comment in "explain"
    }
#line 7651 "parser.c"
    break;

  case 299: /* $@10: %empty  */
#line 3690 "parser.y"
    {
      c_type_t const *const cur_type =
        c_sname_local_type( &in_attr.scope_sname );
      if ( c_tid_is_any( cur_type->btids, TB_ANY_CLASS ) ) {
        char const *const cur_name = c_sname_local_name( &in_attr.scope_sname );
        char const *const mbr_name = c_sname_local_name( &(yyvsp[0].sname) );
        if ( strcmp( mbr_name, cur_name ) == 0 ) {
          print_error( &(yylsp[0]),
            "\"%s\": member has the same name as its enclosing %s\n",
            mbr_name, c_type_name_c( cur_type )
          );
          c_sname_cleanup( &(yyvsp[0].sname) );
          PARSE_ABORT();
        }
      }

      DUMP_START( "class_struct_union_declaration_c",
                  "class_struct_union_btid any_sname_c_exp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      c_sname_append_sname( &in_attr.scope_sname, &(yyvsp[0].sname) );
      c_sname_set_local_type(
        &in_attr.scope_sname, &C_TYPE_LIT_B( (yyvsp[-2].tid) )
      );
      PARSE_ASSERT( c_sname_check( &in_attr.scope_sname, &(yylsp[0]) ) );

      c_ast_t *const csu_ast = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yylsp[0]) );
      csu_ast->sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_name(
        &csu_ast->csu.csu_sname,
        check_strdup( c_sname_local_name( &in_attr.scope_sname ) )
      );
      csu_ast->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", csu_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( csu_ast, C_GIB_TYPEDEF ) );
    }
#line 7697 "parser.c"
    break;

  case 301: /* $@11: %empty  */
#line 3739 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[0]) ) );
      gibberish_to_english();           // see the comment in "explain"
    }
#line 7706 "parser.c"
    break;

  case 302: /* enum_declaration_c: enum_btids $@11 any_sname_c_exp enum_fixed_type_c_ast_opt  */
#line 3744 "parser.y"
    {
      DUMP_START( "enum_declaration_c",
                  "enum_btids any_sname_c_exp enum_fixed_type_c_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-3].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_c_ast_opt", (yyvsp[0].ast) );

      c_sname_t enum_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_sname( &enum_sname, &(yyvsp[-1].sname) );
      c_sname_set_local_type( &enum_sname, &C_TYPE_LIT_B( (yyvsp[-3].tid) ) );
      if ( !c_sname_check( &enum_sname, &(yylsp[-1]) ) ) {
        c_sname_cleanup( &enum_sname );
        PARSE_ABORT();
      }

      c_ast_t *const enum_ast = c_ast_new_gc( K_ENUM, &(yylsp[-1]) );
      enum_ast->sname = enum_sname;
      enum_ast->type.btids = c_tid_check( (yyvsp[-3].tid), C_TPID_BASE );
      c_ast_set_parent( (yyvsp[0].ast), enum_ast );
      c_sname_append_name(
        &enum_ast->enum_.enum_sname,
        check_strdup( c_sname_local_name( &enum_sname ) )
      );

      DUMP_AST( "$$_ast", enum_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( enum_ast, C_GIB_TYPEDEF ) );
    }
#line 7740 "parser.c"
    break;

  case 303: /* $@12: %empty  */
#line 3780 "parser.y"
    {
      gibberish_to_english();           // see the comment in "explain"
    }
#line 7748 "parser.c"
    break;

  case 304: /* $@13: %empty  */
#line 3784 "parser.y"
    {
      DUMP_START( "namespace_declaration_c",
                  "namespace_type namespace_sname_c_exp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_TYPE( "namespace_type", (yyvsp[-2].type) );
      DUMP_SNAME( "namespace_sname_c_exp", (yyvsp[0].sname) );

      //
      // Nested namespace declarations are supported only in C++17 and later.
      // (However, we always allow them in configuration files.)
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the AST has no "memory" of how a namespace was
      // constructed.
      //
      if ( c_sname_count( &(yyvsp[0].sname) ) > 1 && !IS_SUPPORTED( NESTED_namespace ) ) {
        print_error( &(yylsp[0]),
          "nested namespace declarations not supported%s\n",
          C_LANG_WHICH( NESTED_namespace )
        );
        c_sname_cleanup( &(yyvsp[0].sname) );
        PARSE_ABORT();
      }

      //
      // The namespace type (plain namespace or inline namespace) has to be
      // split across the namespace sname: only the storage classes (for
      // TS_inline) has to be or'd with the first scope-type of the sname ...
      //
      c_type_t const *const sname_first_type = c_sname_first_type( &(yyvsp[0].sname) );
      c_sname_set_first_type(
        &(yyvsp[0].sname),
        &C_TYPE_LIT(
          sname_first_type->btids,
          sname_first_type->stids | (yyvsp[-2].type).stids,
          sname_first_type->atids
        )
      );
      //
      // ... and only the base types (for TB_namespace) has to be or'd with the
      // local scope type of the sname.
      //
      c_type_t const *const sname_local_type = c_sname_local_type( &(yyvsp[0].sname) );
      c_sname_set_local_type(
        &(yyvsp[0].sname),
        &C_TYPE_LIT(
          sname_local_type->btids | (yyvsp[-2].type).btids,
          sname_local_type->stids,
          sname_local_type->atids
        )
      );

      c_sname_append_sname( &in_attr.scope_sname, &(yyvsp[0].sname) );

      DUMP_SNAME( "$$_sname", (yyvsp[0].sname) );
      DUMP_END();

      PARSE_ASSERT( c_sname_check( &in_attr.scope_sname, &(yylsp[0]) ) );
    }
#line 7812 "parser.c"
    break;

  case 308: /* namespace_sname_c_exp: error  */
#line 3850 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 7821 "parser.c"
    break;

  case 309: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON Y_NAME  */
#line 3863 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "sname_c '::' NAME" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-2].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_namespace ) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7838 "parser.c"
    break;

  case 310: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON any_typedef  */
#line 3877 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "namespace_sname_c '::' any_typedef" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_namespace ) );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7856 "parser.c"
    break;

  case 311: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON Y_inline name_exp  */
#line 3892 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "sname_c '::' NAME INLINE NAME" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-3].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-3].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_set_local_type( &(yyval.sname),
        &C_TYPE_LIT( TB_namespace, (yyvsp[-1].tid), TA_NONE )
      );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7875 "parser.c"
    break;

  case 312: /* namespace_sname_c: Y_NAME  */
#line 3908 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      c_sname_init_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_namespace ) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7890 "parser.c"
    break;

  case 313: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON sname_c  */
#line 3927 "parser.y"
    {
      DUMP_START( "namespace_typedef_sname_c",
                  "namespace_typedef_sname_c '::' sname_c" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_append_sname( &(yyval.sname), &(yyvsp[0].sname) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7907 "parser.c"
    break;

  case 314: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON any_typedef  */
#line 3941 "parser.y"
    {
      DUMP_START( "namespace_typedef_sname_c",
                  "namespace_typedef_sname_c '::' any_typedef" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_set_local_type( &(yyval.sname), c_sname_local_type( &(yyvsp[0].tdef)->ast->sname ) );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7926 "parser.c"
    break;

  case 315: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON Y_inline name_exp  */
#line 3958 "parser.y"
    {
      DUMP_START( "namespace_typedef_sname_c",
                  "namespace_typedef_sname_c '::' INLINE NAME" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-3].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-3].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_set_local_type( &(yyval.sname),
        &C_TYPE_LIT( TB_namespace, (yyvsp[-1].tid), TA_NONE )
      );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7946 "parser.c"
    break;

  case 316: /* namespace_typedef_sname_c: any_typedef  */
#line 3974 "parser.y"
                                  { (yyval.sname) = c_sname_dup( &(yyvsp[0].tdef)->ast->sname ); }
#line 7952 "parser.c"
    break;

  case 318: /* brace_in_scope_declaration_c_exp: error  */
#line 3980 "parser.y"
    {
      punct_expected( '{' );
    }
#line 7960 "parser.c"
    break;

  case 326: /* in_scope_declaration_c_exp: error  */
#line 4000 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 7968 "parser.c"
    break;

  case 327: /* lambda_declaration_c: '[' capture_decl_list_c_opt ']' lambda_param_c_ast_list_opt storage_class_subset_english_type_opt lambda_return_type_c_ast_opt  */
#line 4012 "parser.y"
    {
      DUMP_START( "lambda_declaration_c",
                  "'[' capture_decl_list_c_opt ']' "
                  "lambda_param_c_ast_list_opt "
                  "lambda_return_type_c_ast_opt" );
      DUMP_AST_LIST( "capture_decl_list_c_opt", (yyvsp[-4].ast_list) );
      DUMP_AST_LIST( "lambda_param_c_ast_list_opt", (yyvsp[-2].ast_list) );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "lambda_return_type_c_ast_opt", (yyvsp[0].ast) );

      c_ast_t *const lambda_ast = c_ast_new_gc( K_LAMBDA, &(yyloc) );
      lambda_ast->type = (yyvsp[-1].type);
      c_ast_list_set_param_of( &(yyvsp[-4].ast_list), lambda_ast );
      lambda_ast->lambda.capture_ast_list = slist_move( &(yyvsp[-4].ast_list) );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), lambda_ast );
      lambda_ast->lambda.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), lambda_ast );

      DUMP_AST( "$$_ast", lambda_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( lambda_ast ) );
      c_ast_english( lambda_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 7998 "parser.c"
    break;

  case 328: /* capture_decl_list_c_opt: %empty  */
#line 4040 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 8004 "parser.c"
    break;

  case 330: /* capture_decl_list_c: capture_decl_list_c comma_exp capture_decl_c_ast  */
#line 4047 "parser.y"
    {
      DUMP_START( "capture_decl_list_c",
                  "capture_decl_list_c ',' "
                  "capture_decl_c_ast" );
      DUMP_AST_LIST( "capture_decl_list_c", (yyvsp[-2].ast_list) );
      DUMP_AST( "capture_decl_c_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 8022 "parser.c"
    break;

  case 331: /* capture_decl_list_c: capture_decl_c_ast  */
#line 4062 "parser.y"
    {
      DUMP_START( "capture_decl_list_c",
                  "capture_decl_c_ast" );
      DUMP_AST( "capture_decl_c_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 8038 "parser.c"
    break;

  case 332: /* capture_decl_c_ast: '&'  */
#line 4077 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 8047 "parser.c"
    break;

  case 333: /* capture_decl_c_ast: '&' Y_NAME  */
#line 4082 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_append_name( &(yyval.ast)->sname, (yyvsp[0].name) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 8057 "parser.c"
    break;

  case 334: /* capture_decl_c_ast: '='  */
#line 4088 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_COPY;
    }
#line 8066 "parser.c"
    break;

  case 335: /* capture_decl_c_ast: Y_NAME  */
#line 4093 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_append_name( &(yyval.ast)->sname, (yyvsp[0].name) );
    }
#line 8075 "parser.c"
    break;

  case 336: /* capture_decl_c_ast: Y_this  */
#line 4098 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_THIS;
    }
#line 8084 "parser.c"
    break;

  case 337: /* capture_decl_c_ast: '*' this_exp  */
#line 4103 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_STAR_THIS;
    }
#line 8093 "parser.c"
    break;

  case 338: /* lambda_param_c_ast_list_opt: %empty  */
#line 4110 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 8099 "parser.c"
    break;

  case 339: /* lambda_param_c_ast_list_opt: '(' param_c_ast_list_opt ')'  */
#line 4111 "parser.y"
                                  { (yyval.ast_list) = (yyvsp[-1].ast_list); }
#line 8105 "parser.c"
    break;

  case 340: /* lambda_return_type_c_ast_opt: %empty  */
#line 4115 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 8111 "parser.c"
    break;

  case 341: /* $@14: %empty  */
#line 4116 "parser.y"
                                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 8117 "parser.c"
    break;

  case 342: /* lambda_return_type_c_ast_opt: Y_MINUS_GREATER type_c_ast $@14 cast_c_astp_opt  */
#line 4118 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "lambda_return_type_c_ast_opt",
                  "'->' type_c_ast cast_c_astp_opt" );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = IF_ELSE( (yyvsp[0].ast_pair).ast, (yyvsp[-2].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 8135 "parser.c"
    break;

  case 343: /* template_declaration_c: Y_template  */
#line 4137 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "template declarations" );
      PARSE_ABORT();
    }
#line 8144 "parser.c"
    break;

  case 344: /* $@15: %empty  */
#line 4146 "parser.y"
                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 8150 "parser.c"
    break;

  case 345: /* typed_declaration_c: type_c_ast $@15 decl_list_c_opt  */
#line 4147 "parser.y"
    {
      ia_type_ast_pop();
    }
#line 8158 "parser.c"
    break;

  case 346: /* $@16: %empty  */
#line 4156 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[-1]) ) );
      in_attr.is_typename = (yyvsp[0].flag);
      gibberish_to_english();           // see the comment in "explain"
    }
#line 8168 "parser.c"
    break;

  case 347: /* $@17: %empty  */
#line 4162 "parser.y"
    {
      PARSE_ASSERT( !in_attr.is_typename || c_ast_is_typename_ok( (yyvsp[0].ast) ) );
      // see the comment in "define_command" about TS_typedef
      PARSE_ASSERT(
        c_type_add_tid( &(yyvsp[0].ast)->type, TS_typedef, &(yylsp[0]) )
      );
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 8181 "parser.c"
    break;

  case 348: /* typedef_declaration_c: Y_typedef typename_flag_opt $@16 type_c_ast $@17 typedef_decl_list_c  */
#line 4171 "parser.y"
    {
      ia_type_ast_pop();
    }
#line 8189 "parser.c"
    break;

  case 351: /* typedef_decl_c: decl_c_astp  */
#line 4184 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "typedef_decl_c", "decl_c_astp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      c_ast_t *const decl_ast = (yyvsp[0].ast_pair).ast;
      c_ast_t *typedef_ast;
      c_sname_t temp_sname;

      if ( decl_ast->kind == K_TYPEDEF ) {
        //
        // This is for either of the following cases:
        //
        //      typedef int int32_t;
        //      typedef int32_t int_least32_t;
        //
        // that is: any type name followed by an existing typedef name.
        //
        typedef_ast = type_ast;
        if ( c_sname_empty( &typedef_ast->sname ) )
          typedef_ast->sname = c_sname_dup( &decl_ast->tdef.for_ast->sname );
      }
      else {
        //
        // This is for either of the following cases:
        //
        //      typedef int foo;
        //      typedef int32_t foo;
        //
        // that is: any type name followed by a new name.
        //
        typedef_ast = c_ast_patch_placeholder( type_ast, decl_ast );
        temp_sname = c_ast_move_sname( decl_ast );
        c_sname_set( &typedef_ast->sname, &temp_sname );
      }

      PARSE_ASSERT( c_ast_check( typedef_ast ) );
      // see the comment in "define_command" about TS_typedef
      PJL_IGNORE_RV( c_ast_take_type_any( typedef_ast, &T_TS_typedef ) );

      if ( c_sname_count( &typedef_ast->sname ) > 1 ) {
        print_error( &(yylsp[0]),
          "typedef names can not be scoped; "
          "use: namespace %s { typedef ... }\n",
          c_sname_scope_name( &typedef_ast->sname )
        );
        PARSE_ABORT();
      }

      temp_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_prepend_sname( &typedef_ast->sname, &temp_sname );

      DUMP_AST( "$$_ast", typedef_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( typedef_ast, C_GIB_TYPEDEF  ) );
    }
#line 8254 "parser.c"
    break;

  case 353: /* typedef_decl_c_exp: error  */
#line 4249 "parser.y"
    {
      elaborate_error( "type expected" );
    }
#line 8262 "parser.c"
    break;

  case 354: /* user_defined_conversion_declaration_c: user_defined_conversion_decl_c_astp  */
#line 4258 "parser.y"
    {
      DUMP_START( "user_defined_conversion_declaration_c",
                  "user_defined_conversion_decl_c_astp" );
      DUMP_AST_PAIR( "user_defined_conversion_declaration_c", (yyvsp[0].ast_pair) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast_pair).ast ) );
      c_ast_english( (yyvsp[0].ast_pair).ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8277 "parser.c"
    break;

  case 355: /* using_declaration_c: using_decl_c_ast  */
#line 4274 "parser.y"
    {
      // see the comment in "define_command" about TS_typedef
      PJL_IGNORE_RV( c_ast_take_type_any( (yyvsp[0].ast), &T_TS_typedef ) );

      PARSE_ASSERT( define_type( (yyvsp[0].ast), C_GIB_USING ) );
    }
#line 8288 "parser.c"
    break;

  case 356: /* $@18: %empty  */
#line 4284 "parser.y"
    { //
      // Using declarations are supported only in C++11 and later.  (However,
      // we always allow them in configuration files.)
      //
      // This check has to be done now in the parser rather than later in the
      // AST because using declarations are treated like typedef declarations
      // and the AST has no "memory" that such a declaration was a using
      // declaration.
      //
      if ( !IS_SUPPORTED( using_DECLS ) ) {
        print_error( &(yylsp[0]),
          "\"using\" not supported%s\n",
          C_LANG_WHICH( using_DECLS )
        );
        PARSE_ABORT();
      }

      gibberish_to_english();           // see the comment in "explain"
    }
#line 8312 "parser.c"
    break;

  case 357: /* $@19: %empty  */
#line 4305 "parser.y"
    {
      // see the comment in "define_command" about TS_typedef
      if ( !c_type_add_tid( &(yyvsp[0].ast)->type, TS_typedef, &(yylsp[0]) ) ) {
        free( (yyvsp[-3].name) );
        PARSE_ABORT();
      }
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 8325 "parser.c"
    break;

  case 358: /* using_decl_c_ast: Y_using $@18 any_name_exp attribute_specifier_list_c_atid_opt equals_exp type_c_ast $@19 cast_c_astp_opt  */
#line 4314 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "using_decl_c_ast",
                  "USING any_name_exp attribute_specifier_list_c_atid_opt '=' "
                  "type_c_ast cast_c_astp_opt" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_STR( "any_name_exp", (yyvsp[-5].name) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-4].tid) );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      c_ast_t *const cast_ast = (yyvsp[0].ast_pair).ast;

      //
      // Ensure the type on the right-hand side doesn't have a name, e.g.:
      //
      //      using U = void (*F)();    // error
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the patched AST loses the name.
      //
      c_sname_t const *const sname = c_ast_find_name( cast_ast, C_VISIT_DOWN );
      if ( sname != NULL ) {
        print_error( &cast_ast->loc, "\"using\" type can not have a name\n" );
        free( (yyvsp[-5].name) );
        PARSE_ABORT();
      }

      c_sname_t temp_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_name( &temp_sname, (yyvsp[-5].name) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), cast_ast );
      c_sname_set( &(yyval.ast)->sname, &temp_sname );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-4].tid), C_TPID_ATTR );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyval.ast) ) );
    }
#line 8371 "parser.c"
    break;

  case 359: /* decl_list_c_opt: %empty  */
#line 4369 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "decl_list_c_opt", "<empty>" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );

      if ( (type_ast->kind & K_ANY_ECSU) == 0 ) {
        //
        // The declaration is a non-ECSU type, e.g.:
        //
        //      int
        //
        c_loc_t const loc = lexer_loc();
        print_error( &loc, "declaration expected" );
        print_error_token_is_a( lexer_printable_token() );
        EPUTC( '\n' );
        PARSE_ABORT();
      }

      if ( in_attr.align.kind != C_ALIGNAS_NONE ) {
        print_error( &in_attr.align.loc,
          "\"%s\" invalid here\n",
          alignas_name()
        );
        PARSE_ABORT();
      }

      c_sname_t const *const ecsu_sname = &type_ast->csu.csu_sname;
      assert( !c_sname_empty( ecsu_sname ) );

      if ( c_sname_count( ecsu_sname ) > 1 ) {
        print_error( &type_ast->loc,
          "forward declaration can not have a scoped name\n"
        );
        PARSE_ABORT();
      }

      c_sname_t temp_sname = c_sname_dup( ecsu_sname );
      c_sname_set( &type_ast->sname, &temp_sname );

      DUMP_AST( "$$_ast", type_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( type_ast ) );
      c_typedef_english( &C_TYPEDEF_LIT( type_ast, C_ENG_DECL ), stdout );
      PUTC( '\n' );
    }
#line 8423 "parser.c"
    break;

  case 360: /* decl_list_c_opt: decl_list_c  */
#line 4418 "parser.y"
    {
      PARSE_ASSERT( c_ast_list_check( &(yyvsp[0].ast_list) ) );
      c_ast_list_english( &(yyvsp[0].ast_list), stdout );
    }
#line 8432 "parser.c"
    break;

  case 361: /* decl_list_c: decl_list_c ',' decl_c_exp  */
#line 4426 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 8441 "parser.c"
    break;

  case 362: /* decl_list_c: decl_c  */
#line 4431 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 8450 "parser.c"
    break;

  case 363: /* decl_c: decl_c_astp  */
#line 4440 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "decl_c", "decl_c_astp" );
      switch ( in_attr.align.kind ) {
        case C_ALIGNAS_NONE:
          break;
        case C_ALIGNAS_BYTES:
          DUMP_INT( "in_attr__alignas_bytes", in_attr.align.bytes );
          break;
        case C_ALIGNAS_TYPE:
          DUMP_AST( "in_attr__alignas_type_ast", in_attr.align.type_ast );
          break;
      } // switch
      DUMP_BOOL( "in_attr__typename_flag_opt", in_attr.is_typename );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast) = join_type_decl( ia_type_spec_ast( type_ast ), (yyvsp[0].ast_pair).ast );
      PARSE_ASSERT( (yyval.ast) != NULL );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 8479 "parser.c"
    break;

  case 365: /* decl_c_exp: error  */
#line 4469 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 8487 "parser.c"
    break;

  case 370: /* decl_c_astp: msc_calling_convention_atid msc_calling_convention_c_astp  */
#line 4480 "parser.y"
    {
      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);
      (yyval.ast_pair).ast->type.atids |= (yyvsp[-1].tid);
    }
#line 8497 "parser.c"
    break;

  case 378: /* decl2_c_astp: sname_c_ast gnu_attribute_specifier_list_c_opt  */
#line 4499 "parser.y"
    {
      (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[-1].ast), .target_ast = NULL };
    }
#line 8505 "parser.c"
    break;

  case 379: /* decl2_c_astp: typedef_type_decl_c_ast  */
#line 4503 "parser.y"
    {
      (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), .target_ast = NULL };
    }
#line 8513 "parser.c"
    break;

  case 382: /* array_decl_c_astp: decl2_c_astp array_size_c_ast gnu_attribute_specifier_list_c_opt  */
#line 4516 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "array_decl_c_astp", "decl2_c_astp array_size_c_ast" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl2_c_astp", (yyvsp[-2].ast_pair) );
      DUMP_AST( "array_size_c_ast", (yyvsp[-1].ast) );

      c_ast_set_parent(
        c_ast_new_gc( K_PLACEHOLDER, &(yylsp[-2]) ), (yyvsp[-1].ast)
      );

      c_ast_t *const of_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-2].ast_pair).target_ast != NULL ) {
        // array-of or function-like-ret type
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-2].ast_pair).ast,
          c_ast_add_array( (yyvsp[-2].ast_pair).target_ast, (yyvsp[-1].ast), of_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_array( (yyvsp[-2].ast_pair).ast, (yyvsp[-1].ast), of_ast ),
          .target_ast = NULL
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 8548 "parser.c"
    break;

  case 383: /* array_size_c_ast: '[' rbracket_exp  */
#line 4550 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_EMPTY_SIZE;
    }
#line 8557 "parser.c"
    break;

  case 384: /* array_size_c_ast: '[' uint_lit rbracket_exp  */
#line 4555 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_INT_SIZE;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 8567 "parser.c"
    break;

  case 385: /* array_size_c_ast: '[' Y_NAME rbracket_exp  */
#line 4561 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 8577 "parser.c"
    break;

  case 386: /* array_size_c_ast: '[' type_qualifier_list_c_stid rbracket_exp  */
#line 4567 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-1].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_EMPTY_SIZE;
    }
#line 8587 "parser.c"
    break;

  case 387: /* array_size_c_ast: '[' type_qualifier_list_c_stid static_stid_opt uint_lit rbracket_exp  */
#line 4574 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-3].tid) | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_INT_SIZE;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 8598 "parser.c"
    break;

  case 388: /* array_size_c_ast: '[' type_qualifier_list_c_stid static_stid_opt Y_NAME rbracket_exp  */
#line 4582 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-3].tid) | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 8609 "parser.c"
    break;

  case 389: /* array_size_c_ast: '[' type_qualifier_list_c_stid_opt '*' rbracket_exp  */
#line 4589 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_VLA_STAR;
    }
#line 8619 "parser.c"
    break;

  case 390: /* array_size_c_ast: '[' Y_static type_qualifier_list_c_stid_opt uint_lit rbracket_exp  */
#line 4596 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids =
        c_tid_check( TS_NON_EMPTY_ARRAY | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_INT_SIZE;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 8631 "parser.c"
    break;

  case 391: /* array_size_c_ast: '[' Y_static type_qualifier_list_c_stid_opt Y_NAME rbracket_exp  */
#line 4605 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids =
        c_tid_check( TS_NON_EMPTY_ARRAY | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 8643 "parser.c"
    break;

  case 392: /* array_size_c_ast: '[' error ']'  */
#line 4613 "parser.y"
    {
      elaborate_error( "array size expected" );
    }
#line 8651 "parser.c"
    break;

  case 393: /* $@20: %empty  */
#line 4623 "parser.y"
    { //
      // A block AST has to be the type inherited attribute for decl_c_astp so
      // we have to create it here.
      //
      ia_type_ast_push( c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) ) );
    }
#line 8662 "parser.c"
    break;

  case 394: /* block_decl_c_astp: '(' '^' $@20 type_qualifier_list_c_stid_opt decl_c_astp rparen_exp lparen_exp param_c_ast_list_opt ')' gnu_attribute_specifier_list_c_opt  */
#line 4632 "parser.y"
    {
      c_ast_t *const block_ast = ia_type_ast_pop();
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "block_decl_c_astp",
                  "'(' '^' type_qualifier_list_c_stid_opt decl_c_astp ')' "
                  "'(' param_c_ast_list_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[-6].tid) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[-5].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-2].ast_list) );

      PARSE_ASSERT(
        c_type_add_tid( &block_ast->type, (yyvsp[-6].tid), &(yylsp[-6]) )
      );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), block_ast );
      block_ast->block.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );

      c_ast_t *const ret_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-5].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-5].ast_pair).ast,
          c_ast_add_func( (yyvsp[-5].ast_pair).target_ast, block_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( (yyvsp[-5].ast_pair).ast, block_ast, ret_ast ),
          block_ast->block.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 8702 "parser.c"
    break;

  case 395: /* destructor_declaration_c: virtual_stid_opt '~' any_name_exp lparen_exp no_destructor_params rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt func_equals_c_stid_opt  */
#line 4680 "parser.y"
    {
      DUMP_START( "destructor_declaration_c",
                  "virtual_stid_opt '~' any_name_exp '(' ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                  "gnu_attribute_specifier_list_c_opt func_equals_c_stid_opt" );
      DUMP_TID( "virtual_stid_opt", (yyvsp[-8].tid) );
      DUMP_STR( "any_name_exp", (yyvsp[-6].name) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *const dtor_ast = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );
      c_sname_append_name( &dtor_ast->sname, (yyvsp[-6].name) );
      dtor_ast->type.stids = c_tid_check(
        (yyvsp[-8].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      DUMP_AST( "$$_ast", dtor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( dtor_ast ) );
      c_ast_english( dtor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8732 "parser.c"
    break;

  case 397: /* no_destructor_params: error  */
#line 4727 "parser.y"
    { //
      // Ordinarily, we'd get an error message like:
      //
      //      c++decl> explain ~C(int)
      //                          ^
      //      12: syntax error: "int": destructors may not have parameters
      //      ("int" is a keyword)
      //
      // where the <<("int" is a keyword)>> part seems wrong since the user
      // didn't try using "int" as an ordinary identifier.  To suppress that
      // part, set lexer_token to the empty string so elaborate_error() won't
      // print it nor call call print_error_token_is_a() and and we'll instead
      // get an error message like:
      //
      //      c++decl> explain ~C(int)
      //                          ^
      //      12: syntax error: destructors may not have parameters
      //
      lexer_token = "";
      elaborate_error( "destructors may not have parameters" );
    }
#line 8758 "parser.c"
    break;

  case 398: /* file_scope_constructor_declaration_c: inline_stid_opt Y_CONSTRUCTOR_SNAME lparen_exp param_c_ast_list_opt rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt  */
#line 4757 "parser.y"
    {
      DUMP_START( "file_scope_constructor_declaration_c",
                  "inline_opt CONSTRUCTOR_SNAME '(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt" );
      DUMP_TID( "inline_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "CONSTRUCTOR_SNAME", (yyvsp[-5].sname) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_sname_set_scope_type( &(yyvsp[-5].sname), &C_TYPE_LIT_B( TB_class ) );

      c_ast_t *const ctor_ast = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      ctor_ast->sname = c_sname_move( &(yyvsp[-5].sname) );
      ctor_ast->type.stids = c_tid_check(
        (yyvsp[-6].tid) | (yyvsp[-2].tid) | (yyvsp[-1].tid),
        C_TPID_STORE
      );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), ctor_ast );
      ctor_ast->ctor.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      DUMP_AST( "$$_ast", ctor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( ctor_ast ) );
      c_ast_english( ctor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8791 "parser.c"
    break;

  case 399: /* file_scope_destructor_declaration_c: inline_stid_opt destructor_sname lparen_exp no_destructor_params rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt  */
#line 4794 "parser.y"
    {
      DUMP_START( "file_scope_destructor_declaration_c",
                  "inline_opt destructor_sname '(' ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt" );
      DUMP_TID( "inline_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "destructor_sname", (yyvsp[-5].sname) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_sname_set_scope_type( &(yyvsp[-5].sname), &C_TYPE_LIT_B( TB_class ) );

      c_ast_t *const dtor_ast = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );
      dtor_ast->sname = c_sname_move( &(yyvsp[-5].sname) );
      dtor_ast->type.stids = c_tid_check(
        (yyvsp[-6].tid) | (yyvsp[-2].tid) | (yyvsp[-1].tid),
        C_TPID_STORE
      );

      DUMP_AST( "$$_ast", dtor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( dtor_ast ) );
      c_ast_english( dtor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8821 "parser.c"
    break;

  case 400: /* func_decl_c_astp: decl2_c_astp '(' param_c_ast_list_opt rparen_func_qualifier_list_c_stid_opt func_ref_qualifier_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt func_equals_c_stid_opt  */
#line 4838 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "func_decl_c_astp",
                  "decl2_c_astp '(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt "
                  "func_ref_qualifier_c_stid_opt noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt "
                  "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl2_c_astp", (yyvsp[-7].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-5].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-4].tid) );
      DUMP_TID( "func_ref_qualifier_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[-1].ast) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_tid_t const func_stids = c_tid_check(
        (yyvsp[-4].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      bool const assume_constructor =
        // + The type is likely for a constructor; and:
        c_ast_is_likely_ctor( type_ast ) &&

        // + The new type does _not_ have any non-constructor storage classes.
        !c_tid_is_any( func_stids, TS_FUNC_LIKE_NOT_CTOR );

      c_ast_t *const func_ast =
        c_ast_new_gc( assume_constructor ? K_CONSTRUCTOR : K_FUNCTION, &(yyloc) );
      func_ast->type.stids = func_stids;
      c_ast_list_set_param_of( &(yyvsp[-5].ast_list), func_ast );
      func_ast->func.param_ast_list = slist_move( &(yyvsp[-5].ast_list) );

      c_ast_t *const decl_ast = (yyvsp[-7].ast_pair).ast;

      if ( assume_constructor ) {
        assert( (yyvsp[-1].ast) == NULL );
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( decl_ast, func_ast, /*ret_ast=*/NULL ),
          .target_ast = NULL
        };
      }
      else {
        c_ast_t *ret_ast;
        c_ast_t *target_ast = (yyvsp[-7].ast_pair).target_ast;

        if ( target_ast != NULL && target_ast->kind != K_POINTER ) {
          //
          // This is for a case like:
          //
          //      int f() ()
          //       |    |  |
          //       |    |  func
          //       |    |
          //       |    decl_ast (func)
          //       |
          //       ret_ast
          //
          // We replace ret_ast with decl_ast:
          //
          //      int f() ()
          //       |    |  |
          //       |    |  func
          //       X    |
          //       |    decl_ast (func)
          //       |
          //       ret_ast <- decl_ast (func)
          //
          // that is, a "function returning function" -- which is illegal
          // (since functions can't return functions) and will be caught by
          // c_ast_check_ret_type().
          //
          ret_ast = decl_ast;
          target_ast = NULL;
        }
        else {
          ret_ast = IF_ELSE( (yyvsp[-1].ast), ia_type_spec_ast( type_ast ) );
        }

        if ( target_ast != NULL ) {
          (yyval.ast_pair) = (c_ast_pair_t){
            decl_ast,
            c_ast_add_func( target_ast, func_ast, ret_ast )
          };
        }
        else {
          (yyval.ast_pair) = (c_ast_pair_t){
            c_ast_add_func( decl_ast, func_ast, ret_ast ),
            func_ast->func.ret_ast
          };
        }
      }

      c_tid_t const msc_call_atids = (yyval.ast_pair).ast->type.atids & TA_ANY_MSC_CALL;
      if ( msc_call_atids != TA_NONE ) {
        //
        // Microsoft calling conventions need to be moved from the pointer to
        // the function, e.g., change:
        //
        //      declare f as cdecl pointer to function returning void
        //
        // to:
        //
        //      declare f as pointer to cdecl function returning void
        //
        for ( c_ast_t *ast = (yyval.ast_pair).ast;
              (ast = CONST_CAST(c_ast_t*, c_ast_unpointer( ast ))) != NULL; ) {
          if ( ast->kind == K_FUNCTION ) {
            (yyval.ast_pair).ast->type.atids &= c_tid_compl( TA_ANY_MSC_CALL );
            ast->type.atids |= msc_call_atids;
          }
        } // for
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 8946 "parser.c"
    break;

  case 401: /* $@21: %empty  */
#line 4969 "parser.y"
    {
      if ( OPT_LANG_IS( CONSTRUCTORS ) ) {
        //
        // In C++, encountering a name followed by '(' declares an in-class
        // constructor.  That means NAME is the name of a class, so we have to
        // create a temporary class type for it so if it's used as the type of
        // a parameter, e.g.:
        //
        //      C(C const&)
        //
        // it'll be recognized as such.
        //
        c_ast_t *const csu_ast = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yylsp[-1]) );
        csu_ast->type.btids = TB_class;
        c_sname_init_name( &csu_ast->csu.csu_sname, check_strdup( (yyvsp[-1].name) ) );
        csu_ast->sname = c_sname_dup( &csu_ast->csu.csu_sname );

        in_attr.typedef_rb = c_typedef_add( csu_ast, C_GIB_TYPEDEF );
        MAYBE_UNUSED c_typedef_t const *const csu_tdef =
          in_attr.typedef_rb->data;
        assert( csu_tdef->ast == csu_ast );
      }
    }
#line 8974 "parser.c"
    break;

  case 402: /* pc99_func_or_constructor_declaration_c: Y_NAME '(' $@21 param_c_ast_list_opt ')' noexcept_c_stid_opt func_equals_c_stid_opt  */
#line 4994 "parser.y"
    {
      DUMP_START( "pc99_func_or_constructor_declaration_c",
                  "NAME '(' param_c_ast_list_opt ')' noexcept_c_stid_opt "
                  "func_equals_c_stid_opt" );
      DUMP_STR( "NAME", (yyvsp[-6].name) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *ast;

      if ( OPT_LANG_IS( CONSTRUCTORS ) ) {
        //
        // Free the temporary typedef for the class.
        //
        // Note that we free only the typedef and not its AST; its AST will be
        // garbage collected.
        //
        free( c_typedef_remove( in_attr.typedef_rb ) );

        //
        // In C++, encountering a name followed by '(' declares an in-class
        // constructor.
        //
        ast = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      }
      else {
        if ( !IS_SUPPORTED( IMPLICIT_int ) ) {
          //
          // In C99 and later, implicit int is an error.  This check has to be
          // done now in the parser rather than later in the AST since the AST
          // would have no "memory" that the return type was implicitly int.
          //
          print_error( &(yylsp[-6]),
            "implicit \"%s\" functions are illegal%s",
            c_tid_name_error( TB_int ),
            C_LANG_WHICH( IMPLICIT_int )
          );
          print_error_token_is_a( (yyvsp[-6].name) );
          if ( strcmp( (yyvsp[-6].name), L_typeof ) == 0 ||
               strcmp( (yyvsp[-6].name), L_typeof_unqual ) == 0 ) {
            EPRINTF( "; use \"%s\" instead", L_GNU___typeof__ );
          }
          else {
            print_suggestions(
              DYM_C_KEYWORDS | DYM_C_MACROS | DYM_C_TYPES,
              (yyvsp[-6].name)
            );
          }
          EPUTC( '\n' );
          free( (yyvsp[-6].name) );
          PARSE_ABORT();
        }

        //
        // In C prior to C99, encountering a name followed by '(' declares a
        // function that implicitly returns int:
        //
        //      power(x, n)             /* raise x to n-th power; n > 0 */
        //
        c_ast_t *const ret_ast = c_ast_new_gc( K_BUILTIN, &(yylsp[-6]) );
        ret_ast->type.btids = TB_int;

        ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
        c_ast_set_parent( ret_ast, ast );
      }

      c_sname_init_name( &ast->sname, (yyvsp[-6].name) );
      ast->type.stids =
        c_tid_check( (yyvsp[-1].tid) | (yyvsp[0].tid), C_TPID_STORE );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), ast );
      ast->func.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      DUMP_AST( "$$_ast", ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( ast ) );
      c_ast_english( ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 9059 "parser.c"
    break;

  case 403: /* $@22: %empty  */
#line 5078 "parser.y"
    {
      if ( OPT_LANG_IS( MEMBER_FUNCTIONS ) ) {
        //
        // Both "final" and "override" are matched only within member function
        // declarations.  Now that ')' has been parsed, we're within one, so
        // set the keyword context to C_KW_CTX_MBR_FUNC.
        //
        lexer_keyword_ctx = C_KW_CTX_MBR_FUNC;
      }
    }
#line 9074 "parser.c"
    break;

  case 404: /* rparen_func_qualifier_list_c_stid_opt: ')' $@22 func_qualifier_list_c_stid_opt  */
#line 5089 "parser.y"
    {
      lexer_keyword_ctx = C_KW_CTX_DEFAULT;
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 9083 "parser.c"
    break;

  case 405: /* func_qualifier_list_c_stid_opt: %empty  */
#line 5096 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9089 "parser.c"
    break;

  case 406: /* func_qualifier_list_c_stid_opt: func_qualifier_list_c_stid_opt func_qualifier_c_stid  */
#line 5098 "parser.y"
    {
      DUMP_START( "func_qualifier_list_c_stid_opt",
                  "func_qualifier_list_c_stid_opt func_qualifier_c_stid" );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_qualifier_c_stid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 9106 "parser.c"
    break;

  case 411: /* func_ref_qualifier_c_stid_opt: %empty  */
#line 5127 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9112 "parser.c"
    break;

  case 412: /* func_ref_qualifier_c_stid_opt: '&'  */
#line 5128 "parser.y"
                                  { (yyval.tid) = TS_REFERENCE; }
#line 9118 "parser.c"
    break;

  case 413: /* func_ref_qualifier_c_stid_opt: Y_AMPER_AMPER  */
#line 5129 "parser.y"
                                  { (yyval.tid) = TS_RVALUE_REFERENCE; }
#line 9124 "parser.c"
    break;

  case 414: /* noexcept_c_stid_opt: %empty  */
#line 5133 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9130 "parser.c"
    break;

  case 416: /* noexcept_c_stid_opt: Y_noexcept '(' noexcept_bool_stid_exp rparen_exp  */
#line 5136 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 9138 "parser.c"
    break;

  case 417: /* noexcept_c_stid_opt: Y_throw lparen_exp rparen_exp  */
#line 5140 "parser.y"
    {
      (yyval.tid) = (yyvsp[-2].tid);
    }
#line 9146 "parser.c"
    break;

  case 418: /* noexcept_c_stid_opt: Y_throw lparen_exp param_c_ast_list ')'  */
#line 5144 "parser.y"
    {
      c_ast_list_cleanup( &(yyvsp[-1].ast_list) );

      if ( OPT_LANG_IS( throw ) ) {
        UNSUPPORTED( &(yylsp[-1]), "dynamic exception specifications" );
      } else {
        print_error( &(yylsp[-1]),
          "dynamic exception specifications not supported%s\n",
          C_LANG_WHICH( throw )
        );
      }
      PARSE_ABORT();
    }
#line 9164 "parser.c"
    break;

  case 421: /* noexcept_bool_stid_exp: error  */
#line 5163 "parser.y"
    {
      elaborate_error( "\"true\" or \"false\" expected" );
    }
#line 9172 "parser.c"
    break;

  case 422: /* trailing_return_type_c_ast_opt: %empty  */
#line 5169 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 9178 "parser.c"
    break;

  case 423: /* $@23: %empty  */
#line 5171 "parser.y"
                                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9184 "parser.c"
    break;

  case 424: /* trailing_return_type_c_ast_opt: Y_MINUS_GREATER type_c_ast $@23 cast_c_astp_opt  */
#line 5173 "parser.y"
    { //
      // The function trailing return-type syntax is supported only in C++11
      // and later.  This check has to be done now in the parser rather than
      // later in the AST because the AST has no "memory" of where the return-
      // type came from.
      //
      if ( !IS_SUPPORTED( TRAILING_RETURN_TYPES ) ) {
        print_error( &(yylsp[-3]),
          "trailing return type not supported%s\n",
          C_LANG_WHICH( TRAILING_RETURN_TYPES )
        );
        PARSE_ABORT();
      }

      ia_type_ast_pop();
      c_ast_t const *const ret_ast = ia_type_ast_peek();

      DUMP_START( "trailing_return_type_c_ast_opt",
                  "'->' type_c_ast cast_c_astp_opt" );
      DUMP_AST( "in_attr__type_c_ast", ret_ast );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = IF_ELSE( (yyvsp[0].ast_pair).ast, (yyvsp[-2].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      //
      // Ensure that a function using the C++11 trailing return type syntax
      // starts with "auto":
      //
      //      void f() -> int
      //      ^
      //      error: must be "auto"
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the "auto" is just a syntactic return-type placeholder in
      // C++11 and the AST node for the placeholder is discarded and never made
      // part of the AST.
      //
      if ( ret_ast->type.btids != TB_auto ) {
        print_error( &ret_ast->loc,
          "function with trailing return type must only specify \"%s\"\n",
          c_tid_name_error( TB_auto )
        );
        PARSE_ABORT();
      }
    }
#line 9238 "parser.c"
    break;

  case 425: /* trailing_return_type_c_ast_opt: gnu_attribute_specifier_list_c  */
#line 5224 "parser.y"
    {
      (yyval.ast) = NULL;
    }
#line 9246 "parser.c"
    break;

  case 426: /* func_equals_c_stid_opt: %empty  */
#line 5230 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9252 "parser.c"
    break;

  case 427: /* func_equals_c_stid_opt: '=' Y_default  */
#line 5231 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 9258 "parser.c"
    break;

  case 428: /* func_equals_c_stid_opt: '=' Y_delete  */
#line 5232 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 9264 "parser.c"
    break;

  case 429: /* func_equals_c_stid_opt: '=' uint_lit  */
#line 5234 "parser.y"
    {
      if ( (yyvsp[0].uint_val) != 0 ) {
        print_error( &(yylsp[0]), "'0' expected\n" );
        PARSE_ABORT();
      }
      (yyval.tid) = TS_PURE_virtual;
    }
#line 9276 "parser.c"
    break;

  case 430: /* func_equals_c_stid_opt: '=' error  */
#line 5242 "parser.y"
    {
      if ( OPT_LANG_IS( default_delete_FUNCS ) )
        elaborate_error( "'0', \"default\", or \"delete\" expected" );
      else
        elaborate_error( "'0' expected" );
    }
#line 9287 "parser.c"
    break;

  case 432: /* param_c_ast_list_exp: error  */
#line 5255 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      elaborate_error( "parameter list expected" );
    }
#line 9296 "parser.c"
    break;

  case 433: /* param_c_ast_list_opt: %empty  */
#line 5262 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 9302 "parser.c"
    break;

  case 435: /* param_c_ast_list: param_c_ast_list comma_exp param_c_ast_exp  */
#line 5268 "parser.y"
    {
      DUMP_START( "param_c_ast_list", "param_c_ast_list ',' param_c_ast" );
      DUMP_AST_LIST( "param_c_ast_list", (yyvsp[-2].ast_list) );
      DUMP_AST( "param_c_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 9318 "parser.c"
    break;

  case 436: /* param_c_ast_list: param_c_ast  */
#line 5281 "parser.y"
    {
      DUMP_START( "param_c_ast_list", "param_c_ast" );
      DUMP_AST( "param_c_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 9333 "parser.c"
    break;

  case 437: /* $@24: %empty  */
#line 5298 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 9341 "parser.c"
    break;

  case 438: /* param_c_ast: this_stid_opt type_c_ast $@24 cast_c_astp_opt  */
#line 5302 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "param_c_ast", "this_stid_opt type_c_ast cast_c_astp_opt" );
      DUMP_TID( "this_stid_opt", (yyvsp[-3].tid) );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast );

      if ( (yyval.ast)->kind == K_FUNCTION ) {
        //
        // From the C11 standard, section 6.3.2.1(4):
        //
        //    [A] function designator with type "function returning type" is
        //    converted to an expression that has type "pointer to function
        //    returning type."
        //
        (yyval.ast) = c_ast_pointer( (yyval.ast), &gc_ast_list );
      }

      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-3].tid), &(yylsp[-3]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9372 "parser.c"
    break;

  case 440: /* param_c_ast: "..."  */
#line 5338 "parser.y"
    {
      DUMP_START( "param_c_ast", "..." );

      (yyval.ast) = c_ast_new_gc( K_VARIADIC, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9385 "parser.c"
    break;

  case 442: /* param_c_ast_exp: error  */
#line 5351 "parser.y"
    {
      elaborate_error( "parameter declaration expected" );
    }
#line 9393 "parser.c"
    break;

  case 443: /* $@25: %empty  */
#line 5360 "parser.y"
    {
      ia_type_ast_push( c_ast_new_gc( K_PLACEHOLDER, &(yyloc) ) );
      ++in_attr.ast_depth;
    }
#line 9402 "parser.c"
    break;

  case 444: /* nested_decl_c_astp: '(' $@25 decl_c_astp rparen_exp  */
#line 5365 "parser.y"
    {
      ia_type_ast_pop();
      --in_attr.ast_depth;

      DUMP_START( "nested_decl_c_astp", "'(' decl_c_astp ')'" );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[-1].ast_pair) );

      (yyval.ast_pair) = (yyvsp[-1].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9420 "parser.c"
    break;

  case 445: /* oper_decl_c_astp: oper_sname_c_opt Y_operator c_operator lparen_exp param_c_ast_list_opt rparen_func_qualifier_list_c_stid_opt func_ref_qualifier_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt func_equals_c_stid_opt  */
#line 5391 "parser.y"
    {
      c_operator_t const *const operator = c_op_get( (yyvsp[-7].op_id) );
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "oper_decl_c_astp",
                  "oper_sname_c_opt OPERATOR c_operator "
                  "'(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt "
                  "func_ref_qualifier_c_stid_opt noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt "
                  "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-9].sname) );
      DUMP_STR( "c_operator", operator->literal );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-5].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-4].tid) );
      DUMP_TID( "func_ref_qualifier_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[-1].ast) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_tid_t const oper_stids = c_tid_check(
        (yyvsp[-4].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      c_ast_t *const oper_ast = c_ast_new_gc( K_OPERATOR, &(yyloc) );
      oper_ast->sname = c_sname_move( &(yyvsp[-9].sname) );
      oper_ast->type.stids = oper_stids;
      c_ast_list_set_param_of( &(yyvsp[-5].ast_list), oper_ast );
      oper_ast->oper.param_ast_list = slist_move( &(yyvsp[-5].ast_list) );
      oper_ast->oper.operator = operator;

      c_ast_t *const ret_ast =
        IF_ELSE( (yyvsp[-1].ast), ia_type_spec_ast( type_ast ) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_add_func( type_ast, oper_ast, ret_ast ),
        oper_ast->oper.ret_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9469 "parser.c"
    break;

  case 446: /* $@26: %empty  */
#line 5440 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9475 "parser.c"
    break;

  case 447: /* pointer_decl_c_astp: pointer_type_c_ast $@26 decl_c_astp  */
#line 5442 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_decl_c_astp", "pointer_type_c_ast decl_c_astp" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      PJL_IGNORE_RV( c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ) );
      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9494 "parser.c"
    break;

  case 448: /* pointer_type_c_ast: '*' type_qualifier_list_c_stid_opt  */
#line 5461 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "pointer_type_c_ast", "'*' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_POINTER, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9513 "parser.c"
    break;

  case 449: /* pc99_pointer_decl_list_c: pc99_pointer_decl_c ',' decl_list_c  */
#line 5481 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[0].ast_list);
      slist_push_front( &(yyval.ast_list), (yyvsp[-2].ast) );
    }
#line 9522 "parser.c"
    break;

  case 450: /* pc99_pointer_decl_list_c: pc99_pointer_decl_c  */
#line 5486 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 9531 "parser.c"
    break;

  case 451: /* $@27: %empty  */
#line 5493 "parser.y"
                                      { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9537 "parser.c"
    break;

  case 452: /* pc99_pointer_decl_c: pc99_pointer_type_c_ast $@27 decl_c_astp  */
#line 5495 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pc99_pointer_decl_c",
                  "pc99_pointer_type_c_ast decl_c_astp" );
      DUMP_AST( "pc99_pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast );
      (yyval.ast)->loc = (yyloc);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9556 "parser.c"
    break;

  case 453: /* pc99_pointer_type_c_ast: '*' type_qualifier_list_c_stid_opt  */
#line 5514 "parser.y"
    {
      if ( !IS_SUPPORTED( IMPLICIT_int ) ) {
        //
        // In C99 and later, implicit int is an error.  This check has to be
        // done now in the parser rather than later in the AST since the AST
        // would have no "memory" that the return type was implicitly int.
        //
        print_error( &(yylsp[-1]),
          "implicit \"%s\" is illegal%s\n",
          c_tid_name_error( TB_int ),
          C_LANG_WHICH( IMPLICIT_int )
        );
        PARSE_ABORT();
      }

      c_ast_t *type_ast = ia_type_ast_peek();

      DUMP_START( "pc99_pointer_type_c_ast",
                  "'*' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      if ( type_ast == NULL ) {
        type_ast = c_ast_new_gc( K_BUILTIN, &(yylsp[-1]) );
        type_ast->type.btids = TB_int;
        ia_type_ast_push( type_ast );
      }

      (yyval.ast) = c_ast_pointer( ia_type_spec_ast( type_ast ), &gc_ast_list );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9595 "parser.c"
    break;

  case 454: /* $@28: %empty  */
#line 5553 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9601 "parser.c"
    break;

  case 455: /* pointer_to_member_decl_c_astp: pointer_to_member_type_c_ast $@28 decl_c_astp  */
#line 5555 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_to_member_decl_c_astp",
                  "pointer_to_member_type_c_ast decl_c_astp" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9620 "parser.c"
    break;

  case 456: /* pointer_to_member_type_c_ast: any_sname_c Y_COLON_COLON_STAR '*' cv_qualifier_list_stid_opt  */
#line 5575 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "pointer_to_member_type_c_ast",
                  "any_sname_c '::*' cv_qualifier_list_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "any_sname_c", (yyvsp[-3].sname) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_POINTER_TO_MEMBER, &(yyloc) );

      c_type_t scope_type = *c_sname_local_type( &(yyvsp[-3].sname) );
      if ( !c_tid_is_any( scope_type.btids, TB_ANY_SCOPE ) ) {
        //
        // The sname has no scope-type, but we now know there's a pointer-to-
        // member of it, so it must be a class.  (It could alternatively be a
        // struct, but we have no context to know, so just pick class because
        // it's more C++-like.)
        //
        scope_type.btids = TB_class;
        c_sname_set_local_type( &(yyvsp[-3].sname), &scope_type );
      }

      // adopt sname's scope-type for the AST
      (yyval.ast)->type = c_type_or( &C_TYPE_LIT_S( (yyvsp[0].tid) ), &scope_type );

      (yyval.ast)->ptr_mbr.class_sname = c_sname_move( &(yyvsp[-3].sname) );
      c_ast_set_parent( c_ast_dup_gc( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9657 "parser.c"
    break;

  case 457: /* $@29: %empty  */
#line 5612 "parser.y"
                                   { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9663 "parser.c"
    break;

  case 458: /* reference_decl_c_astp: reference_type_c_ast $@29 decl_c_astp  */
#line 5614 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "reference_decl_c_astp", "reference_type_c_ast decl_c_astp" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9681 "parser.c"
    break;

  case 459: /* reference_type_c_ast: '&' type_qualifier_list_c_stid_opt  */
#line 5632 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "reference_type_c_ast",
                  "'&' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_REFERENCE, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9701 "parser.c"
    break;

  case 460: /* reference_type_c_ast: Y_AMPER_AMPER type_qualifier_list_c_stid_opt  */
#line 5650 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "reference_type_c_ast",
                  "'&&' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_RVALUE_REFERENCE, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9721 "parser.c"
    break;

  case 461: /* typedef_type_decl_c_ast: typedef_type_c_ast bit_field_c_uint_opt  */
#line 5672 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "typedef_type_decl_c_ast",
                  "typedef_type_c_ast bit_field_c_uint_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST( "typedef_type_c_ast", (yyvsp[-1].ast) );
      DUMP_INT( "bit_field_c_uint_opt", (yyvsp[0].uint_val) );

      if ( c_tid_is_any( type_ast->type.stids, TS_typedef ) ) {
        //
        // If we're defining a type, return the type as-is.
        //
        (yyval.ast) = (yyvsp[-1].ast);
      }
      else {
        //
        // Otherwise, return the type that it's typedef'd as.
        //
        c_ast_t const *const raw_tdef_ast = c_ast_untypedef( (yyvsp[-1].ast) );

        //
        // But first ensure the name isn't of a previously declared type:
        //
        //      cdecl> struct S
        //      cdecl> explain int S    // error: "S": previously declared
        //
        // Note that typedef_type_c_ast is like:
        //
        //      typedef_type_c_ast: {
        //        sname: { string: "" },
        //        kind: { value: 0x20, string: "typedef" },
        //        ...
        //        type: { btid: 0x10000001, ..., string: "none" },
        //        tdef: {
        //          for_ast: {
        //            sname: { string: "S", scopes: "struct" },
        //            kind: { value: 0x8, string: "struct or union" },
        //            ...
        //            type: { btid: 0x800001, ..., string: "struct" },
        //            csu: {
        //              csu_sname: { string: "S", scopes: "none" }
        //            }
        //          }
        //        },
        //        ...
        //      }
        //
        // That is, typedef_type_c_ast has no name itself (at this point), but
        // the raw type, of course, does, so it's that name we have to check.
        //
        // This check has to be done now in the parser rather than later in the
        // AST since if this declaration were joined with a type (like `int`
        // above), the type information would be lost and we'd get this from
        // above:
        //
        //      declare S as structure S          // wrong
        //
        // Additionally, we also get here when the typedef name is used as part
        // of longer name, e.g., `S::x`:
        //
        //      c++decl> explain int S::x
        //      declare x of structure S as int   // correct
        //
        // but that name isn't of a previously declared type, so it's OK.
        //
        c_typedef_t const *const tdef =
          c_typedef_find_sname( &raw_tdef_ast->sname );
        if ( tdef != NULL ) {
          print_error( &(yyvsp[-1].ast)->loc,
            "\"%s\": previously declared as type \"",
            c_sname_full_name( &raw_tdef_ast->sname )
          );
          print_type_ast( tdef, stderr );
          EPUTS( "\"\n" );
          PARSE_ABORT();
        }

        //
        // We have to duplicate the type to set the current location.
        //
        (yyval.ast) = c_ast_dup_gc( raw_tdef_ast );
        (yyval.ast)->loc = (yyvsp[-1].ast)->loc;
      }

      PARSE_ASSERT( c_ast_set_bit_field_width( (yyval.ast), (yyvsp[0].uint_val) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9816 "parser.c"
    break;

  case 462: /* $@30: %empty  */
#line 5769 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 9824 "parser.c"
    break;

  case 463: /* user_defined_conversion_decl_c_astp: oper_sname_c_opt Y_operator type_c_ast $@30 udc_decl_c_ast_opt lparen_exp rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt func_equals_c_stid_opt  */
#line 5775 "parser.y"
    {
      ia_type_ast_pop();

      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "user_defined_conversion_decl_c_astp",
                  "oper_sname_c_opt OPERATOR "
                  "type_c_ast udc_decl_c_ast_opt '(' ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                  "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-8].sname) );
      DUMP_AST( "type_c_ast", (yyvsp[-6].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[-4].ast) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *const udc_ast = c_ast_new_gc( K_UDEF_CONV, &(yyloc) );
      udc_ast->sname = c_sname_move( &(yyvsp[-8].sname) );
      udc_ast->type.stids = c_tid_check(
        (yyvsp[-2].tid) | (yyvsp[-1].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );
      if ( type_ast != NULL )
        c_type_or_eq( &udc_ast->type, &type_ast->type );
      udc_ast->udef_conv.to_ast = IF_ELSE( (yyvsp[-4].ast), (yyvsp[-6].ast) );

      (yyval.ast_pair) = (c_ast_pair_t){ udc_ast, udc_ast->udef_conv.to_ast };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9862 "parser.c"
    break;

  case 464: /* user_defined_literal_decl_c_astp: oper_sname_c_opt Y_operator empty_str_lit_exp name_exp lparen_exp param_c_ast_list_exp ')' noexcept_c_stid_opt trailing_return_type_c_ast_opt  */
#line 5818 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "user_defined_literal_decl_c_astp",
                  "oper_sname_c_opt OPERATOR '\"\"' "
                  "'(' param_c_ast_list_exp ')' noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-8].sname) );
      DUMP_STR( "name", (yyvsp[-5].name) );
      DUMP_AST_LIST( "param_c_ast_list_exp", (yyvsp[-3].ast_list) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[0].ast) );

      c_sname_set( &type_ast->sname, &(yyvsp[-8].sname) );
      c_sname_append_name( &type_ast->sname, (yyvsp[-5].name) );

      c_ast_t *const udl_ast = c_ast_new_gc( K_UDEF_LIT, &(yyloc) );
      udl_ast->type.stids = c_tid_check( (yyvsp[-1].tid), C_TPID_STORE );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), udl_ast );
      udl_ast->udef_lit.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_add_func(
          type_ast,
          udl_ast,
          IF_ELSE( (yyvsp[0].ast), type_ast )
        ),
        udl_ast->udef_lit.ret_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9901 "parser.c"
    break;

  case 465: /* cast_c_astp_opt: %empty  */
#line 5859 "parser.y"
                                  { (yyval.ast_pair) = (c_ast_pair_t){ NULL, NULL }; }
#line 9907 "parser.c"
    break;

  case 475: /* cast2_c_astp: sname_c_ast  */
#line 5876 "parser.y"
                                  { (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), NULL }; }
#line 9913 "parser.c"
    break;

  case 476: /* array_cast_c_astp: cast_c_astp_opt array_size_c_ast  */
#line 5887 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "array_cast_c_astp", "cast_c_astp_opt array_size_c_ast" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );
      DUMP_AST( "array_size_c_ast", (yyvsp[0].ast) );

      c_ast_set_parent(
        c_ast_new_gc( K_PLACEHOLDER, &(yylsp[-1]) ), (yyvsp[0].ast)
      );

      c_ast_t *const of_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-1].ast_pair).target_ast != NULL ) {
        // array-of or function-like-ret type
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-1].ast_pair).ast,
          c_ast_add_array( (yyvsp[-1].ast_pair).target_ast, (yyvsp[0].ast), of_ast )
        };
      } else {
        c_ast_t *const ast = IF_ELSE( (yyvsp[-1].ast_pair).ast, of_ast );
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_array( ast, (yyvsp[0].ast), of_ast ),
          .target_ast = NULL
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9948 "parser.c"
    break;

  case 477: /* $@31: %empty  */
#line 5924 "parser.y"
    { //
      // A block AST has to be the type inherited attribute for cast_c_astp_opt
      // so we have to create it here.
      //
      ia_type_ast_push( c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) ) );
    }
#line 9959 "parser.c"
    break;

  case 478: /* block_cast_c_astp: '(' '^' $@31 type_qualifier_list_c_stid_opt cast_c_astp_opt rparen_exp lparen_exp param_c_ast_list_opt ')'  */
#line 5932 "parser.y"
    {
      c_ast_t *const block_ast = ia_type_ast_pop();
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "block_cast_c_astp",
                  "'(' '^' type_qualifier_list_c_stid_opt cast_c_astp_opt ')' "
                  "'(' param_c_ast_list_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[-5].tid) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-4].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-1].ast_list) );

      PARSE_ASSERT(
        c_type_add_tid( &block_ast->type, (yyvsp[-5].tid), &(yylsp[-5]) )
      );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), block_ast );
      block_ast->block.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );

      c_ast_t *const ret_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-4].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-4].ast_pair).ast,
          c_ast_add_func( (yyvsp[-4].ast_pair).target_ast, block_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( (yyvsp[-4].ast_pair).ast, block_ast, ret_ast ),
          block_ast->block.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9999 "parser.c"
    break;

  case 479: /* func_cast_c_astp: cast2_c_astp '(' param_c_ast_list_opt rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt  */
#line 5977 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "func_cast_c_astp",
                  "cast2_c_astp '(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast2_c_astp", (yyvsp[-5].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[0].ast) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_ast_t *const func_ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
      func_ast->type.stids =
        c_tid_check( (yyvsp[-2].tid) | (yyvsp[-1].tid), C_TPID_STORE );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), func_ast );
      func_ast->func.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      c_ast_t *const cast_ast = (yyvsp[-5].ast_pair).ast;
      //
      // This is for a case similar to the one in func_decl_c_astp like:
      //
      //     void f( int () () )
      //              |   |  |
      //              |   |  func
      //              |   |
      //              |   cast_ast (func)
      //              |
      //              ret_ast
      //
      // We replace ret_ast with cast_ast:
      //
      //      void f( int() () )
      //              |  |  |
      //              |  |  func
      //              X  |
      //              |  cast_ast (func)
      //              |
      //              ret_ast <- cast_ast (func)
      //
      // that is, a "function returning function returning int" -- which is
      // illegal (since functions can't return functions) and will be caught by
      // c_ast_check_ret_type().
      //
      c_ast_t *const ret_ast = cast_ast->kind == K_FUNCTION ?
        cast_ast : IF_ELSE( (yyvsp[0].ast), ia_type_spec_ast( type_ast ) );

      if ( (yyvsp[-5].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          cast_ast,
          c_ast_add_func( (yyvsp[-5].ast_pair).target_ast, func_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( cast_ast, func_ast, ret_ast ),
          func_ast->func.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10069 "parser.c"
    break;

  case 480: /* $@32: %empty  */
#line 6048 "parser.y"
    {
      ia_type_ast_push( c_ast_new_gc( K_PLACEHOLDER, &(yyloc) ) );
      ++in_attr.ast_depth;
    }
#line 10078 "parser.c"
    break;

  case 481: /* nested_cast_c_astp: '(' $@32 cast_c_astp_opt rparen_exp  */
#line 6053 "parser.y"
    {
      ia_type_ast_pop();
      --in_attr.ast_depth;

      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "nested_cast_c_astp", "'(' cast_c_astp_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.ast_pair) = (yyvsp[-1].ast_pair);

      if ( (yyval.ast_pair).ast == NULL ) {
        //
        // This is for a case like:
        //
        //      void f( int() )
        //                 ^^
        //
        // where the unnamed parameter is a "function returning int".  (In
        // param_c_ast, this will be converted into a "pointer to function
        // returning int".)
        //
        (yyval.ast_pair).ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
        c_ast_set_parent( type_ast, (yyval.ast_pair).ast );
      } else {
        (yyval.ast_pair).ast->loc = (yyloc);
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10115 "parser.c"
    break;

  case 482: /* $@33: %empty  */
#line 6090 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10121 "parser.c"
    break;

  case 483: /* pointer_cast_c_astp: pointer_type_c_ast $@33 cast_c_astp_opt  */
#line 6092 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_cast_c_astp", "pointer_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10141 "parser.c"
    break;

  case 484: /* $@34: %empty  */
#line 6112 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10147 "parser.c"
    break;

  case 485: /* pointer_to_member_cast_c_astp: pointer_to_member_type_c_ast $@34 cast_c_astp_opt  */
#line 6114 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_to_member_cast_c_astp",
                  "pointer_to_member_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10168 "parser.c"
    break;

  case 486: /* $@35: %empty  */
#line 6135 "parser.y"
                                   { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10174 "parser.c"
    break;

  case 487: /* reference_cast_c_astp: reference_type_c_ast $@35 cast_c_astp_opt  */
#line 6137 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "reference_cast_c_astp",
                  "reference_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10195 "parser.c"
    break;

  case 488: /* udc_decl_c_ast_opt: %empty  */
#line 6164 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 10201 "parser.c"
    break;

  case 494: /* $@36: %empty  */
#line 6176 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10207 "parser.c"
    break;

  case 495: /* pointer_udc_decl_c_ast: pointer_type_c_ast $@36 udc_decl_c_ast_opt  */
#line 6178 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_udc_decl_c_ast",
                  "pointer_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10225 "parser.c"
    break;

  case 496: /* $@37: %empty  */
#line 6194 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10231 "parser.c"
    break;

  case 497: /* pointer_to_member_udc_decl_c_ast: pointer_to_member_type_c_ast $@37 udc_decl_c_ast_opt  */
#line 6196 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_to_member_udc_decl_c_ast",
                  "pointer_to_member_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10249 "parser.c"
    break;

  case 498: /* $@38: %empty  */
#line 6212 "parser.y"
                                   { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10255 "parser.c"
    break;

  case 499: /* reference_udc_decl_c_ast: reference_type_c_ast $@38 udc_decl_c_ast_opt  */
#line 6214 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "reference_udc_decl_c_ast",
                  "reference_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10273 "parser.c"
    break;

  case 500: /* type_c_ast: type_modifier_list_c_type  */
#line 6240 "parser.y"
    {
      DUMP_START( "type_c_ast", "type_modifier_list_c_type" );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[0].type) );

      //
      // Prior to C99, typeless declarations are implicitly int, so we set it
      // here.  In C99 and later, however, implicit int is an error, so we
      // don't set it here and c_ast_check() will catch the error later.
      //
      // Note that type modifiers, e.g., unsigned, count as a type since that
      // means unsigned int; however, neither qualifiers, e.g., const, nor
      // storage classes, e.g., register, by themselves count as a type:
      //
      //      unsigned i;   // legal in C99
      //      const    j;   // illegal in C99
      //      register k;   // illegal in C99
      //
      c_type_t type = OPT_LANG_IS( IMPLICIT_int ) ?
        C_TYPE_LIT_B( TB_int ) : T_NONE;

      PARSE_ASSERT( c_type_add( &type, &(yyvsp[0].type), &(yylsp[0]) ) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type = type;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10306 "parser.c"
    break;

  case 501: /* type_c_ast: type_modifier_list_c_type east_modified_type_c_ast  */
#line 6275 "parser.y"
    {
      DUMP_START( "type_c_ast",
                  "type_modifier_list_c_type east_modified_type_c_ast " );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[-1].type) );
      DUMP_AST( "east_modified_type_c_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10324 "parser.c"
    break;

  case 503: /* type_modifier_list_c_type_opt: %empty  */
#line 6293 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 10330 "parser.c"
    break;

  case 505: /* type_modifier_list_c_type: type_modifier_list_c_type type_modifier_c_type  */
#line 6299 "parser.y"
    {
      DUMP_START( "type_modifier_list_c_type",
                  "type_modifier_list_c_type type_modifier_c_type" );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_modifier_c_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 10347 "parser.c"
    break;

  case 507: /* type_modifier_c_type: type_modifier_base_type  */
#line 6317 "parser.y"
    {
      (yyval.type) = (yyvsp[0].type);
      //
      // This is for a case like:
      //
      //      explain typedef unsigned long size_t
      //
      // that is: explain a redefinition of a typedef'd type with the same type
      // that contains only one or more type_modifier_base_type.  The problem
      // is that, without an east_modified_type_c_ast (like int), the parser
      // would ordinarily take the typedef'd type (here, the size_t) as part of
      // the type_c_ast and then be out of tokens for the decl_c_astp -- at
      // which time it'll complain.
      //
      // Since type modifiers can't apply to a typedef'd type (e.g., "long
      // size_t" is illegal), we tell the lexer not to return either
      // Y_TYPEDEF_NAME or Y_TYPEDEF_SNAME if we encounter at least one type
      // modifier (except "register" since it's is really a storage class --
      // see the comment in type_modifier_base_type about "register").
      //
      if ( (yyval.type).stids != TS_register )
        lexer_find &= ~LEXER_FIND_TYPES;
    }
#line 10375 "parser.c"
    break;

  case 508: /* type_modifier_c_type: type_qualifier_c_stid  */
#line 6340 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10381 "parser.c"
    break;

  case 510: /* type_modifier_c_type: attribute_specifier_list_c_atid  */
#line 6343 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 10389 "parser.c"
    break;

  case 511: /* type_modifier_base_type: Y__Complex  */
#line 6349 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10395 "parser.c"
    break;

  case 512: /* type_modifier_base_type: Y__Imaginary  */
#line 6350 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10401 "parser.c"
    break;

  case 513: /* type_modifier_base_type: Y_long  */
#line 6351 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10407 "parser.c"
    break;

  case 514: /* type_modifier_base_type: Y_short  */
#line 6352 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10413 "parser.c"
    break;

  case 515: /* type_modifier_base_type: Y_signed  */
#line 6353 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10419 "parser.c"
    break;

  case 516: /* type_modifier_base_type: Y_unsigned  */
#line 6354 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10425 "parser.c"
    break;

  case 517: /* type_modifier_base_type: Y_EMC__Sat  */
#line 6355 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10431 "parser.c"
    break;

  case 518: /* type_modifier_base_type: Y_register  */
#line 6361 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10437 "parser.c"
    break;

  case 519: /* east_modified_type_c_ast: atomic_builtin_typedef_type_c_ast type_modifier_list_c_type_opt  */
#line 6367 "parser.y"
    {
      DUMP_START( "east_modified_type_c_ast",
                  "atomic_builtin_typedef_type_c_ast "
                  "type_modifier_list_c_type_opt" );
      DUMP_AST( "atomic_builtin_typedef_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TYPE( "type_modifier_list_c_type_opt", (yyvsp[0].type) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10456 "parser.c"
    break;

  case 520: /* east_modified_type_c_ast: enum_class_struct_union_c_ast cv_qualifier_list_stid_opt  */
#line 6384 "parser.y"
    {
      DUMP_START( "east_modified_type_c_ast",
                  "enum_class_struct_union_c_ast cv_qualifier_list_stid_opt" );
      DUMP_AST( "enum_class_struct_union_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10474 "parser.c"
    break;

  case 525: /* $@39: %empty  */
#line 6410 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 10482 "parser.c"
    break;

  case 526: /* atomic_specifier_type_c_ast: Y__Atomic_SPEC lparen_exp type_c_ast $@39 cast_c_astp_opt rparen_exp  */
#line 6414 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "atomic_specifier_type_c_ast",
                  "ATOMIC '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.ast) = IF_ELSE( (yyvsp[-1].ast_pair).ast, (yyvsp[-3].ast) );
      (yyval.ast)->loc = (yyloc);

      //
      // Ensure the _Atomic() specifier type doesn't have either a storage
      // class or attributes:
      //
      //      const _Atomic(int) x;     // OK
      //      _Atomic(const int) y;     // error
      //
      // This check has to be done now in the parser rather than later in the
      // AST since the type would be stored as "atomic const int" either way so
      // the AST has no "memory" of which it was.
      //
      if ( (yyval.ast)->type.stids != TS_NONE || (yyval.ast)->type.atids != TA_NONE ) {
        static c_type_t const TSA_ANY = { TB_NONE, TS_ANY, TA_ANY };
        c_type_t const error_type = c_type_and( &(yyval.ast)->type, &TSA_ANY );
        print_error( &(yylsp[-3]),
          "\"%s\" can not be of \"%s\"\n",
          c_tid_name_error( TS__Atomic ),
          c_type_name_c( &error_type )
        );
        PARSE_ABORT();
      }

      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, TS__Atomic, &(yylsp[-5]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10525 "parser.c"
    break;

  case 527: /* builtin_type_c_ast: builtin_no_BitInt_c_btid  */
#line 6458 "parser.y"
    {
      DUMP_START( "builtin_type_c_ast", "builtin_no_BitInt_c_btid" );
      DUMP_TID( "builtin_no_BitInt_c_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10540 "parser.c"
    break;

  case 528: /* builtin_type_c_ast: Y__BitInt lparen_exp uint_lit_exp rparen_exp  */
#line 6469 "parser.y"
    {
      DUMP_START( "builtin_type_c_ast", "_BitInt '(' uint_lit_exp ')'" );
      DUMP_INT( "uint_lit_exp", (yyvsp[-1].uint_val) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = TB__BitInt;
      (yyval.ast)->builtin.BitInt.width = (yyvsp[-1].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10556 "parser.c"
    break;

  case 543: /* $@40: %empty  */
#line 6501 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 10564 "parser.c"
    break;

  case 544: /* typeof_type_c_ast: typeof lparen_exp type_c_ast $@40 cast_c_astp_opt rparen_exp  */
#line 6505 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "typeof_type_c_ast",
                  "TYPEOF '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_BOOL( "is_unqual", (yyvsp[-5].flag) );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      if ( (yyvsp[-5].flag) ) {
        c_ast_t const *const raw_ast = c_ast_untypedef( (yyvsp[-3].ast) );
        if ( raw_ast != (yyvsp[-3].ast) &&
             c_tid_is_any( raw_ast->type.stids, TS__Atomic | TS_CVR ) ) {
          //
          // The type is a typedef and the type that it's for is ACVR-qualified
          // so we need to dup _that_ type before un-ACVR-qualifying it because
          // we don't want to modify it.
          //
          (yyvsp[-3].ast) = c_ast_dup_gc( raw_ast );
        }
        (yyvsp[-3].ast)->type.stids &= c_tid_compl( TS__Atomic | TS_CVR );
      }

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-3].ast), (yyvsp[-1].ast_pair).ast );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      //
      // Overwrite type_spec_ast to be the typeof type since _that_ is the base
      // type for one or more declarators, e.g.:
      //
      //      typeof(int*) p, a[2], f(char)
      //
      in_attr.type_spec_ast = (yyval.ast);
    }
#line 10605 "parser.c"
    break;

  case 545: /* typeof_type_c_ast: typeof lparen_exp error  */
#line 6543 "parser.y"
    {
      elaborate_error(
        "typeof(expression) declarations not supported by " CDECL
      );
    }
#line 10615 "parser.c"
    break;

  case 546: /* typeof: Y_typeof  */
#line 6551 "parser.y"
                                  { (yyval.flag) = /*is_unqual=*/false; }
#line 10621 "parser.c"
    break;

  case 547: /* typeof: Y_typeof_unqual  */
#line 6552 "parser.y"
                                  { (yyval.flag) = /*is_unqual=*/true;  }
#line 10627 "parser.c"
    break;

  case 550: /* class_struct_union_c_ast: class_struct_union_btid attribute_specifier_list_c_atid_opt any_sname_c_exp  */
#line 6565 "parser.y"
    {
      DUMP_START( "enum_class_struct_union_c_ast",
                  "class_struct_union_btid "
                  "attribute_specifier_list_c_atid_opt any_sname_c_exp" );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-2].tid) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-1].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      (yyval.ast) = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-1].tid), C_TPID_ATTR );
      (yyval.ast)->csu.csu_sname = c_sname_move( &(yyvsp[0].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10648 "parser.c"
    break;

  case 551: /* class_struct_union_c_ast: class_struct_union_btid attribute_specifier_list_c_atid_opt any_sname_c_opt '{'  */
#line 6584 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]),
        "explaining %s declarations", c_tid_name_c( (yyvsp[-3].tid) )
      );
      c_sname_cleanup( &(yyvsp[-1].sname) );
      PARSE_ABORT();
    }
#line 10660 "parser.c"
    break;

  case 552: /* enum_c_ast: enum_btids attribute_specifier_list_c_atid_opt any_sname_c_exp enum_fixed_type_c_ast_opt  */
#line 6596 "parser.y"
    {
      DUMP_START( "enum_c_ast",
                  "enum_btids attribute_specifier_list_c_atid_opt "
                  "any_sname_c_exp enum_fixed_type_c_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-3].tid) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ENUM, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-3].tid), C_TPID_BASE );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-2].tid), C_TPID_ATTR );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      (yyval.ast)->enum_.enum_sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10683 "parser.c"
    break;

  case 553: /* enum_c_ast: enum_btids attribute_specifier_list_c_atid_opt any_sname_c_opt '{'  */
#line 6617 "parser.y"
    {
      c_sname_cleanup( &(yyvsp[-1].sname) );
      UNSUPPORTED( &(yylsp[0]),
        "explaining %s declarations", c_tid_name_c( (yyvsp[-3].tid) )
      );
      PARSE_ABORT();
    }
#line 10695 "parser.c"
    break;

  case 554: /* enum_btids: Y_enum class_struct_btid_opt  */
#line 6629 "parser.y"
                                  { (yyval.tid) = (yyvsp[-1].tid) | (yyvsp[0].tid); }
#line 10701 "parser.c"
    break;

  case 555: /* enum_fixed_type_c_ast_opt: %empty  */
#line 6633 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 10707 "parser.c"
    break;

  case 556: /* enum_fixed_type_c_ast_opt: ':' enum_fixed_type_c_ast  */
#line 6634 "parser.y"
                                  { (yyval.ast) = (yyvsp[0].ast); }
#line 10713 "parser.c"
    break;

  case 557: /* enum_fixed_type_c_ast_opt: ':' error  */
#line 6636 "parser.y"
    {
      elaborate_error( "type name expected" );
    }
#line 10721 "parser.c"
    break;

  case 558: /* enum_fixed_type_c_ast: enum_fixed_type_modifier_list_btid  */
#line 6652 "parser.y"
    {
      DUMP_START( "enum_fixed_type_c_ast",
                  "enum_fixed_type_modifier_list_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yylsp[0]) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10737 "parser.c"
    break;

  case 559: /* enum_fixed_type_c_ast: enum_fixed_type_modifier_list_btid enum_unmodified_fixed_type_c_ast enum_fixed_type_modifier_list_btid_opt  */
#line 6672 "parser.y"
    {
      DUMP_START( "enum_fixed_type_c_ast",
                  "enum_fixed_type_modifier_list_btid "
                  "enum_unmodified_fixed_type_c_ast "
                  "enum_fixed_type_modifier_list_btid_opt" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[-2].tid) );
      DUMP_AST( "enum_unmodified_fixed_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "enum_fixed_type_modifier_list_btid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-2].tid), &(yylsp[-2]) ) );
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10759 "parser.c"
    break;

  case 560: /* enum_fixed_type_c_ast: enum_unmodified_fixed_type_c_ast enum_fixed_type_modifier_list_btid_opt  */
#line 6697 "parser.y"
    {
      DUMP_START( "enum_fixed_type_c_ast",
                  "enum_unmodified_fixed_type_c_ast "
                  "enum_fixed_type_modifier_list_btid_opt" );
      DUMP_AST( "enum_unmodified_fixed_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "enum_fixed_type_modifier_list_btid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10778 "parser.c"
    break;

  case 561: /* enum_fixed_type_modifier_list_btid_opt: %empty  */
#line 6714 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 10784 "parser.c"
    break;

  case 563: /* enum_fixed_type_modifier_list_btid: enum_fixed_type_modifier_list_btid enum_fixed_type_modifier_btid  */
#line 6721 "parser.y"
    {
      DUMP_START( "enum_fixed_type_modifier_list_btid",
                  "enum_fixed_type_modifier_list_btid "
                  "enum_fixed_type_modifier_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[-1].tid) );
      DUMP_TID( "enum_fixed_type_modifier_btid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_btids", (yyval.tid) );
      DUMP_END();
    }
#line 10802 "parser.c"
    break;

  case 572: /* class_struct_btid_opt: %empty  */
#line 6754 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 10808 "parser.c"
    break;

  case 578: /* type_qualifier_list_c_stid_opt: %empty  */
#line 6771 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 10814 "parser.c"
    break;

  case 580: /* type_qualifier_list_c_stid: type_qualifier_list_c_stid type_qualifier_c_stid gnu_or_msc_attribute_specifier_list_c_opt  */
#line 6778 "parser.y"
    {
      DUMP_START( "type_qualifier_list_c_stid",
                  "type_qualifier_list_c_stid type_qualifier_c_stid" );
      DUMP_TID( "type_qualifier_list_c_stid", (yyvsp[-2].tid) );
      DUMP_TID( "type_qualifier_c_stid", (yyvsp[-1].tid) );

      (yyval.tid) = (yyvsp[-2].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[-1].tid), &(yylsp[-1]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 10831 "parser.c"
    break;

  case 581: /* type_qualifier_list_c_stid: gnu_or_msc_attribute_specifier_list_c type_qualifier_c_stid  */
#line 6792 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 10839 "parser.c"
    break;

  case 582: /* type_qualifier_list_c_stid: type_qualifier_c_stid gnu_or_msc_attribute_specifier_list_c_opt  */
#line 6797 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 10847 "parser.c"
    break;

  case 592: /* cv_qualifier_list_stid_opt: %empty  */
#line 6818 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 10853 "parser.c"
    break;

  case 593: /* cv_qualifier_list_stid_opt: cv_qualifier_list_stid_opt cv_qualifier_stid  */
#line 6820 "parser.y"
    {
      DUMP_START( "cv_qualifier_list_stid_opt",
                  "cv_qualifier_list_stid_opt cv_qualifier_stid" );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "cv_qualifier_stid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 10870 "parser.c"
    break;

  case 594: /* restrict_qualifier_c_stid: Y_restrict  */
#line 6836 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since both "restrict" and "__restrict" map to TS_restrict and the
      // AST has no "memory" of which it was.
      //
      if ( OPT_LANG_IS( CPP_ANY ) ) {
        print_error( &(yylsp[0]),
          "\"restrict\" not supported in C++; use \"%s\" instead\n",
          L_GNU___restrict
        );
        PARSE_ABORT();
      }
    }
#line 10888 "parser.c"
    break;

  case 599: /* upc_layout_qualifier_c: '[' error ']'  */
#line 6857 "parser.y"
    {
      elaborate_error( "one of nothing, integer, or '*' expected" );
    }
#line 10896 "parser.c"
    break;

  case 600: /* storage_class_c_type: Y_auto_STORAGE  */
#line 6865 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10902 "parser.c"
    break;

  case 601: /* storage_class_c_type: Y_Apple___block  */
#line 6866 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10908 "parser.c"
    break;

  case 602: /* storage_class_c_type: Y_consteval  */
#line 6867 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10914 "parser.c"
    break;

  case 603: /* storage_class_c_type: Y_constexpr  */
#line 6868 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10920 "parser.c"
    break;

  case 604: /* storage_class_c_type: Y_constinit  */
#line 6869 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10926 "parser.c"
    break;

  case 605: /* storage_class_c_type: Y_explicit  */
#line 6870 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10932 "parser.c"
    break;

  case 606: /* storage_class_c_type: Y_export  */
#line 6871 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10938 "parser.c"
    break;

  case 607: /* storage_class_c_type: Y_extern  */
#line 6872 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10944 "parser.c"
    break;

  case 608: /* storage_class_c_type: extern_linkage_c_stid  */
#line 6873 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10950 "parser.c"
    break;

  case 609: /* storage_class_c_type: Y_final  */
#line 6874 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10956 "parser.c"
    break;

  case 610: /* storage_class_c_type: Y_friend  */
#line 6875 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10962 "parser.c"
    break;

  case 611: /* storage_class_c_type: Y_inline  */
#line 6876 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10968 "parser.c"
    break;

  case 612: /* storage_class_c_type: Y_mutable  */
#line 6877 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10974 "parser.c"
    break;

  case 613: /* storage_class_c_type: _Noreturn_atid  */
#line 6879 "parser.y"
    {
      //
      // These checks have to be done now in the parser rather than later in
      // the AST because the _Noreturn keyword is mapped to the [[noreturn]]
      // attribute and the AST has no "memory" that it was _Noreturn.
      //
      if ( !IS_SUPPORTED( _Noreturn ) ) {
        print_error( &(yylsp[0]),
          "\"%s\" keyword not supported%s",
          lexer_token, C_LANG_WHICH( _Noreturn )
        );
        print_hint(
          "%snoreturn%s", other_token_c( "[[" ), other_token_c( "]]" )
        );
        PARSE_ABORT();
      }
      if ( !OPT_LANG_IS( _Noreturn_NOT_DEPRECATED ) ) {
        print_warning( &(yylsp[0]),
          "\"%s\" is deprecated%s",
          lexer_token, C_LANG_WHICH( _Noreturn_NOT_DEPRECATED )
        );
        print_hint(
          "%snoreturn%s", other_token_c( "[[" ), other_token_c( "]]" )
        );
      }

      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 11007 "parser.c"
    break;

  case 614: /* storage_class_c_type: Y_override  */
#line 6907 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11013 "parser.c"
    break;

  case 615: /* storage_class_c_type: Y_static  */
#line 6909 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11019 "parser.c"
    break;

  case 616: /* storage_class_c_type: Y_typedef  */
#line 6910 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11025 "parser.c"
    break;

  case 617: /* storage_class_c_type: Y__Thread_local  */
#line 6911 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11031 "parser.c"
    break;

  case 618: /* storage_class_c_type: Y_thread_local  */
#line 6912 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11037 "parser.c"
    break;

  case 619: /* storage_class_c_type: Y_virtual  */
#line 6913 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11043 "parser.c"
    break;

  case 622: /* attribute_specifier_list_c_atid_opt: %empty  */
#line 6924 "parser.y"
                                  { (yyval.tid) = TA_NONE; }
#line 11049 "parser.c"
    break;

  case 624: /* $@41: %empty  */
#line 6930 "parser.y"
    {
      if ( !IS_SUPPORTED( ATTRIBUTES ) ) {
        print_error( &(yylsp[-1]),
          "\"%s\" attribute syntax not supported%s\n",
          other_token_c( "[[" ),
          C_LANG_WHICH( ATTRIBUTES )
        );
        PARSE_ABORT();
      }
      lexer_keyword_ctx = C_KW_CTX_ATTRIBUTE;
    }
#line 11065 "parser.c"
    break;

  case 625: /* attribute_specifier_list_c_atid: Y_ATTR_BEGIN '[' $@41 using_opt attribute_list_c_atid_opt ']' rbracket_exp  */
#line 6942 "parser.y"
    {
      lexer_keyword_ctx = C_KW_CTX_DEFAULT;

      DUMP_START( "attribute_specifier_list_c_atid",
                  "'[[' using_opt attribute_list_c_atid_opt ']]'" );
      DUMP_TID( "attribute_list_c_atid_opt", (yyvsp[-2].tid) );

      (yyval.tid) = (yyvsp[-2].tid);

      DUMP_END();
    }
#line 11081 "parser.c"
    break;

  case 626: /* attribute_specifier_list_c_atid: gnu_or_msc_attribute_specifier_list_c  */
#line 6955 "parser.y"
    {
      (yyval.tid) = TA_NONE;
    }
#line 11089 "parser.c"
    break;

  case 628: /* using_opt: Y_using name_exp colon_exp  */
#line 6963 "parser.y"
    {
      IGNORING( &(yylsp[-2]), "\"using\" in attributes" );
      free( (yyvsp[-1].name) );
    }
#line 11098 "parser.c"
    break;

  case 629: /* attribute_list_c_atid_opt: %empty  */
#line 6970 "parser.y"
                                  { (yyval.tid) = TA_NONE; }
#line 11104 "parser.c"
    break;

  case 631: /* attribute_list_c_atid: attribute_list_c_atid comma_exp attribute_c_atid_exp  */
#line 6976 "parser.y"
    {
      DUMP_START( "attribute_list_c_atid",
                  "attribute_list_c_atid ',' attribute_c_atid" );
      DUMP_TID( "attribute_list_c_atid", (yyvsp[-2].tid) );
      DUMP_TID( "attribute_c_atid_exp", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-2].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_atids", (yyval.tid) );
      DUMP_END();
    }
#line 11121 "parser.c"
    break;

  case 641: /* attribute_c_atid_exp: sname_c  */
#line 7002 "parser.y"
    {
      if ( c_sname_count( &(yyvsp[0].sname) ) > 1 ) {
        IGNORING( &(yylsp[0]),
          "\"%s\": namespaced attributes", c_sname_full_name( &(yyvsp[0].sname) )
        );
      }
      else {
        char const *adj = "unknown";
        c_lang_id_t lang_ids = LANG_NONE;

        char const *const name = c_sname_local_name( &(yyvsp[0].sname) );
        c_keyword_t const *const ck = c_keyword_find(
          name, c_lang_newer( opt_lang_id ), C_KW_CTX_ATTRIBUTE
        );
        if ( ck != NULL && c_tid_tpid( ck->tid ) == C_TPID_ATTR ) {
          adj = "unsupported";
          lang_ids = ck->lang_ids;
        }
        print_warning( &(yylsp[0]),
          "\"%s\": %s attribute%s",
          name, adj, c_lang_which( lang_ids )
        );

        print_suggestions( DYM_C_ATTRIBUTES, name );
        EPUTC( '\n' );
      }

      (yyval.tid) = TA_NONE;
      c_sname_cleanup( &(yyvsp[0].sname) );
    }
#line 11156 "parser.c"
    break;

  case 642: /* attribute_c_atid_exp: error  */
#line 7033 "parser.y"
    {
      elaborate_error_dym( DYM_C_ATTRIBUTES, "attribute name expected" );
    }
#line 11164 "parser.c"
    break;

  case 644: /* attribute_str_arg_c_opt: '(' str_lit_exp rparen_exp  */
#line 7041 "parser.y"
    {
      IGNORING( &(yylsp[-2]), "attribute arguments" );
      free( (yyvsp[-1].str_val) );
    }
#line 11173 "parser.c"
    break;

  case 653: /* $@42: %empty  */
#line 7069 "parser.y"
    {
      attr_syntax_not_supported( L_GNU___attribute__, &(yylsp[0]) );
      //
      // Temporariy disabling finding keywords allows GNU attributes that are C
      // keywords (e.g., const) to be found as ordinary string literals.
      //
      lexer_find &= ~LEXER_FIND_C_KEYWORDS;
    }
#line 11186 "parser.c"
    break;

  case 654: /* gnu_attribute_specifier_c: Y_GNU___attribute__ $@42 lparen_exp lparen_exp gnu_attribute_list_c_opt ')' rparen_exp  */
#line 7078 "parser.y"
    {
      lexer_find |= LEXER_FIND_C_KEYWORDS;
    }
#line 11194 "parser.c"
    break;

  case 659: /* gnu_attribute_c_exp: Y_NAME gnu_attribute_decl_arg_list_c_opt  */
#line 7095 "parser.y"
    {
      free( (yyvsp[-1].name) );
    }
#line 11202 "parser.c"
    break;

  case 660: /* gnu_attribute_c_exp: error  */
#line 7099 "parser.y"
    {
      elaborate_error( "attribute name expected" );
    }
#line 11210 "parser.c"
    break;

  case 667: /* gnu_attribute_arg_c: Y_NAME  */
#line 7120 "parser.y"
                                  { free( (yyvsp[0].name) ); }
#line 11216 "parser.c"
    break;

  case 668: /* gnu_attribute_arg_c: Y_CHAR_LIT  */
#line 7121 "parser.y"
                                  { free( (yyvsp[0].str_val) ); }
#line 11222 "parser.c"
    break;

  case 670: /* gnu_attribute_arg_c: Y_STR_LIT  */
#line 7123 "parser.y"
                                  { free( (yyvsp[0].str_val) ); }
#line 11228 "parser.c"
    break;

  case 672: /* gnu_attribute_arg_c: Y_LEXER_ERROR  */
#line 7126 "parser.y"
    {
      PARSE_ABORT();
    }
#line 11236 "parser.c"
    break;

  case 675: /* $@43: %empty  */
#line 7138 "parser.y"
    {
      attr_syntax_not_supported( L_MSC___declspec, &(yylsp[0]) );
      // See comment in gnu_attribute_specifier_c.
      lexer_find &= ~LEXER_FIND_C_KEYWORDS;
    }
#line 11246 "parser.c"
    break;

  case 676: /* msc_attribute_specifier_c: Y_MSC___declspec $@43 lparen_exp msc_attribute_list_c_opt ')'  */
#line 7144 "parser.y"
    {
      lexer_find |= LEXER_FIND_C_KEYWORDS;
    }
#line 11254 "parser.c"
    break;

  case 684: /* array_decl_english_ast: Y_array array_size_decl_ast of_exp decl_english_ast  */
#line 7180 "parser.y"
    {
      DUMP_START( "array_decl_english_ast",
                  "ARRAY array_size_num_opt OF decl_english_ast" );
      DUMP_AST( "array_size_decl_ast", (yyvsp[-2].ast) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[-2].ast);
      (yyval.ast)->loc = (yylsp[-3]);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11272 "parser.c"
    break;

  case 685: /* array_decl_english_ast: Y_variable length_opt array_exp name_opt of_exp decl_english_ast  */
#line 7196 "parser.y"
    {
      DUMP_START( "array_decl_english_ast",
                  "VARIABLE LENGTH ARRAY name_opt OF decl_english_ast" );
      DUMP_STR( "name_opt", (yyvsp[-2].name) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      if ( (yyvsp[-2].name) == NULL ) {
        (yyval.ast)->array.kind = C_ARRAY_VLA_STAR;
      } else {
        (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
        (yyval.ast)->array.size_name = (yyvsp[-2].name);
      }
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11295 "parser.c"
    break;

  case 686: /* array_size_decl_ast: %empty  */
#line 7218 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_EMPTY_SIZE;
    }
#line 11304 "parser.c"
    break;

  case 687: /* array_size_decl_ast: uint_lit  */
#line 7223 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_INT_SIZE;
      (yyval.ast)->array.size_int = (yyvsp[0].uint_val);
    }
#line 11314 "parser.c"
    break;

  case 688: /* array_size_decl_ast: Y_NAME  */
#line 7229 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
      (yyval.ast)->array.size_name = (yyvsp[0].name);
    }
#line 11324 "parser.c"
    break;

  case 689: /* array_size_decl_ast: '*'  */
#line 7235 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_VLA_STAR;
    }
#line 11333 "parser.c"
    break;

  case 692: /* block_decl_english_ast: Y_Apple_block paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 7252 "parser.y"
    {
      DUMP_START( "block_decl_english_ast",
                  "BLOCK paren_param_decl_list_english_opt "
                  "returning_english_ast_opt" );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), (yyval.ast) );
      (yyval.ast)->block.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11353 "parser.c"
    break;

  case 693: /* constructor_decl_english_ast: Y_constructor paren_param_decl_list_english_opt  */
#line 7273 "parser.y"
    {
      DUMP_START( "constructor_decl_english_ast",
                  "CONSTRUCTOR paren_param_decl_list_english_opt" );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[0].ast_list) );

      (yyval.ast) = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[0].ast_list), (yyval.ast) );
      (yyval.ast)->ctor.param_ast_list = slist_move( &(yyvsp[0].ast_list) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11370 "parser.c"
    break;

  case 694: /* destructor_decl_english_ast: Y_destructor destructor_parens_opt  */
#line 7291 "parser.y"
    {
      DUMP_START( "destructor_decl_english_ast", "DESTRUCTOR ['(' ')']" );

      (yyval.ast) = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11383 "parser.c"
    break;

  case 697: /* func_decl_english_ast: func_qualifier_english_type_opt member_or_non_member_opt Y_function paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 7313 "parser.y"
    {
      DUMP_START( "func_decl_english_ast",
                  "ref_qualifier_english_stid_opt "
                  "member_or_non_member_opt "
                  "FUNCTION paren_param_decl_list_english_opt "
                  "returning_english_ast_opt" );
      DUMP_TYPE( "func_qualifier_english_type_opt", (yyvsp[-4].type) );
      DUMP_INT( "member_or_non_member_opt", (yyvsp[-3].member) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_FUNCTION, &(yyloc) );
      (yyval.ast)->type = (yyvsp[-4].type);
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), (yyval.ast) );
      (yyval.ast)->func.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      (yyval.ast)->func.member = (yyvsp[-3].member);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11409 "parser.c"
    break;

  case 698: /* func_qualifier_english_type_opt: ref_qualifier_english_stid_opt  */
#line 7338 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) );
    }
#line 11417 "parser.c"
    break;

  case 699: /* func_qualifier_english_type_opt: msc_calling_convention_atid  */
#line 7342 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 11425 "parser.c"
    break;

  case 706: /* paren_param_decl_list_english_opt: %empty  */
#line 7359 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 11431 "parser.c"
    break;

  case 708: /* paren_param_decl_list_english: '(' param_decl_list_english_opt ')'  */
#line 7365 "parser.y"
    {
      DUMP_START( "paren_param_decl_list_english",
                  "'(' param_decl_list_english_opt ')'" );
      DUMP_AST_LIST( "param_decl_list_english_opt", (yyvsp[-1].ast_list) );

      (yyval.ast_list) = (yyvsp[-1].ast_list);

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 11446 "parser.c"
    break;

  case 709: /* param_decl_list_english_opt: %empty  */
#line 7378 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 11452 "parser.c"
    break;

  case 711: /* param_decl_list_english: param_decl_list_english comma_exp decl_english_ast_exp  */
#line 7385 "parser.y"
    {
      DUMP_START( "param_decl_list_english",
                  "param_decl_list_english ',' decl_english_ast" );
      DUMP_AST_LIST( "param_decl_list_english", (yyvsp[-2].ast_list) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 11469 "parser.c"
    break;

  case 712: /* param_decl_list_english: decl_english_ast  */
#line 7399 "parser.y"
    {
      DUMP_START( "param_decl_list_english", "decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      if ( (yyvsp[0].ast)->kind == K_FUNCTION ) // see the comment in param_c_ast
        (yyvsp[0].ast) = c_ast_pointer( (yyvsp[0].ast), &gc_ast_list );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 11487 "parser.c"
    break;

  case 714: /* decl_english_ast_exp: error  */
#line 7417 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 11495 "parser.c"
    break;

  case 715: /* ref_qualifier_english_stid_opt: %empty  */
#line 7425 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 11501 "parser.c"
    break;

  case 716: /* ref_qualifier_english_stid_opt: Y_reference  */
#line 7426 "parser.y"
                                  { (yyval.tid) = TS_REFERENCE; }
#line 11507 "parser.c"
    break;

  case 717: /* ref_qualifier_english_stid_opt: Y_rvalue reference_exp  */
#line 7427 "parser.y"
                                  { (yyval.tid) = TS_RVALUE_REFERENCE; }
#line 11513 "parser.c"
    break;

  case 718: /* returning_english_ast_opt: %empty  */
#line 7434 "parser.y"
    {
      DUMP_START( "returning_english_ast_opt", "<empty>" );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      // see the comment in "type_c_ast"
      (yyval.ast)->type.btids = OPT_LANG_IS( IMPLICIT_int ) ? TB_int : TB_void;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11528 "parser.c"
    break;

  case 720: /* returning_english_ast: returning decl_english_ast  */
#line 7450 "parser.y"
    {
      DUMP_START( "returning_english_ast", "RETURNING decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11542 "parser.c"
    break;

  case 721: /* returning_english_ast: returning error  */
#line 7461 "parser.y"
    {
      elaborate_error( "English expected after \"returning\"" );
    }
#line 11550 "parser.c"
    break;

  case 722: /* qualified_decl_english_ast: type_qualifier_list_english_type_opt qualifiable_decl_english_ast  */
#line 7471 "parser.y"
    {
      DUMP_START( "qualified_decl_english_ast",
                  "type_qualifier_list_english_type_opt "
                  "qualifiable_decl_english_ast" );
      DUMP_TYPE( "type_qualifier_list_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "qualifiable_decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( !c_type_is_none( &(yyvsp[-1].type) ) )
        (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11570 "parser.c"
    break;

  case 723: /* type_qualifier_list_english_type_opt: %empty  */
#line 7489 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 11576 "parser.c"
    break;

  case 725: /* type_qualifier_list_english_type: type_qualifier_list_english_type type_qualifier_english_type  */
#line 7496 "parser.y"
    {
      DUMP_START( "type_qualifier_list_english_type",
                  "type_qualifier_list_english_type "
                  "type_qualifier_english_type" );
      DUMP_TYPE( "type_qualifier_list_english_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_qualifier_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 11594 "parser.c"
    break;

  case 727: /* type_qualifier_english_type: attribute_english_atid  */
#line 7514 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) ); }
#line 11600 "parser.c"
    break;

  case 728: /* type_qualifier_english_type: storage_class_english_stid  */
#line 7515 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11606 "parser.c"
    break;

  case 729: /* type_qualifier_english_type: type_qualifier_english_stid  */
#line 7516 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11612 "parser.c"
    break;

  case 730: /* attribute_english_atid: Y_carries dependency_exp  */
#line 7520 "parser.y"
                                  { (yyval.tid) = TA_carries_dependency; }
#line 11618 "parser.c"
    break;

  case 733: /* attribute_english_atid: Y_maybe unused_exp  */
#line 7523 "parser.y"
                                  { (yyval.tid) = TA_maybe_unused; }
#line 11624 "parser.c"
    break;

  case 735: /* attribute_english_atid: Y_no Y_discard  */
#line 7525 "parser.y"
                                  { (yyval.tid) = TA_nodiscard; }
#line 11630 "parser.c"
    break;

  case 737: /* attribute_english_atid: Y_no Y_return  */
#line 7527 "parser.y"
                                  { (yyval.tid) = TA_noreturn; }
#line 11636 "parser.c"
    break;

  case 740: /* attribute_english_atid: Y_no Y_unique address_exp  */
#line 7530 "parser.y"
                                  { (yyval.tid) = TA_no_unique_address; }
#line 11642 "parser.c"
    break;

  case 746: /* storage_class_english_stid: Y_const_ENG eval_expr_init_stid  */
#line 7540 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 11650 "parser.c"
    break;

  case 755: /* storage_class_english_stid: Y_extern linkage_stid linkage_opt  */
#line 7552 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 11658 "parser.c"
    break;

  case 760: /* storage_class_english_stid: Y_no Y_except  */
#line 7559 "parser.y"
                                  { (yyval.tid) = TS_noexcept; }
#line 11664 "parser.c"
    break;

  case 762: /* storage_class_english_stid: Y_non_empty  */
#line 7561 "parser.y"
                                  { (yyval.tid) = TS_NON_EMPTY_ARRAY; }
#line 11670 "parser.c"
    break;

  case 766: /* storage_class_english_stid: Y_thread local_exp  */
#line 7566 "parser.y"
                                  { (yyval.tid) = TS_thread_local; }
#line 11676 "parser.c"
    break;

  case 772: /* storage_class_english_stid: Y_pure virtual_stid_exp  */
#line 7572 "parser.y"
                                  { (yyval.tid) = TS_PURE_virtual | (yyvsp[0].tid); }
#line 11682 "parser.c"
    break;

  case 773: /* eval_expr_init_stid: Y_evaluation  */
#line 7576 "parser.y"
                                  { (yyval.tid) = TS_consteval; }
#line 11688 "parser.c"
    break;

  case 774: /* eval_expr_init_stid: Y_expression  */
#line 7577 "parser.y"
                                  { (yyval.tid) = TS_constexpr; }
#line 11694 "parser.c"
    break;

  case 775: /* eval_expr_init_stid: Y_initialization  */
#line 7578 "parser.y"
                                  { (yyval.tid) = TS_constinit; }
#line 11700 "parser.c"
    break;

  case 776: /* linkage_stid: str_lit  */
#line 7590 "parser.y"
    {
      bool ok = true;

      if ( strcmp( (yyvsp[0].str_val), "C" ) == 0 )
        (yyval.tid) = TS_extern_C;
      else if ( strcmp( (yyvsp[0].str_val), "C++" ) == 0 )
        (yyval.tid) = TS_NONE;
      else {
        print_error( &(yylsp[0]), "\"%s\": unknown linkage language", (yyvsp[0].str_val) );
        print_hint( "\"C\" or \"C++\"" );
        ok = false;
      }

      free( (yyvsp[0].str_val) );
      PARSE_ASSERT( ok );
    }
#line 11721 "parser.c"
    break;

  case 796: /* pointer_decl_english_ast: Y_pointer to_exp decl_english_ast  */
#line 7647 "parser.y"
    {
      DUMP_START( "pointer_decl_english_ast", "POINTER TO decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      if ( (yyvsp[0].ast)->kind == K_NAME ) { // see the comment in "declare_command"
        assert( !c_sname_empty( &(yyvsp[0].ast)->sname ) );
        print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].ast)->sname );
        PARSE_ABORT();
      }

      (yyval.ast) = c_ast_new_gc( K_POINTER, &(yyloc) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11742 "parser.c"
    break;

  case 797: /* pointer_decl_english_ast: Y_pointer to_exp Y_member of_exp class_struct_union_btid_exp sname_english_exp decl_english_ast  */
#line 7670 "parser.y"
    {
      DUMP_START( "pointer_to_member_decl_english",
                  "POINTER TO MEMBER OF "
                  "class_struct_union_btid_exp "
                  "sname_english decl_english_ast" );
      DUMP_TID( "class_struct_union_btid_exp", (yyvsp[-2].tid) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-1].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_POINTER_TO_MEMBER, &(yyloc) );
      (yyval.ast)->ptr_mbr.class_sname = c_sname_move( &(yyvsp[-1].sname) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-2].tid), &(yylsp[-2]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11764 "parser.c"
    break;

  case 798: /* pointer_decl_english_ast: Y_pointer to_exp error  */
#line 7689 "parser.y"
    {
      if ( OPT_LANG_IS( POINTERS_TO_MEMBER ) )
        elaborate_error( "type name or \"member\" expected" );
      else
        elaborate_error( "type name expected" );
    }
#line 11775 "parser.c"
    break;

  case 799: /* reference_decl_english_ast: reference_english_ast to_exp decl_english_ast  */
#line 7702 "parser.y"
    {
      DUMP_START( "reference_decl_english_ast",
                  "reference_english_ast TO decl_english_ast" );
      DUMP_AST( "reference_english_ast", (yyvsp[-2].ast) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[-2].ast);
      (yyval.ast)->loc = (yyloc);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11793 "parser.c"
    break;

  case 800: /* reference_english_ast: Y_reference  */
#line 7719 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_REFERENCE, &(yyloc) );
    }
#line 11801 "parser.c"
    break;

  case 801: /* reference_english_ast: Y_rvalue reference_exp  */
#line 7724 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_RVALUE_REFERENCE, &(yyloc) );
    }
#line 11809 "parser.c"
    break;

  case 802: /* user_defined_literal_decl_english_ast: user_defined literal_exp lparen_exp param_decl_list_english_opt ')' returning_english_ast_opt  */
#line 7735 "parser.y"
    { //
      // User-defined literals are supported only in C++11 and later.
      // (However, we always allow them in configuration files.)
      //
      // This check is better to do now in the parser rather than later in the
      // AST because it has to be done in fewer places in the code plus gives a
      // better error location.
      //
      if ( !IS_SUPPORTED( USER_DEF_LITS ) ) {
        print_error( &(yylsp[-5]),
          "user-defined literals not supported%s\n",
          C_LANG_WHICH( USER_DEF_LITS )
        );
        PARSE_ABORT();
      }

      DUMP_START( "user_defined_literal_decl_english_ast",
                  "USER-DEFINED LITERAL '(' param_decl_list_english_opt ')' "
                  "returning_english_ast_opt" );
      DUMP_AST_LIST( "param_decl_list_english_opt", (yyvsp[-2].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_UDEF_LIT, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), (yyval.ast) );
      (yyval.ast)->udef_lit.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11844 "parser.c"
    break;

  case 803: /* var_decl_english_ast: sname_c Y_as decl_english_ast  */
#line 7774 "parser.y"
    {
      DUMP_START( "var_decl_english_ast", "sname_c AS decl_english_ast" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      if ( (yyvsp[0].ast)->kind == K_NAME ) { // see the comment in "declare_command"
        assert( !c_sname_empty( &(yyvsp[0].ast)->sname ) );
        print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].ast)->sname );
        c_sname_cleanup( &(yyvsp[-2].sname) );
        PARSE_ABORT();
      }

      (yyval.ast) = (yyvsp[0].ast);
      (yyval.ast)->loc = (yyloc);
      c_sname_set( &(yyval.ast)->sname, &(yyvsp[-2].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11868 "parser.c"
    break;

  case 805: /* var_decl_english_ast: "..."  */
#line 7803 "parser.y"
    {
      DUMP_START( "var_decl_english_ast", "..." );

      (yyval.ast) = c_ast_new_gc( K_VARIADIC, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11881 "parser.c"
    break;

  case 806: /* type_english_ast: type_modifier_list_english_type_opt unmodified_type_english_ast  */
#line 7820 "parser.y"
    {
      DUMP_START( "type_english_ast",
                  "type_modifier_list_english_type_opt "
                  "unmodified_type_english_ast" );
      DUMP_TYPE( "type_modifier_list_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "unmodified_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( !c_type_is_none( &(yyvsp[-1].type) ) ) {
        // Set the AST's location to the entire rule only if the leading
        // optional rule is actually present, otherwise @$ refers to a column
        // before $ast.
        (yyval.ast)->loc = (yyloc);
        PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11905 "parser.c"
    break;

  case 807: /* type_english_ast: type_modifier_list_english_type  */
#line 7842 "parser.y"
    {
      DUMP_START( "type_english_ast", "type_modifier_list_english_type" );
      DUMP_TYPE( "type_modifier_list_english_type", (yyvsp[0].type) );

      // see the comment in "type_c_ast"
      c_type_t new_type =
        C_TYPE_LIT_B( OPT_LANG_IS( IMPLICIT_int ) ? TB_int : TB_NONE );

      PARSE_ASSERT( c_type_add( &new_type, &(yyvsp[0].type), &(yylsp[0]) ) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type = new_type;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11926 "parser.c"
    break;

  case 808: /* type_modifier_list_english_type_opt: %empty  */
#line 7861 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 11932 "parser.c"
    break;

  case 810: /* type_modifier_list_english_type: type_modifier_list_english_type type_modifier_english_type  */
#line 7868 "parser.y"
    {
      DUMP_START( "type_modifier_list_english_type",
                  "type_modifier_list_english_type "
                  "type_modifier_english_type" );
      DUMP_TYPE( "type_modifier_list_english_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_modifier_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 11950 "parser.c"
    break;

  case 817: /* builtin_type_english_ast: builtin_no_BitInt_english_btid  */
#line 7898 "parser.y"
    {
      DUMP_START( "builtin_type_english_ast",
                  "builtin_no_BitInt_english_btid" );
      DUMP_TID( "builtin_no_BitInt_english_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11966 "parser.c"
    break;

  case 818: /* builtin_type_english_ast: BitInt_english_int  */
#line 7910 "parser.y"
    {
      DUMP_START( "builtin_type_english_ast", "BitInt_english_int" );
      DUMP_INT( "BitInt_english_int", (yyvsp[0].uint_val) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = TB__BitInt;
      (yyval.ast)->builtin.BitInt.width = (yyvsp[0].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11982 "parser.c"
    break;

  case 823: /* builtin_no_BitInt_english_btid: Y_char uint_lit_opt  */
#line 7929 "parser.y"
    {
      switch ( (yyvsp[0].uint_val) ) {
        case  0: (yyval.tid) = TB_char    ; break;
        case  8: (yyval.tid) = TB_char8_t ; break;
        case 16: (yyval.tid) = TB_char16_t; break;
        case 32: (yyval.tid) = TB_char32_t; break;
        default:
          print_error( &(yylsp[0]), "bits must be one of 8, 16, or 32\n" );
          PARSE_ABORT();
      } // switch
    }
#line 11998 "parser.c"
    break;

  case 828: /* builtin_no_BitInt_english_btid: Y_wide char_exp  */
#line 7944 "parser.y"
                                  { (yyval.tid) = TB_wchar_t; }
#line 12004 "parser.c"
    break;

  case 831: /* builtin_no_BitInt_english_btid: Y_floating point_exp  */
#line 7947 "parser.y"
                                  { (yyval.tid) = TB_float; }
#line 12010 "parser.c"
    break;

  case 832: /* builtin_no_BitInt_english_btid: Y_double precision_opt  */
#line 7948 "parser.y"
                                  { (yyval.tid) = TB_double; }
#line 12016 "parser.c"
    break;

  case 835: /* BitInt_english_int: BitInt_english uint_lit bits_opt  */
#line 7955 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12024 "parser.c"
    break;

  case 836: /* BitInt_english_int: BitInt_english '(' uint_lit_exp rparen_exp  */
#line 7959 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12032 "parser.c"
    break;

  case 837: /* BitInt_english_int: BitInt_english Y_width uint_lit_exp bits_opt  */
#line 7963 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12040 "parser.c"
    break;

  case 838: /* BitInt_english_int: BitInt_english error  */
#line 7967 "parser.y"
    {
      elaborate_error( "integer literal, '(', or \"width\" expected" );
    }
#line 12048 "parser.c"
    break;

  case 844: /* class_struct_union_english_ast: class_struct_union_btid any_sname_c_exp  */
#line 7985 "parser.y"
    {
      DUMP_START( "class_struct_union_english_ast",
                  "class_struct_union_btid any_sname_c_exp" );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-1].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      (yyval.ast) = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-1].tid), C_TPID_BASE );
      (yyval.ast)->csu.csu_sname = c_sname_move( &(yyvsp[0].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12066 "parser.c"
    break;

  case 845: /* enum_english_ast: enum_btids any_sname_c_exp of_type_enum_fixed_type_english_ast_opt  */
#line 8003 "parser.y"
    {
      DUMP_START( "enum_english_ast",
                  "enum_btids any_sname_c_exp "
                  "of_type_enum_fixed_type_english_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ENUM, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      (yyval.ast)->enum_.enum_sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12087 "parser.c"
    break;

  case 846: /* of_type_enum_fixed_type_english_ast_opt: %empty  */
#line 8022 "parser.y"
                                        { (yyval.ast) = NULL; }
#line 12093 "parser.c"
    break;

  case 847: /* of_type_enum_fixed_type_english_ast_opt: Y_of type_opt enum_fixed_type_english_ast  */
#line 8024 "parser.y"
    {
      (yyval.ast) = (yyvsp[0].ast);
    }
#line 12101 "parser.c"
    break;

  case 848: /* enum_fixed_type_english_ast: enum_fixed_type_modifier_list_english_btid_opt enum_unmodified_fixed_type_english_ast  */
#line 8032 "parser.y"
    {
      DUMP_START( "enum_fixed_type_english_ast",
                  "enum_fixed_type_modifier_list_stid" );
      DUMP_TID( "enum_fixed_type_modifier_list_stid", (yyvsp[-1].tid) );
      DUMP_AST( "enum_unmodified_fixed_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( (yyvsp[-1].tid) != TB_NONE ) {        // See comment in type_english_ast.
        (yyval.ast)->loc = (yyloc);
        PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-1].tid), &(yylsp[-1]) ) );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12121 "parser.c"
    break;

  case 849: /* enum_fixed_type_english_ast: enum_fixed_type_modifier_list_english_btid  */
#line 8049 "parser.y"
    {
      DUMP_START( "enum_fixed_type_english_ast",
                  "enum_fixed_type_modifier_list_english_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_english_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12137 "parser.c"
    break;

  case 850: /* enum_fixed_type_modifier_list_english_btid_opt: %empty  */
#line 8063 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 12143 "parser.c"
    break;

  case 852: /* enum_fixed_type_modifier_list_english_btid: enum_fixed_type_modifier_list_english_btid enum_fixed_type_modifier_btid  */
#line 8070 "parser.y"
    {
      DUMP_START( "enum_fixed_type_modifier_list_english_btid",
                  "enum_fixed_type_modifier_list_english_btid "
                  "enum_fixed_type_modifier_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_english_btid", (yyvsp[-1].tid) );
      DUMP_TID( "enum_fixed_type_modifier_btid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_btids", (yyval.tid) );
      DUMP_END();
    }
#line 12161 "parser.c"
    break;

  case 857: /* any_name: Y_TYPEDEF_NAME  */
#line 8099 "parser.y"
    {
      assert( c_sname_count( &(yyvsp[0].tdef)->ast->sname ) == 1 );
      (yyval.name) = check_strdup( c_sname_local_name( &(yyvsp[0].tdef)->ast->sname ) );
    }
#line 12170 "parser.c"
    break;

  case 859: /* any_name_exp: error  */
#line 8108 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "name expected" );
    }
#line 12179 "parser.c"
    break;

  case 863: /* any_sname_c_exp: error  */
#line 8122 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 12188 "parser.c"
    break;

  case 864: /* any_sname_c_opt: %empty  */
#line 8129 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12194 "parser.c"
    break;

  case 868: /* name_ast: Y_NAME  */
#line 8140 "parser.y"
    {
      DUMP_START( "name_ast", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      (yyval.ast) = c_ast_new_gc( K_NAME, &(yyloc) );
      c_sname_append_name( &(yyval.ast)->sname, (yyvsp[0].name) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12209 "parser.c"
    break;

  case 870: /* name_exp: error  */
#line 8155 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "name expected" );
    }
#line 12218 "parser.c"
    break;

  case 871: /* name_cat: name_cat Y_NAME  */
#line 8163 "parser.y"
    {
      (yyval.name) = str_realloc_cat( (yyvsp[-1].name), " ", (yyvsp[0].name) );
      free( (yyvsp[0].name) );
    }
#line 12227 "parser.c"
    break;

  case 873: /* name_opt: %empty  */
#line 8171 "parser.y"
                                  { (yyval.name) = NULL; }
#line 12233 "parser.c"
    break;

  case 875: /* oper_sname_c_opt: %empty  */
#line 8176 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12239 "parser.c"
    break;

  case 876: /* oper_sname_c_opt: Y_OPERATOR_SNAME Y_COLON_COLON  */
#line 8179 "parser.y"
    {
      (yyval.sname) = (yyvsp[-1].sname);
      if ( c_type_is_none( c_sname_local_type( &(yyval.sname) ) ) )
        c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_SCOPE ) );
    }
#line 12249 "parser.c"
    break;

  case 877: /* typedef_type_c_ast: any_typedef sub_scope_sname_c_opt  */
#line 8188 "parser.y"
    {
      c_ast_t *type_ast = ia_type_ast_peek();
      c_ast_t const *type_for_ast = (yyvsp[-1].tdef)->ast;

      DUMP_START( "typedef_type_c_ast", "any_typedef sub_scope_sname_c_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST( "any_typedef__ast", type_for_ast );
      DUMP_SNAME( "sub_scope_sname_c_opt", (yyvsp[0].sname) );

      if ( c_sname_empty( &(yyvsp[0].sname) ) ) {
ttntd:  (yyval.ast) = c_ast_new_gc( K_TYPEDEF, &(yyloc) );
        (yyval.ast)->type.btids = TB_typedef;
        (yyval.ast)->tdef.for_ast = type_for_ast;
      }
      else {
        c_sname_t temp_name = c_sname_dup( &(yyvsp[-1].tdef)->ast->sname );
        c_sname_append_sname( &temp_name, &(yyvsp[0].sname) );

        if ( type_ast == NULL ) {
          //
          // This is for a case like:
          //
          //      define S as struct S
          //      explain S::T x
          //
          // that is: a typedef'd type followed by ::T where T is an unknown
          // name used as a type. Just assume the T is some type, say int, and
          // create a name for it.
          //
          type_ast = c_ast_new_gc( K_BUILTIN, &(yylsp[0]) );
          type_ast->type.btids = TB_int;
          c_sname_set( &type_ast->sname, &temp_name );
          type_for_ast = type_ast;
          goto ttntd;
        }

        //
        // Otherwise, this is for cases like:
        //
        //  1. A typedef'd type used for a scope:
        //
        //          define S as struct S
        //          explain int S::x
        //
        //  2. A typedef'd type used for an intermediate scope:
        //
        //          define S as struct S
        //          define T as struct T
        //          explain int S::T::x
        //
        (yyval.ast) = type_ast;
        c_sname_set( &(yyval.ast)->sname, &temp_name );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12311 "parser.c"
    break;

  case 878: /* sub_scope_sname_c_opt: %empty  */
#line 8248 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12317 "parser.c"
    break;

  case 879: /* sub_scope_sname_c_opt: Y_COLON_COLON any_sname_c  */
#line 8250 "parser.y"
    {
      (yyval.sname) = (yyvsp[0].sname);
    }
#line 12325 "parser.c"
    break;

  case 880: /* sname_c: sname_c Y_COLON_COLON Y_NAME  */
#line 8257 "parser.y"
    {
      // see the comment in "of_scope_english"
      if ( !IS_SUPPORTED( SCOPED_NAMES ) ) {
        print_error( &(yylsp[-1]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        c_sname_cleanup( &(yyvsp[-2].sname) );
        free( (yyvsp[0].name) );
        PARSE_ABORT();
      }

      DUMP_START( "sname_c", "sname_c '::' NAME" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_SCOPE ) );
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12353 "parser.c"
    break;

  case 881: /* sname_c: sname_c Y_COLON_COLON any_typedef  */
#line 8282 "parser.y"
    { //
      // This is for a case like:
      //
      //      define S::int8_t as char
      //
      // that is: the type int8_t is an existing type in no scope being defined
      // as a distinct type in a new scope.
      //
      DUMP_START( "sname_c", "sname_c '::' any_typedef" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_SCOPE ) );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12378 "parser.c"
    break;

  case 882: /* sname_c: Y_NAME  */
#line 8304 "parser.y"
    {
      DUMP_START( "sname_c", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      c_sname_init_name( &(yyval.sname), (yyvsp[0].name) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12392 "parser.c"
    break;

  case 883: /* sname_c_ast: sname_c bit_field_c_uint_opt  */
#line 8318 "parser.y"
    {
      c_ast_t *type_ast = ia_type_ast_peek();

      DUMP_START( "sname_c_ast", "sname_c" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "sname_c", (yyvsp[-1].sname) );
      DUMP_INT( "bit_field_c_uint_opt", (yyvsp[0].uint_val) );

      type_ast = ia_type_spec_ast( type_ast );
      c_sname_set( &type_ast->sname, &(yyvsp[-1].sname) );
      PARSE_ASSERT( c_ast_set_bit_field_width( type_ast, (yyvsp[0].uint_val) ) );

      (yyval.ast) = type_ast;
      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12413 "parser.c"
    break;

  case 884: /* bit_field_c_uint_opt: %empty  */
#line 8337 "parser.y"
                                  { (yyval.uint_val) = 0; }
#line 12419 "parser.c"
    break;

  case 885: /* bit_field_c_uint_opt: ':' uint_lit_exp  */
#line 8339 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since we use 0 to mean "no bit-field."
      //
      if ( (yyvsp[0].uint_val) == 0 ) {
        print_error( &(yylsp[0]), "bit-field width must be > 0\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = (yyvsp[0].uint_val);
    }
#line 12434 "parser.c"
    break;

  case 887: /* sname_c_exp: error  */
#line 8354 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 12443 "parser.c"
    break;

  case 888: /* sname_c_opt: %empty  */
#line 8361 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12449 "parser.c"
    break;

  case 890: /* sname_english: any_sname_c of_scope_list_english_opt  */
#line 8367 "parser.y"
    {
      DUMP_START( "sname_english", "any_sname_c of_scope_list_english_opt" );
      DUMP_SNAME( "any_sname_c", (yyvsp[-1].sname) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[0].sname) );

      c_type_t const *local_type = c_sname_local_type( &(yyvsp[0].sname) );
      if ( c_type_is_none( local_type ) )
        local_type = c_sname_local_type( &(yyvsp[-1].sname) );
      (yyval.sname) = (yyvsp[0].sname);
      c_sname_append_sname( &(yyval.sname), &(yyvsp[-1].sname) );
      c_sname_set_local_type( &(yyval.sname), local_type );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12469 "parser.c"
    break;

  case 891: /* sname_english_ast: Y_NAME of_scope_list_english_opt  */
#line 8386 "parser.y"
    {
      DUMP_START( "sname_english_ast", "NAME of_scope_list_english_opt" );
      DUMP_STR( "NAME", (yyvsp[-1].name) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[0].sname) );

      c_sname_t sname = c_sname_move( &(yyvsp[0].sname) );
      c_sname_append_name( &sname, (yyvsp[-1].name) );

      //
      // See if the full name is the name of a typedef'd type.
      //
      c_typedef_t const *const tdef = c_typedef_find_sname( &sname );
      if ( tdef != NULL ) {
        (yyval.ast) = c_ast_new_gc( K_TYPEDEF, &(yyloc) );
        (yyval.ast)->type.btids = TB_typedef;
        (yyval.ast)->tdef.for_ast = tdef->ast;
        c_sname_cleanup( &sname );
      } else {
        (yyval.ast) = c_ast_new_gc( K_NAME, &(yyloc) );
        c_sname_set( &(yyval.ast)->sname, &sname );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12499 "parser.c"
    break;

  case 893: /* sname_english_exp: error  */
#line 8416 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 12508 "parser.c"
    break;

  case 894: /* sname_english_opt: %empty  */
#line 8423 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12514 "parser.c"
    break;

  case 896: /* sname_list_english: sname_list_english ',' sname_english_exp  */
#line 8429 "parser.y"
    {
      DUMP_START( "sname_list_english",
                  "sname_list_english ',' sname_english" );
      DUMP_SNAME_LIST( "sname_list_english", (yyvsp[-2].sname_list) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[0].sname) );

      (yyval.sname_list) = (yyvsp[-2].sname_list);
      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 12533 "parser.c"
    break;

  case 897: /* sname_list_english: sname_english  */
#line 8445 "parser.y"
    {
      DUMP_START( "sname_list_english", "sname_english" );
      DUMP_SNAME( "sname_english", (yyvsp[0].sname) );

      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_init( &(yyval.sname_list) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 12550 "parser.c"
    break;

  case 898: /* typedef_sname_c: typedef_sname_c Y_COLON_COLON sname_c  */
#line 8461 "parser.y"
    {
      DUMP_START( "typedef_sname_c", "typedef_sname_c '::' sname_c" );
      DUMP_SNAME( "typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      //
      // This is for a case like:
      //
      //      define S as struct S
      //      define S::T as struct T
      //
      (yyval.sname) = c_sname_move( &(yyvsp[-2].sname) );
      c_sname_append_sname( &(yyval.sname), &(yyvsp[0].sname) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12572 "parser.c"
    break;

  case 899: /* typedef_sname_c: typedef_sname_c Y_COLON_COLON any_typedef  */
#line 8480 "parser.y"
    {
      DUMP_START( "typedef_sname_c", "typedef_sname_c '::' any_typedef" );
      DUMP_SNAME( "typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      //
      // This is for a case like:
      //
      //      define S as struct S
      //      define T as struct T
      //      define S::T as struct S_T
      //
      (yyval.sname) = c_sname_move( &(yyvsp[-2].sname) );
      c_sname_set_local_type( &(yyval.sname), c_sname_local_type( &(yyvsp[0].tdef)->ast->sname ) );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12597 "parser.c"
    break;

  case 900: /* typedef_sname_c: any_typedef  */
#line 8501 "parser.y"
                                  { (yyval.sname) = c_sname_dup( &(yyvsp[0].tdef)->ast->sname ); }
#line 12603 "parser.c"
    break;

  case 902: /* address_exp: error  */
#line 8511 "parser.y"
    {
      keyword_expected( L_address );
    }
#line 12611 "parser.c"
    break;

  case 904: /* array_exp: error  */
#line 8519 "parser.y"
    {
      keyword_expected( L_array );
    }
#line 12619 "parser.c"
    break;

  case 905: /* as_exp: Y_as  */
#line 8526 "parser.y"
    {
      if ( OPT_LANG_IS( MEMBER_FUNCTIONS ) ) {
        //
        // For either "declare" or "define", neither "override" nor "final"
        // must be matched initially to allow for cases like:
        //
        //      c++decl> declare final as int
        //      int final;
        //
        // (which is legal).  However, in C++, after parsing "as", the keyword
        // context has to be set to C_KW_CTX_MBR_FUNC to be able to match
        // "override" and "final", e.g.:
        //
        //      c++decl> declare f as final function
        //      void f() final;
        //
        lexer_keyword_ctx = C_KW_CTX_MBR_FUNC;
      }
    }
#line 12643 "parser.c"
    break;

  case 906: /* as_exp: error  */
#line 8546 "parser.y"
    {
      keyword_expected( L_as );
    }
#line 12651 "parser.c"
    break;

  case 910: /* as_into_to_exp: error  */
#line 8556 "parser.y"
    {
      elaborate_error( "\"as\", \"into\", or \"to\" expected" );
    }
#line 12659 "parser.c"
    break;

  case 920: /* cast_exp: error  */
#line 8581 "parser.y"
    {
      keyword_expected( L_cast );
    }
#line 12667 "parser.c"
    break;

  case 922: /* char_exp: error  */
#line 8589 "parser.y"
    {
      keyword_expected( L_char );
    }
#line 12675 "parser.c"
    break;

  case 924: /* class_struct_union_btid_exp: error  */
#line 8597 "parser.y"
    {
      elaborate_error( "\"class\", \"struct\", or \"union\" expected" );
    }
#line 12683 "parser.c"
    break;

  case 926: /* colon_exp: error  */
#line 8605 "parser.y"
    {
      punct_expected( ':' );
    }
#line 12691 "parser.c"
    break;

  case 928: /* comma_exp: error  */
#line 8613 "parser.y"
    {
      punct_expected( ',' );
    }
#line 12699 "parser.c"
    break;

  case 930: /* conversion_exp: error  */
#line 8621 "parser.y"
    {
      keyword_expected( L_conversion );
    }
#line 12707 "parser.c"
    break;

  case 931: /* c_operator: Y_co_await  */
#line 8627 "parser.y"
                                  { (yyval.op_id) = C_OP_CO_AWAIT              ; }
#line 12713 "parser.c"
    break;

  case 932: /* c_operator: Y_new  */
#line 8628 "parser.y"
                                  { (yyval.op_id) = C_OP_NEW                   ; }
#line 12719 "parser.c"
    break;

  case 933: /* c_operator: Y_new '[' rbracket_exp  */
#line 8629 "parser.y"
                                  { (yyval.op_id) = C_OP_NEW_ARRAY             ; }
#line 12725 "parser.c"
    break;

  case 934: /* c_operator: Y_delete  */
#line 8630 "parser.y"
                                  { (yyval.op_id) = C_OP_DELETE                ; }
#line 12731 "parser.c"
    break;

  case 935: /* c_operator: Y_delete '[' rbracket_exp  */
#line 8631 "parser.y"
                                  { (yyval.op_id) = C_OP_DELETE_ARRAY          ; }
#line 12737 "parser.c"
    break;

  case 936: /* c_operator: '!'  */
#line 8632 "parser.y"
                                  { (yyval.op_id) = C_OP_EXCLAM                ; }
#line 12743 "parser.c"
    break;

  case 937: /* c_operator: Y_EXCLAM_EQUAL  */
#line 8633 "parser.y"
                                  { (yyval.op_id) = C_OP_EXCLAM_EQUAL          ; }
#line 12749 "parser.c"
    break;

  case 938: /* c_operator: '%'  */
#line 8634 "parser.y"
                                  { (yyval.op_id) = C_OP_PERCENT               ; }
#line 12755 "parser.c"
    break;

  case 939: /* c_operator: Y_PERCENT_EQUAL  */
#line 8635 "parser.y"
                                  { (yyval.op_id) = C_OP_PERCENT_EQUAL         ; }
#line 12761 "parser.c"
    break;

  case 940: /* c_operator: '&'  */
#line 8636 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPER                 ; }
#line 12767 "parser.c"
    break;

  case 941: /* c_operator: Y_AMPER_AMPER  */
#line 8637 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPER_AMPER           ; }
#line 12773 "parser.c"
    break;

  case 942: /* c_operator: Y_AMPER_EQUAL  */
#line 8638 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPER_EQUAL           ; }
#line 12779 "parser.c"
    break;

  case 943: /* c_operator: '(' rparen_exp  */
#line 8639 "parser.y"
                                  { (yyval.op_id) = C_OP_PARENS                ; }
#line 12785 "parser.c"
    break;

  case 944: /* c_operator: '*'  */
#line 8640 "parser.y"
                                  { (yyval.op_id) = C_OP_STAR                  ; }
#line 12791 "parser.c"
    break;

  case 945: /* c_operator: Y_STAR_EQUAL  */
#line 8641 "parser.y"
                                  { (yyval.op_id) = C_OP_STAR_EQUAL            ; }
#line 12797 "parser.c"
    break;

  case 946: /* c_operator: '+'  */
#line 8642 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS                  ; }
#line 12803 "parser.c"
    break;

  case 947: /* c_operator: "++"  */
#line 8643 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS_PLUS             ; }
#line 12809 "parser.c"
    break;

  case 948: /* c_operator: Y_PLUS_EQUAL  */
#line 8644 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS_EQUAL            ; }
#line 12815 "parser.c"
    break;

  case 949: /* c_operator: ','  */
#line 8645 "parser.y"
                                  { (yyval.op_id) = C_OP_COMMA                 ; }
#line 12821 "parser.c"
    break;

  case 950: /* c_operator: '-'  */
#line 8646 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS                 ; }
#line 12827 "parser.c"
    break;

  case 951: /* c_operator: "--"  */
#line 8647 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_MINUS           ; }
#line 12833 "parser.c"
    break;

  case 952: /* c_operator: Y_MINUS_EQUAL  */
#line 8648 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_EQUAL           ; }
#line 12839 "parser.c"
    break;

  case 953: /* c_operator: Y_MINUS_GREATER  */
#line 8649 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_GREATER         ; }
#line 12845 "parser.c"
    break;

  case 954: /* c_operator: Y_MINUS_GREATER_STAR  */
#line 8650 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_GREATER_STAR    ; }
#line 12851 "parser.c"
    break;

  case 955: /* c_operator: '.'  */
#line 8651 "parser.y"
                                  { (yyval.op_id) = C_OP_DOT                   ; }
#line 12857 "parser.c"
    break;

  case 956: /* c_operator: Y_DOT_STAR  */
#line 8652 "parser.y"
                                  { (yyval.op_id) = C_OP_DOT_STAR              ; }
#line 12863 "parser.c"
    break;

  case 957: /* c_operator: '/'  */
#line 8653 "parser.y"
                                  { (yyval.op_id) = C_OP_SLASH                 ; }
#line 12869 "parser.c"
    break;

  case 958: /* c_operator: Y_SLASH_EQUAL  */
#line 8654 "parser.y"
                                  { (yyval.op_id) = C_OP_SLASH_EQUAL           ; }
#line 12875 "parser.c"
    break;

  case 959: /* c_operator: Y_COLON_COLON  */
#line 8655 "parser.y"
                                  { (yyval.op_id) = C_OP_COLON_COLON           ; }
#line 12881 "parser.c"
    break;

  case 960: /* c_operator: '<'  */
#line 8656 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS                  ; }
#line 12887 "parser.c"
    break;

  case 961: /* c_operator: Y_LESS_LESS  */
#line 8657 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_LESS             ; }
#line 12893 "parser.c"
    break;

  case 962: /* c_operator: Y_LESS_LESS_EQUAL  */
#line 8658 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_LESS_EQUAL       ; }
#line 12899 "parser.c"
    break;

  case 963: /* c_operator: Y_LESS_EQUAL  */
#line 8659 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_EQUAL            ; }
#line 12905 "parser.c"
    break;

  case 964: /* c_operator: Y_LESS_EQUAL_GREATER  */
#line 8660 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_EQUAL_GREATER    ; }
#line 12911 "parser.c"
    break;

  case 965: /* c_operator: '='  */
#line 8661 "parser.y"
                                  { (yyval.op_id) = C_OP_EQUAL                 ; }
#line 12917 "parser.c"
    break;

  case 966: /* c_operator: Y_EQUAL_EQUAL  */
#line 8662 "parser.y"
                                  { (yyval.op_id) = C_OP_EQUAL_EQUAL           ; }
#line 12923 "parser.c"
    break;

  case 967: /* c_operator: '>'  */
#line 8663 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER               ; }
#line 12929 "parser.c"
    break;

  case 968: /* c_operator: Y_GREATER_GREATER  */
#line 8664 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_GREATER       ; }
#line 12935 "parser.c"
    break;

  case 969: /* c_operator: Y_GREATER_GREATER_EQUAL  */
#line 8665 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_GREATER_EQUAL ; }
#line 12941 "parser.c"
    break;

  case 970: /* c_operator: Y_GREATER_EQUAL  */
#line 8666 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_EQUAL         ; }
#line 12947 "parser.c"
    break;

  case 971: /* c_operator: Y_QMARK_COLON  */
#line 8667 "parser.y"
                                  { (yyval.op_id) = C_OP_QMARK_COLON           ; }
#line 12953 "parser.c"
    break;

  case 972: /* c_operator: '[' rbracket_exp  */
#line 8668 "parser.y"
                                  { (yyval.op_id) = C_OP_BRACKETS              ; }
#line 12959 "parser.c"
    break;

  case 973: /* c_operator: '^'  */
#line 8669 "parser.y"
                                  { (yyval.op_id) = C_OP_CARET                 ; }
#line 12965 "parser.c"
    break;

  case 974: /* c_operator: Y_CARET_EQUAL  */
#line 8670 "parser.y"
                                  { (yyval.op_id) = C_OP_CARET_EQUAL           ; }
#line 12971 "parser.c"
    break;

  case 975: /* c_operator: '|'  */
#line 8671 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE                  ; }
#line 12977 "parser.c"
    break;

  case 976: /* c_operator: Y_PIPE_PIPE  */
#line 8672 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE_PIPE             ; }
#line 12983 "parser.c"
    break;

  case 977: /* c_operator: Y_PIPE_EQUAL  */
#line 8673 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE_EQUAL            ; }
#line 12989 "parser.c"
    break;

  case 978: /* c_operator: '~'  */
#line 8674 "parser.y"
                                  { (yyval.op_id) = C_OP_TILDE                 ; }
#line 12995 "parser.c"
    break;

  case 980: /* default_exp: error  */
#line 8680 "parser.y"
    {
      keyword_expected( L_default );
    }
#line 13003 "parser.c"
    break;

  case 982: /* defined_exp: error  */
#line 8688 "parser.y"
    {
      keyword_expected( L_defined );
    }
#line 13011 "parser.c"
    break;

  case 984: /* dependency_exp: error  */
#line 8696 "parser.y"
    {
      keyword_expected( L_dependency );
    }
#line 13019 "parser.c"
    break;

  case 986: /* destructor_sname: Y_LEXER_ERROR  */
#line 8704 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      PARSE_ABORT();
    }
#line 13028 "parser.c"
    break;

  case 987: /* empty_str_lit_exp: str_lit_exp  */
#line 8712 "parser.y"
    { //
      // This check is done now in the parser rather than later in the AST so
      // we don't have to keep the string literal around.
      //
      bool const is_empty = (yyvsp[0].str_val) == NULL || (yyvsp[0].str_val)[0] == '\0';
      free( (yyvsp[0].str_val) );
      if ( !is_empty ) {
        print_error( &(yylsp[0]), "empty string literal expected\n" );
        PARSE_ABORT();
      }
    }
#line 13044 "parser.c"
    break;

  case 989: /* equals_exp: error  */
#line 8728 "parser.y"
    {
      punct_expected( '=' );
    }
#line 13052 "parser.c"
    break;

  case 990: /* extern_linkage_c_stid: Y_extern linkage_stid  */
#line 8734 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 13058 "parser.c"
    break;

  case 991: /* extern_linkage_c_stid: Y_extern linkage_stid '{'  */
#line 8736 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "scoped linkage declarations" );
      PARSE_ABORT();
    }
#line 13067 "parser.c"
    break;

  case 992: /* extern_linkage_c_stid_opt: %empty  */
#line 8743 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13073 "parser.c"
    break;

  case 994: /* glob: Y_GLOB  */
#line 8749 "parser.y"
    {
      if ( !OPT_LANG_IS( SCOPED_NAMES ) && strchr( (yyvsp[0].name), ':' ) != NULL ) {
        print_error( &(yylsp[0]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        free( (yyvsp[0].name) );
        PARSE_ABORT();
      }
      (yyval.name) = (yyvsp[0].name);
    }
#line 13089 "parser.c"
    break;

  case 995: /* glob_opt: %empty  */
#line 8763 "parser.y"
                                  { (yyval.name) = NULL; }
#line 13095 "parser.c"
    break;

  case 998: /* gt_exp: error  */
#line 8770 "parser.y"
    {
      punct_expected( '>' );
    }
#line 13103 "parser.c"
    break;

  case 999: /* inline_stid_opt: %empty  */
#line 8776 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13109 "parser.c"
    break;

  case 1002: /* int_exp: error  */
#line 8783 "parser.y"
    {
      elaborate_error( "int[eger] expected" );
    }
#line 13117 "parser.c"
    break;

  case 1004: /* literal_exp: error  */
#line 8791 "parser.y"
    {
      keyword_expected( L_literal );
    }
#line 13125 "parser.c"
    break;

  case 1006: /* local_exp: error  */
#line 8799 "parser.y"
    {
      keyword_expected( L_local );
    }
#line 13133 "parser.c"
    break;

  case 1008: /* lparen_exp: error  */
#line 8807 "parser.y"
    {
      punct_expected( '(' );
    }
#line 13141 "parser.c"
    break;

  case 1010: /* lt_exp: error  */
#line 8815 "parser.y"
    {
      punct_expected( '<' );
    }
#line 13149 "parser.c"
    break;

  case 1011: /* member_or_non_member_opt: %empty  */
#line 8821 "parser.y"
                                  { (yyval.member) = C_FUNC_UNSPECIFIED; }
#line 13155 "parser.c"
    break;

  case 1012: /* member_or_non_member_opt: Y_member  */
#line 8822 "parser.y"
                                  { (yyval.member) = C_FUNC_MEMBER     ; }
#line 13161 "parser.c"
    break;

  case 1013: /* member_or_non_member_opt: Y_non_member  */
#line 8823 "parser.y"
                                  { (yyval.member) = C_FUNC_NON_MEMBER ; }
#line 13167 "parser.c"
    break;

  case 1015: /* namespace_btid_exp: error  */
#line 8829 "parser.y"
    {
      keyword_expected( L_namespace );
    }
#line 13175 "parser.c"
    break;

  case 1016: /* namespace_type: Y_namespace  */
#line 8835 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 13181 "parser.c"
    break;

  case 1017: /* namespace_type: Y_inline namespace_btid_exp  */
#line 8836 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT( (yyvsp[0].tid), (yyvsp[-1].tid), TA_NONE ); }
#line 13187 "parser.c"
    break;

  case 1019: /* of_exp: error  */
#line 8842 "parser.y"
    {
      keyword_expected( L_of );
    }
#line 13195 "parser.c"
    break;

  case 1020: /* of_scope_english: Y_of scope_english_type_exp any_sname_c_exp  */
#line 8849 "parser.y"
    { //
      // Scoped names are supported only in C++.  (However, we always allow
      // them in configuration files.)
      //
      // This check is better to do now in the parser rather than later in the
      // AST because it has to be done in fewer places in the code plus gives a
      // better error location.
      //
      if ( !IS_SUPPORTED( SCOPED_NAMES ) ) {
        print_error( &(yylsp[-1]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        c_sname_cleanup( &(yyvsp[0].sname) );
        PARSE_ABORT();
      }
      (yyval.sname) = c_sname_move( &(yyvsp[0].sname) );
      c_sname_set_local_type( &(yyval.sname), &(yyvsp[-1].type) );
    }
#line 13219 "parser.c"
    break;

  case 1021: /* of_scope_list_english: of_scope_list_english of_scope_english  */
#line 8872 "parser.y"
    {
      // "of scope X of scope Y" means Y::X
      (yyval.sname) = c_sname_move( &(yyvsp[0].sname) );
      c_sname_append_sname( &(yyval.sname), &(yyvsp[-1].sname) );
      c_sname_fill_in_namespaces( &(yyval.sname) );
      if ( !c_sname_check( &(yyval.sname), &(yylsp[-1]) ) ) {
        c_sname_cleanup( &(yyval.sname) );
        PARSE_ABORT();
      }
    }
#line 13234 "parser.c"
    break;

  case 1023: /* of_scope_list_english_opt: %empty  */
#line 8886 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 13240 "parser.c"
    break;

  case 1026: /* operator_exp: error  */
#line 8893 "parser.y"
    {
      keyword_expected( L_operator );
    }
#line 13248 "parser.c"
    break;

  case 1030: /* point_exp: error  */
#line 8906 "parser.y"
    {
      keyword_expected( L_point );
    }
#line 13256 "parser.c"
    break;

  case 1034: /* rbrace_exp: error  */
#line 8918 "parser.y"
    {
      punct_expected( '}' );
    }
#line 13264 "parser.c"
    break;

  case 1036: /* rbracket_exp: error  */
#line 8926 "parser.y"
    {
      punct_expected( ']' );
    }
#line 13272 "parser.c"
    break;

  case 1038: /* reference_exp: error  */
#line 8934 "parser.y"
    {
      keyword_expected( L_reference );
    }
#line 13280 "parser.c"
    break;

  case 1042: /* returning_exp: error  */
#line 8947 "parser.y"
    {
      keyword_expected( L_returning );
    }
#line 13288 "parser.c"
    break;

  case 1044: /* rparen_exp: error  */
#line 8955 "parser.y"
    {
      punct_expected( ')' );
    }
#line 13296 "parser.c"
    break;

  case 1045: /* scope_english_type: class_struct_union_btid  */
#line 8961 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 13302 "parser.c"
    break;

  case 1047: /* scope_english_type: Y_scope  */
#line 8963 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( TB_SCOPE ); }
#line 13308 "parser.c"
    break;

  case 1049: /* scope_english_type_exp: error  */
#line 8969 "parser.y"
    {
      elaborate_error(
        "\"class\", \"namespace\", \"scope\", \"struct\", or \"union\" expected"
      );
    }
#line 13318 "parser.c"
    break;

  case 1051: /* semi_exp: error  */
#line 8979 "parser.y"
    {
      punct_expected( ';' );
    }
#line 13326 "parser.c"
    break;

  case 1056: /* static_stid_opt: %empty  */
#line 8995 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13332 "parser.c"
    break;

  case 1057: /* static_stid_opt: Y_static  */
#line 8996 "parser.y"
                                  { (yyval.tid) = TS_NON_EMPTY_ARRAY; }
#line 13338 "parser.c"
    break;

  case 1059: /* str_lit: Y_LEXER_ERROR  */
#line 9002 "parser.y"
    {
      (yyval.str_val) = NULL;
      PARSE_ABORT();
    }
#line 13347 "parser.c"
    break;

  case 1061: /* str_lit_exp: error  */
#line 9011 "parser.y"
    {
      (yyval.str_val) = NULL;
      elaborate_error( "string literal expected" );
    }
#line 13356 "parser.c"
    break;

  case 1063: /* this_exp: error  */
#line 9020 "parser.y"
    {
      keyword_expected( L_this );
    }
#line 13364 "parser.c"
    break;

  case 1064: /* this_stid_opt: %empty  */
#line 9026 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13370 "parser.c"
    break;

  case 1067: /* to_exp: error  */
#line 9033 "parser.y"
    {
      keyword_expected( L_to );
    }
#line 13378 "parser.c"
    break;

  case 1070: /* typename_flag_opt: %empty  */
#line 9044 "parser.y"
                                  { (yyval.flag) = false; }
#line 13384 "parser.c"
    break;

  case 1071: /* typename_flag_opt: Y_typename  */
#line 9045 "parser.y"
                                  { (yyval.flag) = true; }
#line 13390 "parser.c"
    break;

  case 1072: /* uint_lit: Y_INT_LIT  */
#line 9050 "parser.y"
    {
      if ( (yyvsp[0].int_val) < 0 ) {
        //
        // This check is better to do now in the parser rather than later in
        // the AST because we can store the value as unsigned plus gives a
        // better error location.
        //
        print_error( &(yylsp[0]), "non-negative integer expected\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = STATIC_CAST( unsigned, (yyvsp[0].int_val) );
    }
#line 13407 "parser.c"
    break;

  case 1074: /* uint_lit_exp: error  */
#line 9067 "parser.y"
    {
      elaborate_error( "integer literal expected" );
    }
#line 13415 "parser.c"
    break;

  case 1075: /* uint_lit_opt: %empty  */
#line 9073 "parser.y"
                                  { (yyval.uint_val) = 0; }
#line 13421 "parser.c"
    break;

  case 1078: /* unused_exp: error  */
#line 9080 "parser.y"
    {
      keyword_expected( L_unused );
    }
#line 13429 "parser.c"
    break;

  case 1082: /* virtual_stid_exp: error  */
#line 9093 "parser.y"
    {
      keyword_expected( L_virtual );
    }
#line 13437 "parser.c"
    break;

  case 1083: /* virtual_stid_opt: %empty  */
#line 9099 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13443 "parser.c"
    break;


#line 13447 "parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 9103 "parser.y"


/// @endcond

// Re-enable warnings.
#ifdef __GNUC__
# pragma GCC diagnostic pop
#endif /* __GNUC__ */

/**
 * @addtogroup parser-group
 * @{
 */

////////// local functions ////////////////////////////////////////////////////

/**
 * Prints an additional parsing error message including a newline to standard
 * error that continues from where yyerror() left off.  Additionally:
 *
 * + If the lexer_printable_token() isn't NULL:
 *     + Checks to see if it's a keyword: if it is, mentions that it's a
 *       keyword in the error message.
 *     + May print "did you mean ...?" \a dym_kinds suggestions.
 *
 * + In debug mode, also prints the file & line where the function was called
 *   from as well as the ID of the lookahead token, if any.
 *
 * @note A newline _is_ printed.
 * @note This function isn't normally called directly; use the
 * #elaborate_error() or #elaborate_error_dym() macros instead.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param dym_kinds The bitwise-or of the kind(s) of things possibly meant.
 * @param format A `printf()` style format string.  It _must not_ end in a
 * newline since this function prints its own newline.
 * @param ... Arguments to print.
 *
 * @sa #elaborate_error()
 * @sa #elaborate_error_dym()
 * @sa fl_keyword_expected()
 * @sa fl_punct_expected()
 * @sa yyerror()
 */
PJL_PRINTF_LIKE_FUNC(4)
static void fl_elaborate_error( char const *file, int line,
                                dym_kind_t dym_kinds, char const *format,
                                ... ) {
  assert( format != NULL );

  EPUTS( ": " );
  print_debug_file_line( file, line );

  char const *const error_token = lexer_printable_token();
  if ( error_token != NULL ) {
    EPRINTF( "\"%s\"", error_token );
    if ( opt_cdecl_debug != CDECL_DEBUG_NO ) {
      switch ( yychar ) {
        case YYEMPTY:
          EPUTS( " [<empty>]" );
          break;
        case YYEOF:
          EPUTS( " [<EOF>]" );
          break;
        default:
          EPRINTF( " [%d]", yychar );
      } // switch
    }
    EPUTS( ": " );
  }

  va_list args;
  va_start( args, format );
  vfprintf( stderr, format, args );
  va_end( args );

  if ( error_token != NULL ) {
    print_error_token_is_a( error_token );
    print_suggestions( dym_kinds, error_token );
  }

  EPUTC( '\n' );
}

////////// extern functions ///////////////////////////////////////////////////

void parser_cleanup( void ) {
  c_ast_list_cleanup_gc( &typedef_ast_list );
}

///////////////////////////////////////////////////////////////////////////////

/** @} */

/* vim:set et sw=2 ts=2: */
